*COMDECK AELERRINT
          IDENT  AELERR
          B1=1
          TITLE   AELERR - ERROR MESSAGE ISSUER FOR AELIB SUBROUTINES
          COMMENT ISSUE ERROR MESSAGES FOR AELIB.
*
*     SUBROUTINE AELERR (N,FLAG)
*         ISSUE ERROR MESSAGES FOR AELIB ROUTINES.
*         ALL ERROR MESSAGES ARE IN A SYSTEM TEXT. D00 IS CALLED TO
*     RETREIVE THE REQUESTED MESSAGE AND SYSERR. IS CALL TO ISSUE THE
*     MESSAGE AND PROVIDE A TRACE BACK.
*
*     N = NUMBER OF MESSAGE IN TEXT AELERTX
*     FLAG - 1HF - FATAL ERROR  (USES FORTRAN ERROR 52)
*            2HNF - NON-FATAL ERROR (USES FORTRAN ERROR 51)
*
*
*     IF MESSAGE HAS INSERTIONS, PUT THEM INTO THEM COMMON BLOCK
*   AELERCOM CELLS 3 AND 4
          SPACE  4
          ENTRY     AELERR
TRACE     VFD    42/6HAELERR,18/AELERR       TRACE BACK INFO
AELERR    DATA   0            ENTRY EXIT LINE
          SB1    1
          SA2    A1+B1        ADDRESS OF F/NF FLAG.
          SA4    X1           MESSAGE NUMBER
          SA3    D00PR1
          SB4    X4           SAVE MESSAGE NUMBER.
          LX4    36
          BX6    X4+X3        PUT MESSAGE NUMBER INTO D00 CALL
          SA5    =2HNF
          SA2    X2           FATAL/NON-FATAL FLAG
          SA6    D00PRM       SET UP D00 CALL
          IX7    X5-X2
          NZ     X7,AEL7      IF FATAL ERROR
          SA1    NONFMSG
          SB2    X1+MSGTBL    ADDRESS OF LAST ENTRY IN TABLE.
          ZR     X1,AEL2      IF NO ENTRIES IN MESSAGE NUMBER TABLE
          SB3     MSGTBL
AEL1      SA3    B3           ENTRY IN TABLE
          SB5    X3           MESSAGE NUMBER
          EQ     B5,B4,AEL4   IF ENTRIES MATCH
          SB3    B3+B1
          LT     B3,B2,AEL1   LOOP IF MORE ENTRIES IN TABLE.
AEL2      SX7    X1+B1        STEP NO OF ENTRIES IN TABLE.
          SX6    X7-11
          NG     X6,AEL3      IF SPACE LEFT IN TABLE
          SA1    ARG1
          JP     AELERR+1     ISSUE - NON-FATAL MESSAGE TABLE OVERFLOW.
AEL3      SA7    NONFMSG
          SX5    B4           SET UP TABLE ENTRY
          SB3    B2           ADDRESS OF NEW ENTRY
          LX5    24
          EQ     AEL5         JOIN MAIN LINE
AEL4      MX0    48           BUMP NMESS AND NTOT.
          LX3    12
          BX7   -X0*X3        NFREQ
          LX3    12
          SB7    X7           B7=NFREQ
          BX6    -X0*X3       NMESS
          SB6    X6+B1
          BX5    X0*X3
          ZR     X6,AEL5      ISSUE MESSAGE FIRST TIME THRU.
          LE     B6,B7,AEL6   IF MESSAGE NOT TO BE ISSUED
AEL5      SB6    B1
AEL6      SX6    B6
          BX3    X5+X6        ADD NEW NMESS INTO TABLE WORD
          MX0    42
          LX3    18
          SX2    X3+B1        STEP NTOT
          BX5    X0*X3
          BX6    X5+X2        ADD IN NEW NTOT
          LX6    18           RESTORE POSITION
          SA6    B3           STORE TABLE ENTRY
          NE     B6,B1,AELERR      RETURN IF DO NOT ISSUE MESSAGE
          SB6    51           NON-FATAL ERROR NUMBER
          EQ     AEL8
AEL7      SB6    52           FATAL ERROR NUMBER.
AEL8      BSS    0
          SYSTEM    D00,RCL,D00PRM      GET ERROR MESSAGE
            SX1  B6             MESSAGE NUMBER
            SX2    PLTMES
+           RJ     =XSYSERR.    PRINT ERROR MESSAGE.
-           VFD    30/TRACE
          EQ     AELERR       RETURN
*
D00PR1      VFD    1/1,1/0,1/1,1/0,1/0,31/14,18/PLTMES,6/0
ARG1      VFD    60/FTNO      ARGUMENT LIST FOR
          VFD    60/FTFLAG     -NON FATAL MESSAGE TABLE OVERFLOW-
          DATA   0
FTNO      CON    1
FTFLAG    CON    1HF
AELERCM   SPACE  2,6
          USE    /AELERCM/         COMMON BLOCK
D00PRM    DATA   0            CALLING SEQUENCE TO D00
          VFD    42/0LAELERTX,18/1R'
          BSSZ   13          RESERVED FOR INSERTIONS
AE$COMM   SPACE  2,6
         USE     /AE$COMM/    BLOCK FOR MISC. ARRAYS.
MSGTBL    BSSZ   11           MESSAGE NUMBER TABLE FOR NON-FATAL ERRORS
*                   FORMAT -  12/NFREQ,12/NMESS,18/NTOT,18/MESS.
*                     NFREQ - ISSUE ERROR MESSAGE EVERY NFREQ TIMES
*                     NMESS - NUMBER OF OCCURANCES SINCE LAST MESSAGE
*                     NTOT  - TOTAL NUMBER OF OCCURANCES
*                     MESS  - MESSAGE NUMBER.
NONFMSG   DATA   0            NUMBER OF ACTIVE NON-FATAL MESSAGES.
PLTMES      BSSZ   14
          END
