*DECK ALERON
      SUBROUTINE ALERON(ROUTNE,ERROR)
C
C     ******************************************************************
C     *                                                                *
C     *   ALERON IS WRITTEN IN MODULAR FORM USING THE ADDITIONAL       *
C     * ROUTINES:                                                      *
C     *                      ALRINI                                    *
C     *                      ALRDEL                                    *
C     *                      ALRFND                                    *
C     *                      ALRTST                                    *
C     *                      TRACEB                                    *
C     * ALRINI THROUGH ALRTST ACCOMPANY ALEROF ON THE AELIB SOURCE     *
C     * TAPE UNDER THE DECK NAME ALEROF.  TRACEB IS STORED ON THE      *
C     * AELIB SOURCE TAPE UNDER THE DECK NAME TRACEB.                  *
C     *                                                                *
C     ******************************************************************
C     ROUTINE ALERON: ENABLE THE PRINTING OF THE ERROR MESSAGE
C                     "ERROR" (I.E. THE MESSAGES ASSOCIATED WITH
C                     ERROR NUMBER "ERROR") FOR THE AELIB ROUTINE
C                     "ROUTNE".  IF "ERROR" = 0 THEN ENABLE ALL
C                     ERROR MESSAGES FOR ROUTINE "ROUTNE".
C
C     ERROR EXIT
C     ----------
C     THERE IS ONE ERROR EXIT FOR ALERON:
C     (1)  IF THERE IS NOT ENOUGH ROOM IN THE TABLES TO HANDLE
C          THE REQUEST TO TURN ON AN INDIVIDUAL MESSAGE, ALL THE
C          MESSAGES FOR THAT ROUTINE WILL BE TURNED ON, A MESSAGE
C          WILL BE PRINTED, AND CONTROL WILL BE RETURNED TO THE
C          CALLING PROGRAM.
C
C     AUTHOR & REVISION HISTORY
C     -------------------------
C     MAY 1979     - WRITTEN, P. BUMBULIS
C
*CALL ALRCOM
C     FOR A COMPLETE DESCRIPTION OF THE COMMON BLOCKS, PLEASE SEE THE
C     WRITE UP IN "ALEROF".
C
C     VARIABLES USED/FUNCTIONS CALLED:
C     -------------------------------
C (A) ROUTNE,ERROR - DESCRIBES THE ERROR MESSAGE(S) TO TURN ON
C     ERRFLG - SET TO 1 (USUALLY 0) IF INTERNAL TABLES OVERFLOW
C     INDEX  - INDEX INTO THE TABLES
C     ALRTST - FUNCTION TO TEST IF WE WOULD PRINT A MESSAGE OR NOT
C     PRINT  - .TRUE. IF WE WOULD PRINT IT
C     ALRINI - INITIALIZATION ROUTINE
C *** (A) DENOTES THAT THE VARIABLE IS A FORMAL PARAMETER (ARGUMENT)
C
      INTEGER ROUTNE,ERROR,ERRFLG,INDEX
      LOGICAL PRINT,ALRTST
C
*CALL STATF
      CALL ALRINI
C
      IF (ROUTNE .NE. 0) GO TO 5
C
C        TURN ON ALL MESSAGES
C
         NLAST = 0
      RETURN
    5    IF (ERROR .NE. 0) GO TO 10
C
C           TURN ON ALL MESSAGES ASSOCIATED WITH GIVEN ROUTINE
C
            CALL ALRDEL(ROUTNE)
         RETURN
C
C           TURN ON A SPECIFIC MESSAGE
C
   10       PRINT = ALRTST(ROUTNE,ERROR,INDEX)
            IF (PRINT) RETURN
               IF (INDEX .EQ. 0) GO TO 20
                  ROUTAB(INDEX) = 0
               RETURN
   20             CALL ALRFND(INDEX,ERRFLG)
                  IF (ERRFLG .NE. 0) GO TO 30
                     ROUTAB(INDEX) = ROUTNE
                     ERRTAB(INDEX) = ERROR
                  RETURN
   30                CALL ALRDEL(ROUTNE)
                     PRINT 35
*IF -DEF,AELIB5
   35                FORMAT(" ***TOO MANY ERROR CONTROL REQUESTS - ",
     *                      "EXPAND TABLE IF NECCESSARY")
*ENDIF
*IF DEF,AELIB5
   35                FORMAT(' ***TOO MANY ERROR CONTROL REQUESTS - ',
     *                      'EXPAND TABLE IF NECCESSARY')
*ENDIF
                     CALL TRACEB(0)
                  RETURN
      END
