*DECK ARSINH
      REAL FUNCTION ARSINH(X)
C
C                                      S.BERUBE  JUNE 1974
C THIS FUNCTION CALCULATES THE INVERSE HYPERBOLIC SIN.  IT USES THE
C CHEBYSHEV SERIES.
C REF. CHEBYSHEV SERIES FOR MATHEMATICAL FUNCTIONS BY C.W. CLENSHAW
C MATHEMATICAL TABLES, VOL.5   TABLE 7  P.26
C
      REAL B(19), A(17), C(17)
C
C     A IS AN ARRAY OF THE CHEBYSHEV COEFFICIENTS
C
      DATA A / 1.87179960088262,  -.058811761189952,  .004727465432212,
     ,-.000493836316265, .585062070586E-04,  -.746699832893E-05,
     ,.100116935836E-05, -.139035438587E-06,  .1982316948E-07,
     ,-.288474684E-08,  .42672965E-09,  -.6397608E-10,  .96991686E-11,
     ,-.14844E-11,  .229037E-12,  -.355884E-13,  .556E-14 /
      DATA C / 1.58703862545432,  .093506080153667,  -.006189818258529,
     ,.000598521242397,  -.6797708624157E-4,  .844638113659E-5,
     ,-.111164105746E-5,  .15228226661E-6,  -.21485481E-7,
     ,.310080617E-8,  -.45560923E-9,  .6792544E-10,  -.102496E-10,
     ,.156238E-11,  -.24023E-12,  .3721E-13,  -.58E-14 /
C
*IF -DEF,AELIB5
  101 FORMAT (///,* ARSIN CALLED WITH    X < -1.    = *, G10.3, * IS SET
     , TO INFINITY*)
*ENDIF
*IF DEF,AELIB5
  101 FORMAT (///,' ARSIN CALLED WITH    X < -1.    = ', G10.3, ' IS SET
     , TO INFINITY')
*ENDIF
*CALL  STATF
      CALL PRESET (B,19,0.0)
C
         IF (ABS(X) .LE. 1.) GO TO 30
         GO TO 50
C
C     THEN
C
C
C     THIS LOOP CALCULATES THE ARRAY B, STARTING FROM B(16) TO B(0)
C     B(0) AND B(2) WILL GET THE ANSWER
C
   30       DO 40 IND = 1, 17
              L = 18 - IND
              B(L) = 2. * (2. *X*X - 1.) * B(L+1) - B(L+2) + A(L)
   40       CONTINUE
            ARSINH = .5 *X * (B(1) - B(3))
            RETURN
C
C     ELSE
C
   50       DO 60 IND = 1, 17
               L = 18 - IND
               B(L) = 2. * (2./(X*X)- 1.) * B(L+1) - B(L+2) + C(L)
   60       CONTINUE
            Y=ABS(X)
            ARSINH=SIGN(Y,X)/Y*(ALOG(Y)+.5*(B(1)-B(3)))
            RETURN
         END
