*DECK BESGEN
      SUBROUTINE BESGEN (X,N,BESIJ,BESKY,M,NCALC)
C  WRITTEN BY A. PERREAULT JUNE 1974
C  X AND N  ARE THE OBVIOUS
C  BESIJ ARRAY TO HOLD I"S OR J"S
C  BESKY ARRAY TO HOLD K"S OR Y"S
C  M = +1   FOR I"S AND K"S
C      -1   FOR J"S AND Y"S
C  BES     ARRAY TO HOLD VALUES FROM AI0BES , AI1BES , AK0BES , AK1BES
C     AND AJYBES.
C  NCALC     TO HOLD NUMBER OF ELEMENTS SUCCESSFULLY CALCULATED
C             MACHINE DEPENDENT CONSTANTS
C   NSIG   DECIMAL SIGNIFICANCE DESIRED SHOULD BE SET TO
C          IFIX(ALOG10(2)*NBIT+1),  WHERE NBIT IS THE NUMBER OF BITS IN
C          THE MANTISSA OF A VARIABLE (MAXIMUM PRECISION OF THE MACHINE)
C          NSIG HIGHER WILL INCREASE CPU TIME WHITOUT INCREASING
C          ACCURACY, NSIG LOWER WILL DECREASE ACCURACY.
C
C   NTEN   LARGEST INTEGER K SUCH THAT 10**K IS MACHINE REPRESENTABLE
C          IN A FLOATING POINT VARIABLE.
C
C                            ERROR RETURNS
C   IN CASE OF AN ERROR, NCALC .NE. NPLUS1, NOT ALL I-J*S ARE CALCULATED
C   TO THE DISIRED ACCURATY.
C   N .GE. NCALC .GT. 0 WILL OCCOR IF N IS MUCH GREATER THAN MAGX.
C   IN THIS CASE, BESIJ IS CALCULATED TO THE DISIRED ACCURACY FOR
C   N .LE. NCALC, BUT FOR NCALC .LT. N .LE. NPLUS1, INDEFINITE VALUES
C   ARE SET.
C
C   REVISION HISTORY :
C
C        -REVISED JUN 5, 1980 TO CHANGE UPPER LIMIT ON X  FROM 667.5 TO
C         667.2 TO ACHIEVE IDENTICAL RESULTS ON BOTH MAIN FRAMES.
C         (SEE CONSULTING REPORTS 80-19, 80-20)
C
      DIMENSION BESIJ(1),BESKY(1),BES(4)
      DATA NSIG,NTEN,XLARGE/14,293,667.2/
*CALL  STATF
C
C     MSG1 AND MSG2 ARE THE INTEGERS REFFERING TO ERROR MESSAGES IN
C     AELERR
C
C     MSG1=205   " BESGEN HAS ONLY CALCULATED THE FIRST NCALC
C     ELEMENTS. ALL OTHER ELEMENTS ARE SET TO INFINITY.
      MSG1=205
C
C     MSG2=206   " ILLEGAL ARGUMENT SENT TO BESGEN . VALID ARGUMENTS
C     ARE N \ 2 , 0. @ X @ 667.5 , M= +1 OR M= -1
      MSG2=206
      NPLUS1=N+1
      NCALC = NPLUS1
      MAGX = IFIX(X)
      IF (M .NE. 1  .AND.  M .NE. -1) GO TO 998
      IF (X) 998,997,20
 20   IF (N .LT. 2  .OR.  X .GT. XLARGE) GO TO 998
C
C   INITIALIZE THE CALCULATION OF P*S
C
      NBMX = N+1 - MAGX
      NB = MAGX + 1
      PLAST = 1.E0
      P = FLOAT(2*NB) / X
C
C    CALCULATE GENERAL SIGNIFICANCE TEST
C
      TEST = 2.E0 * 1.E1 ** NSIG
      IF(M .EQ. 1 .AND. 2*MAGX .GT. 5*NSIG)  TEST = SQRT(TEST*P)
      IF(M .EQ. 1 .AND. 2*MAGX .LE. 5*NSIG)  TEST = TEST/1.585**MAGX
      MM = 0
      IF(NBMX .LT. 3) GOTO 4
C
C    CALCULATE P*S UNTIL NB = N. CHECK FOR POSSIBLE OVERFLOW
C
      TOVER = 1.E1**(NTEN-NSIG)
      NSTART = MAGX + 2
      DO 3 NB=NSTART , N
         POLD = PLAST
         PLAST = P
         P = FLOAT(2*NB)*PLAST/X+M*POLD
         IF(P-TOVER) 3,3,5
    3 CONTINUE
      NB = N
C
C    CALCULATE SPECIAL SIGNIFICANCE TEST FOR NBMX .GT. 2
C
      TEST = AMAX1(TEST,SQRT(PLAST*1.E1**NSIG)*SQRT(2.E0*P))
C
C    CALCULATE P*S UNTIL SIGNIFICANCE TEST PASSES
C
    4 NB = NB + 1
         POLD = PLAST
         PLAST = P
         P = FLOAT(2*NB)*PLAST/X+M*POLD
      IF(P .LT. TEST) GO TO 4
C
C    FOR J*S A STRONG VARIANT OF THE TEST IS NECESSARY
C
      IF(M .EQ. 1 .OR. MM .EQ. 1)  GO TO 12
C
C    CALCULATE IT, AND CALCULATE P*S UNTIL THIS TEST IS PASSED.
C
      MM = 1
      TEMPB = P/PLAST
      TEMPC = FLOAT(NB+1)/X
      IF(TEMPB+1.E0/TEMPB .GT. 2.E0*TEMPC) TEMPB = TEMPC+SQRT(TEMPC**
     12-1.E0)
      TEST = TEST/SQRT(TEMPB-1.E0/TEMPB)
      IF(P-TEST) 4,12,12
C
C    TO AVOID OVERFLOW, DIVIDE P*S BY TOVER. CALCULATE P*S UNTIL
C    ABS(P) .GT. 1.
C
    5 TOVER = 1.E1**NTEN
      P = P/TOVER
      PLAST = PLAST/TOVER
      PSAVE = P
      PSAVEL = PLAST
      NSTART = NB + 1
    6 NB = NB + 1
         POLD  = PLAST
         PLAST = P
         P = FLOAT(2*NB)*PLAST/X+M*POLD
      IF(P .LE. 1.E0) GO TO 6
      TEMPB = FLOAT(2*NB)/X
      IF(M .EQ. 1) GO TO 8
      TEMPC = .5E0*TEMPB
      TEMPB = PLAST/POLD
      IF(TEMPB+1.E0/TEMPB .GT. 2.E0*TEMPC) TEMPB = TEMPC+SQRT(TEMPC**
     12-1.E0)
C
C    CALCULATE BACKWARD TEST , AND FIND NCALC( THE HIGHEST N
C    SUCH THAT THE TEST IS PASSED
C
    8 TEST = .5E0*POLD*PLAST*(1.E0-1.E0/TEMPB**2)/1.E1**NSIG
      P = PLAST*TOVER
      NB = NB-1
      NEND = MIN0(N+1,NB)
      DO 9 NCALC = NSTART , NEND
         POLD = PSAVEL
         PSAVEL = PSAVE
         PSAVE = FLOAT(2*NB)*PSAVEL/X+M*POLD
         IF(PSAVE*PSAVEL - TEST) 9,9,10
    9 CONTINUE
      NCALC = NEND + 1
 10   NCALC = NCALC - 1
*IF -DEF,AELIB5
   12 TERM=0.   $   SCALE=1. / P    $   Y=1./X
*ENDIF
*IF DEF,AELIB5
   12 TERM=0.
      SCALE=1. / P
      Y=1./X
*ENDIF
C
C     UP TO STATEMENT 70 DOES BACKWARD RECURSION OUTSIDE THE BESIJ
C     ARRAY BOUNDS SINCE NB \ N
C
 60   RINT=SCALE*(NB+NB)*Y+M*TERM
         IF (NB .LT. NCALC) GO TO 70
*IF -DEF,AELIB5
         TERM=SCALE   $   SCALE=RINT
*ENDIF
*IF DEF,AELIB5
         TERM=SCALE
         SCALE=RINT
*ENDIF
         NB = NB - 1
      GO TO 60
 70   IF (M .EQ. -1) GO TO 80
      BES(1)=AI0BES(X)
      BES(2)=AI1BES(X)
      BES(3)=AK0BES(X)
      BES(4)=AK1BES(X)
      GO TO 85
*IF -DEF,AELIB5
 80   BES(1)=AJYBES(X,BES,1)
   85 BESKY(1)=BES(3)     $     BESKY(2)=BES(4)
*ENDIF
*IF DEF,AELIB5
 80   BES(1)=AJYBES(X,BES(1),1)
   85 BESKY(1)=BES(3)
      BESKY(2)=BES(4)
*ENDIF
      BESIJ(NCALC)=SCALE
      BESIJ(NCALC-1) = RINT
C
C     LOOP 100 DOES BACKWARD RECURSION FOR THE I"S AND J"S AND
C     FORWARD RECURSION FOR THE K"S AND Y"S
C
      DO 100 J=3,NCALC
         NN=NCALC-J+1
         BESKY(J)=(J+J-4)*Y*BESKY(J-1)+M*BESKY(J-2)
 100  BESIJ(NN)=BESIJ(NN+1)*(NN+NN)*Y+M*BESIJ(NN+2)
      IF (NCALC .EQ. NPLUS1)  GO TO 29
C
C   SETTING THE UNCALCULATED ELEMENTS TO INFINITY
C
*IF -DEF,AELIB5
      CALL AELERR(MSG1,2HNF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MSG1,'NF')
*ENDIF
      NN = NCALC + 1
      DO 101 J= NN , NPLUS1
*IF -DEF,AELIB5
 101  BESIJ(J) = BESKY(J) = 37777777777777777777B
*ENDIF
*IF DEF,AELIB5
 101  BESIJ(J) = BESKY(J) = O"37777777777777777777"
*ENDIF
C
C     DETERMINE THE SCALE FACTOR AND ADJUST THE BACKWARD RECURSION
C     VALUES ACCORDINGLY
C
C
C   USE ASCENDING SERIES FOR SMALL X
C
 29   IF (X**4 .GE. .1**NSIG) GO TO 30
      BES(1) = 1. + .25 * X * X * M
   30 CONTINUE
      SCALE=BES(1)/BESIJ(1)
      DO 150 J=1,NCALC
 150  BESIJ(J)=SCALE*BESIJ(J)
 999  RETURN
C
C   ARGUMENT ERROR
C
*IF -DEF,AELIB5
998   CALL AELERR(MSG2,2HNF)
*ENDIF
*IF DEF,AELIB5
998   CALL AELERR(MSG2,'NF')
*ENDIF
      DO 102 J = 1 , NPLUS1
*IF -DEF,AELIB5
 102  BESIJ(J) = BESKY(J) = 37777777777777777777B
*ENDIF
*IF DEF,AELIB5
 102  BESIJ(J) = BESKY(J) = O"37777777777777777777"
*ENDIF
      NCALC = 0
      GO TO 999
*IF -DEF,AELIB5
 997  BESIJ(1) = 1.     $     BESKY(1)=37770000000000000000B
*ENDIF
*IF DEF,AELIB5
 997  BESIJ(1) = 1.
      BESKY(1)=O"37770000000000000000"
*ENDIF
      DO 200 J=2,NPLUS1
      BESIJ(J)=0.
*IF -DEF,AELIB5
 200  BESKY(J)=37770000000000000000B
*ENDIF
*IF DEF,AELIB5
 200  BESKY(J)=O"37770000000000000000"
*ENDIF
      GO TO 999
      END
