*DECK CEL3
      FUNCTION CEL3(XN,XXM,EPS)
C
C                                              L.YAMAZAKI  MARCH 1974
C MODIFIED BY L EVANS TO CHANGE FORMAL PARAMETER XM TO XXM
C        BECAUSE XM REDEFINED AT ENTRY EL3COMP          JAN 1976
C
C FUNCTION SUBPROGRAM TO CALCULATE THE COMPLETE ELLIPTIC INTEGRAL OF THE
C THIRD KIND USING FORMULAS FROM
C        GROBNER AND HOFREITER, INTEGRALTAFEL, 1958, PAGES 42-43
C
C EPS IS THE RELATIVE ERROR CRITERION REQUIRED BY EINCO.
C
C CHECK INPUT PARAMETERS
C
*CALL  STATF
      XM=XXM
      IF (XN .GE. 1.) GO TO 40
      IF (XM .GE. 1.) GO TO 50
      IF (XM .LT. 0.) GO TO 50
      IF (XN .EQ. 0.) GO TO 60
C
C AT THIS POINT, BOTH PARAMETERS  HAVE BEEN CHECKED AND IF ILLEGAL,
C CONTROL TRANSFERRED TO APPROPRIATE ERROR EXIT.  CALCULATION WILL
C NOW PROCEED BY ONE OF THE FOLLOWING THREE FORMULAS.
C
C
      X=1.-XM
      X1=XM
      XK=ELK(XM)
      XE=ELE(XM)
 10   XS=SQRT(X)
      YS=SQRT(XM)
      XMR=1./(XM-XN)
C
      IF (XN  .GT. 0.) GO TO 20
C
C
C                 FORMULA A       XN  <  0
C                 ---------
C
              PHI=ASIN(SQRT(-XN *XMR))
              CPHI=COS(PHI)
              CALL EINCO(X1,PHI,CPHI,3,F,E,EPS)
              CEL3=XM*XMR*XK+SQRT(-XN/(1.-XN)*XMR)
     ,             *((XE-XK)*F+XK*E)
              RETURN
C
C
 20   IF(XN  .GT.XM) GO TO 30
C
C
C                 FORMULA B    0<XM<XN<1
C                 ---------
C
              PHI=ASIN(SQRT(XN )/YS)
              CPHI=COS(PHI)
              CALL EINCO(X,PHI,CPHI,3,F,E,EPS)
              CEL3=XK-SQRT(XN /(1.-XN )*XMR)
     ,             *(XE*F-XK*E)
              RETURN
C
C
C                 FORMULA C   0<XN<XM<1
C                 ---------
C
 30           PHI=ASIN(1./XS*SQRT((XM-XN)/(-XN )))
              CPHI=COS(PHI)
              CALL EINCO(X1,PHI,CPHI,3,F,E,EPS)
              CEL3=SQRT(-XN /(1.-XN )*XMR)*
     ,             ((XE-XK)*F+XK*E)
              RETURN
C
C
C
*IF -DEF,AELIB5
      ENTRY EL3COMP
*ENDIF
*IF DEF,AELIB5
      ENTRY EL3COMP(XN,XXM,EPS)
*ENDIF
C
*CALL  STATF
      XM=XXM
      IF (XN .GE. 1.) GO TO 40
      IF (XN  .EQ. 0.) GO TO 70
      X=XM
      XM=1.-X
      X1=XM
      IF (XM .GE. 1.) GO TO 50
      IF (XM .LT. 0.) GO TO 50
         XK=ELKCOMP(X)
         XE=ELECOMP(X)
         GO TO 10
C
C ERROR EXITS
C
*IF -DEF,AELIB5
 40   CEL3=37770000000000000000B
*ENDIF
*IF DEF,AELIB5
 40   CEL3=O"37770000000000000000"
*ENDIF
      PRINT 1000,XN
      RETURN
*IF -DEF,AELIB5
 50   CEL3=37770000000000000000B
*ENDIF
*IF DEF,AELIB5
 50   CEL3=O"37770000000000000000"
*ENDIF
      PRINT 1001,XM
      RETURN
 60   CEL3=ELK(XM)
      RETURN
 70   CEL3=ELKCOMP(XM)
      RETURN
C
*IF -DEF,AELIB5
 1000 FORMAT (1H0,"CEL3,EL3COMP ENTERED WITH ILLEGAL N=",E15.6,5X,
     ,"FUNCTION SET TO INFINITY")
 1001 FORMAT (1H0,"CEL3,EL3COMP ENTERED WITH ILLEGAL M=",E15.6,5X,
     ,"FUNCTION SET TO INFINITY")
*ENDIF
*IF DEF,AELIB5
 1000 FORMAT (1H0,'CEL3,EL3COMP ENTERED WITH ILLEGAL N=',E15.6,5X,
     ,'FUNCTION SET TO INFINITY')
 1001 FORMAT (1H0,'CEL3,EL3COMP ENTERED WITH ILLEGAL M=',E15.6,5X,
     ,'FUNCTION SET TO INFINITY')
*ENDIF
C
      END
