*DECK CGAMMA
      COMPLEX FUNCTION CGAMMA(ZM)
*IF -DEF,AELIB5
      COMPLEX Z,ZM,T,TT,SUM,TERM,RTPI,PI
*ENDIF
*IF DEF,AELIB5
      COMPLEX Z,ZM,T,TT,SUM,TERM,RTPI,PI,CGAMLN
*ENDIF
      DIMENSION C(9)
***ARRAY C CONTAINS THE OCTAL VALUES OF C(J)=B(2J)/((2J)(2J-1)) WHERE
***B(2J) IS THE (2J)TH BERNOULLI NUMBER
***NOTE RTPI=LN(SQRT(2*PI))
*IF -DEF,AELIB5
      DATA PI/(3.14159265358979,0.)/,RTPI/(.918938533204674,0.)/,C/
     117145252525252525252B,60702237223722372237B,17056400640064006400B,
     260723077307730773077B,17056712436126143771B,60710112517114633034B,
     317106440644064406440B,60650336571151702543B,17155577226160170063B/
*ENDIF
*IF DEF,AELIB5
      DATA PI/(3.14159265358979,0.)/,RTPI/(.918938533204674,0.)/,C/
     1O"17145252525252525252",O"60702237223722372237",O"1705640064006400
     26400",O"60723077307730773077",O"17056712436126143771",O"6071011251
     37114633034",O"17106440644064406440",O"60650336571151702543",O"1715
     35577226160170063"/
*ENDIF
      DATA TOL/1.E-14/
*IF -DEF,AELIB5
 900  FORMAT (*0ERROR IN CGAMMA - ARGUMENT*2G15.7* TOO CLOSE TO POLE*/)
 910  FORMAT (*0ERROR IN CGAMMA - STIRLINGS SERIES HAS NOT CONVERGED FOR
     1*2G15.7/)
*ENDIF
*IF DEF,AELIB5
 900  FORMAT ('0ERROR IN CGAMMA - ARGUMENT',2G15.7,' TOO CLOSE TO POLE'/
     +)
 910  FORMAT ('0ERROR IN CGAMMA - STIRLINGS SERIES HAS NOT CONVERGED FOR
     1',2G15.7/)
*ENDIF
*CALL  STATF
      LN=0
      GOTO 5
***ENTRY POINT FOR LN(CGAMMA)
*IF -DEF,AELIB5
      ENTRY CGAMLN
*ENDIF
*IF DEF,AELIB5
      ENTRY CGAMLN(ZM)
*ENDIF
*CALL  STATF
      LN=1
 5    IFLEK=0
*IF -DEF,AELIB5
      Z=ZM   $   X=REAL(Z)   $   Y=AIMAG(Z)
*ENDIF
*IF DEF,AELIB5
      Z=ZM
      X=REAL(Z)
      Y=AIMAG(Z)
*ENDIF
***DETERMINE IF Z IS TOO CLOSE TO A POLE
      IF (X .GE. TOL) GO TO 20
      IF (((X-INT(X-.5))**2+Y*Y) .GE. TOL*TOL) GOTO 10
      PRINT 900,Z
*IF -DEF,AELIB5
      CGAMMA=37770000000000000000B
*ENDIF
*IF DEF,AELIB5
      CGAMMA=O"37770000000000000000"
*ENDIF
      RETURN
***FOR REAL(Z) < 0. USE THE REFLECTION FORMULA
***            GAMMA(Z)*GAMMA(1-Z)=PI/SIN(PI*Z)
***AND COMPUTE GAMMA(1-Z).REFLEK IS A TAG TO INDICATE THIS RELATIONSHIP
***MUST BE USED LATER
 10   IF (X .GE. 0.) GO TO 20
      IFLEK=1
      Z=(1.,0.)-Z
      X=1.-X
      Y=-Y
***MAKE REAL(Z) > 10 AND ARG(Z) < PI/4
 20   M=0
 40   IF (X .GE. 10.) GO TO 50
      X=X+1.
      M=M+1
      GO TO 40
 50   IF (ABS(Y) .LT. X) GO TO 60
      X=X+1.
      M=M+1
      GO TO 50
 60   T=CMPLX(X,Y)
      TT=T*T
      SUM=(T-(.5,0.))*CLOG(T)-T+RTPI
***TEST REAL AND IMAGINARY PARTS OF LN(GAMMA(Z)) SEPARATELY FOR
***CONVERGENCE. IF Z IS REAL,SKIP IMAGINARY PART OF CHECK.
      DO 70 J=1,9
      TERM=C(J)/T
      IF (ABS(REAL(TERM)) .GE. TOL*ABS(REAL(SUM))) GOTO 80
      IF (Y .EQ. 0.) GO TO 100
      IF (ABS(AIMAG(TERM)) .LT. TOL*ABS(AIMAG(SUM))) GOTO 100
 80   SUM=SUM+TERM
 70   T=T*TT
      PRINT 910,ZM
***RECURSION RELATION USED TO GET LN(GAMMAZ))
***            LN(GAMMA(Z))=LN(GAMMA(Z+M)/(Z*(Z+1)*...*(Z+M-1)))
 100  IF (M .EQ. 0) GO TO 120
      DO 110 J=1,M
 110  SUM=SUM-CLOG(Z+J-1.)
***CHECK IF REFLECTION FORMULA SHOULD BE USED
***CONSTANT = CLOG(PI)
 120  IF (IFLEK .EQ. 1) SUM=(1.14472988584940,0.)-(CLOG(CSIN(PI*Z))+SUM)
      CGAMMA=SUM
      IF (LN .EQ. 0) CGAMMA=CEXP(SUM)
      RETURN
      END
