*DECK CHISQ
      FUNCTION CHISQ ( ESTIM, DEGFRM )
C***********************************************************************
C***
C***
C***     THIS FUNCTION RETURNS THE PROBABILITY OF OBTAINING A
C***     CHI-SQUARED STATISTIC AT LEAST AS LARGE AS THE SPECIFIED
C***     ESTIMATE.
C***
C***                 IT IS COMPUTED AS THE RATIO OF INCOMPLETE AND
C***                 COMPLETE GAMMA FUNCTIONS, USING
C***
C***                    HANDBOOK OF MATH. FUNCTIONS
C***                    ( STEGUN AND ABRAMOWITZ )
C***                    2ND FORMULA  26.4.19 - P. 941
C***
C***
C***          ESTIM  CHI-SQUARED STATISTIC TO BE TESTED
C***
C***          DEGFRM NUMBER OF DEGREES OF FREEDOM ASSOCIATED WITH
C***                 ESTIM
C***
C***
C***********************************************************************
      INTEGER DEGFRM
*CALL  STATF
C*** IF ERROR CONDITION DETECTED, RESULTING PROB IS SET TO -VE INDEF.
*IF -DEF,AELIB5
      CHISQ = 60000000000000000000B
*ENDIF
*IF DEF,AELIB5
      CHISQ = O"60000000000000000000"
*ENDIF
      IF ( ESTIM .GE. 0.0 .AND. DEGFRM .GE. 1 ) GO TO 100
      IF ( ESTIM .LT. 0.0 ) PRINT 55
      IF ( DEGFRM .LT. 1 ) PRINT 77
      GO TO 500
*IF -DEF,AELIB5
   55 FORMAT ( * ERROR IN CHISQ - ATTEMPTING TO TEST A NEGATIVE CHI - *,
     1         *SQUARED ESTIMATE * )
  77  FORMAT ( * ERROR IN CHISQ - DEGREES OF FREEDOM LESS THAN 1 * )
*ENDIF
*IF DEF,AELIB5
   55 FORMAT ( ' ERROR IN CHISQ - ATTEMPTING TO TEST A NEGATIVE CHI - ',
     1         'SQUARED ESTIMATE ' )
  77  FORMAT ( ' ERROR IN CHISQ - DEGREES OF FREEDOM LESS THAN 1 ' )
*ENDIF
  100 IF ( DEGFRM .LE. 320 .AND. ESTIM .LE. 200 ) GO TO 200
      PRINT 150
*IF -DEF,AELIB5
  150 FORMAT ( * ERROR IN CHISQ - PARAMETER(S) TOO LARGE * )
*ENDIF
*IF DEF,AELIB5
  150 FORMAT ( ' ERROR IN CHISQ - PARAMETER(S) TOO LARGE ' )
*ENDIF
      RETURN
  200 ARG = FLOAT ( DEGFRM ) / 2.0
      S = ESTIM / 2.0
      CHISQ = GAMIN ( ARG, S ) / GAMMA ( ARG )
 500  RETURN
      END
