*DECK COMBES
      SUBROUTINE COMBES (X,N,BESIJ,M,NCALC)
*  WRITTEN BY A. PERREAULT MAY 1974
*  X AND N  ARE THE OBVIOUS
*  BESIJ ARRAY TO HOLD I"S OR J"S
C  M = +1   FOR I"S
C      -1   FOR J"S
C             MACHINE DEPENDENT CONSTANTS
C   NSIG   DECIMAL SIGNIFICANCE DESIRED SHOULD BE SET TO
C          IFIX(ALOG10(2)*NBIT+1),  WHERE NBIT IS THE NUMBER OF BITS IN
C          THE MANTISSA OF A VARIABLE (MAXIMUM PRECISION OF THE MACHINE)
C          NSIG HIGHER WILL INCREASE CPU TIME WHITOUT INCREASING
C          ACCURACY, NSIG LOWER WILL DECREASE ACCURACY.
C
C   NTEN   LARGEST INTEGER K SUCH THAT 10**K IS MACHINE REPRESENTABLE
C          IN A FLOATING POINT VARIABLE.
C
C    EXPARG   THE LARGEST ARGUMENT THAT THE LIBRARY EXP ROUTINE CAN
C             HANDLE.
C
C
C                            ERROR RETURNS
C   IN CASE OF AN ERROR, NCALC .NE. NPLUS1, NOT ALL I-J*S ARE CALCULATED
C   TO THE DISIRED ACCURATY.
C   N .GE. NCALC .GT. 0 WILL OCCOR IF N IS MUCH GREATER THAN MAGX.
C   IN THIS CASE, BESIJ IS CALCULATED TO THE DISIRED ACCURACY FOR
C   N .LE. NCALC, BUT FOR NCALC .LT. N .LE. NPLUS1, PRECISION IS LOST.
C
      COMPLEX BESIJ(1),SUM
      COMPLEX X,P,PLAST,POLD,PSAVE,TEMPC,TEMPB,XINV,PINV
      DATA NSIG,NTEN,EXPARG/14,293,741.667/
*IF -DEF,AELIB5
 444  FORMAT (/* ARGUMENT ERROR IN BESIKJY(*,I5*,*F10.4*)*)
*ENDIF
*IF DEF,AELIB5
 444  FORMAT (/' ARGUMENT ERROR IN BESIKJY(',I5,',',F10.4,')')
*ENDIF
*CALL  STATF
      NPLUS1=N+1
      IF(M .EQ. 1 .AND. ABS(REAL(X)) .LT. EXPARG)  GO TO 999
      IF(M .NE. -1 .OR. ABS(AIMAG(X)) .GE. EXPARG)  GO TO 998
 999  XMAGX = CABS(X)
      MAGX = IFIX(XMAGX)
      IF (N .LT. 0) GO TO 998
      NCALC = NPLUS1
C
C   USE TWO-TERM ASCENDING SERIES FOR SMALL X
C
      IF(XMAGX**4 .LT. .1**NSIG)  GO TO 50
C
C   INITIALIZE THE CALCULATION OF P*S
C
      NBMX = NPLUS1 - MAGX
      NB = MAGX + 1
*IF -DEF,AELIB5
      RX = REAL(X) $ AIX = AIMAG(X)
*ENDIF
*IF DEF,AELIB5
      RX = REAL(X)
      AIX = AIMAG(X)
*ENDIF
      IF(ABS(RX) .LT. ABS(AIX)) GO TO 1
      A = 1. / (RX+AIX*AIX/RX)
      B = -AIX * A / RX
      GO TO 2
    1 B = -1. / (AIX+RX*RX/AIX)
      A = -RX*B/AIX
    2 XINV = CMPLX(A,B)
      PLAST = (1.,0.0)
      P =-M*FLOAT(2*NB)*XINV
      TEST = 2.E0 * 1.E1 ** NSIG
      MM = 0
      IF(NBMX .LT. 3) GOTO 4
C
C    CALCULATE P*S UNTIL NB = N. CHECK FOR POSSIBLE OVERFLOW
C
      TOVER = 1.E1**(NTEN-NSIG)
      NSTART = MAGX + 2
      DO 3 NB=NSTART , N
         POLD = PLAST
         PLAST = P
         P =-M*(FLOAT(2*NB)*(PLAST*XINV)-POLD)
         IF((CABS(P)/TOVER) -1.) 3,3,5
    3 CONTINUE
      NB = N
C
C    CALCULATE SPECIAL SIGNIFICANCE TEST FOR NBMX .GT. 2
C
      TEMB = AMAX1(ABS(REAL(P)),ABS(AIMAG(P)))
      TEMB = TEMB * SQRT(2.*10.**NSIG*(CABS(P)/TEMB)*(CABS(PLAST)/TEMB))
      TEST = AMAX1(TEST,TEMB)
C
C    CALCULATE P*S UNTIL SIGNIFICANCE TEST PASSES
C
    4 NB = NB + 1
         POLD = PLAST
         PLAST = P
         P =-M*(FLOAT(2*NB)*(PLAST*XINV)-POLD)
      IF(CABS(P)/TEST .LT. 1.)  GO TO 4
      IF(MM .EQ.1)  GO TO 12
C
C      CALCULATE STRICT VARIANT OF SIGNIFICANCE TEST AND
C      CALCULATE P*S UNTIL THIS TEST IS PASSED.
C
      MM = 1
      TEMBR = CABS(P)/CABS(PLAST)
      TEMBI = FLOAT(NB+1) / XMAGX
      IF(TEMBR + 1./TEMBR .GT. 2.*TEMBI)  TEMBR =
     ,             TEMBI + SQRT(TEMBI*TEMBI - 1.)
      TEST = TEST/SQRT(TEMBR-1./TEMBR)
      IF(CABS(P)/TEST - 1.) 4,12,12
    5 NSTART = NB + 1
C
C   TO AVOID OVERFLOW, NORMALIZE P*S BY DIVIDING BY TOVER
C   CALCULATE P*S UNTIL UNNORMALIZED P WOULD OVERFLOW
C
      P = CMPLX(REAL(P)/TOVER,AIMAG(P)/TOVER)
      PLAST = CMPLX(REAL(PLAST)/TOVER,AIMAG(PLAST)/TOVER)
      PSAVE = P
      TEMPC = PLAST
      TEST = 10. **(2*NSIG)
    6 NB = NB + 1
         POLD  = PLAST
         PLAST = P
         P =-M*(FLOAT(2*NB)*(PLAST*XINV)-POLD)
*IF -DEF,AELIB5
      IF(P*CONJG(P) .LE. TEST)  GO TO 6
*ENDIF
*IF DEF,AELIB5
      IF(REAL(P*CONJG(P) ).LE. TEST)  GO TO 6
*ENDIF
C
C    CALCULATE BACKWARD TEST , AND FIND NCALC( THE HIGHEST N
C    SUCH THAT THE TEST IS PASSED
C
      TEMBR = CABS(PLAST) / CABS(POLD)
      TEMBI = FLOAT(NB)/XMAGX
      IF(TEMBR + 1./TEMBR .GT. 2.*TEMBI)  TEMBR = TEMBI+SQRT(TEMBI
     1 *TEMBI-1.)
      TEST = .5 * (1.-1./(TEMBR*TEMBR))/10.**NSIG
      TEST = PLAST*CONJG(PLAST) * TEST * ((POLD*CONJG(POLD))* TEST)
      P = PLAST*TOVER
      NB = NB-1
      NEND = MIN0(N+1,NB)
      DO 9 NCALC = NSTART , NEND
         POLD = TEMPC
         TEMPC = PSAVE
         PSAVE =-M*(FLOAT(2*NB)*(PLAST*XINV)-POLD)
*IF -DEF,AELIB5
         IF(PSAVE*CONJG(PSAVE)*(TEMPC*CONJG(TEMPC)) - TEST) 9,9,10
*ENDIF
*IF DEF,AELIB5
         IF(REAL(PSAVE*CONJG(PSAVE)*(TEMPC*CONJG(TEMPC)) - TEST) )9,9,10
*ENDIF
    9 CONTINUE
         NCALC = NEND + 1
 10   NCALC = NCALC - 1
C
C   THE COEFFICIENT OF BESIJ(N) IN THE NORMALIZATION SUM IS
C   MM*SQRT(-1)**IMAG, WHERE MM = -2,0, OR 2, AND IMAG IS 0 OR 1.
C   CALCULATE RECURSION RULES FOR MM AND IMAG, AND INITIALIZE THEM.
C
   12 NB = NB + 1
      IZE = (M+1)/2
      TEMBR = IZE * RX + (1-IZE) * AIX
      IPOS = 0
      IF(TEMBR) 13,14,13
   13 IPOS = IFIX(1.1*TEMBR/ABS(TEMBR))
   14 MRECUR = 4 *((2+IZE+IPOS)/2)-3-2*(IZE+IPOS)
      K= 2+IPOS+2*IZE*IPOS*IPOS-IZE
      L = NB-4*(NB/4)
      MLAST = 2+8*((K*L)/4)-4*((K*L)/2)
      IF(IPOS.EQ.0 .AND.(L.EQ.1 .OR. L.EQ.3)) MLAST = 0
      L = L+3-4*((L+3)/4)
      MM = 2+8*((K*L)/4)-4*((K*L)/2)
      IF(IPOS.EQ.0 .AND.(L.EQ.1 .OR. L.EQ.3)) MM =0
      IMRECR = (1-IZE)*IPOS*IPOS
      IMAG = IMRECR*(L-2*(L/2))
C
C   INITIALISE THE BACKWARD RECURSION AND NORMALIZATION SUM
C
      TEMPB = (0.,0.)
*IF -DEF,AELIB5
      PR = REAL(P)  $  PI = AIMAG(P)
*ENDIF
*IF DEF,AELIB5
      PR = REAL(P)
      PI = AIMAG(P)
*ENDIF
      IF(ABS(PI) .GT. ABS(PR))  GO TO 15
      A = 1./(PR+PI*(PI/PR))
      B = -(PI*A)/PR
      GO TO 16
   15 B = -1./(PI+PR*(PR/PI))
      A = -(PR*B)/PI
   16 PINV = CMPLX(A,B)
      IF(IMAG .NE. 0 ) GO TO 17
      SUM = FLOAT(MM) * PINV
      GO TO 18
   17 SUM = FLOAT(MM) * CMPLX(-B,A)
   18 NEND = NB - NPLUS1
      IF(NEND) 26,22,19
C
C   RECUR BACKWARD VIA DIFFERENCE EQUATION CALCULATING (BUT NOT STORING)
C   BESIJ UNTIL NB=NPLUS1
C
   19 DO 21 L=1,NEND
         NB = NB - 1
         TEMPC = TEMPB
         TEMPB = PINV
         P = FLOAT(2*NB) * XINV
         PINV = P*TEMPB + M*TEMPC
         IMAG = (1-IMAG) * IMRECR
         K = MLAST
         MLAST = MM
         MM = K * MRECUR
         IF(IMAG .NE. 0) GO TO 20
         SUM = SUM + FLOAT(MM) * PINV
         GO TO 21
   20    SUM = SUM + CMPLX(-AIMAG(PINV),REAL(PINV)) * FLOAT(MM)
   21 CONTINUE
C
C   STORE BESIJ(NPLUS1)
C
   22 BESIJ(NB) = PINV
      IF(NB .GT. 1)  GO TO 23
C
C   NPLUS1 = 1. SINCE 2*PINV WERE ADDED TO SUM, WE MUST SUBSTRACT PINV
C
      SUM = SUM - PINV
      GO TO 35
C
C   CALCULATE AND STORE BESIJ(N)
C
   23 NB = NB - 1
      P = FLOAT(2*NB) * XINV
      BESIJ(NB) = P * PINV + M*TEMPB
      IF(NB .EQ. 1) GO TO 34
      IMAG = (1-IMAG)*IMRECR
      K = MLAST
      MLAST = MM
      MM = K * MRECUR
      IF(IMAG .NE. 0)  GO TO 24
      SUM = SUM + FLOAT(MM) * BESIJ(NB)
      GO TO 30
   24 SUM = SUM + FLOAT(MM) * CMPLX(-AIMAG(BESIJ(NB)),REAL(BESIJ(NB)))
      GO TO 30
C
C   NB .LT. NPLUS1, SO STORE BESIJ(NB), AND SET HIGHER ORDERS ZERO
C
   26 BESIJ(NB) = PINV
      NEND = -NEND
      DO 27 L=1,NEND
   27 BESIJ(NB+L) = (0.,0.)
   30 NEND = NB-2
      IF(NEND .EQ. 0) GO TO 33
C
C   CALCULATE VIA DIFFERENCE EQUATION AND STORE BESIJ(NB) UNTIL NB=2
C
      DO 32 L=1,NEND
         NB = NB - 1
         P = FLOAT(2*NB)  * XINV
         BESIJ(NB) = P * BESIJ(NB+1) + M*BESIJ(NB+2)
         IMAG = (1-IMAG)*IMRECR
         K = MLAST
         MLAST = MM
         MM = K * MRECUR
         IF(IMAG .NE. 0)  GO TO  31
         SUM = SUM + FLOAT(MM) * BESIJ(NB)
         GO TO 32
   31    SUM = SUM + FLOAT(MM)*CMPLX(-AIMAG(BESIJ(NB)),REAL(BESIJ(NB)))
   32 CONTINUE
C
C   CALCULATE AND STORE BESIJ(1)
C
*IF -DEF,AELIB5
   33 BESIJ(1) = 2. * (BESIJ(2)*XINV) + M*BESIJ(3)
*ENDIF
*IF DEF,AELIB5
   33 BESIJ(1) = 2. * (BESIJ(2)*XINV) + M*BESIJ(3)
*ENDIF
   34 SUM = SUM + BESIJ(1)
C
C   CALCULATE NORMALIZATION FACTOR, PINV
   35 IF(IZE .EQ. 1) GO TO 36
      TEMPC = CMPLX(AIMAG(X),-REAL(X)) * FLOAT(IPOS)
      GO TO 37
   36 TEMPC = X * FLOAT(IPOS)
*IF -DEF,AELIB5
   37 TCR = EXP(REAL(TEMPC))  $  TCI = AIMAG(TEMPC)
      TBR = COS(TCI)  $  TBI = SIN(TCI)
      SR = REAL(SUM)  $  SI = AIMAG(SUM)
*ENDIF
*IF DEF,AELIB5
   37 TCR = EXP(REAL(TEMPC))
      TCI = AIMAG(TEMPC)
      TBR = COS(TCI)
      TBI = SIN(TCI)
      SR = REAL(SUM)
      SI = AIMAG(SUM)
*ENDIF
      IF(ABS(SR) .LT. ABS(SI))  GO TO 38
      TCI = SI / SR
      TCR = (TCR/SR) / (1.+TCI*TCI)
      PINV = TCR * CMPLX((TBR+TBI*TCI),(TBI-TBR*TCI))
      GO TO 39
   38 TCI = SR / SI
      TCR = (TCR/SI) / (1.+TCI*TCI)
      PINV = TCR * CMPLX((TBR*TCI+TBI),(TBI*TCI-TBR))
C
C   NORMALIZE
   39 DO 40 L=1,NPLUS1
   40 BESIJ(L) = BESIJ(L) * PINV
      RETURN
  998 CONTINUE
C
C     E R R O R   R E T U R N
C
      DO 997 I=1,NPLUS1
*IF -DEF,AELIB5
  997 BESIJ(I) = CMPLX(37770000000000000000B,37770000000000000000B)
*ENDIF
*IF DEF,AELIB5
  997 BESIJ(I) = CMPLX(O"37770000000000000000",O"37770000000000000000")
*ENDIF
      NCALC = 0
      PRINT 1000,X,N,M
 1000 FORMAT(22H COMBES ARGUMENT ERROR,5X,2HZ=,2E15.8,5X,2HN=,I5,5X,2HM=
     ,,I5)
      RETURN
C
C   TWO-TERM ASCENDING SERIES FOR SMALL X
C
   50 XINV = (1.,0.)
      TEMPC = X * X * .25
      BESIJ(1) = XINV + M * TEMPC
      IF(N .EQ. 0)  GO TO 52
      TEMPC = CMPLX(-M*REAL(TEMPC),AIMAG(TEMPC))
      DO 51 NB = 2,NPLUS1
         XINV = XINV * X / FLOAT(2*NB-2)
   51 BESIJ(NB) = XINV - XINV*TEMPC/FLOAT(NB)
   52 RETURN
      END
