*DECK COMKTM
      SUBROUTINE COMKTM(IDEG, KTRM, NRK, M)
C
C
C  PURPOSE:
C
C     DEFINE A POLYNOMIAL OF GIVEN DEGREE IN ONE OR MORE INDEPENDENT
C     VARIABLES IN A FORM SUITABLE FOR USE BY THE MULTIPLE LINEAR
C     REGRESSION ROUTINES.
C
C  ENTRY:
C     CALL COMKTM(IDEG,KTRM,NRK,M)
C
C     IDEG....INTEGER, HIGHEST DEGREE OF POLYNOMIAL TO BE FITTED.
C     KTRM....INTEGER MATRIX, RETURNED BY COMKTM DEFINING THE
C                  NON-CONSTANT TERMS IN ORDER OF THE POLYNOMIAL BEING
C                  FITTED.  KTRM(I,J) IS THE POWER OF THE I-TH
C                  INDEPENDENT VARIABLE IN THE J-TH NON-CONSTANT TERM.
C     NRK.....INTEGER, NUMBER OF ROWS DIMENSIONED FOR KTRM IN THE
C                  CALLING PROGRAM.  NRK \ M.
C     M.......INTEGER, NUMBER OF INDEPENDENT VARIABLES.
C
C  EXIT:
C
C     NO ERROR EXITS - CONTROL IS RETURNED TO THE CALLING PROGRAM WITH
C     THE POLYNOMIAL DEFINED IN KTRM.
C
C  AUTHORS:     D. E. SMITH AND L. E. EVANS         JUNE 1975
C
C
      INTEGER  KTRM(NRK, 1)
      INTEGER  WX, CX, SR
*CALL  STATF
C
C        INITIALIZATION
C
      WX = 0
      CX = M
      CALL PRESET(KTRM, NRK * M, 0)
C
C        SET UP THE IDENTITY MATRIX FOR DEGREE ONE
C
      DO 5  I = 1, M
        KTRM(I, I) = 1
5     CONTINUE
10    IF ((KTRM(1, WX+1) + 1) .GT. IDEG) RETURN
C
C        FIND NUMBER OF COLUMNS IN THE SUBMATRIX
C
      DO 15  I = 1,M
        NC = I
        IF (KTRM(M, WX+I) .NE. 0) GO TO 20
15    CONTINUE
C
C        ADD ON TO THE KTRM MATRIX PROGRESSIVELY FEWER COLUMNS OF THE
C                  SUBMATRIX - FROM NC COLUMNS DOWN TO 1
C
20    L = CX + 1
      DO 40  K = 1, NC
        DO 35  J = K, NC
          DO 30  I = 1, M
            KTRM(I, L) = KTRM(I, WX+J)
30        CONTINUE
          L = L + 1
35      CONTINUE
40    CONTINUE
C
C        INCREMENT BY 1 THE ENTRIES OF THE SUBMATRICES IN A
C                       DESCENDING ROW ORDER
C
      SR = M - NC + 1
      DO 50  I = SR, M
        DO 45  J = I, M
          KTRM(I, CX+1) = KTRM(I, CX+1) + 1
          CX = CX + 1
45      CONTINUE
50    CONTINUE
      WX = WX + NC
      GO TO 10
      END
