*DECK CONTOUR
      SUBROUTINE CONTOUR(XP,YP,ZP,NX,NY,NZ,START,STEP,FIN)
C
C
C AELIB SUBROUTINE CONTOUR  2-1-35
C THE SUBROUTINE HAS TWO ENTRY POINTS:
C    A) CONTOUR - USED WHEN ENGLISH UNITS HAVE BEEN USED IN THE
C CALLING PROGRAM TO PLOT THE FRAME FOR THE CONTOUR MAP
C    B) CONTOUM - USED WHEN METRIC UNITS HAVE BEEN USED IN THE CALLING
C PROGRAM TO PLOT THE FRAME FOR THE CONTOUR MAP.
C CONTOUR CALLS PLOT TO PLOT THE CONTOUR MAP AND CONTOUM MAKES A
C CORRESPONDING CALL TO PLOTM.
C
C     MODIFIED BY L E EVANS 1981 MAY TO CHECK GRID SIZE ON INPUT ARRAY
C
C ALSO MODIFIED BY L E EVANS 1981 MAY TO REPLACE CALL TO AELERR
C (TO ISSUE ERROR MESSAGES) BY A PRINT MESSAGE UNDER CONTROL OF ALERPR.
C
      DIMENSION ZP(NZ,NX),XP(NX),YP(NY),TRACK(140),ANDOR(60)
      DIMENSION PLOTX(200),PLOTY(200)
      INTEGER ANDOR,TRACK,DONE
      INTEGER S,ER,COUNT,ADDRESS,CELL,A,B,C,D,E,  A1,A2,B1,B2,C1,C2,D1,
     1  D2,TEMP
      REAL K
      LOGICAL METRIC
      LOGICAL ALERPR
*CALL STATF
C
      METRIC=.FALSE.
      GOTO 1
C
C     THE ALTERNATE ENTRY CONTOUM ALLOWS METRIC UNITS TO BE USED AS
C     DIMENSIONS.
C
*IF -DEF,AELIB5
      ENTRY CONTOUM
*ENDIF
*IF DEF,AELIB5
      ENTRY CONTOUM(XP,YP,ZP,NX,NY,NZ,START,STEP,FIN)
*ENDIF
*CALL STATF
C
      METRIC=.TRUE.
C
C     DEFINE ROUTINE NUMBER FOR NON-FATAL ERROR MESSAGE CONTROL
C
 1    IROUT = 20135
C
C CHECK TO MAKE SURE GRID SIZE IS LE 8400.
C IF GRID SIZE IS TOO LARGE, ISSUE AN ERROR MESSAGE AND ABORT PROGRAM.
C
 2    IF(NX*NY.LE.8400) GOTO 4
         PRINT 2000,NX,NY
*IF -DEF,AELIB5
 2000    FORMAT(" ***MORE THAN 8400 GRID POINTS FOR CONTOUR PLOT, NX = "
     ,            ,I5, " NY = ", I5)
*ENDIF
*IF DEF,AELIB5
 2000    FORMAT(' ***MORE THAN 8400 GRID POINTS FOR CONTOUR PLOT, NX = '
     ,            ,I5, ' NY = ', I5)
*ENDIF
         CALL TRACEB(1)
C
C        JOB IS TERMINATED BY THE SYSTEM.(TRACEB CALLS SYSTEMC)
C
C
C SET UP MASK ARRAY CALLED ANDOR FOR USE WITH TRACK
C
 4    ANDOR(60) = 1
      DO 5 J=1,59
    5 ANDOR(60-J)=SHIFT(ANDOR(61-J),1)
      MARK=E=0
      N=1
*** IF K=ZP(I,J) OVER ANY AREA,(I.E. AT LEAST 3 ADJACENT POINTS),
*** PROBLEMS ARISE.  TO CORRECT THIS THE STEP IS INCREMENTED BY A
*** SMALL AMOUNT.  THE VALUE OF FIN IS INCREASED TO ENSURE THE LAST
*** CONTOUR IS DRAWN.  HOPEFULLY THIS CURES MOST OF THE PROBLEMS.
      K=START-STEP
      AK=1.000000000001
      STEPF=STEP*AK
      FINISH=FIN+(FIN*(AK-1.)*((FIN-START)/STEP+1.))
 7    K=K+STEPF
      IF(K.GT.FINISH) RETURN
      DO 10 L=1,140
   10 TRACK(L)=0
      S=3
      ASSIGN 15 TO L1
      A1=C1=NY
      A2=NX-1
      C2=D2=1
      D1=0
      GO TO 100
   15 S=5
      ASSIGN 16 TO L1
      A1=2
      C1=NY
      A2=C2=NX
      D1=-1
      D2=0
      GO TO 100
   16 S=7
      ASSIGN 17 TO L1
      A1=C1=1
      A2=2
      C2=NX
      D1=0
      D2=-1
      GO TO 100
   17 S=1
      A1=NY-1
      C1=A2=C2=D1=1
      D2=0
      ASSIGN 18 TO L1
      GO TO 100
   18 S=7
      A1=NY-1
      C1=A2=2
      C2=NX
      D1=0
      D2=-1
      ASSIGN 999 TO L1
      GO TO 100
  999 GO TO 7
C                  ****  SCAN  ****
C
C             SCAN TO FIND  CONTOUR WHICH PASSES BETWEEN ADJACENT POINTS
*IF -DEF,AELIB5
  100 IF(C1.GE.A1) 101,102
*ENDIF
*IF DEF,AELIB5
  100 IF(C1.GE.A1) GOTO 101
      GOTO 102
*ENDIF
  101 B1=1
      GO TO 103
  102 B1=-1
*IF -DEF,AELIB5
  103 IF(C2.GE.A2) 104,105
*ENDIF
*IF DEF,AELIB5
  103 IF(C2.GE.A2) GOTO 104
      GOTO 105
*ENDIF
  104 B2=1
      GO TO 106
  105 B2=-1
  106 I=A1-B1
  107 I=I+B1
      J=A2-B2
      IF(B1) 108,109,109
  108 IF(I.LT.C1) GO TO L1,(15,16,17,18,999)
      GO TO 110
  109 IF(I.GT.C1) GO TO L1,(15,16,17,18,999)
  110 J=J+B2
      IF(B2) 111,112,112
  111 IF(J.LT.C2) GO TO 107
      GO TO 113
  112 IF(J.GT.C2) GO TO 107
  113 IF(ZP(I,J).LT.K) GO TO 199
C
C  CHECKS THE BORDER POINT(ZP) AND THE CONTOUR(K).
C  IF THEY ARE EQUAL THE CONTOUR WILL PROBABLY BE MISSED
C     AND A WARNING MESSAGE WILL BE PRINTED. PLOTTING WILL BE ALLOWED
C     TO CONTINUE
C
      IF(ZP(I+D1,J+D2).NE.K) GO TO 114
      IF(.NOT.ALERPR(IROUT,0)) GOTO 114
      PRINT 2001,K,I+D1, J+D2
*IF -DEF,AELIB5
 2001    FORMAT(" ***THE CONTOUR VALUE ", E15.8 ," IS EQUAL TO Z(",I3,
     ,            ",",I3,").",/,"    THAT CONTOUR MAY BE MISSED")
*ENDIF
*IF DEF,AELIB5
 2001    FORMAT(' ***THE CONTOUR VALUE ', E15.8 ,' IS EQUAL TO Z(',I3,
     ,            ',',I3,').',/,'    THAT CONTOUR MAY BE MISSED')
*ENDIF
 114  CONTINUE
*IF -DEF,AELIB5
      IF(ZP(I+D1,J+D2).LT.K) 115,199
*ENDIF
*IF DEF,AELIB5
      IF(ZP(I+D1,J+D2).LT.K) GOTO 115
*ENDIF
  199 GO TO 110
C                  ****  TRACER  ****
C
C   START TO TRACE THE CONTOUR PASSING BETWEEN ADJACENT POINTS
C
  115 A=I
      B=J
      ASSIGN 116 TO LL
      GO TO 200
C
C    CHECK IF POINT HAS BEEN DONE
C
  116 DONE=TRACK(ADDRESS).AND.ANDOR(CELL)
      IF(S.EQ.5) GO TO 117
      IF(DONE.NE.0) GO TO 199
  117 COUNT=1
*IF -DEF,AELIB5
      GO TO  (120,130,140,150,160,170,180,190),S
*ENDIF
*IF DEF,AELIB5
      GO TO  (120,130,140,150,160,170,180,190),S
      CALL GOTOER
*ENDIF
C
C     SCAN BETWEEN SURROUNDING POINTS
C
  120 ER=6
      C=A+1
      D=B
      ASSIGN 130 TO JMP
      GO TO 300
  130 ER=7
      C=A+1
      D=B+1
      ASSIGN 140 TO JMP
      GO TO 300
  140 ER=8
      C=A
      D=B+1
      ASSIGN 150 TO JMP
      GO TO 300
  150 ER=1
      C=A-1
      D=B+1
      ASSIGN 160 TO JMP
      GO TO 300
  160 ER=2
      C=A-1
      D=B
      ASSIGN 170 TO JMP
      GO TO 300
  170 ER=3
      C=A-1
      D=B-1
      ASSIGN 180 TO JMP
      GO TO 300
  180 ER=4
      C=A
      D=B-1
      ASSIGN 185 TO JMP
      GO TO 300
  185 ASSIGN 186 TO LL
      GO TO 200
  186 TRACK(ADDRESS)=TRACK(ADDRESS).OR.ANDOR(CELL)
  190 ER=5
      C=A+1
      D=B-1
      ASSIGN 120 TO JMP
      GO TO 300
C                  ****  GETCELL  ****
C
C     GET LOCATION OF BIT WHICH IS SET WHEN POINT HAS BEEN DONE
C
  200 ADDRESS=NX*(A-1)+B
      TEMP=ADDRESS/60
      CELL=ADDRESS-60*TEMP+1
      ADDRESS=TEMP+1
      GO TO LL,(116,186)
C                  ****  INTERPOL  ****
C
C      SET UP END POINT VALUES FOR INTERPOLATION PROCEDURE
C
  300 IF(C.LT.1) GO TO 950
      IF(C.GT.NY) GO TO 950
      IF(D.LT.1) GO TO 950
      IF(D.GT.NX) GO TO 950
      TEMP=ER.AND.1
*IF -DEF,AELIB5
      IF(ZP(C,D).LT.K) 301,350
*ENDIF
*IF DEF,AELIB5
      IF(ZP(C,D).LT.K) GOTO 301
      GOTO 350
*ENDIF
*IF -DEF,AELIB5
  301 IF(TEMP.EQ.0) 302,305
*ENDIF
*IF DEF,AELIB5
  301 IF(TEMP.EQ.0) GOTO 302
      GOTO 305
*ENDIF
C
C     NON-DIAGONAL SCAN , ZP(C,D) LT K
C
  302 ASSIGN 303 TO L2
      GO TO 500
  303 ASSIGN 398 TO L3
      GO TO 510
C
C     DIAGONAL SCAN , ZP(C,D)LT K
C
  305 ASSIGN 306 TO L6
      GO TO 540
*IF -DEF,AELIB5
  306 IF(ZMP.GE.K) 310,320
*ENDIF
*IF DEF,AELIB5
  306 IF(ZMP.GE.K) GOTO 310
      GOTO 320
*ENDIF
  310 ASSIGN 311 TO L3
      GO TO 510
  311 ASSIGN 312 TO L4
      GO TO 520
  312 MARK=1
      GO TO 398
  320 ASSIGN 321 TO L5
      GO TO 530
  321 ASSIGN 322 TO L2
      GO TO 500
  322 MARK=0
      GO TO 398
C
C
C     ZP(C,D) GE K
C
  350 IF(TEMP.EQ.0) GO TO 380
      ASSIGN 351 TO L6
      GO TO 540
*IF -DEF,AELIB5
  351 IF(ZMP.GE.K) 352,355
*ENDIF
*IF DEF,AELIB5
  351 IF(ZMP.GE.K) GOTO 352
      GOTO 355
*ENDIF
  352 ASSIGN 353 TO L4
      GO TO 520
  353 JUMP=(ER+1)*0.5
*IF -DEF,AELIB5
      GO TO (370,365,370,365),JUMP
*ENDIF
*IF DEF,AELIB5
      GO TO (370,365,370,365),JUMP
      CALL GOTOER
*ENDIF
  355 ASSIGN 356 TO L2
      GO TO 500
  356 ASSIGN 398 TO L5
      GO TO 530
  365 Z2=ZP(C,B)
      Y2=YP(C)
      X2=XP(B)
      GO TO  375
  370 Z2=ZP(A,D)
      Y2=YP(A)
      X2=XP(D)
  375 ASSIGN 385 TO L7
      GO TO 400
  380 IF(MARK.NE.1) GO TO 385
      PLOTX(COUNT)=X1
      PLOTY(COUNT)=Y1
      E=-1
  385 A=C
      B=D
*IF -DEF,AELIB5
      GO TO (120,130,140,150,160,170,180,190),ER
*ENDIF
*IF DEF,AELIB5
      GO TO (120,130,140,150,160,170,180,190),ER
      CALL GOTOER
*ENDIF
  398 ASSIGN 399 TO L7
      GO TO 400
  399 GO TO JMP,(130,140,150,160,170,180,185)
C                  ****  LININT  ****
C
C     LINEAR INTERPOLATION BETWEEN Z1 AND Z2
C
  400 Z1=(Z1-K)/(Z1-Z2)
      X1=X1-(X1-X2)*Z1
      Y1=Y1-(Y1-Y2)*Z1
      PLOTX(COUNT+E)=X1
      PLOTY(COUNT+E)=Y1
      COUNT=COUNT+1
      E=0
      IF(COUNT.LE.200) GO TO 410
      N=2
      GO TO 950
  405 PLOTX(1)=PLOTX(199)
      PLOTY(1)=PLOTY(199)
      PLOTX(2)=PLOTX(200)
      PLOTY(2)=PLOTY(200)
      COUNT=3
      N=1
      GO TO 420
  410 IF(COUNT.EQ.2) GO TO 415
      IF(X1.NE.XSTART) GO TO 412
      IF(Y1.EQ.YSTART) GO TO 950
  412 GO TO 420
  415 XSTART=X1
      YSTART=Y1
  420 GO TO L7,(385,399)
C                  ****  ZPAB  ****
  500 Z1=ZP(A,B)
      X1=XP(B)
      Y1=YP(A)
      GO TO L2,(303,322,356)
C                  ****  ZPCD  ****
  510 Z2=ZP(C,D)
      X2=XP(D)
      Y2=YP(C)
      GO TO L3,(311,398)
C                  ****  MP1  ****
  520 Z1=ZMP
      X1=XMP
      Y1=YMP
      GO TO L4,(312,353)
C                  ****  MP2  ****
  530 Z2=ZMP
      X2=XMP
      Y2=YMP
      GO TO L5,(321,398)
C                  ****  MIDPOINT  ****
  540 XMP=XP(B)+(XP(D)-XP(B))*.5
      YMP=YP(C)+(YP(A)-YP(C))*.5
      ZMP=(ZP(A,B)+ZP(C,D)+ZP(C,B)+ZP(A,D))*.25
      GO TO L6,(306,351)
C
C         PLOT POINTS WHEN PLOT ARRAYS ARE FULL
C
  950 IJK=COUNT-N
C
C     IF METRIC UNITS ARE BEING USED PLOTM MUST BE CALLED, AND IF
C     ENGLISH MEASURE UNITS ARE USED PLOT IS CALLED.
C
      IF (METRIC) GO TO 960
      CALL PLOT(2,1,0,PLOTX,PLOTY,IJK)
      GO TO 970
  960 CALL PLOTM(2,1,0,PLOTX,PLOTY,IJK)
  970 IF (COUNT.GT.200) GO TO 405
      GO TO 199
      END
