*DECK DUDXX
      FUNCTION DUDXX(U,DU,X,NPOINT,NCUP)
C
C   ROUTINE TO OBTAIN THE SECND DERIVATIVES DU OF AN ARRAY U WITH NPOINT
C     ELEMENTS , COUPLING NCUP POINTS IN THE FORMULA (ORDER=NCUP-1)   .
C
C     MAY ALSO BE CALLED AS A FUNCTION DUDX=DUDXX1(U,X1,X,NPOINT,NCUP)
C         WHICH GIVES THE DERIVATIVE DUDX AT X=X1  X(1)@X1@X(NPOINT)
C
C     FORMULAE OBTAINED BY DIFFERENTIATING THE GENERAL LAGRANGE INTERPOL
C      -ATION FORMULA _ TWICE
C  FX=SUM(I_NCUP)[FI*PROD(J_NCUP)[X-XJ]/PROD(J_NCUP)[XI-XJ]   J "I  ]
C       THIS GIVES
C  DFDX=SUM(I_NCUP)[FI*(SUM(J_NCUP)[PROD(K_NCUP)[X-XK]] /PROD(J_NCUP)
C                   ]     J,I"K  ,  I"J      ]JX-IX[
C
C  D2FDXX=SUM(I_NCUP)[FI*SUM(J_NCUP)[SUM(K_NCUP)[PROD(L_NCUP)[X-XL]]]
C         /PROD(J_NCUP)[XI-XJ]  J"I , K"I,J L"I,J,K  ]
C
C     DFDX IS COMPUTED FOR EACH POINT BY CENTRAL DIFFERENCES WHENEVER
C     POSSIBLE.    NPOINT POINTS WITH NCUP COUPLING PERMITS (NPOINT-NCUP
C     +1) CENTRAL DIFFERENCE EVALUATIONS WITH (NCUP/2) SKEWED  FORMULAE
C     AT EACH END.   THESE NUMBERS ARE COMPUTED FIRST, THEN THE EQUATION
C     FOR DFDX IS ASSEMBLED AS STATED ABOVE.
C
C     NOTE THAT NCUP=1 GIVES  3  POINT FORWARD DIFFERENCES AND NCUP=2
C     GIVES 3   POINT BACKWARD DIFFERENCES.  OTHER ODD VALUES OF NCUP
C     GIVE CENTRAL DIFFERENCES , EVEN VALUES GIVE CENRTRAL WITH ONE
C     BACKWARD BIAS
C
C        AUTHOR MB CARVER JULY 1974 CRNL
C
      REAL U(NPOINT),DU(NPOINT),X(NPOINT)
      LOGICAL SUB
C
*IF -DEF,AELIB5
      SUB=.T.
*ENDIF
*IF DEF,AELIB5
      SUB=.TRUE.
*ENDIF
      IF=NPOINT
      IS=1
 100  NCAP=MAX0(NCUP,3)
      IMAX=NPOINT-NCAP+1
      ISKU=NCUP/2
      IF(NCUP.EQ.2)ISKU=2
      DO 1000 I1=IS,IF
      IF(SUB)XI1=X(I1)
        DUI1=0.
        IO=MIN0(IMAX,MAX0(1,I1-ISKU))
        I2=IO+NCAP-1
        DO 800 I=IO,I2
          DNOM=1.
          ANUM=0.
          DO 600 J=IO,I2
            BNUM=0.
            IF(J.EQ.I)GOTO600
            DNOM=DNOM*(X(I)-X(J))
            DO 400 K=IO,I2
              CNUM=0.
              IF(K.EQ.I.OR.K.EQ.J)GOTO400
              CNUM=1.
              DO 200 L=IO,I2
                IF(L.EQ.I.OR.L.EQ.J.OR.L.EQ.K)GOTO200
                CNUM=CNUM*(XI1-X(L))
 200          CONTINUE
 400        BNUM=BNUM+CNUM
 600      ANUM=ANUM+BNUM
 800    DUI1=DUI1+U(I)*ANUM/DNOM
        IF(SUB)DU(I1)=DUI1
 1000 CONTINUE
      DUDXX=DUI1
      RETURN
C
*IF -DEF,AELIB5
      ENTRY DUDXX1
*ENDIF
*IF DEF,AELIB5
      ENTRY DUDXX1(U,DU,X,NPOINT,NCUP)
*ENDIF
C
C     ENTRY FOR A SINGLE POINT ONLY - CALL WITH DU= X OF POINT REQUIRED
C
*IF -DEF,AELIB5
      SUB=.F.
*ENDIF
*IF DEF,AELIB5
      SUB=.FALSE.
*ENDIF
      DO 1200 I=1,NPOINT
*IF -DEF,AELIB5
        IF(DU.LE.X(I))GOTO1400
*ENDIF
*IF DEF,AELIB5
        IF(DU(1).LE.X(I))GOTO1400
*ENDIF
 1200 CONTINUE
        IS=NPOINT
        GOTO 1600
 1400 IS=I
 1600 IF=IS
*IF -DEF,AELIB5
      XI1=DU
*ENDIF
*IF DEF,AELIB5
      XI1=DU(1)
*ENDIF
      GOTO 100
C
      END
