*DECK FREEIN
      SUBROUTINE FREEIN (IUNIT,ARRAY,NWD,MODE,NUSED)
C
C     IUNIT - UNIT ON WHICH FREE FORMAT INPUT IS READ.
C     ARRAY - ARRAY WHERE FREE FORMAT INPUT IS STORED.
C     NWD   - NUMBER OF WORDS IN ARRAY (1 - NWD).
C     MODE  - 0 IF ONLY ONE CARD IMAGE TO BE READ
C             1 IF MORE THAN ONE CARD IMAGE TO BE READ
C     NUSED - CONTAINS NUMBER OF WORDS USED IN ARRAY RETURNED TO USER,
C             IF AN EOF WAS READ IN FREEIN THE VALUE RETURNED TO THE MAI
C             PROGRAM IS -1.
C
C
C     THIS FREE FORMAT INPUT ROUTINE READS A CARD IMAGE FROM AN INPUT
C     UNIT.  EACH CHARACTER IS EXAMINED TO DETERMINE ITS GROUP.
C     A STATE FROM 1-8 ALREADY EXISTS AND CHANGES AS ASSEMBLY PROCEEDS.
C
C                VALUES OF GROUP AND STATE
C     GROUPS       ELEMENTS OF GROUP
C     ------       -----------------
C       1          DIGITS  0-9
C       2          ALPHABETIC CHARACTERS  A-Z
C       3          EXPONENTIAL INDICATOR  E
C       4          DECIMAL POINT  .
C       5          SIGN  +-
C       6          SEPERATORS  BLANK=/,EOL
C       7          SPECIAL CHARACTERS  *()$
C       8          ILLEGAL CHARACTERS #[]:<" ETC.
C                  (ASSEMBLED AS SEPERATORS)
C
C
C     STATES       FUNCTION
C     ------       --------
C       1          NO ITEM STARTED
C       2          WORD STARTED
C       3          NUMBER STARTED BUT BEFORE D.P.
C       4          NUMBER STARTED BUT AFTER D.P.
C       5          EXPONENTIAL INDICATOR READ
C       6          EXPONENTIAL INDICATOR PASSED AFTER NUMBER
C       7          EXPONENT STARTED
C       8          SPECIAL CHARACTER PROCESSING
C
C
C     DEPENDING UPON WHAT THE PRESENT VALUES OF STATE AND GROUP ARE
C     DETERMINES TO WHICH STATEMENT LABEL CONTROL IS TRANSFERED TO.
C
C                       GROUP
C     STATE/       1  2  3  4  5  6  7  8
C     -----------------------------------
C       1          3  2  2  4  1 17 16 18
C       2          6  6  6  6  6  9  6  6
C       3          7 18 11 18 18 10 18 18
C       4          8 18 11 18 18 10 18 18
C       5         12 18 18 18 12 10 18 18
C       6         13 18 18 18  1 10 18 18
C       7         14 18 18 18 18 15 18 18
C       8         19 19 19 19 19 19 20 19
C
      EQUIVALENCE (REEL,INT)
      REAL MVAL
      INTEGER EOFLG
      DIMENSION ARRAY(NWD),ICARD(14),LGRP(8),LABEL(8),ISH(10)
      DATA EOFLG/0/
C
C     ARRAY LGRP CONTAINS THE CORRESPONDING GROUP FOR EACH DISPLAY CODE
C     CHARACTER - 8 PER WORD
C     EXAMPLE  DISPLAY CODE 01 = A = GROUP 2,
C     EXAMPLE DISPLAY CODE 45 = + = GROUP 5.
C
*IF -DEF,AELIB5
      DATA (LGRP(I),I=1,8)/06020202020302020000B,
     *                     02020202020202020000B,
     *                     02020202020202020000B,
     *                     02020201010101010000B,
     *                     01010101010505070000B,
     *                     06070707060606040000B,
     *                     10101010101010100000B,
     *                     10101010101010100000B/
*ENDIF
*IF DEF,AELIB5
      DATA (LGRP(I),I=1,8)/O"06020202020302020000",
     *                     O"02020202020202020000",
     *                     O"02020202020202020000",
     *                     O"02020201010101010000",
     *                     O"01010101010505070000",
     *                     O"06070707060606040000",
     *                     O"10101010101010100000",
     *                     O"10101010101010100000"/
*ENDIF
C
C     ARRAY LABEL CONTAINS THE STATEMENT LABELS TO WHICH TRANSFER WILL
C     BE PASSED IN THE COMPUTED GO TO STATEMENT.
C     THE ROWS CORRESPOND TO THE 8 STATE VALUES, ESTABLISHED DURING
C     ASSEMBLY OF THE WORD, NUMBER OR COMMENT.
C     THE FIRST 48 BITS CORRESPOND TO THE 8 GROUP VALUES CALCULATED FROM
C     THE LGRP ARRAY.
C
*IF -DEF,AELIB5
      DATA (LABEL(I),I=1,8)/03020204012120220000B,
     *                      06060606061106060000B,
     *                      07221305221222220000B,
     *                      10221322221222220000B,
     *                      14222222141222220000B,
     *                      15222222011222220000B,
     *                      16222222221722220000B,
     *                      23232323232324230000B/
*ENDIF
*IF DEF,AELIB5
      DATA (LABEL(I),I=1,8)/O"03020204012120220000",
     *                      O"06060606061106060000",
     *                      O"07221305221222220000",
     *                      O"10221322221222220000",
     *                      O"14222222141222220000",
     *                      O"15222222011222220000",
     *                      O"16222222221722220000",
     *                      O"23232323232324230000"/
*ENDIF
C
C     ARRAY ICONV CONTAINS NUMERIC VALUES 0-9 SO THAT A NUMBER READ IN
C     DISPLAY CODE CAN BE CONVERTED TO A REAL F.P. NUMBER.
C
*IF -DEF,AELIB5
      DATA ICONV/00010203040506071011B/
*ENDIF
*IF DEF,AELIB5
      DATA ICONV/O"00010203040506071011"/
*ENDIF
C
C     ARRAY ISH CONTAINS VALUES CORRESPONDING TO THE NUMBER OF BITS
C     SHIFTED - USED IN EXTRACTING INFORMATION FROM THE LGRP, LABEL AND
C     ICONV ARRAYS.
C
      DATA ISH/6,12,18,24,30,36,42,48,54,60/
C
C     VARIABLES------
C     IMAGE - COUNTER FOR NUMBER OF CARD IMAGES READ.
C     IDEX  - COUNTER FOR NUMBER OF WORDS FILLED IN ARRAY, RETURNED TO
C             USER IN NUSED.
C     NWORD - COUNTER FOR THE NUMBER OF WORDS READ PER CARD IMAGE.
C     ICHAR - EACH CHARACTER IS STORED IN THIS WORD TEMPORARILY
C             IN R1 FORMAT.
C     MVAL  - CONTAINS THE MANTISSA VALUE OF THE NUMBER BEING ASSEMBLED.
C     EVAL  - CONTAINS THE EXPONENT BEING ACCUMULATED.
C     INWORD- ALPHABETIC STRINGS ARE BUILT UP TO FORM A WHOLE WORD.
C     MESIGN- CONTAINS SIGN OF EXPONENT.
C     MSIGN - CONTAINS A SIGN READ IN.
C     BASE  - BASE OF NUMBER READ IN, ASSUMED TO BE DECIMAL (10)
C     UNLESS A $ IS READ BEFORE A NUMBER CHANGING THE BASE TO OCTAL.
C     ISTATE- THE CURRENT VALUE OF STATE.
C
C
*CALL  STATF
*IF -DEF,AELIB5
      IMAGE=0 $ IDEX=1 $ IBRAC=0
*ENDIF
*IF DEF,AELIB5
      IMAGE=0
      IDEX=1
      IBRAC=0
*ENDIF
      MSIGN=MESIGN=0
      IF (EOFLG.EQ.0) GO TO 29
*IF -DEF,AELIB5
      PRINT 27  $ EOFLG=0
*ENDIF
*IF DEF,AELIB5
      PRINT 27
      EOFLG=0
*ENDIF
*IF -DEF,AELIB5
27    FORMAT(/,7X,*EOF ENCOUNTERED DURING PREVIOUS CALL TO FREEIN*)
*ENDIF
*IF DEF,AELIB5
27    FORMAT(/,7X,'EOF ENCOUNTERED DURING PREVIOUS CALL TO FREEIN')
*ENDIF
29    IF ((MODE.EQ.0).AND.(IMAGE.EQ.1)) GO TO 1000
*IF -DEF,AELIB5
28    READ(IUNIT,30) (ICARD(I),I=1,14)
*ENDIF
*IF DEF,AELIB5
28    READ(IUNIT,30,END=10000) (ICARD(I),I=1,14)
*ENDIF
*IF -DEF,AELIB5
30    FORMAT(14A10)
*ENDIF
*IF DEF,AELIB5
   30 FORMAT( BZ, 13A10,A7 )
*ENDIF
*IF -DEF,AELIB5
      IF (EOF(IUNIT)) 1001,31
*ENDIF
*IF DEF,AELIB5
10000 IF (EOF(IUNIT)) 1001,31,1001
*ENDIF
*IF -DEF,AELIB5
31    IMAGE=IMAGE+1 $ NWORD=0 $ ISTATE=1 $ BASE= 10.
*ENDIF
*IF DEF,AELIB5
31    IMAGE=IMAGE+1
      NWORD=0
      ISTATE=1
      BASE= 10.
*ENDIF
      IF (IBRAC.NE.0) ISTATE=8
*IF -DEF,AELIB5
32    NWORD=NWORD+1 $ IF ((NWORD.GE.15).AND.(ISTATE.NE.1)) GO TO 18
*ENDIF
*IF DEF,AELIB5
32    NWORD=NWORD+1
      IF ((NWORD.GE.15).AND.(ISTATE.NE.1)) GO TO 18
*ENDIF
*IF -DEF,AELIB5
        IF (NWORD.GE.15) GO TO 29 $ ID=0
*ENDIF
*IF DEF,AELIB5
        IF (NWORD.GE.15) GO TO 29
        ID=0
*ENDIF
*IF -DEF,AELIB5
100   ID=ID+1 $ IF (ID.GT.10) GO TO 32
*ENDIF
*IF DEF,AELIB5
100   ID=ID+1
      IF (ID.GT.10) GO TO 32
*ENDIF
C     ICHAR HAS CHARACTER RIGHT JUSTIFIED ZERO FILL
*IF -DEF,AELIB5
      ICHAR=(SHIFT(ICARD(NWORD),ISH(ID)).AND.77B)
*ENDIF
*IF DEF,AELIB5
      ICHAR=(SHIFT(ICARD(NWORD),ISH(ID)).AND.O"77")
*ENDIF
C     JSHIFT IS THE NUMBER OF SHIFTS IN LGRP ARRAY
C     NGRP   IS THE ARRAY ELEMENT
*IF -DEF,AELIB5
      JSHIFT=(ICHAR.AND.7B)+1
*ENDIF
*IF DEF,AELIB5
      JSHIFT=(ICHAR.AND.O"7")+1
*ENDIF
*IF -DEF,AELIB5
      NGRP=(SHIFT(ICHAR,-3).AND.7B)+1
*ENDIF
*IF DEF,AELIB5
      NGRP=(SHIFT(ICHAR,-3).AND.O"7")+1
*ENDIF
*IF -DEF,AELIB5
      NGRP=SHIFT(LGRP(NGRP),ISH(JSHIFT)).AND.77B
*ENDIF
*IF DEF,AELIB5
      NGRP=SHIFT(LGRP(NGRP),ISH(JSHIFT)).AND.O"77"
*ENDIF
*IF -DEF,AELIB5
      IF ((ICHAR.LT.1R+).AND.(ICHAR.GT.1RZ)) GO TO 96
*ENDIF
*IF DEF,AELIB5
      IF ((ICHAR.LT.R"+").AND.(ICHAR.GT.R"Z")) GO TO 96
*ENDIF
*IF -DEF,AELIB5
57    JUMP=SHIFT(LABEL(ISTATE),ISH(NGRP)).AND.77B
*ENDIF
*IF DEF,AELIB5
57    JUMP=SHIFT(LABEL(ISTATE),ISH(NGRP)).AND.O"77"
*ENDIF
*IF -DEF,AELIB5
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,100,20) JUMP
*ENDIF
*IF DEF,AELIB5
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,100,20) JUMP
      CALL GOTOER
*ENDIF
*IF -DEF,AELIB5
1     MSIGN=ICHAR $ GO TO 100
*ENDIF
*IF DEF,AELIB5
1     MSIGN=ICHAR
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
2     INWORD=ICHAR.AND.77B.OR.9L
*ENDIF
*IF DEF,AELIB5
2     INWORD=ICHAR.AND.O"77".OR.L"         "
*ENDIF
*IF -DEF,AELIB5
      IW=1 $ MSIGN=0 $ ISTATE=2 $ GO TO 100
*ENDIF
*IF DEF,AELIB5
      IW=1
      MSIGN=0
      ISTATE=2
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
3     MVAL=VAL $ ISTATE=3 $ GO TO 100
*ENDIF
*IF DEF,AELIB5
3     MVAL=VAL
      ISTATE=3
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
4     MVAL=0. $ ISTATE=4 $ POW=1. $ GO TO 100
*ENDIF
*IF DEF,AELIB5
4     MVAL=0.
      ISTATE=4
      POW=1.
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
5     POW=1. $ ISTATE=4 $ GO TO 100
*ENDIF
*IF DEF,AELIB5
5     POW=1.
      ISTATE=4
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
6     INWORD=(SHIFT(INWORD,6).AND.77777777777777777700B).OR.(ICHAR.AND.7
     *7B)
*ENDIF
*IF DEF,AELIB5
6     INWORD=(SHIFT(INWORD,6).AND.O"77777777777777777700").OR.(ICHAR.AND
     *.O"77")
*ENDIF
*IF -DEF,AELIB5
      IW=IW+1 $ IF(IW.NE.10) GO TO 100
*ENDIF
*IF DEF,AELIB5
      IW=IW+1
      IF(IW.NE.10) GO TO 100
*ENDIF
*IF -DEF,AELIB5
      INT=INWORD $ ARRAY(IDEX)=REEL $ IW=0 $ GO TO 103
*ENDIF
*IF DEF,AELIB5
      INT=INWORD
      ARRAY(IDEX)=REEL
      IW=0
      GO TO 103
*ENDIF
*IF -DEF,AELIB5
7     MVAL=(MVAL*BASE)+VAL $ GO TO 100
*ENDIF
*IF DEF,AELIB5
7     MVAL=(MVAL*BASE)+VAL
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
8     POW=POW/BASE $ MVAL=MVAL+(POW*VAL) $ GO TO 100
*ENDIF
*IF DEF,AELIB5
8     POW=POW/BASE
      MVAL=MVAL+(POW*VAL)
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
9     ISHIFT=(10-IW)*6 $ INT=SHIFT(INWORD,ISHIFT) $ ARRAY(IDEX)=REEL
*ENDIF
*IF DEF,AELIB5
9     ISHIFT=(10-IW)*6
      INT=SHIFT(INWORD,ISHIFT)
      ARRAY(IDEX)=REEL
*ENDIF
      GO TO 103
*IF -DEF,AELIB5
10    LEN=LEGVAR(MVAL) $ IF (LEN) 105,106,105
*ENDIF
*IF DEF,AELIB5
10    LEN=LEGVAR(MVAL)
      IF (LEN) 105,106,105
*ENDIF
*IF -DEF,AELIB5
106   IF (MSIGN.EQ.1R-) 101,102
*ENDIF
*IF DEF,AELIB5
106   IF (MSIGN.EQ.R"-") GOTO 101
      GOTO 102
*ENDIF
*IF -DEF,AELIB5
101   ARRAY(IDEX)=-MVAL $ GO TO 103
*ENDIF
*IF DEF,AELIB5
101   ARRAY(IDEX)=-MVAL
      GO TO 103
*ENDIF
102   ARRAY(IDEX)=MVAL
*IF -DEF,AELIB5
103   IF (IDEX.GT.NWD) GO TO 104  $ IDEX=IDEX+1
*ENDIF
*IF DEF,AELIB5
103   IF (IDEX.GT.NWD) GO TO 104
      IDEX=IDEX+1
*ENDIF
*IF -DEF,AELIB5
105   IF (ICHAR.EQ.1R/) GO TO 1000
*ENDIF
*IF DEF,AELIB5
105   IF (ICHAR.EQ.R"/") GO TO 1000
*ENDIF
*IF -DEF,AELIB5
107   ISTATE=1 $ MSIGN=MESIGN=0 $ BASE= 10. $ GO TO 100
*ENDIF
*IF DEF,AELIB5
107   ISTATE=1
      MSIGN=MESIGN=0
      BASE= 10.
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
11    ISTATE=5 $ GO TO 100
*ENDIF
*IF DEF,AELIB5
11    ISTATE=5
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
12    ISTATE=6 $ IF ((ICHAR.EQ.1R+).OR.(ICHAR.EQ.1R-)) 131,13
*ENDIF
*IF DEF,AELIB5
12    ISTATE=6
      IF ((ICHAR.EQ.R"+").OR.(ICHAR.EQ.R"-")) GOTO 131
*ENDIF
*IF -DEF,AELIB5
13    ISTATE=7 $ EVAL=VAL $ GO TO 100
*ENDIF
*IF DEF,AELIB5
13    ISTATE=7
      EVAL=VAL
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
131   MESIGN=ICHAR $ GO TO 100
*ENDIF
*IF DEF,AELIB5
131   MESIGN=ICHAR
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
14    EVAL=(EVAL*BASE)+VAL $ GO TO 100
*ENDIF
*IF DEF,AELIB5
14    EVAL=(EVAL*BASE)+VAL
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
15    ISTATE=1 $ IF (MESIGN.EQ.1R-) 161,162
*ENDIF
*IF DEF,AELIB5
15    ISTATE=1
      IF (MESIGN.EQ.R"-") GOTO 161
      GOTO 162
*ENDIF
161   EVAL=-EVAL
*IF -DEF,AELIB5
162   LEN=LEGVAR(EVAL) $ IF (LEN) 168,167,168
*ENDIF
*IF DEF,AELIB5
162   LEN=LEGVAR(EVAL)
      IF (LEN) 168,167,168
*ENDIF
*IF -DEF,AELIB5
167   IF (MSIGN.EQ.1R-) 163,164
*ENDIF
*IF DEF,AELIB5
167   IF (MSIGN.EQ.R"-") GOTO 163
      GOTO 164
*ENDIF
163   MVAL=-MVAL
*IF -DEF,AELIB5
164   MVAL=MVAL*(BASE**EVAL) $ LEN=LEGVAR(MVAL)
*ENDIF
*IF DEF,AELIB5
164   MVAL=MVAL*(BASE**EVAL)
      LEN=LEGVAR(MVAL)
*ENDIF
      IF (LEN) 168,160,168
*IF -DEF,AELIB5
168   ND=(NWORD-1)*10 + ID $ PRINT 169,IMAGE,ND $ GO TO 107
*ENDIF
*IF DEF,AELIB5
168   ND=(NWORD-1)*10 + ID
      PRINT 169,IMAGE,ND
      GO TO 107
*ENDIF
*IF -DEF,AELIB5
169   FORMAT( ,5X,* OVERFLOW CONDITION IN FREEIN, RECORD *,I4,* COLUMN *
     1,I2,* NUMBER IS TOO LARGE, IGNORED*)
*ENDIF
*IF DEF,AELIB5
  169 FORMAT( 5X, 'OVERFLOW CONDITION IN FREEIN, RECORD ',I4,'COLUMN '
     1,I2,' NUMBER IS TOO LARGE, IGNORED')
*ENDIF
*IF -DEF,AELIB5
160   ARRAY(IDEX)=MVAL $ GO TO 103
*ENDIF
*IF DEF,AELIB5
160   ARRAY(IDEX)=MVAL
      GO TO 103
*ENDIF
*IF -DEF,AELIB5
104   ND=(NWORD-1)*10+ID $ PRINT 108,NWD,IMAGE,ND
*ENDIF
*IF DEF,AELIB5
104   ND=(NWORD-1)*10+ID
      PRINT 108,NWD,IMAGE,ND
*ENDIF
      GO TO 1000
*IF -DEF,AELIB5
16    IF (ICHAR.EQ.1R*) GO TO 180 $ IF (ICHAR.EQ.1R() GO TO 183
*ENDIF
*IF DEF,AELIB5
16    IF (ICHAR.EQ.R"*") GO TO 180
      IF (ICHAR.EQ.R"(") GO TO 183
*ENDIF
*IF -DEF,AELIB5
      IF (ICHAR.EQ.1R)) GO TO 18  $ BASE=8. $ GO TO 100
*ENDIF
*IF DEF,AELIB5
      IF (ICHAR.EQ.R")") GO TO 18
      BASE=8.
      GO TO 100
*ENDIF
*IF -DEF,AELIB5
17    IF (ICHAR.EQ.1R/) 1000,100
*ENDIF
*IF DEF,AELIB5
17    IF (ICHAR.EQ.R"/") GOTO 1000
      GOTO 100
*ENDIF
*IF -DEF,AELIB5
18    IF (IBRAC.NE.0) GO TO 29 $ NGRP=6 $ GO TO 57
*ENDIF
*IF DEF,AELIB5
18    IF (IBRAC.NE.0) GO TO 29
      NGRP=6
      GO TO 57
*ENDIF
*IF -DEF,AELIB5
183   ISTATE = 8 $ IBRAC=1 $ GO TO 100
*ENDIF
*IF DEF,AELIB5
183   ISTATE = 8
      IBRAC=1
      GO TO 100
*ENDIF
* 19  GO TO 100  THIS IS EXECUTED FROM THE COMPUTED GO AT STMT LABEL 57
*IF -DEF,AELIB5
20    IF (ICHAR.EQ.1R)) IBRAC=IBRAC-1
*ENDIF
*IF DEF,AELIB5
20    IF (ICHAR.EQ.R")") IBRAC=IBRAC-1
*ENDIF
*IF -DEF,AELIB5
      IF (ICHAR.EQ.1R() IBRAC=IBRAC+1
*ENDIF
*IF DEF,AELIB5
      IF (ICHAR.EQ.R"(") IBRAC=IBRAC+1
*ENDIF
*IF -DEF,AELIB5
      IF (IBRAC.EQ.0) 107,100
*ENDIF
*IF DEF,AELIB5
      IF (IBRAC.EQ.0) GOTO 107
      GOTO 100
*ENDIF
*IF -DEF,AELIB5
180   IF ((NWORD.EQ.1).AND.(ID.EQ.1)) 182,18
*ENDIF
*IF DEF,AELIB5
180   IF ((NWORD.EQ.1).AND.(ID.EQ.1)) GOTO 182
      GOTO 18
*ENDIF
*IF -DEF,AELIB5
182   ICARD(1)=(ICARD(1).AND.00777777777777777777B).OR.1L
*ENDIF
*IF DEF,AELIB5
182   ICARD(1)=(ICARD(1).AND.O"00777777777777777777").OR.L" "
*ENDIF
*IF -DEF,AELIB5
      DO 181 I=1,8 $ INT=ICARD(I) $ ARRAY(IDEX)=REEL $ IDEX=IDEX+1
*ENDIF
*IF DEF,AELIB5
      DO 181 I=1,8
      INT=ICARD(I)
      ARRAY(IDEX)=REEL
      IDEX=IDEX+1
*ENDIF
181   CONTINUE
      GO TO 29
C     CONVERT NUMBER
*IF -DEF,AELIB5
96    J=ICHAR-32B
*ENDIF
*IF DEF,AELIB5
96    J=ICHAR-O"32"
*ENDIF
*IF -DEF,AELIB5
      IVAL=SHIFT(ICONV,ISH(J)).AND.77B
*ENDIF
*IF DEF,AELIB5
      IVAL=SHIFT(ICONV,ISH(J)).AND.O"77"
*ENDIF
      VAL=IVAL
      GO TO 57
1001  IF (IMAGE.NE.0) GO TO 1002
*IF -DEF,AELIB5
      IDEX=0 $ GO TO 1000
*ENDIF
*IF DEF,AELIB5
      IDEX=0
      GO TO 1000
*ENDIF
1002  EOFLG=-1
1000  NUSED=IDEX-1
*IF -DEF,AELIB5
108   FORMAT( ,5X,* IN FREEIN, DATA EXCEEDED MAXIMUM SIZE OF STORAGE ARR
     *AY (*,I5,* WORDS) AT LOGICAL RECORD*,I5,* COLUMN*,I3,*   PROCESSIN
     *G STOPPED.*)
*ENDIF
*IF DEF,AELIB5
  108 FORMAT(  5X,' IN FREEIN, DATA EXCEEDED MAXIMUM SIZE OF STORAGE ARR
     *AY (',I5,' WORDS) AT LOGICAL RECORD',I5,' COLUMN',I3,'   PROCESSIN
     *G STOPPED.')
*ENDIF
200   RETURN
      END
