*DECK GAMLN
      FUNCTION GAMLN(X)
C
C     CDC 6600 ROUTINE
C     12-18-73
C
C     GAMLN EVALUATES THE NATURAL LOG OF THE GAMMA FUNCTION FOR X.GT.0
C
C                                   INPUT
C
C         X - ARGUMENT, X.GT.0.
C
C                                  OUTPUT
C
C     GAMLN - NATURAL LOG OF THE GAMMA FUNCTION AT X.
C
C
C
C                                WRITTEN BY
C
C                                D. E. AMOS
C                               S. L. DANIEL
C               SANDIA LABORATORIES, ALBUQUERQUE, N.M. 87115
C
C     RATIONAL CHEBYSHEV APPROXIMATION FOR 8..LT.X.LT.1000., ASYMPTOTIC
C     EXPANSION FOR X.GE.1000., AND BACKWARD RECURSION FOR 0..LT.X.LT.8.
C     FOR X NON-INTEGRAL. FOR X=1.,...,8., GAMLN IS SET TO A COMPONENT
C     OF THE G VECTOR WHICH CONTAINS NATURAL LOGS OF FACTORIALS.
C
      DOUBLE PRECISION DXZ,RXZ,XK
      DIMENSION G(8),P(5),Q(2)
C
      DATA XLIM1,XLIM2,RTWPIL/    8.  ,  1000.   , 9.18938533204673E-01/
C
*IF -DEF,AELIB5
      DATA  G              / 8.52516136106541E+00, 6.57925121201010E+00,
     1 4.78749174278205E+00, 3.17805383034795E+00, 1.79175946922806E+00,
     2 6.93147180559945E-01,         2(0.)       /
*ENDIF
*IF DEF,AELIB5
      DATA  G              / 8.52516136106541E+00, 6.57925121201010E+00,
     1 4.78749174278205E+00, 3.17805383034795E+00, 1.79175946922806E+00,
     2 6.93147180559945E-01,         2*0./
*ENDIF
C
      DATA  P              / 7.66345188000000E-04,-5.94095610520000E-04,
     1 7.93643110484500E-04,-2.77777775657725E-03, 8.33333333333169E-02/
C
      DATA  Q              /-2.77777777777778E-03, 8.33333333333333E-02/
C
C
*CALL  STATF
      IF(X) 90,90,10
   10 DX=X-XLIM1
      IF(DX) 20,50,40
   20 IF(X-1.) 21,52,23
   21 XZ=X+8.
      TX=X
      FK=-.5
      NDX=7
      GO TO 26
   23 DX=ABS(DX)
      NDX=DX
      DNDX=NDX
      NDX=NDX+1
      IF((DNDX-DX).EQ.0.) GO TO 51
      XZ=X+DNDX+1.
      TX=1.
      FK=.5
   26 DXZ=XZ
      RXZ=1.D+0/DXZ
      RX=RXZ
      RXX=RX*RX
      XK=1.D+0
      DO 24 I=1,NDX
      XK=XK-RXZ
      SXK=XK
      TX=TX*SXK
   24 CONTINUE
      SUM=(X-FK)*ALOG(XZ)-ALOG(TX)-XZ
      PX=P(1)
      DO 25 I=2,5
      PX=PX*RXX+P(I)
   25 CONTINUE
      GAMLN=PX*RX+SUM+RTWPIL
      RETURN
   40 RX=1./X
      RXX=RX*RX
      IF((X-XLIM2).LT.0.) GO TO 41
      PX=Q(1)*RXX+Q(2)
      GAMLN=PX*RX+(X-.5)*ALOG(X)-X+RTWPIL
      RETURN
   41 PX=P(1)
      SUM=(X-.5)*ALOG(X)-X
      DO 42 I=2,5
      PX=PX*RXX+P(I)
   42 CONTINUE
      GAMLN=PX*RX+SUM+RTWPIL
      RETURN
   50 GAMLN=G(1)
      RETURN
   51 GAMLN=G(NDX)
      RETURN
   52 GAMLN=G(8)
      RETURN
   90 PRINT 900,X
*IF -DEF,AELIB5
  900 FORMAT(* ARGUMENT FOR GAMLN IS LESS THAN OR EQUAL TO ZERO, X=*
     1E25.14)
      GAMLN=37770000000000000000B
*ENDIF
*IF DEF,AELIB5
  900 FORMAT(' ARGUMENT FOR GAMLN IS LESS THAN OR EQUAL TO ZERO, X='
     1,E25.14)
      GAMLN=O"37770000000000000000"
*ENDIF
      RETURN
      END
