*DECK GLINT
      SUBROUTINE GLINT(E,E1,EPS,SIG,G)
C
C  THIS SUBROUTINE CALCULATES A GAUSS-LORENTZ INTEGRAL BY MEANS OF A
C  FOURIER TRANSFORM. FOUR PARAMETERS - E,E1,EPS,AND SIG- ARE SUPPLIED B
C  THE USER, AND THE INTEGRAL VALUE IS CALCULATED BY THE SUBROUTINE
C  AND RETURNED TO THE CALLING PROGRAM.
C  VARIOUS LETTERS HAVE BEEN USED TO DESIGNATE PARTS OF THE INTEGRAL]
C
C  RT2= THE DENOMINATOR OF THE TERMS WHICH CALCULATE  A AND  B.
C  NN= THE NUMBER OF TERMS TO BE CALCULATED BY THE FOURIER SERIES.
C  Q= COS( 2AB)
C  R= (COS(2AB)-1 )/4B  ,WHICH IS THE TERM ADDED TO 2B * THE FOURIER
C  SERIES. THE COMBINATION OF THESE TWO TERMS WHEN MULTIPLIED BY -2/PI
C  RESULT IN WHAT THE PROGRAM REFERS TO AS PART2 OF THE FUNCTION J(A,B).
C  PART1= EXP(BSQ)* COS(2AB) * ERFC(B)
C  PART1 + PART2 GIVES THE INNER RESULT OF THE FUNCTION J(A,B)
C  INNER RESULT OF J(A,B) * F (WHICH IS PI*EXP(-ASQ)/B ) YIELDS J(A,B)
C  THE DESIRED INTEGRAL( G) = J(A,B) * 1./(SQRT(2) * SIG )
C
C  PROGRAMMED BY B.PURCELL                      OCTOBER,1975.
C
      REAL J,N,NSQ
      DIMENSION MES(2)
      DATA MES/305,306/
      DATA PI/3.14159265358979/
*CALL STATF
C
C  CHECK FOR LEGAL PARAMETER VALUES.
C
      IF (LEGVAR(E).NE.0) GO TO 100
      IF (LEGVAR(E1).NE.0) GO TO 100
      IF (LEGVAR(EPS).NE.0) GO TO 100
      IF (LEGVAR(SIG).NE.0) GO TO 100
      IF((EPS.EQ.0.) .OR. (SIG.EQ.0.))GO TO 100
C
      RT2=1./(SQRT(2.)*SIG)
      A=(E1-E)*RT2
      AA=ABS(A)
      B=ABS(EPS*RT2)
      BB=ABS(B)
      BSQ=B*B
      ASQ=A*A
      ABSQ=ASQ+BSQ
      C=4*BSQ
      B4=4*B
      Q=COS(2*A*B)
      R=(Q-1)/B4
      NN=1+2*ABS(A)+2*SQRT(ASQ+40)
C
C  TEST FOR ARGUMENTS WHICH MAY BE OUT OF RANGE FOR FUNCTIONS EXP AND CO
C
      IF((AA.GE.12.).OR.(BB.GE.20.)) GO TO 600
C
      PART1=EXP(BSQ)*Q*ERFC(B)
      F=(PI*EXP(-ASQ))/B
      ST=0.
      N=1.
      DO 15 K=1,NN
      NSQ=N*N
      TERM=(EXP(-NSQ*.25)/(NSQ+C))*(Q-COSH(N*A))
      ST=ST+TERM
      N=N+1.
  15  CONTINUE
      SUM=2*B*ST
      PART2=(-2./PI)*(R+SUM)
      D=PART1+PART2
      J=F*D
      G=RT2*J
      RETURN
C
C  THIS BRANCH OF THE SUBROUTINE IS FOR A\12 OR B\20. THE INTEGRAL IS IN
C  THIS BRANCH CALCULATED BY MEANS OF AN ASYMPTOTIC SERIES RATHER THAN
C  BY A FOURIER TRANSFORM.
C
*IF -DEF,AELIB5
  600 CALL AELERR(MES(2),2HNF)
*ENDIF
*IF DEF,AELIB5
  600 CALL AELERR(MES(2),'NF')
*ENDIF
      X=((3*ASQ)-BSQ)/(2*ABSQ*ABSQ)
      Y=3*(5*(A**4)-10*ASQ*BSQ+B**4)/(4*(ABSQ**4))
      Z=SQRT(PI)/ABSQ
      YY=15*(7*(A**6)-35*(A**4)*BSQ+21*ASQ*(B**4)-B**6)/(8*(ABSQ**6))
       J=Z*(1+X+Y+YY)
      G=RT2*J
      RETURN
*IF -DEF,AELIB5
  100 CALL AELERR(MES(1),2HNF)
      G=17770000000000000000B
*ENDIF
*IF DEF,AELIB5
  100 CALL AELERR(MES(1),'NF')
      G=O"17770000000000000000"
*ENDIF
      RETURN
      END
