*DECK HDERIV
      SUBROUTINE HDERIV(M,N,X,Y,W,YS,YPRIME,WKA,IER,IPRINT)
C  *********************************************************************
C  *********************************************************************
C
C  TITLE      SMOOTH CURVE FITTING AND SMOOTHED DERIVATIVE EVALUATION
C
C
C
C  ENTRY    CALL HDERIV(M,N,X,Y,W,YS,YPRIME,WKA,IER,IPRINT)
C             M    INTEGER, NUMBER OF DATA POINTS
C             N    ESTIMATE OF THE NUMBER OF KNOTS IN FINAL FIT
C                  ON NORMAL RETURN N WILL CONTAIN THE NUMBER OF
C                  KNOTS USED IN THE FITTING FUNCTION S(X)
C             X    X VALUES OF DATA POINTS  IN INCREASING ORDER
C             Y VALUES OF DATA POINTS
C             W    WEIGHTS
C             YS   SMOOTHED FUNCTIONAL VALUES RETURNED BY HDERIV
C             YPRIME  COMPUTED DERIVATIVES CALCULATED BY HDERIV
C             WKA  WORKING STORAGE SHOULD BE DIMENSIONED AT LEAST
C             7M+14N+6 IN THE CALLING PROGRAM
C
C             IER  ERROR FLAG
C                IER = 0  NO ERRORS
C                IER = 1  NEXT ITERATION REQUIRES LARGER NUMBER
C                       OF KNOTS THEN N SPECIFIED
C                IER = 2  SOME DATA POINTS WHICH WERE OUT OF ORDER
C                         HAVE BEEN REMOVED
C                IER = 3  INSUFFICIENT DATA
C                IER = 4   N MUST BE LARGER THEN 4
C                IER = 5  DATA POINT 1 MUST BE LESS THEN DATA POINT M
C                IER = 6  NUMBER OF DATA POINTS M IS LESS THAN 6
C           IPRINT  INTEGER SPECIFYING THE PRINTING REQUIRED
C                  IPRINT = 0   NO PRINTING,EXCEPT FOR ERROR MESSAGES
C                  IPRINT > 0  PRINTS DETAILS OF THE FINAL FIT ONLY
C                  IPRINT <   PRINT DETAILS OF THE FIT AT EVERY
C                             ITERATION USING NEW KNOTS
C
C  *********************************************************************
C  *********************************************************************
      DIMENSION X(1),Y(1),W(1),YPRIME(1),WKA(N,4),YS(1)
      REAL L1,L2
*CALL  STATF
      CALL SMOOTH(M,N,X,Y,W,YS,WKA(1,1),WKA(1,2),WKA(1,3),
     $IPRINT,WKA(1,4),IER)
      IF(IER.EQ.1.OR.IER.EQ.4.OR.IER.EQ.5.OR.IER.EQ.6) GO TO 999
C             INTERPOLATE THE FITTED DERIVATIVE FUNCTION TO OBTAIN
C             A DERIVATIVE -YPRIME- FOR EACH DATA POINT
C             USING RESIDUALS RETURNED BY SMOOTH CALCULATE SMOOTHED
C             FUNCTION VALUE -YS- AT EACH DATA POINT
      NN=0
      MM=M-1
      DO 20 I=1,MM
      IF(X(I).GE.WKA(NN+1,1)) NN=NN+1
      L1=X(I)-WKA(NN,1)
      L2=X(I)-WKA(NN+1,1)
      D1=WKA(NN+1,1)-WKA(NN,1)
      D2=-D1
      U0P=(1+L1/D1*2)*(2*L2/D2**2)+(2/D1*(L2/D2)**2)
      U1P=(1+L2/D2*2)*(2*L1/D1**2)+(2/D2*(L1/D1)**2)
      V0P=L2*(L2+2*L1)/D2**2
      V1P=L1*(L1+2*L2)/D1**2
      YPRIME(I)=U0P*WKA(NN,2)+U1P*WKA(NN+1,2)+V0P*WKA(NN,3)+
     $ V1P*WKA(NN+1,3)
      YS(I)=Y(I)-YS(I)
  20  CONTINUE
      YPRIME(M)=WKA(N,3)
      YS(M)=Y(M)-YS(M)
      RETURN
C
C     SET YPRIME AND YS ARRAYS TO + INDEFINATE
  999 DO 1000 I=1,M
*IF -DEF,AELIB5
      YPRIME(I)=17770000000000000000B
*ENDIF
*IF DEF,AELIB5
      YPRIME(I)=O"17770000000000000000"
*ENDIF
      YS(I)=YPRIME(I)
 1000 CONTINUE
      RETURN
      END
