*DECK LINE
      SUBROUTINE LINE(XARRAY,YARRAY,NPTS,INC,LINTYP,INTEQ)
************************************************************************
* THIS SUBROUTINE PRODUCES A LINE PLOT OF THE PAIRS OF DATA VALUES
* IN TWO ARRAYS(XARRAY AND YARRAY).THE ACTUAL COORDINATES OF EACH
* PLOTTED POINT ARE COMPUTED USING THE DATA  VAUES FROM THE ARRAYS
* AND THE SCALING PARAMETERS STORED AFTER THE DATA IN THE ARRAYS.
* THEY MAY BE CALCULATED BY THE USER OR COMPUTED BY THE SCAL ROUTINE.
* (SEE SCALE ROUTINE FOR DISCUSSION OF SCALE FACTORS)
************************************************************************
* ARGUMENT LIST
*    XARRAY - ARRAY CONTAINING X DATA VALUES AND SCALE FACTORS
*    YARRAY - ARRAY CONTAINING Y DATA VALUES AND SCALE FACTORS
*    NPTS - NUMBER OF DATA POINTS IN XARRAY AND YARRAY
*    INC - INCREMENT WITH WHICH LINE SUBROUTINE IS TO GATHER DATA
*          FROM XARRAY AND YARRAY
*    LINTYP - TYPE OF LINE TO BE DRAWN THROUGH DATA POINTS
*           - A SYMBOL IS PLOTTED EVERY ABS(LINTYP)TH DATA POINT
*           - LINTYP =0  MEANS  DATA POINTS ARE JOINED  BUT NO SYMBOLS
*           - LINTYP <0  MEANS  DATA POINTS ARE NOT JOINED, ONLY SYMBOLS
*                        ARE PLOTTED
*           - LINTYP >0  MEANS  DATA POINTS ARE  JOINED AND SYMBOLS
*                        ARE PLOTTED
*    INTEQ - MAGNITUDE OF INTEQ IS PLOTTING SYMBOL CODE(SEE SYMBOL)
*          - IF NEGATIVE USE OUR SYMBOLS
*          - IF POSITIVE USE CALCOMP SYMBOLS
C ROUTINES CALLED
C        PLT, SYMBOL FROM CALCOMP PACKAGE
C
C AUTHOR - L EVANS            SEPTEMBER 1973
C
************************************************************************
      DIMENSION XARRAY(1),YARRAY(1)
*CALL STATF
*
* RETRIEVE SCALE FACTORS
      IFIRST=NPTS*INC+1
      ISCALE=IFIRST+INC
      XFIRST=XARRAY(IFIRST)
      YFIRST=YARRAY(IFIRST)
      XSCALE=XARRAY(ISCALE)
      YSCALE=YARRAY(ISCALE)
C
C     DEFINE ERROR MESSAGE NUMBER FOR ILLEGAL PEN COORDINTAES
C
      MESSNO=3671
C
C     IF EITHER X OR Y SCALING PARAMETERS ARE ILLEGAL  , TERMINATE JOB
C
*IF -DEF,AELIB5
      IF((LEGVAR(XFIRST).EQ.0).A.(LEGVAR(XSCALE).EQ.0)) GOTO 100
*ENDIF
*IF DEF,AELIB5
      IF((LEGVAR(XFIRST).EQ.0).AND.(LEGVAR(XSCALE).EQ.0)) GOTO 100
*ENDIF
*IF -DEF,AELIB5
      CALL AELERR(MESSNO,1HF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MESSNO,'F')
*ENDIF
*IF -DEF,AELIB5
 100  IF((LEGVAR(YFIRST).EQ.0).A.(LEGVAR(YSCALE).EQ.0)) GOTO 150
*ENDIF
*IF DEF,AELIB5
 100  IF((LEGVAR(YFIRST).EQ.0).AND.(LEGVAR(YSCALE).EQ.0)) GOTO 150
*ENDIF
*IF -DEF,AELIB5
      CALL AELERR(MESSNO,1HF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MESSNO,'F')
*ENDIF
  150 CONTINUE
*
* SET UP COUNTERS
*     IPOINT - INDEX OF POINT BEING PLOTTED
*     ISYMB - INCREMENT AT WHICH SYMBOLS ARE TO BE PLOTTED
*           =0 IF NO SYMBOLS ARE TO BE PLOTTED
*     ISCNT - COUNTER FOR PLOTTING OF SYMBOLS.
*           =0 IF NO SYMBOLS ARE TO BE PLOTTED
*
*
      IPOINT=1
      ISYMB=IABS(LINTYP)
      ISCNT=ISYMB
*
* INITIALIZE PEN CODES
*     IPS - PEN CODE FOR SYMBOL CALL (-2 PEN DOWN,-1 PEN UP)
*     IPP - PEN CODE FOR PLOT CALL (2 PEN DOWN, 3 PEN UP)
*
      IPS=-2
      IF(LINTYP.LT.0)IPS=-1
      IPP=IPS+4
*
* INITIALIZE SYMBOL CODE
      ICODE=IABS(INTEQ)
      ANGLE=0.0
      IF(INTEQ.GT.0)ANGLE=INTEQ
*
* PLOT DATA POINTS
      XP=(XARRAY(1)-XFIRST)/XSCALE
      YP=(YARRAY(1)-YFIRST)/YSCALE
      CALL PLT(XP,YP,3)
      DO 600 I=1,NPTS
          XP=(XARRAY(IPOINT)-XFIRST)/XSCALE
          YP=(YARRAY(IPOINT)-YFIRST)/YSCALE
*         IF    SYMBOL TO BE PLOTTED HERE
*IF -DEF,AELIB5
          IF((ISCNT.EQ.0).O.(ISCNT.NE.ISYMB)) GOTO  400
*ENDIF
*IF DEF,AELIB5
          IF((ISCNT.EQ.0).OR.(ISCNT.NE.ISYMB)) GOTO  400
*ENDIF
*         THEN ...
               CALL SYMBOL(XP,YP,0.08,ICODE,ANGLE,IPS)
               ISCNT=1
               GOTO 500
*         ELSE ...
  400          CALL PLT(XP,YP,IPP)
               IF(ISCNT.NE.0)ISCNT=ISCNT+1
*
 500      IPOINT=IPOINT+INC
 600  CONTINUE
* END OF DATA POINTS
      RETURN
      END
