*DECK LOCRL
      FUNCTION LOCRL(Y,X,NN,IOPT,IER,TOLL)
C
C
C  THIS IS A NEW TABLE LOOKUP FUNCTION TO REPLACE ITABLK,ITABGR
C  AND ITABLS.
C
C  THIS FUNCTION HAS TWO ENTRY POINTS LOCRL AND LOCINT.
C
C  LOCRL(Y,X,N,IOPT,IER,TOL) CALL TO LOCATE A REAL VARIABLE.
C  LOCINT(IY,IX,N,IOPT,IER) CALL TO LOCATE AN INTEGER VARIABLE.
C
C
C  Y IS A REAL VARIABLE.
C  X REAL ARRAY OF VALUES TO BE COMPARED TO Y.
C
C  IY IS AN INTEGER VARIABLE.
C  IX INTEGER ARRAY OF VALUES TO BE COMPARED TO IY.
C
C  NN IS NUMBER OF ELLEMENTS OF X OR IX TO BE SEARCHED.
C  IF NN GT 0 TABLE OF VALUES SEARCHED FROM X(1) ...... X(NN).
C  IF NN LT 0 TABLE OF VALUES SEARCHED FROM X(NN) ...... X(1).
C
C  IOPT INTEGER VARIABLE OF OPTION CHOICES.
C   = 1 LOCATE FIRST ELEMENT IN X EQUAL TO OR EQUAL WITHIN
C     TOLERENCE(TOL) OF Y.
C   = 2 LOCATE FIRST ELEMENT LE Y.
C   = 3 LOCATE FIRST ELEMENT GE Y.
C   = 4 LOCATE FIRST ELEMENT CLOSEST TO Y.
C
C  TOL REAL VARIABLE SPECIFYING TOLERENCE FOR LOCRL ENTRY WHEN IOPT=1.
C  TOL WILL BE SET TO 0.0 IF INDEFINITE OR INFINITE.
C
C  EXIT VALUES.
C
C  IER ERROR FLAG.
C  IF IER = 0 NO ERROR OCCURRED.
C  IF IER = 1 IF NO ELEMENT FOUND AND FUNCTION VALUE SET TO ZERO
C  IF IER = 2 IF MORE THAN ONE ELEMENT CLOSEST TO Y AND
C  FUNCTION VALUE SET TO INDEX OF FIRST ELEMENT FOUND PRINTED VIA AELERR
C  IF IER = 3 FOR ILLEGAL ARGUMENTS AND MESSAGE NUMBER 3802
C  ***ILLEGAL ARGUMENT - FUNCTION VALUE SET TO ZERO IS PRINTED VIA AELER
C
C FUNCTIONS RETURNS WITH LOCATION (INDEX) OF VARIABLE IN ARRAY.
C  IN THE CASE OF ERROR
C  IN THE CASE OF IER = 1 AND IER = 3 VALUE OF FUNCTION WILL BE ZERO.
C  FOR CASE OF IER = 2 THE LOCATION OF THE FIRST ELLEMENT FOUND WILL
C  BE RETURNED.
C
C
C  AUTHOR D.G. STEWART MATHEMATICS AND COMPUTATION.
C  INSTALLED MARCH 1976.
C
C
C REVISED BY M. T. BOULANGER   MAY 1982.
C     TO - HANDLE SPECIAL CASE WHERE THE FIRST ELEMENT OF THE
C          ARRAY BEING SEARCHED IS EQUAL TO Y.
C
C
      REAL X(1)
      EQUIVALENCE(XX,IX),(YY,IY)
C
C     ERROR MESSAGE NUMBER FOR LOCRL/LOCINT
C
      DATA MESNO/3802/
*CALL STATF
C
C  CHECKING FOR ILLEGAL ARGUMENTS.
      IF(IOPT.LT.1.OR.IOPT.GT.4) GO TO 960
      IF(LEGVAR(Y).NE.0) GO TO 960
      IF(NN.EQ.0) GO TO 960
C
      IER=0
      M=0
C  IF  M = 1 THE ARRAY TO BE SEARCHED BACKWARDS.
      IF(NN.LT.0) M=1
      N=IABS(NN)
      TOL=TOLL
C
*IF -DEF,AELIB5
      GO TO(100,200,300,400),IOPT
*ENDIF
*IF DEF,AELIB5
      GO TO(100,200,300,400),IOPT
      CALL GOTOER
*ENDIF
C
C  IF IOPT = 1 LOCATE FIRST REAL ELEMENT EQUAL TO OR EQUAL WITHIN A
C  TOLERENCE(TOL) OF Y.
 100  IF(LEGVAR(TOL).NE.0) TOL=0.0
      DO 110 I=1,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      IF(ABS(X(J)-Y).LT.TOL) GO TO 120
 110  CONTINUE
      GO TO 900
 120  LOCRL=J
      RETURN
C
C  IF IOPT = 2 LOCATE FIRST REAL ELEMENT LE Y.
 200  DO 210 I=1,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      IF(X(J).LE.Y) GO TO 220
 210  CONTINUE
      GO TO 900
 220  LOCRL=J
      RETURN
C
C  IF IOPT = 3 LOCATE FIRST REAL ELEMENT GE Y.
 300  DO 310 I=1,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      IF(X(J).GE.Y) GO TO 320
 310  CONTINUE
      GO TO 900
 320  LOCRL=J
      RETURN
C
C  IF IOPT = 4 LOCATE FIRST REAL ELEMENT CLOSEST TO Y.
 400  IF(LEGVAR(X(1)).NE.0) GO TO 960
C  THIS VALUE OF XM ENSURES FIRST ELEMENT OF ARRAY IS CHECKED.
      IST = 1
      XM=ABS(X(1)-Y)*100.
      IF ( XM .NE. 0.0 ) GO TO 405
      IS = 1
      IST = 2
 405  DO 430 I=IST,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      XM1=ABS(X(J)-Y)
      IF(XM1-XM) 410,420,430
 410  XM=XM1
      ICK=0
      IS=J
      GO TO 430
C  IF ICK = 1 IF IF MORE THAN 1 ELEMENT FOUND CLOSEST TO Y.
 420  ICK = 1
 430  CONTINUE
      LOCRL=IS
      IF(ICK.EQ.1) GO TO 950
      IER=0
      RETURN
C
C  ENTRY POINT FOR INTEGER ELEMENTS.
C
*IF -DEF,AELIB5
      ENTRY LOCINT
*ENDIF
*IF DEF,AELIB5
      ENTRY LOCINT(Y,X,NN,IOPT,IER,TOLL)
*ENDIF
*CALL STATF
C
C  CHECKING FOR ILLEGAL ARGUMENTS.
      IF(IOPT.LT.1.OR.IOPT.GT.4) GO TO 960
      IF(LEGVAR(Y).NE.0) GO TO 960
      IF(NN.EQ.0) GO TO 960
C
      IER=0
      M=0
C  IF  M = 1 THE ARRAY TO BE SEARCHED BACKWARDS.
      IF(NN.LT.0) M=1
      N=IABS(NN)
      YY=Y
C
*IF -DEF,AELIB5
      GO TO(500,600,700,800),IOPT
*ENDIF
*IF DEF,AELIB5
      GO TO(500,600,700,800),IOPT
      CALL GOTOER
*ENDIF
C
C  IF IOPT = 1 LOCATE FIRST INTEGER ELEMENT EQUAL TO IY.
 500  DO 510 I=1,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      XX=X(J)
      IF(IX.EQ.IY) GO TO 520
 510  CONTINUE
      GO TO 900
 520  LOCRL=J
      RETURN
C
C  IF IOPT = 2 LOCATE FIRST INTEGER ELEMENT LE IY.
 600  DO 610 I=1,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      XX=X(J)
      IF(IX.LE.IY) GO TO 620
 610  CONTINUE
      GO TO 900
 620  LOCRL=J
      RETURN
C
C  IF IOPT = 3 LOCATE FIRST INTEGER ELEMENT GE IY.
 700  DO 710 I=1,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      XX=X(J)
      IF(IX.GE.IY) GO TO 720
 710  CONTINUE
      GO TO 900
 720  LOCRL=J
      RETURN
C
C  IF IOPT = 4 LOCATE FIRST INTEGER ELEMENT CLOSEST TO IY.
 800  IF(LEGVAR(X(1)).NE.0) GO TO 960
      XX=X(1)
      IST = 1
C  THIS VALUE OF IM ENSURES FIRST ELEMENT OF ARRAY IS CHECKED.
      IM=IABS(IX-IY)*100
      IF ( IM .NE. 0 ) GO TO 805
      IS = 1
      IST = 2
 805  DO 830 I=IST,N
      J=IABS((N+1)*M-I)
      IF(LEGVAR(X(J)).NE.0) GO TO 960
      XX=X(J)
      IM1=IABS(IX-IY)
      IF(IM1-IM) 810,820,830
 810  IM=IM1
      ICK=0
      IS=J
      GO TO 830
C  IF ICK = 1 IF IF MORE THAN 1 ELEMENT FOUND CLOSEST TO IY.
 820  ICK = 1
      ICK = 1
 830  CONTINUE
      LOCRL=IS
      IF(ICK.EQ.1) GO TO 950
      IER=0
      RETURN
C
C
C  ERROR PROCESSING SECTION.
C
C  IER = 1 IF NO ELEMENT FOUND FOR OPTIONS 1,2, OR 3.
 900  CONTINUE
      IER=1
      LOCRL=0
      RETURN
C
C  IER = 2 FOR MORE THAN 1 ELEMENT CLOSEST TO Y(IOPT = 4).
 950  CONTINUE
      IER=2
      RETURN
C
C  IER = 3 FOR AN ILLEGAL ARGUMENT.
 960  IER=3
      LOCRL=0
*IF -DEF,AELIB5
      CALL AELERR(MESNO,2HNF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MESNO,'NF')
*ENDIF
C
      RETURN
      END
