*DECK LOGLOG
       SUBROUTINE LOGLOG (XL,YL,EXXL,NCX,EXYL,NCY,FORMX,NTX,FORMY,NTY)
       DIMENSION ALOGXY(3),XX(3),YY(3)
C
C THE SUBROUTINE HAS TWO ENTRY POINTS:
C    LOGLOG  - ALLL DIMENSIONAL QUANTITIES PASSED IN THE ARGUMENT LIST
C ARE IN INCHES
C    LOGLOGM - ALL DIMENSIONAL QUANTITIES ARE IN MILLIMETERS
C DIMENSIONAL QUANTITIES ARE PASSED IN THE ARGUMENT LIST AND ON THE
C METRIC ENTRY, LOGLOGM, THEY ARE CONVERTED TO ENGLISH UNITS, THE
C INTERNAL WORKING UNITS OF THE ROUTINE.  CALLS TO PLOT ARE MADE BY
C LOGLOG AND LOGLOGM MAKES CORRESPONDING CALLS TO PLOTM.  DIMENSIONAL
C QUANTITIES ARE CONVERTED BACK TO MILLIMETERS BEFORE A PLOTM MODE 1
C CALL TO PLOT THE FRAME IS MADE BY LOGLOGM.
C
       REAL MTOE
       LOGICAL METRIC
       DATA TITLE1/4H(I3)/,TITLE2/6H(2H10)/,TITLE3/4H(I1)/
       DATA ALOGXY/0,0.30103,0.69897/
*CALL STATF
       METRIC=.FALSE.
       XLE=XL
       YLE=YL
       GO TO 10
C
C
C     ENTRY LOGLOGM ALLOWS USE OF METRIC DIMENSIONS
C
*IF -DEF,AELIB5
       ENTRY LOGLOGM
*ENDIF
*IF DEF,AELIB5
       ENTRY LOGLOGM(XL,YL,EXXL,NCX,EXYL,NCY,FORMX,NTX,FORMY,NTY)
*ENDIF
*CALL  STATF
       METRIC=.TRUE.
       ETOM=25.4
       MTOE=1./ETOM
C
C     CONVERT METRIC DIMENSIONS TO ENGLISH
C
       XLE=XL*MTOE
       YLE=YL*MTOE
C
   10  LEXX=EXXL
       LEXY=EXYL
       EXL=LEX=LEXX - IABS(NCX)
       EYL=LEY=LEXY - IABS(NCY)
       CXLX=(EXXL-EXL)/XLE
       CYLY=(EXYL-EYL)/YLE
C
       TICXX=TICYY=0.0
       IF (NCX.LT.0) TICXX=1.0
       IF (NCY.LT.0) TICYY=1.0
       IF (METRIC) GO TO 20
       CALL PLOT(1,XLE,YLE,EXL,EXXL,EYL,EXYL,TICXX,TICYY)
       GO TO 30
C
C     CONVERT ENGLISH DIMENSIONS TO METRIC BEFORE PLOTTING THE FRAME
C
   20  XLM=XLE*ETOM
       YLM=YLE*ETOM
       CALL PLOTM(1,XLM,YLM,EXL,EXXL,EYL,EXYL,TICXX,TICYY)
   30  IF (NCX.LT.0) GO TO 110
       YY(1)=EYL
       YY(2)=EXYL
       DO 100 I=LEX,LEXX
          JJ=1
          IF (I.EQ.LEX) JJ=2
          DO 100 J=JJ,3
             XX(1)=XX(2)=I+ALOGXY(J)
             IF (XX(1).GE.EXXL) GO TO 110
             IF (METRIC) GO TO 40
             CALL PLOT(2,1,0,XX,YY,2)
             GO TO 50
   40        CALL PLOTM(2,1,0,XX,YY,2)
   50        YY(3)=YY(2)
             YY(2)=YY(1)
             YY(1)=YY(3)
  100  CONTINUE
  110  IF(NTX.EQ.0) GO TO 120
       XLOC=0.5*(EXXL+EXL) - 0.08*CXLX*NTX
      IF(XLOC.LT.EXL)XLOC=EXL
       YLOC=EYL - 0.5*CYLY
       IF (METRIC) GO TO 115
       CALL PLOT(3,FORMX,2,0,XLOC,YLOC)
       GO TO 120
  115  CALL PLOTM(3,FORMX,2,0,XLOC,YLOC)
  120  Y5=0.125*CYLY
       Y4=LEY - Y5
       JJ=LEXX + LEX
       DO 300 I=LEX,LEXX
          J=JJ-I
          DO 200 K=2,3
             XLOC=J+ALOGXY(5-K)
             IF (XLOC.GT.EXXL) GO TO 200
             L=-3*K+11
             IF (METRIC) GO TO 130
             CALL PLOT(3,TITLE3,1,0,XLOC,Y4,L,1)
             GO TO 140
  130        CALL PLOTM(3,TITLE1,1,0,XLOC,Y4,L,1)
  140        IF (NCX.GE.0) GO TO 200
             XX(1)=XX(2)=XLOC
             YY(1)=EYL
             YY(2)=EYL+0.13*CYLY
             IF (METRIC) GO TO 150
             CALL PLOT(2,1,0,XX,YY,2)
             GO TO 200
  150        CALL PLOTM(2,1,0,XX,YY,2)
  200     CONTINUE
          XLOC=J-0.25*CXLX
          YLOC=LEY-0.25*CYLY
          IF (METRIC) GO TO 210
          CALL PLOT(3,TITLE2,2,0,XLOC,YLOC)
          GO TO 220
  210     CALL PLOTM(3,TITLE2,2,0,XLOC,YLOC)
  220     XLOC=J
          IF (METRIC) GO TO 230
          CALL PLOT(3,TITLE1,1,0,XLOC,Y4,J,1)
          GO TO 300
  230     CALL PLOTM(3,TITLE1,1,0,XLOC,Y4,J,1)
  300  CONTINUE
       IF (NCY.LT.0) GO TO 410
       XX(1)=EXL
       XX(2)=EXXL
       DO 400 I=LEY,LEXY
          JJ=1
          IF (I.EQ.LEY) JJ=2
          DO 400 J=JJ,3
             YY(1)=YY(2)=I+ALOGXY(J)
             IF (YY(1).GE.EXYL) GO TO 410
             IF (METRIC) GO TO 310
             CALL PLOT(2,1,0,XX,YY,2)
             GO TO 320
  310        CALL PLOTM(2,1,0,XX,YY,2)
  320        XX(3)=XX(2)
             XX(2)=XX(1)
             XX(1)=XX(3)
  400  CONTINUE
  410  IF (NTY.EQ.0) GO TO 430
       XLOC=LEX - 0.65*CXLX
       YLOC=0.5*(EXYL+EYL) - 0.08*CYLY*NTY
      IF(YLOC.LT.EYL)YLOC=EYL
       IF (METRIC) GO TO 420
       CALL PLOT(3,FORMY,2,6,XLOC,YLOC)
       GO TO 430
  420  CALL PLOTM(3,FORMY,2,6,XLOC,YLOC)
  430  JJ=LEXY+LEY
       DO 600 I=LEY,LEXY
          J=JJ-I
          DO 500 K=2,3
             YLOC=J+ALOGXY(5-K)
             IF (YLOC.GE.EXYL) GO TO 500
             XLOC=EXL-0.125*CXLX
             L=-3*K+11
             IF (METRIC) GO TO 440
             CALL PLOT(3,TITLE3,1,0,XLOC,YLOC,L,1)
             GO TO 450
  440        CALL PLOTM(3,TITLE3,1,0,XLOC,YLOC,L,1)
  450        IF (NCY.GE.0) GO TO 500
             XX(1)=EXL
             XX(2)=EXL+0.13*CXLX
             YY(1)=YY(2)=YLOC
  500     CONTINUE
          XLOC=EXL-0.6*CXLX
          YLOC=J-0.64*Y5
          IF (METRIC) GO TO 510
          CALL PLOT(3,TITLE2,2,0,XLOC,YLOC)
          GO TO 520
  510     CALL PLOTM(3,TITLE2,2,0,XLOC,YLOC)
  520     XLOC=EXL-0.3*CXLX
          YLOC=J+0.36*Y5
          IF (METRIC) GO TO 530
          CALL PLOT(3,TITLE1,1,0,XLOC,YLOC,J,1)
          GO TO 600
  530     CALL PLOTM(3,TITLE1,1,0,XLOC,YLOC,J,1)
  600  CONTINUE
       IF (NCX.LT.0) GO TO 620
  610  IF (NCY.LT.0) GO TO 710
       RETURN
C
  620  DO 700 I=LEX,LEXX
          DO 700 K=2,3
             XLOC=I+ALOGXY(K)
             IF (XLOC.GE.EXXL) GO TO 610
             XX(1)=XX(2)=XLOC
             YY(1)=EXYL-0.13*CYLY
             YY(2)=EXYL
             IF (METRIC) GO TO 630
             CALL PLOT(2,1,0,XX,YY,2)
             GO TO 700
  630        CALL PLOTM(2,1,0,XX,YY,2)
  700  CONTINUE
       GO TO610
C
  710  JJ=LEY+LEXY
       DO 900 I=LEY,LEXY
          J=JJ-I
          DO 800 K=2,3
             YLOC=J+ALOGXY(5-K)
             IF (YLOC.GE.EXYL) GO TO 800
             XX(1)=EXXL-0.13*CXLX
             XX(2)=EXXL
             YY(1)=YY(2)=YLOC
             IF (METRIC) GO TO 720
             CALL PLOT(2,1,0,XX,YY,2)
             GO TO 800
  720        CALL PLOTM(2,1,0,XX,YY,2)
  800     CONTINUE
  900  CONTINUE
       RETURN
       END
