*DECK NUMBER
      SUBROUTINE NUMBER(XXX,YYY,H,FPN,ANGLE,MDEC)
************************************************************************
**                                                                    **
**    NOTE THAT NUMBER IS WRITTEN IN MODULAR FORM USING THE ADDITIONAL**
**    ROUTINE:                                                        **
**       PLFL                                                         **
**    PLFL IS STORED ON AELIB SOURCE TAPE WITH ROUTINE PLT UNDER DECK **
**    NAME PLT.                                                       **
**                                                                    **
************************************************************************
C
C THIS SUBROUTINE PLOTS FLOATING POINT NUMBERS TO DESIRED ACCURACY IN
C EITHER F OR I TYPE FORTRAN FORMATS
C
C ARGUMENT LIST
C    XXX  -
C    YYY  -  COORDINATES, IN INCHES, OF THE LOWER LEFT HAND CORNER OF
C            THE FIRST CHARACTER TO BE PRODUCED. THE PEN IS UP WHILE
C            MOVING TO THIS POINT
C          - IF EITHER OR BOTH COORDINATES HAVE A VALUE OF 999., THIS
C            MEANS THAT THE VALUE OF THAT COORDINATE WILL BE
C            THAT VALUE DEFINED BY WHERE SUBROUTINE.(SEE INTRODUCTORY
C            COMMENTS FOR THAT ROUTINE)
C
C    H -  HEIGHT,IN INCHES, OF CHARACTER TO BE PLOTTED. FOR OUT PLOTTER
C         ONLY  INTEGRAL MULTIPLES OF .08 IN.  BETWEEN .08 AND .8 IN.
C         ARE ALLOWED, SO HEIGHT IS ROUNDED TO CLOSEST VALUE
C    ANGLE - ANGLE,IN DEGREES FROM THE X-AXIS  AT WHICH ANNOTATION IS TO
C            BE PLOTTED. FOR OUR PLOTTER ONLY INTEGRAL MULTIPLES OF
C            45 DEGREES BETWEEN 0 AND 360 DEGREES ARE ALLOWED,SO ANGLE
C            IS CONVERTED TO NEXT HIGHEST SUCH VALUE
C            (NOTE - CHARACTERS PLOTTED AT ODD MULTIPLES OF 45 DEGREES
C            ARE SQRT(2)*HEIGHT, WHERE HEIGHT CALCULATED AS ABOVE)
C    FPN - FLOATING POINT NUMBER THAT IS TO BE CONVERTED AND PLOTTED
C    MDEC - DEFINES DESIRED ACCURACY FOR PRINTING FPN
C         - MDEC GT 0 MEANS NDEC DIGITS TO RIGHT OF DECIMAL ARE TO BE
C           PLOTTED(AFTER ROUNDING)
C         - MDEC EQ 0 MEANS ONLY INTEGER PORTION AND DECIMAL ARE TO BE
C           PLOTTED(AFTER ROUNDING)
C         - MDEC LT 0 MEANS FPN IS ROUNDED TO AN INTEGER FIRST, THEN
C           -MDEC-1 DIGITS ARE TRUNCATED FROM LOW ORDER. THE RESULTING
C           INTEGER IS PLOTTED WITH NO DECIMAL POINT
C         - IF MAGNITUDE OF MDEC GT 9,THEN MAGNITUDE SET TO 9 WITH SAME
C           SIGN
C
C ROUTINES CALLED -
C        PLFL FROM CALCOMP PACKAGE
C        PLOT FROM AELIB
C
C AUTHOR - L EVANS       SEPTEMBER 1973
C REVISION - TO OPTIMIZE PLOTTING BY L EVANS OCTOBER 1975
C REVISION - TO FIX PLOTTING OF INTEGER WITH DECIMAL POINT L EVANS
C                                   JANUARY 1976
C
      INTEGER FORM(10)
      EQUIVALENCE(IFPN,PFPN)
*CALL BLOCK
*CALL BLOCKS
*CALL STATF
*CALL ERROR
*CALL PLCHK
C
C     DO ARGUMENT CHECKING ON XXX AND YYY. IF EITHER ILLEGAL, PRINT
C     A MESSAGE AND RETURN
C
      LX=LEGVAR(XXX)
      LY=LEGVAR(YYY)
*IF -DEF,AELIB5
      IF((LX.EQ.0).A.(LY.EQ.0)) GOTO 1
*ENDIF
*IF DEF,AELIB5
      IF((LX.EQ.0).AND.(LY.EQ.0)) GOTO 1
*ENDIF
*IF -DEF,AELIB5
      CALL AELERR(MESSNO,1HF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MESSNO,'F')
*ENDIF
  1   CONTINUE
C
C     ADJUST CALCOMP PARAMETERS
C
      X=XXX
      Y=YYY
      NDEC=MDEC
      ISIZE=(H*FACT)/.08
      IF((ISIZE*.08+.04).LT.H*FACT) ISIZE=ISIZE+1
      IF(ISIZE.EQ.0) ISIZE=1
      IF(ISIZE.GT.10)ISIZE=3
      XX=XN
      IF(X .NE.999.)XX=XORG+X*FACT
      YY=YN
      IF(Y .NE.999.)YY=YORG+Y*FACT
C
C     ONLY IMPLEMENT NUMBER IF STARTING COORDINATES ARE IN RANGE
C
      A=ANGLE/57.256
      DIR=AMOD((360.-ANGLE)/45.,8.)
      IDIR=DIR
      RSIZE=ISIZE
      IF(FLOAT(IDIR/2).NE.(DIR/2.)) RSIZE=RSIZE*1.4
C
C CALCULATE FORMAT FOR PLOTTING FPN TO DESIRED ACCURACY
C
      IF(IABS(NDEC).GT.9)NDEC=ISIGN(9,NDEC)
      IF(NDEC.GT.0) GOTO 1100
C PLOT FPN AS AN INTEGER
      IF(NDEC.EQ.0) GOTO 1000
      FFPN=FPN+SIGN(1.,FPN)*.5
      IFPN=FFPN*10.**(NDEC+1)
C NO DECIMAL POINT
      IF(IFPN.EQ.0)LEN=2
      IF(IFPN.NE.0) LEN=ALOG10(FLOAT(IABS(IFPN)))+2
      IF(LEN.GE.10) GOTO 800
      ENCODE(4,100,FORM)LEN
  100 FORMAT(2H(I,I1,1H))
      GOTO 2100
  800 ENCODE(5,101,FORM)LEN
  101 FORMAT(2H(I,I2,1H))
      GOTO 2100
C DECIMAL POINT ON INTEGER
 1000 PFPN=FPN
      AFFPN=ABS(PFPN)
      LEN=3
      IF(AFFPN.GE.10) LEN=LEN + ALOG10(AFFPN)
      IF(LEN.GE.10)GOTO 1010
      ENCODE(5,102,FORM)LEN
  102 FORMAT(2H(F,I1,2H.))
      GOTO 2100
 1010 ENCODE(6,103,FORM)LEN
  103 FORMAT(2H(F,I2,2H.))
      GOTO 2100
C FLOATING POINT FORMAT
 1100 FFPN=FPN+SIGN(.5*10.**(-NDEC),FPN)
      PFPN=FPN
C
C     LENGTH IS 3+NDEC UNLESS ABS(FPN)GE10.
C
      AFFPN=ABS(FFPN)
      LEN=3
      IF(AFFPN.GE.10.)LEN=LEN+ALOG10(AFFPN)
      LEN=LEN+NDEC
      IF(LEN.GE.10) GOTO 1200
C PREPARE FX.Y
      ENCODE(6,104,FORM)LEN,NDEC
  104 FORMAT(2H(F,I1,1H.,I1,1H))
      GOTO 2100
C PREPARE FXX.Y
 1200 IF(NDEC.GE.10) GOTO 1300
      ENCODE(7,105,FORM)LEN,NDEC
  105 FORMAT(2H(F,I2,1H.,I1,1H))
      GOTO 2100
C PREPARE FXX.YY
 1300 ENCODE(8,106,FORM)LEN,NDEC
 106  FORMAT(2H(F,I2,1H.,I2,1H))
      GOTO 2100
 2100  CONTINUE
C
C     IMPLEMENT NUMBER CALL BY A PLOT MODE 3 CALL
C
C     PLOT"S ENTRY POINT PLOTC IS USED HERE TO AVOID A POSSIBLE NAME
C     CONFLICT WITH CALCOMP"S ROUTINE CALLED PLOT (CALLING PLOTC
C     PRODUCES THE SAME RESULTS AS CALLING PLOT)
      CALL PLOTC(3,FORM,ISIZE,IDIR,XX,YY,IFPN,1)
C
C     UPDATE PRESENT POSITION POINTERS XN,YN
C
 2299 XN=COS(A)*IABS(LEN)*RSIZE*.08+XX
      YN=SIN(A)*IABS(LEN)*RSIZE*.08+YY
 2300 RETURN
      END
