*DECK OCSOLVE
      SUBROUTINE OCSOLVE(X,N,W,IER)
C
C THIS ROUTINE SOLVES SYSTEMS OF SIMULTANEOUS EQUATIONS USING GAUSSIAN
C ELIMINATION WITH PARTIAL PIVOTING. IT DOES THIS BY COMPLETELY OPERATIN
C ON EACH COLUMN ONE AT A TIME.
C THREE LEVELS OF MEMORY ARE USED. 4*N WORDS OF CENTRAL MEMORY, FOR OP-
C ERATIONS , DISK FOR FIRST STORING MATRIX , THEN UPPER TRIANGULAR
C MATRIX AND EXTENDED CORE FOR THE STORAGE OF MULTIPLIERS.
C
C KEN CHAPLIN JANUARY 1976
      REAL M(1),W(1),X(1),IND18(600)
      INTEGER RELESE
*IF -DEF,AELIB5
      COMMON /MATRIX1/M(1)
*ENDIF
*IF DEF,AELIB5
      COMMON/MATRIX1/M
*ENDIF
      COMMON /MATRIX2/AM2(1)
      COMMON /MATRIX3/AM3(1)
      COMMON /MATRIX4/AM4(1)
*IF -DEF,AELIB5
      LEVEL 3,M,AM2,AM3,AM4
      DATA ADEF/60007777777777777777B/
*ENDIF
*IF DEF,AELIB5
      LEVEL 3,/MATRIX1/,/MATRIX2/,/MATRIX3/
      DATA ADEF/O"60007777777777777777"/
*ENDIF
*CALL STATF
C
C     MSG1 AND MSG2 ARE THE INTEGERS REFFERING TO ERROR MESSAGES
C     IN AELERR
C
C     MSG1=650 IS "SINGULAR MATRIX IN OCSOLVE"
C     MSG2=651 IS "ILLEGAL ARGUMENT IN OCSOLVE,INFINITE OR
C     INDEFINITE IN MATRIX OR RIGHT HAND SIDE"
C
*IF -DEF,AELIB5
      A=6LTAPE18
*ENDIF
*IF DEF,AELIB5
      A=L"TAPE18"
*ENDIF
      CALL OPENMS(18,IND18,600,0)
      CALL READMS(17,W ,N,1)
      MSG1=650
      MSG2=651
      N2=2.*N
      N1=N+1
C
C     FIND PIVOTAL ELEMENT AND MULTIPLIERS FOR FIRST COLUMN
C
      PIVOT=0.
      DO 10 I=1,N
         IF(LEGVAR(W(I)).NE.0.) GOTO 270
         AA=ABS(W(I))
         IF(PIVOT.GE.AA) GOTO 10
            PIVOT=AA
            IR=I
   10 CONTINUE
      IF(PIVOT.EQ.0.) GOTO 250
      PIVOT=W(IR)
      W(IR)=W(1)
      W(1)=PIVOT
      X(1)=PIVOT
      W(N+1)=FLOAT(IR)
      DO 20 I=2,N
         W(N2+I-1)=W (I)/PIVOT
   20 CONTINUE
   30 CALL MOVLEV(W(N2+1),M,N-1)
      L1=2
      L2=1
C
C     OPERATE ON EACH OF THE NEXT COLUMNS ONE AT A TIME.,
C
      DO 140 I=2,N
         CALL READMS(17,W ,N,I)
         DO 40 J=1,N
            IF(LEGVAR(W(I)).NE.0.) GOTO 270
   40    CONTINUE
         J1=1
         I1=I-1
         DO 60 J=1,I1
C
C           READ IN MULTIPLIERS
C
            CALL MOVLUV(M,W(N2+1),N-J,J1)
            J1=J1+N-J
            J2=IFIX(W(J+N))
            K1=0
            PIV=W(J2)
            W(J2)=W(J)
            W(J)=PIV
            JP=J+1
C
C           OPERATE ON COLUMN
C
            DO 50 K=JP,N
               K1=K1+1
               W (K)=W (K)-W(N2+K1)*PIV
   50       CONTINUE
   60    CONTINUE
         IF(I.NE.N) GOTO 70
            IF(W(N).EQ.0.) GOTO 250
            GOTO 100
   70    PIVOT=0
C
C        FIND PIVOTAL ELEMENT
C
         DO 80 J=I,N
            AA=ABS(W(J))
            IF(PIVOT.GE.AA) GOTO 80
               PIVOT=AA
               IR=J
   80    CONTINUE
         IF(PIVOT.EQ.0.) GOTO 250
         PIVOT=W(IR)
         W(IR)=W(I)
         W(I)=PIVOT
         W(I+N)=FLOAT(IR)
         J2=0
         IP=I+1
C
C        FIND MULTIPLIERS FOR THIS COLUMN
C
         DO 90 J3=IP,N
            J2=J2+1
            W(N2+J2)=W (J3)/PIVOT
   90    CONTINUE
         CALL MOVLUV(W(N2+1),M,N-I,J1)
C
C        WRITE ONLY THE NONZERO ELEMENTS BACK ONTO DISK
C
  100    L12=L1+I-1
         J4=N-L12
         IF(J4.LT.0)L12=N
         J2=0
  110    DO 120 J=L1,L12
            J2=J2+1
            X(J)=W(J2)
  120    CONTINUE
         IF(J4.GT.0) GOTO 130
            L2=L2+1
            CALL WRITMS(18,X,N,L2)
            L1=1
            L12=I-J2
            IF(J4.EQ.0) GOTO 140
            J4=1
            GOTO 110
  130    L1=L12+1
  140 CONTINUE
C
C     READ IN THE RHS AND OPERATE ON IT
C
      CALL READMS(17,W ,N,N1)
      DO 150 I=1,N
         IF(LEGVAR(W(I)).NE.0.) GOTO 270
  150 CONTINUE
      J1=1
      I1=N-1
      DO 170 J=1,I1
         CALL MOVLUV(M,W(N2+1),N-J,J1)
         J1=J1+N-J
         J2=IFIX(W(N+J))
         K1=0
         PIV=W(J2)
         W(J2)=W(J)
         W(J)=PIV
         JP=J+1
         DO 160 K=JP,N
            K1=K1+1
            W (K)=W (K)-W(N2+K1)*PIV
  160    CONTINUE
  170 CONTINUE
C
C     SOLVE UPPER TRIANGULAR MATRIX FOR SOLUTIONS
C
      I1=N
      L2=L2+1
      IF(J4.EQ.0) GOTO 220
         X(N)=W (N)/X(L1-1)
         J3=2-N
         IF(L1-2.EQ.0) GOTO 230
         J1=1
         J2=L1-2
         I3=N
         K=J2+1
         DO 180 J=J1,J2
            I3=I3-1
            K=K-1
  180    W (I3)=W (I3)-X(K)*X(N)
         J3=I3-N
         GOTO 230
  190    X(I1)=W (I1)/W(N2+I2)
         I3=I1
         IF(I2.EQ.1) GOTO 230
  200    K=J2+1
         DO 210 J=J1,J2
            K=K-1
            I3=I3-1
            W (I3)=W (I3)-W(N2+K)*X(I1)
  210    CONTINUE
         IF(I4.EQ.0) GOTO 230
         I1=I1-1
         IF(I1.EQ.1) GOTO 240
         I2=J1-1
         J2=J1-2
         J1=J1-I1
         I4=1
         IF(J1.GT.0) GOTO 190
         J3=J1
         J1=1
         I4=0
  220 IF(I2.GT.0) GOTO 190
      J2=N-1
      I2=N
      J1=N-I1+1
      L2=L2-1
      CALL READMS(18,W(N2+1),N,L2)
      I4=1
      GOTO 190
  230 L2=L2-1
      CALL READMS(18,W(N2+1),N,L2)
      I4=1
      J2=N
      J1=N+J3
      GOTO 200
  240 X(1)=W(1)/W(N2+1)
      IER=0
      I5=RELESE(A,0)
      RETURN
  250 IER=130
*IF -DEF,AELIB5
      CALL AELERR(MSG1 ,2HNF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MSG1 ,'NF')
*ENDIF
      DO 260 I=1,N
         X(I)=ADEF
  260 CONTINUE
      I5=RELESE(A,0)
      RETURN
  270 IER=129
*IF -DEF,AELIB5
      CALL AELERR(MSG2 ,2HNF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MSG2 ,'NF')
*ENDIF
      DO 280 I=1,N
         X(I)=ADEF
  280 CONTINUE
      I5=RELESE(A,0)
      RETURN
      END
