*DECK OFLOW
          IDENT OFLOW
          COMMENT   RETURN CONTROL AFTER OVERFLOW
**        OFLOW
*
*         TITLE
*           RETURN CONTROL TO USERS PROGRAM AFTER AN OVERFLOW
*
*         ENTRY
*           CALL OFLOW (I), RETURNS (L)
*            WHERE
*               I =      ABSENT - TURN OFLOW OFF
*                       PRESENT - TURN OFLOW ON
*                                  RECEIVES CONTENTS OF RA+0 ON REPREIVE
*               L = LABEL NO OF STATEMENT TO BE  EXECUTED AFTER AN
*                   ARITHIMETIC OVERFLOW HAS OCCURED.
*
*         EXIT
*           IF AN ARITHIMETIC OVERFLOW OCCURS, THEN STATEMENT AT
*           -L- IS EXECUTED.
*
*           IF MORE THAN 50 OVERFLOWS OCCUR, THEN EXECUTION IS
*           TERMINATED WITH THE MESSAGE
*              ***MORE THAN 50 MODE ERRORS ENCOUNTERED
*
*         CALLS
*           RECOVR - IN SYSTEM LIBRARY
*           RECV.1, RECV.2  IN RECOVR
*
          ENTRY OFLOW
          EXT RECOVR
TRACE.    VFD    42/5HOFLOW,18/OFLOW
 OFLOW    DATA 0
          SPACE  2,8
*  PICK UP FORMAL PARAMETERS. IF NONE GIVEN, OR IF NO RETURN ADDRESS
*  GIVEN, TURN OFLOW OFF.
          SB1 1
          SA2 A1+B1                WILL BE -0 IF RETURNS, +0 IF NO RETUR
          MX6 0
          SA3 LF                   OFLOW ON-OFF FLAG 1=ON  0=OFF
          ZR X1,SETP               CLEAR IF EMPTY PARAMETER LIST
*IF -DEF,AELIB5
          PL X2,SETP               CLEAR IF NO RETURNS
*ENDIF
*IF DEF,AELIB5
          ZR     X2,SETP      CLEAR IF NO RETURNS
*ENDIF
          SPACE  2,8
*  TURN ON OFLOW. SAVE CONTENTS OF A0 AND ADDRESS OF -I-, AND -L-.
          SX6 B1+B0                TURN ON OFLOW RECOVERY FLAG
          SA6 A3
          SX6 A0
          SA6 SAO                  STORE A0 AT SAO
          SX7 X1                   X1 IS ADDRESS OF I
          SA7 SI                   ADDRESS OF I IS STORED AT SI
*IF -DEF,AELIB5
          SA1 A2+B1
          SX6    X1
          SA6    SLAB         SAVE ADDRESS OF -L-
*ENDIF
          SPACE  2,8
*  IF THIS IS THE FIRST TIME THRU, CALL -RECOVR-, THEN CALL -RECV.1- TO
*  GET THE CURRENT STACK INDEX WHICH IS SAVED IN -SSTI-.
          SA2 RF
          NZ X2,SETQ               GO TO SETQ IF RECOVR CALLED BEFORE
          SX6 B1
          SA6 A2
          SA1 AP
          RJ RECOVR
          RJ     =XRECV.1
          SA6    SSTI         SAVE STACK INDEX
*IF DEF,AELIB5
          SX1    0            NORMAL RETURN
*ENDIF
          JP OFLOW
 SETP     SA6 A3                  ZERO IF OFLOW TURNED OFF
*IF DEF,AELIB5
          SX1    0            NORMAL RETURN
*ENDIF
 SETQ     JP OFLOW
          SPACE  4,8
**        OFL=
*
*         TITLE - REPREIVE ROUTINE FOR OFLOW
*
*         ENTRY - FROM RECOVR
*           CALL OFL= (EXCHPKG, ABTFLAG, CM)
*              SEE RECOVR(NOS/BE REFERENCE MANUAL) FOR DETAILS
*
*         EXIT  -
*           1.AO IS RESTORED.
*           2.RA+0 IS COPIED TO -2-
*           3.CONTROL IS PASSED TO -L-
*
*         CALLS
*           AELSER - TO ISSUE ERROR MESSAGE
*           RECV.2 TO RESET RECOVR STACK AND RPV.
*
*         IF OFLOW TURNED OFF - EXIT.
 OFL=     DATA 0
          SA1 LF
          SB1 1
          ZR     X1,OFL=      IF OFLOW TURNED OFF
          SPACE  2,8
*  IF THIS IS THE 51ST TIME THRU THIS ROUTINE, ISSUE ERROR MESSAGE AND
*  QUIT
          SA1    RC           RECOVERY COUNT
          SX6    X1+B1        ADD 1
          SX3    X6-50
          NG     X3,OFL.1     IF COUNT LT 50
          SA1    ARG1
+         RJ     =XAEISER     ISSUE ERROR MESSAGE
-         VFD    30/TRACE.
          EQ     OFL=           RETURN TO RECOVR (+ ABORT)
OFL.1     SA6    A1
=         SPACE  2,8
*  CALL RECV.2  TO RESET THINGS IN RECOVR
          SA1    ARG2
          RJ     =XRECV.2
          SPACE  2,8
*  PUT RA+0 INTO -I- , RESET A0, AND JUMP TO -L-
          SA2 0                    X2 IS ADDRESS OF RA
          BX6 X2                   CONTENTS OF RA(ERROR MODE + ADDRESS)
          SA3 SI                   X3 EQUAL ADDRESS OF I
          SA6 X3
          SA3 SAO
          SA0 X3
*IF -DEF,AELIB5
          SA1    SLAB
          SB6    X1
          JP     B6           GO TO -L-
*ENDIF
*IF DEF,AELIB5
          SX1    1            RETURN 1
          EQ     OFLOW
*ENDIF
          SPACE  2,8
*  DATA FIELDS - ARGUEMENT LISTS
*  CALL TO RECOVR
 AP       VFD 60/OFL=
          VFD 60/CON
          VFD 60/CON+1B
          DATA 0B
*  CALL TO AEISER
ARG1      CON    FORMAT
          CON    *
          CON    ARGEND         DO NOT PRINT VALUE
ARGEND    DATA   0
*  CALL TO RECV.2
ARG2      CON    SSTI
          DATA   0
*  FIELDS FOR RECOVR
 CON      DATA 1
          VFD 60/*
*  MISC FIELDS
FORMAT    DATA   H+(" ***MORE THAN 50 MODE ERRORS ENCOUNTERED")+
 SAO      BSS 1                    SAVE A0
 SLAB     BSS 1                    SAVE ADDRESS OF LABEL(L) IN CALLING P
 SI       BSS 1                    SAVE ADDRESS OF I IN CALLING PROG.
 SSTI     BSS 1                    SAVE STACK INDEX
 RF       DATA 0                   RECOVR FLAG 0 IF NOT CALLED 1 AFTER C
 RC       DATA 0                   RECOVR COUNT MAX = 50
 LF       DATA 0                   OFLOW FLAG IF 1 OFLOW ON IF 0 OFF
          END
