*DECK PLOTCI
      SUBROUTINE PLOTCI(XMAX,YMAX)
C
C THIS SUBROUTINE PERFORMS ALL INITIALIZATION NECESSARY FOR CRNL"S
C IMPLEMENTATION OF THE CALCOMP PLOTTING PACKAGE AND MUST BE CALLED
C BEFORE ANY OF PLT,NUMBER,SYMBOL,AXIS OR LINE
C    IT HAS TWO ENTRY POINTS -
C
C     PLOTCI - WHICH RESULTS IN A MODE 10 CALL OF THE PLOT SUBROUTINE
C
C     PLOTI  - WHICH RESULTS IN A MODE 1 CALL OF THE PLOT SUBROUTINE
C              AND WHICH IS SUPPORTED FOR COMPATIBILITY WITH THE
C              ORIGINAL IMPLEMENTATION OF THE CALCOMP ROUTINES
C
C ARGUMENTS
C     XMAX - REAL, MAXIMUM LENGTH OF PLOTTING SURFACE DESIRED,SUBJECT
C     TO THE RESTRICTIONS ON XD AND XL IN PLOT"S MODE 10 AND 1 CALLS
C     YMAX - REAL,MAXIMUM WIDTH OF PLOTTING SURFACE DESIRED,SUBJECT
C     TO RESTRICTIONS ON YL AND YD IN PLOT"S MODE 10 AND 1 CALLS
C NORMAL EXIT
C     AFTER INITIALIZATION, CONTROL IS RETURNED TO THE CALLING ROUTINE
C ERROR EXIT
C     THE ONLY ERROR EXITS ARE THOSE DESCRIBED FOR PLOT IN AELIB
C
C ROUTINE CALLED
C     PLOT FROM AELIB
C
C AUTHOR
C     L EVANS                SEPTEMBER 1973
C REVISED
C     TO INCLUDE ALL INITIALIZATION BY L EVANS  OCTOBER,1975
C     TO FLUSH BUFFERS BEFORE A NEW FRAME  BY L EVANS  DECEMBER 1978
C     TO CHANGE NAME TO PLOTCI AND RETAIN PLOTI AS AN ENTRY POINT FOR
C        COMPATIBILITY WITH THE ORIGINAL VERSION. BY G N WILLIAMS AUG 79
C
*CALL BLOCK
*CALL BLOCKS
C     VARIABLE USED TO DIFFERENTIATE BETWEEN A CALL OF PLOTCI AND PLOTI
C
      LOGICAL MODE1
C
      DATA NS/0/,LPEN/0/
*CALL STATF
      MODE1=.FALSE.
      GO TO 5
C
C     ENTRY POINT FOR PLOTI
C
*IF -DEF,AELIB5
      ENTRY PLOTI
*ENDIF
*IF DEF,AELIB5
      ENTRY PLOTI(XMAX,YMAX)
*ENDIF
*CALL STATF
      MODE1=.TRUE.
C
C     FLUSH BUFFERS, IF NECESSARY, AND MAKE SURE THAT LPEN IS 0
C
    5 CONTINUE
      IF(NS.NE.0) CALL PLFL
      LPEN=0
C
C     ISSUE PLOT MODE 10 OR 1 CALL TO ESTABLISH PLOTTING FRAME AND SET
C     MAXIMUM X AND Y COORDINATES
C
C     PLOT"S ENTRY POINT PLOTC IS USED HERE TO AVOID A POSSIBLE NAME
C     CONFLICT WITH CALCOMP"S ROUTINE CALLED PLOT (CALLING PLOTC
C     PRODUCES THE SAME RESULTS AS CALLING PLOT)
C
      IF (MODE1) GO TO 20
C
C     ISSUE PLOT MODE 10 CALL TO ESTABLISH DRAWING AREA
C
      CALL PLOTC(10,XMAX,YMAX)
      GO TO 25
C
C     ISSUE MODE 1 CALL SINCE PLOTI WAS CALLED
C
   20 CONTINUE
      CALL PLOTC(1,XMAX,YMAX,0,XMAX,0,YMAX,-1,-1)
C
C     SET CALCOMP ORIGIN TO (0,0), CURRENT PEN POSITION TO (0,0),
C     AND CALCOMP PLOTTING FACTOR TO 1.
C
   25 CONTINUE
      XORG=0
      YORG=0
      XN=0
      YN=0
      FACT=1.0
C
      RETURN
      END
