*DECK PLT
      SUBROUTINE PLT(X,Y,JPEN)
************************************************************************
**                                                                    **
**    NOTE THAT PLT IS WRITTEN IN MODULAR FORM USING THE ADDITIONAL   **
**    ROUTINE:                                                        **
**       PLFL                                                         **
**    PLFL ACCOMPANIES PLT ON AELIB SOURCE TAPE UNDER DECK NAME PLT.  **
**                                                                    **
************************************************************************
C
C THIS SUBROUTINE MOVES THE PEN IN A STRAIGHT LINE TO A NEW POSITION,
C WITH THE PEN EITHER UP OR DOWN DURING THE MOVEMENT. ALSO, IF REQUESTED
C A NEW ORIGIN CAN BE DEFINED AT THE TERMINAL POSITION  SO THAT ALL
C SUBSEQUENT PEN MOVEMENTS WILL BE RELATIVE TO THAT POINT RATHER THAN
C 0IN.,0IN.(DEFAULT ORIGIN)
C THIS SUBROUTINE CORRESPONDS TO CALCOMP"S PLOT CALL, BUT NAME WAS
C CHANGED BECAUSE WE NEED OUR LOCAL PLOT SUBROUTINE FOR THIS PROGRAM
C
C ARGUMENT LIST
C    X -
C    Y - COORDINATES, IN INCHES FROM THE CURRENT ORIGIN, OF THE POSITION
C        TO WHICH PEN IS TO BE MOVED
C    JPEN - IF MAGNITUDE OF JPEN EQUALS 2, THEN THE PEN IS DOWN DURING
C           MOVEMENT
C         - IF MAGNITUDE OF JPEN EQUALS 3, THEN THE PEN IS UP DURING
C           MOVEMENT
C         - IF JPEN NEGATIVE THEN A NEW ORIGIN IS DEFINED AT THE
C           TERMINAL POSITION
C         - JPEN EQUALS 999 IS EQUIVALENT TO JPEN EQUALS -3
C
C ROUTINES CALLED -
C        PLFL FROM CALCOMP PACKAGE
C AUTHOR AND REVISION HISTORY -
C        WRITTEN BY L EVANS            SEPT 1973
C        REVISED BY L EVANS
C               -TO BUFFER PLT CALLS TO SPEED UP PLOTTING   OCT 1975
C                (MOD7,MOD8)
C       REVISED BY DG STEWART        JULY 1980
C               -RESET PEN STATUS(UP OR DOWN) FOLLOWING BUFFER
C                FLUSHING BY PLFL.  THIS ASSURES CONTINUOUS PLOTTING
C                FROM LINE WHEN THERE ARE MORE THAN 49 POINTS.
C                (SEE CONSULTING REPORT NO. 80-28)
C
C
*CALL BLOCK
*CALL BLOCKS
*CALL STATF
*CALL ERROR
C
C     DO ARGUMENT CHECKING ON X AND Y . IF EITHER ILLEGAL, PRINT A
C     MESSAGE AND RETURN
C
      LX=LEGVAR(X)
      LY=LEGVAR(Y)
*IF -DEF,AELIB5
      IF((LX.EQ.0).A.(LY.EQ.0)) GOTO 1
*ENDIF
*IF DEF,AELIB5
      IF((LX.EQ.0).AND.(LY.EQ.0)) GOTO 1
*ENDIF
*IF -DEF,AELIB5
      CALL AELERR(MESSNO,1HF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MESSNO,'F')
*ENDIF
 1    CONTINUE
      IPEN=JPEN
      IF(IPEN.EQ.999)IPEN=-3
C
C     CHECK PEN STATUS AS INDICATED BT LPEN. IF NOT SET( IE ZERO)
C     SET TO CURRENT PEN VALUE. OTHERWISE SEE IF CHANGED FROM LAST CALL
C
      IF(LPEN.NE.0) GOTO 100
      LPEN=IABS(IPEN)
      GOTO 150
 100  IF(LPEN.EQ.IABS(IPEN)) GOTO 150
C
C     PEN STATUS (UP OR DOWN) HAS CHANGED, SO FLUSH BUFFER
C
      IF(NS.NE.0) CALL PLFL
      LPEN=IABS(IPEN)
 150  CONTINUE
C
C     STORE CURRENT POSITION AND CALCULATE ABSOLUTE COORDS
C     OF NEW POSITION
C
      XX=XN
      YY=YN
      IF(X.NE.999.) XN=XORG+X*FACT
      IF(Y.NE.999.) YN=YORG+Y*FACT
C
C     ADD TO BUFFER( FLUSHING IF FULL) ONLY IF PEN DOWN AND
C     POINT WITHIN LIMITS
C
      IF(IABS(IPEN).NE.2) GOTO 300
      IF(NS.EQ.50) CALL PLFL
      IF(NS.NE.0) GOTO 200
      LPEN=IABS(IPEN)
      XS(1)=XX
      YS(1)=YY
      NS=1
 200  NS=NS+1
      XS(NS)=XN
      YS(NS)=YN
C
C     RESET ORIGIN IF REQUESTED
C
 300  IF(IPEN.GT.0) GOTO 350
         XORG=XN
         YORG=YN
C
C     IF PLT WAS CALLED WITH JPEN=999 FLUSH NON-EMPTY BUFFER
C
*IF -DEF,AELIB5
 350  IF((JPEN.EQ.999).A.(NS.NE.0)) CALL PLFL
*ENDIF
*IF DEF,AELIB5
 350  IF((JPEN.EQ.999).AND.(NS.NE.0)) CALL PLFL
*ENDIF
 301  RETURN
      END
      SUBROUTINE PLFL
C
C     THIS SUBROUTINE ISSUES A PLOT MODE 2 CALL TO PROCESS
C     ACCUMULATED PLT CALLS WITH PEN DOWN BEFORE PROCEEDING TO ANOTHER
C     CALCOMP FUNCTION OR TERMINATING A PLOT.
C     THERE ARE NO FORMAL PARAMETERS FOR THIS ROUTINE. ALL INFORMATION
C     IS PASSED THROUGH THE LABELLED COMMON BLOCK, BUFFER,
C     DESCRIBED IN THE CODE
C
C NORMAL EXIT
C     THE PLOT MODE 2 CALL IS ISSUED,NS AND LPEN ARE SET TO ZERO
C     AND CONTROL IS RETURNED TO THE CALLING ROUTINE
C ERROR EXIT
C        IF PLFL IS CALLED WITH LPEN NOT EQUAL 2, THEN NS AND LPEN ARE
C        SET TO 0 AND CONTROL IS RETURNED TO THE CALLING ROUTINE
C
C ROUTINES CALLED
C     PLOT FROM AELIB
C
C AUTHOR
C     L EVANS     OCTOBER 1975
C
*CALL BLOCK
*CALL BLOCKS
      IF(LPEN.EQ.2) GOTO 100
      GOTO 150
C
C     PLOT"S ENTRY POINT PLOTC IS USED HERE TO AVOID A POSSIBLE NAME
C     CONFLICT WITH CALCOMP"S ROUTINE CALLED PLOT (CALLING PLOTC
C     PRODUCES THE SAME RESULTS AS CALLING PLOT)
C
 100  CALL PLOTC(2,1,0,XS,YS,NS)
 150  NS=0
      LPEN=0
      RETURN
      END
