*DECK PROT
      SUBROUTINE PROT(NV,NI,NT,X,Y,W,Z)
C
C        AELIB PRINTER PLOT ROUTINE
C               -PLOTS UP TO 3 CURVES ON ONE SET OF AXES
C
C
C        WRITTEN BY S. LIKENESS        JUNE 1971
C        MODIFIED BY D.G. STEWART      OCT 1978
C              TO - ALLOW USER SPECIFICATION OF TITLES AND
C                   OUTPUT UNIT (BY COMMON BLOCKS)
C                 - REDUCE STORAGE REQUIREMENTS BY PRINTING
C                   LINES AS THEY ARE GENERATED.
C
      COMMON/TITLES/TITLE(8),XTITLE(10),YTITLE(3)
      COMMON/PRCNT/IPF,IUNIT
      DIMENSION X(100),Y(100),W(100),Z(100),YY(4,100),ARMAX(4),ARMIN(4),
     1YSCA(3,6),GRID(101),Q(4),YLABEL(3)
      DATA (YLABEL(I),I=1,3)/1H*,1H+,1H&/
      DATA DEC/1H./,OB/1H /,DS/1H:/
      DATA XTITLE/5*1H ,1HX,4*1H /,YTITLE/2HY1,2HY2,2HY3/,TITLE/10HPRINT
     1ER   ,10HPLOT      ,6*10H          /
      DATA IPF/0/
*CALL  STATF
      N=NV+1
      IF (N.NE.4) GO TO 10
      DO 5 I=1,NI
      YY(4,I)=Z(I)
    5 CONTINUE
   10 IF (N.LT.3) GO TO 20
      DO 15 I=1,NI
      YY(3,I)=W(I)
   15 CONTINUE
   20 DO 25 I=1,NI
      YY(2,I)=Y(I)
      YY(1,I)=X(I)
   25 CONTINUE
C
C     SET UP SCALES
C
      DO 1 I=1,N
      ARMAX(I)=-1.E37
 1    ARMIN(I)=-ARMAX(I)
      DO 30 I=1,NI
      DO 30 J=1,N
      ARMAX(J)=AMAX1(ARMAX(J),YY(J,I))
      ARMIN(J)=AMIN1(ARMIN(J),YY(J,I))
   30 CONTINUE
      DO 40 I=1,N
      DX=(ARMAX(I)-ARMIN(I))*.01
      IF (DX.EQ.0.) DX=.01
      RINC=10.**INT(ALOG10(DX))
      IF (DX .LT. 1.) RINC=RINC*.1
      DX=INT(DX/RINC+1.)
      IF (DX.GT.10.) DX=10.
      DX=DX*RINC
   42 SHIFT=0.
      ZERO=0.
   44 IF (ZERO*DX.GE.-ARMIN(I)) GO TO 46
      SHIFT=1.
      ZERO=ZERO+5.
      GO TO 44
   46 IF ((100.-ZERO)*DX.GE.ARMAX(I)) GO TO 48
      IF (SHIFT.EQ.0.) GO TO 49
      DX=DX+RINC
      GO TO 42
   49 ZERO=ZERO-5.
      GO TO 46
   48 ARMAX(I)=(100.-ZERO)*DX
      ARMIN(I)=ARMAX(I)-100.*DX
   40 CONTINUE
      DO 50 I=2,N
      J=I-1
      YSCA(J,1)=ARMIN(I)
      DY=(ARMAX(I)-ARMIN(I))*.2
      DO 51 M=1,5
      YSCA(J,M+1)=YSCA(J,M)+DY
   51 CONTINUE
   50 CONTINUE
C
C  OPTIONAL READ OF PLOT AND AXIS TITLES
C
      IF(NT.EQ.0) GO TO 52
*IF -DEF,AELIB5
      READ 100,( TITLE(I),I=1,8)
*ENDIF
*IF DEF,AELIB5
      READ (*,100,END=10000)( TITLE(I),I=1,8)
*ENDIF
*IF -DEF,AELIB5
      READ 101,(XTITLE(I),I=1,10)
*ENDIF
*IF DEF,AELIB5
10000 READ (*,101,END=10001)(XTITLE(I),I=1,10)
*ENDIF
*IF -DEF,AELIB5
      READ 102, (YTITLE(I),I=1,3)
*ENDIF
*IF DEF,AELIB5
10001 READ (*,102, END= 52  )(YTITLE(I),I=1,3)
*ENDIF
C
C  PRINT OF PLOT TITLE
C
 52   IF(IPF.EQ.0) PRINT 103,(TITLE(I),I=1,8)
      IF(IPF.EQ.1) WRITE(IUNIT,103) (TITLE(I),I=1,8)
C
      DO 55 M=1,N
 55   Q(M)=100./(ARMAX(M)-ARMIN(M))
      DX=(ARMAX(1)-ARMIN(1))*.1
      XSCA=ARMIN(1)
C
C  Y AXIS LABELS AND VALUES
C
      M=N-1
      DO 60 I=1,M
      IF(IPF.EQ.1)WRITE(IUNIT,108)YLABEL(I),YTITLE(I),(YSCA(I,MM),MM=1,6
     1)
 60   IF(IPF.EQ.0) PRINT 108,YLABEL(I),YTITLE(I),(YSCA(I,MM),MM=1,6)
C
C  SET UP OF PLOT IN GRID ONE LINE AT A TIME
C
      CALL PRESET(GRID,101,OB)
      DO 65 I2=1,101,20
 65   GRID(I2)=DEC
      IF(IPF.EQ.0) PRINT 105,GRID
      IF(IPF.EQ.1) WRITE(IUNIT,105) GRID
      J2=1
      J=1
C
      DO 230 J1=1,101
      J3=0
      IF(J1.EQ.J2) GO TO 70
      GO TO 75
C
C  PUTS HORIZONTAL LINES ACROSS THE PAGE
 70   CALL PRESET(GRID,101,DEC)
      J2=J2+10
      J3=1
      GO TO 80
C
C  PUTS VERTICAL LINES DOWN PAGE
 75   CALL PRESET(GRID,101,OB)
      DO 85 I2=1,101,20
 85   GRID(I2)=DEC
C      IF IXNO = J1 POINT PRINTED ON THIS LINE
C  IF J.GT.NI NO MORE POINTS TO BE PLOTTED
 80   IF(J.GT.NI) GO TO 210
      IXNO=1+INT(.5+Q(1)*(YY(1,J)-ARMIN(1)))
      IF(IXNO.LE.0) GO TO 210
      IF(IXNO.GE.J1) GO TO 90
      J=J+1
      GO TO 80
 90   CONTINUE
      IF(IXNO.EQ.J1) GO TO 95
      GO TO 210
C
C  LOCATION PLACEMENT ON Y AXIS
 95   DO 205 M=2,N
      IYNO=1+INT(.5+Q(M)*(YY(M,J)-ARMIN(M)))
      IF(IYNO.LT.1) IYNO=1
      IF(IYNO.GT.101) IYNO=101
      IF((GRID(IYNO).NE.OB).AND.(GRID(IYNO).NE.DEC)) GO TO 200
      GRID(IYNO)=YLABEL(M-1)
      GO TO 205
C      IF 2 VALUES FALL AT THE SAME PLACE
 200  GRID(IYNO)=DS
 205  CONTINUE
      J=J+1
C
C  IF X AXIS LABEL TO BE PRINTED
 210  IF(J1.LE.10) GO TO 225
C
C  IF J3=1 PUT NUMERIC VALUES ALONG X AXIS
      IF(J3) 220,215,220
 215  IF(IPF.EQ.0)PRINT 105,GRID
      IF(IPF.EQ.1) WRITE(IUNIT,105) GRID
      GO TO 230
C
C  PUT VALUES ALONG X AXIS
 220  IF(IPF.EQ.0) PRINT 106,XSCA,GRID
      IF(IPF.EQ.1) WRITE(IUNIT,106)XSCA,GRID
      XSCA=XSCA+DX
      GO TO 230
C
C  PUT IDENTIFICATION ALONG X AXIS
 225  IF (J1.EQ.1) GO TO 226
      IF(IPF.EQ.0) PRINT 107,XTITLE(J1),GRID
      IF(IPF.EQ.1) WRITE(IUNIT,107) XTITLE(J1),GRID
      GO TO 230
 226  IF(IPF.EQ.0) PRINT 109,XTITLE(J1),XSCA,GRID
      IF(IPF.EQ.1) WRITE(IUNIT,109)XTITLE(J1),XSCA,GRID
      XSCA=XSCA+DX
 230  CONTINUE
C
C     FORMATS
C
*IF -DEF,AELIB5
  100 FORMAT(8A10)
*ENDIF
*IF DEF,AELIB5
  100 FORMAT(BZ,8A10)
*ENDIF
*IF -DEF,AELIB5
  101 FORMAT(10A1)
*ENDIF
*IF DEF,AELIB5
  101 FORMAT(BZ,10A1)
*ENDIF
*IF -DEF,AELIB5
  102 FORMAT(3A10)
*ENDIF
*IF DEF,AELIB5
  102 FORMAT(BZ,3A10)
*ENDIF
  103 FORMAT(1H1,30X,8A10,//)
  105 FORMAT(1H ,23X,101A1)
  106 FORMAT(1H ,13X,G10.3,101A1)
  107 FORMAT(1H ,10X,A1,12X,101A1)
  108 FORMAT(8X,A1,1H=,A10,G10.3,5(10X,G10.3))
  109 FORMAT(1H ,10X,A1,2X,G10.3,101A1)
      RETURN
      END
