*DECK RELESE
      INTEGER FUNCTION RELESE (LFN, IFLAG)
      IMPLICIT INTEGER (A-Z)
C
C         TITLE
C           RETURN A FILE
C
C         ENTRY
C           EITHER
C               CALL RELESE (LFN, IFLAG)
C           OR
C               I = RELESE (LFN, IFLAG)
C
C           WHERE
C             LFN = LOCAL FILE NAME (5HTAPE5) OR LOGICAL UNIT NUMBER
C             IFLAG = 0 OR ABSENT - RETURN FILE
C                     1           - UNLOAD FILE
C
C         EXIT
C           I = 0  - FILE RETURNED SUCCESSFULLY
C               -1 - AN ERROR WAS ENCOUNTERED.
C
C         CALLS
C           AEFLFN - FORMAT THE LOCAL FILE NAME
C           IGETFIT - FIND A FIT.
C           AECLOS  - CLOSE A FILE.
C           AERETR  - RETURN A FILE.
C           AEUNLD  - UNLOAD A FILE.
C           ALEROF - TURN OFF AN ERROR MESSAGE
C           ALERON - TURN ON AN ERROR MESSAGE.
C         NOTE - THIS ROUTINE CALLS IGETFIT WITH ERROR MESSAGE 1
C         TURNED OFF.
C
C         ERRORS
C           1 - LOGICAL UNIT NUMBER OUT OF RANGE (FROM AEFLFN)
C           2 - ATTEMPT TO CLOSE MASS STORAGE FILE (FROM AECLOS)
C           3 - ERROR IN RETURNING FILE (FROM AERETR/AEUNLD)
C       NOTE - THESE ERROR NUMBERS ARE FOR INTERNAL DOCUMENTATION ONLY.
C         THIS ROUTINE DOES NOT HAVE A PROPER ERROR RETURN PPARAMETER.
C
C         WRITTEN BY
C           C TANNER  (JUNE 1979)
C           THIS IS AELIB ROUTINE 02-05-20.
C  COMMON BLOCK FOR ERROR MESSAGES.
      COMMON /AEERCM/ ROUTIN, FLAG
C  ARRAYS USED -
C   RLSMSG  - MESSAGE ISSUED AFTER RELESE SUCCESFUL.
C   RLSMSG(3) - NAME OF FILE BEING RELEASED.
C   AFIT    0 DUMMY ARRAY USED TO LOCATE FIT.
       DIMENSION RLSMSG(3), AFIT(2)
       DATA  RLSMSG/10H          ,10HRELESE----,10H          /
C  CALL FLFN TO FORM LOCAL FILE NAME
      ROUTIN = 20520
      FLAG = 1
      RLSMSG(3) = AEFLFN(LFN)
      IF (RLSMSG(3) .EQ. 0) GO TO 999
C   CALL IGETFIT TO LOCATE THE FIT. BEFORE CALLING THIS ROUTINE,
C   MESSAGE 1 - FILE NOT FOUND, IS TURNED OFF. THIS IS DONE TO AVOID
C   PRINTING UNNECESSARY MESSAGES. IT IS TURNED ON AFTER THE CALL TO
C   IGETFIT.
       I = IGETFIT(RLSMSG(3),IERR,1)
       IF (IERR .EQ. 1) GO TO 999
       IF (IERR .EQ. 2) GO TO 200
C  ENTRY FOUND. IF FILE IS OPEN, THEN IT MUST BE CLOSED.
      I = I - LOCF(AFIT(1)) + 1
      FLAG = 2
      CALL AECLOS(AFIT(I), IERR)
      IF (IERR .NE. 0) GO TO 999
C  NOW THAT THE FILE HAS BEEN CLOSED (AND THE BUFFER FLUSHED) CALL
C  EITHER AERETR (RETURN) OR AEUNLD (UNLOAD) DEPENDING ON INPUT.
200   FLAG = 3
      IF (IFLAG .EQ. 1) GO TO 210
C  IFLAG = 0 OR ABSENT - RETURN FILE.
      IERR = AERETR(RLSMSG(3))
      GO TO 300
C  IFLAG = 1 - UNLOAD FILE
210   IERR = AEUNLD(RLSMSG(3))
C  ISSUE DAYFILE MESSAGE - RELESE----FILENAME
300   IF (IERR .NE. 0) GO TO 999
      CALL REMARK(RLSMSG)
C  SUCCESSFUL COMPLETION, RETURN 0
      RELESE = 0
      RETURN
C  ERROR ENCOUNTERED, RETURN -1
999   RELESE = -1
      RETURN
      END
          IDENT  AECLOS
          TITLE  AECLOS - CLOSE A FILE
          COMMENT  AELIB - CLOSE A FILE
          B1=1
          SPACE  2
**        AECLOS
*
*         TITLE
*           CLOSE A FILE
*
*         ENTRY
*           CALL AECLOS (IFIT, IERR))
*             WHERE
*               IFIT  = ADDRESS OF FIT OF FILE TO BE CLOSED.
*               IERR  =  ERROR FLAG
*
*         EXIT
*           IF -IER- EQUALS ZERO, THEN THE FILE WAS CLOSED SUCCESSFULLY.
*           IF CRM ENCOUNTERES AN ERROR DURING FILE CLOSING, IT WILL
*           ISSUE AN FTN ERROR 103, AND TERMINATE EXECUTION.
*
*         ERRORS
*           IER = 1  - ATTEMPT TO CLOSE A MASS STORAGE FILE
*
*         CALLS
*           PT$TERM  - CLOSE A PLOT FILE
*           CLOSEM   - (CRM) CLOSE ANY FILE
*           AEISER   - ISSUE AN ERROR MESSAGE
*
*         NOTE
*           WHEN COMPILING EXPECT THE FOLLOWING ERRORS -
*             -9- ON -FORMAT-
          SPACE  2
          ENTRY  AECLOS
TRACE$    VFD    42/6HAECLOS,18/AECLOS      FOR FORTRAN TRACEBACK
AECLOS    DATA   0      ENTRY/EXIT LINE
          SX6    A0
*  INITIALIZE -  SAVE A0, FETCH IFIT AND PUT INTO A0 FOR CRM, AND
*       SAVE ADDRESS OF IERR FOR EXIT PROCESSING.
          SA6    TEMPA0         SAVE A0
          SB1    1        CONSTANT
          SA2    A1+B1    ADDRESS OF IERR
          SA0    X1       ADDRESS OF FIT
          BX6    X2
          SA6    IERR     SAVE ADDRESS OF IERR
          SPACE  2,8
*  IF FILE IS ALREADY CLOSED, THEN RETURN.
          FETCH  A0,OC,X2
          LX2    59
          PL     X2,CLS120    IF FILE ALREADY CLOSED.
          SPACE  2,8
*  DUE TO LINKAGE PROBLEMS, WA(MS) FILES CANNOT BE CLOSED HERE.
*  THE USER MUST CALL CLOSMS BEFORE CALLING RELESE.
          FETCH  A0,FO,X2
          SX0    X2-#WA#
          NZ     X0,CLS100      IF NOT WA
          SA1    ARG1           ARGUEMENT LIST FOR ERROR MESSAGE.
+         RJ     =XAEISER
-         VFD    30/TRACE$      SUBROUTINE CALL
          SX6    B1             SET ERROR FLAG = 1
          EQ     CLS999         RETURN
CLS100    BSS    0
*IF -DEF,NOS
          SPACE  2,8
*  IF PLOT FILE, CALL PT$TERM TO CLOSE IT.
          SA2    =4LPLOT
          IX3    X6-X2
          NZ     X3,CLS110      IF LFN NE PLOT
+         RJ     =XPT$TERM      GO CLOSE PLOT FILE
-         VFD    30/TRACE$
          EQ     CLS120
*ENDIF
          SPACE  2,8
*  CALL CRM TO CLOSE ALL OTHER TYPES OF FILES.
CLS110    CLOSEM   A0
          SPACE  2,8
*  CLEAR -OPEN/CLOSE- AND -LAST OPERATION- FIELDS IN FIT. THIS WILL
*  TRICK FTN INTO OPENING THIS FILE PROPERLY IF IT IS USED AGAIN.
CLS120    BSS    0
          STORE  A0,WA=B0
          STORE  A0,RL=B0
          STORE  A0,RT=B0
          STORE  A0,FO=B0
          SPACE  2,8
*  CHECK FOR LABEL BUFFER. IF ONE EXISTS, CLEAR IT. THIS WILL AVOID
*  TROUBLE IF THIS FIT IS USED AGAIN.
          FETCH  A0,FET,X3      ADDRESS OF FET
          SA1    X3+11B         LABEL CONTROL WORD
          SX2    X1             ADDRESS OF LABEL BUFFER
          ZR     X2,CLS900      IF NO LABEL BUFFER
          LX1    60-18
          SB7    X1             LENGTH OF LABEL BUFFER
          SB6    B0
          MX6    0
CLS130    SA6    X2+B6
          SB6    B6+B1
          SB7    B7-B1          STEP LOOP COUNTER
          NZ     B7,CLS130      LOOP
          SPACE  2,8
*  RETURN TO CALLING PROGRAM -
*  SET ERROR FLAG, RESTORE A0, THEN RETURN
CLS900   SX6     B0             NORMAL RETURN
CLS999    SA1    IERR           COME HERE IF ERROR RETURN
          SA2    TEMPA0
          SA6    X1             STORE ERROR FLAG
          SA0    X2             RESTORE A0
          EQ     AECLOS         RETURN
          SPACE  2,8
*  DATA FIELDS
TEMPA0    DATA   0              TEMP STORAGE FOR A0
IERR      DATA   0              ADDRESS OF ERROR FLAG
FORMAT    DATA   H+(" ***CANNOT CLOSE A MASS STORAGE FILE")+
ARG1      CON    FORMAT         ARGUEMENT LIST FOR AEISER
          CON    *              DUMMY
          CON    ARGEND         DO NOT PRINT VALUE
ARGEND    DATA   0
          END
          IDENT  AERETR
          TITLE  AERETR - RETURN A FILE
          COMMENT  AELIB - RETURN A FILE
          SPACE  2
**        AERETR
*
*         TITLE
*           RETURN A FILE
*
*         ENTRY
*           IERR = AERETR(ILFN1, IFLN2, ...)
*             WHERE
*               ILFNN = NAME OF FILE TO BE RETURNED (FORMAT = NLABCD)
*               IERR = ERROR FLAG
*
*         EXIT
*           FILE IS RETURNED. IF AN ERROR IS ENCOUNTERED, IERR IS
*           SET NON-ZERO.(NOTE: CIO WILL HAVE PUT ERROR MESSAGES ONTO
*           THE DAYFILE).
*
*         CALLS
*           CIO - PERFORM INPUT/OUTPUT (PP PROGRAM)
*
*         NOTE
*           WHEN COMPILING, EXPECT A -9- TYPE ERROR AT -FORMAT-.
          SPACE  2,8
          ENTRY  AERETR
TRACE$    DATA   0              WILL CONTAIN FORTRAN TRACEBACK INFO
AERETR    DATA   0              ENTRY/EXIT LINE
          SX2    174B           RETURN CIO CODE
          SA3    =10HRETURN
          SA4    RETRACE
          RJ     CALLCIO        GO PROCESS THE REQUEST(S)
          SA1    ERRORC         ERROR CODE
          BX6    X1
          EQ     AERETR
          SPACE  2,8
**        AEUNLD
*
*         TITLE
*           UNLOAD A FILE
*
*         ENTRY
*           IERR = AEUNLD(ILFN1, IFLN2, ...)
*             WHERE
*               ILFNN = NAME OF FILE TO BE UNLOADED (FORMAT = NLABCD)
*               IERR = ERROR FLAG
*
*         EXIT
*           FILE IS UNLOADED. IF AN ERROR IS ENCOUNTERED, IERR IS
*           SET NON-ZERO.(NOTE: CIO WILL HAVE PUT ERROR MESSAGES ONTO
*           THE DAYFILE).
*
*         CALLS
*           CIO - PERFORM INPUT/OUTPUT (PP PROGRAM)
          SPACE  2,8
          ENTRY  AEUNLD
AEUNLD    DATA   0              ENTRY/EXIT LINE
          SX2    170B           UNLOAD CIO CODE
          SA3    =10HUNLOAD
          SA4    UNLRACE
          RJ     CALLCIO        GO PROCESS THE REQUEST(S)
          SA1    ERRORC         ERROR CODE
          BX6    X1
          EQ     AEUNLD
CALLCIO   SPACE  4,8
*  CALLCIO
*    - MAKE UP DUMMY FET AND CALL CIO
*
*  ENTRY
*   X1 - LFN
*   X2 - CIOCODE
*
*  EXIT
*   X6 - ERROR CODE
*
CALLCIO   DATA   0
*  INITIALIZE PARAMETER LIST POINTERS AND ERROR STATUS FIELD, AND
*  SAVE CIO CODE.
          MX6    0
          SA6    ERRORC         CLEAR ERROR CODE
          BX6    X2
          SA6    SAVCODE        SAVE THE CIO CODE FOR ALL REQUESTS
          SX6    A1             GO GET PARAMETER LIST
          SA6    PARAMLT        LIMIT
          SX6    1              AND
          SA6    PARAMCT        COUNT
          BX6    X3             ROUTINE NAME FOR ERROR MESSAGE.
          SA6    VALUE          SAVE
          BX6    X4         SAVE TRACE FIELD
          SA6    TRACE$
          SPACE  2,8
*  PUT LOCAL FILE NAME AND CIO CODE INTO DUMMY FET, AND CALL CIO
*  TO EXECUTE THE CODE.
CHKLOOP   ZR     X1,CALLCIO     IF AT END OF PARAMTER LIST
          SA1    X1
          MX0    42             MASK FOR LFN
          SA2    SAVCODE        REQUESTED CIO CODE
          BX6    X0*X1          MASK JUST 7 CHAR
          BX6    X6+X2          MERGE IN CIO CODE
          SA6    DUMYFET        PUT INTO FET
          SX6    DUMYFET
          SA5    CIOP           CIO CALL
          BX6    X6+X5          ADD IN FET ADDRESS
          RJ     =XSYS=         CALL CIO
          SPACE  2,8
*   GET STATUS FROM CIO. IF NON ZERO, SAVE IT FOR
*   FUNCTION RETURN.
          SA1    DUMYFET
          MX0    5
          LX0    5              MASK FOR STATUS
          LX1    60-9           RIGHT JUSTIFY STATUS
          BX6    X0*X1          RETURN STATUS
          ZR     X6,NOERROR     IF NO ERROR ENCOUNTERED
          SA6    ERRORC         SAVE ERROR CODE
          SA1    ARG1           ARGUEMENT LIST FOR ERROR MESSAGE PROC.
+         RJ     =XAEISER
-         VFD    30/TRACE$      SUBROUTINE CALL
          SPACE  2,8
*  GET NEXT FILE NAME IN PARAMETER LIST AND LOOP
NOERROR   SA2    PARAMCT        GET LIST POINTERS
          SA3    PARAMLT
          IX1    X2+X3          UPDATE
          SA1    X1
          SX6    X2+1
          SA6    A2             AND
          EQ     CHKLOOP        LOOP FOR MORE LFN-S
          SPACE  2,8
*  DATA FIELDS USED BY CALLCIO
ERRORC    DATA   0              ERROR STATUS
SAVCODE   DATA   0              TEMP STORAGE FOR CIO CODE
PARAMLT   DATA   0              PARAMETER LIST ADDRESS
PARAMCT   DATA   0              PARAMETER LIST COUNT
CIOP      VFD    18/3LCIO,3/2,39/0      CIO CALL
DUMYFET   BSS    1              DUMMY FET
          VFD    18/4,42/100B   FIRST
          DATA   100B           IN
          DATA   101B           OUT
          DATA   200B           LIMIT
          SPACE 2,8
*  FIELDS USED BY ERROR MESSAGE
RETRACE   VFD    42/6HAERETR,18/AERETR    TRACE BACK FOR RETURN
UNLRACE   VFD    42/6HAEUNLD,18/AEUNLD    TRACE BACK FOR UNLOAD
FORMAT    DATA   H+(" *** ERROR IN ", A6, ". SEE DAYFILE")+
VALUE     DATA   0      CONTAINS NAME OF FUCTION
ARG1      CON    FORMAT    ARGUEMENT LIST FOR AEISER
          CON    VALUE
          CON    ARG1
          DATA   0
          END
          IDENT  IGETFIT
          TITLE  IGETFIT - LOCATE FIT  FOR A GIVEN FILE
          COMMENT   AELIB - LOCATE FIT
*
*    IGETFIT
*       LOCATE FIT FOR GIVEN FILE
*
*    ENTRY-
*       LOC = IGETFIT (LFN, IERR, IFLAG)
*         WHERE
*           LFN = EITHER
*                   UNIT NUMBER OF REQUIRED FILE (INTEGER)
*                 OR
*                   FILE NAME (EG 4LNAME)
*           IERR  = ERROR FLAG. IF NON ZERO, AN ERROR WAS ENCOUNTERED.
*         IFLAG = ERROR MESSAGE FLAG. IF NO ZERO, DO NOT ISSUE FILE NOT
*                 MESSAGE.
*
*    EXIT -
*      RETURNS FIT ADDRESS OF GIVEN FILE.
*
*    ERRORS -
*      IERR = 1  TAPE NUMBER OUT OF RANGE (FROM AEFLFN)
*             2  FILE NOT FOUND
*
*    CALLS -
*       AEFLFN - FORMAT THE LOCAL FILE NAME.
*       GETFIT. - FIND FIT FOR GIVEN LFN (ON FORTRAN LIBRARY)
*
*    WRITTEN BY -
*      C J TANNER, JANUARY 1979
*       THIS IS AELIB ROUTINE 02-05-25
*
*    NOTE -
*      WHEN COMPILING, EXPECT A -9- TYPE ERROR AT -FORMAT-.
          SPACE  2,8
          LDSET  LIB=BAMLIB
          ENTRY  IGETFIT
TRACE$     VFD    42/7HIGETFIT,18/IGETFIT       FOR FORTRAN TRACEBACK.
IGETFIT   DATA   0              ENTRY/EXIT LINE.
*
*  SAVE A0 AND CALL LIBSTAT.
          SX6    A0
          SA6    TEMPA0
        SPACE    2
*  PICK UP FORMAL PARAMETERS. (LFN IS LEFT FOR AEFLFN)
          SB1    1
          SA2    A1+B1        ADDRESS OF IERR
          SA3    A2+B1        ADDRESS OF IFLAG
          SX6    X2
          SA3    X3           VALUE OF IFLAG
          SA6    SAVEIERR     SAVE ADDRESS OF IERR
          SX7    X3
          SA7    IFLAG        SAVE VALUE OF IFLAG
          SPACE  2,8
*  CALL AEFLFN  TO PUT LOCAL FILE NAME INTO REQUIRED FORMAT.
          SX7    B1        ROUTINE NUMBER
          SA7    FLAG
+         RJ     =XAEFLFN       SUBROUTINE CALL
-         VFD    30/TRACE$
          SA6    VALUE      SAVE FOR ERROR MESSAGE
          NZ     X6,GFIT050     IF NO ERROR
          SX7    B1     ERROR CODE = 1
          SX6    B0
          EQ     GFIT910        ERROR EXIT
          SPACE  2,8
*  CALL GETFIT. TO LOOK FOR FIT.
GFIT050   BSS    0
          SA1    ARG2
          RJ     =XUGTFIT.
          NZ     X1,GFIT900       IF LFN FOUND.
          SPACE  2,8
*  FILE NOT FOUND. ISSUE ERROR MESSAGE (UNLESS FLAG OFF) AND RETURN
ERR100    SA1    IFLAG
          NZ     X1,ERR110    IF ERROR MESSAGE NOT TO BE ISSUED.
          SA1    ARG1         ARGUEMENT LIST FOR ERROR MESSAGE PROCESSOR
          SX6    B1       MESSAGE NUMBER
          SA6    FLAG
+         RJ     =XAEISER
-         VFD    30/TRACE$      SUBROUTINE CALL
ERR110    SX6    B0             SET FIT ADDRESS = 0
          SX7    B1+B1        ERROR CODE = 2
          EQ     GFIT910        SET ERROR FLAG AND RETURN.
          SPACE  2,8
*  RETURN -
*  PUT ADDRESS OF FIT INTO X6 FOR FUNCTION RETURN, CLEAR ERROR
*  FLAG, AND RETURN.
GFIT900   SX6    X1             ADDRESS OF FIT
          MX7    0              CLEAR ERROR FLAG
GFIT910   SA1    SAVEIERR     GET ADDRESS OF IERR.
          SA7    X1           STORE VALUE INTO IERR
          SA1    TEMPA0         RESTORE A0
          SA0    X1
          EQ     IGETFIT                RETURN
          SPACE  4,8
*  COMMON STORAGE BLOCK FOR ERROR MESSAGE PROCESSOR
          USE    /AEERCM/
ROUTIN    BSS    1      ROUTINE NUMBER
FLAG      BSS    1      MESSAGE NUMBER
          USE    *
          SPACE  4,8
*  DATA FIELDS
TEMPA0   DATA    0          TEMPORARY STORAGE FOR A0
FORMAT    DATA   H+(" ***FILE NAME NOT DECLARED - ", A7)+
VALUE     DATA   0      FILE NAME FOR ERROR MESSAGE
ARG1      CON    FORMAT     ARGUEMENT LIST FOR AEISER
          CON    VALUE
          CON    ARG1
          DATA   0
ARG2      CON    VALUE        ARGUEMENT LIST FOR IGETFIT.
SAVEIERR   DATA  0            WILL HOLD ADDRESS OF IERR
IFLAG     DATA   0            WILL HOLD VALUE OF IFLAG
          END
          IDENT  FLFN
          TITLE  FLFN - FORM LFN FOR AELIB ROUTINES
          COMMENT  FLFN - FORM LFN FOR AELIB
          SPACE 2
**        FLFN
*
*         TITLE
*           FORM FILE NAME
*
*         ENTRY
*           LFN = AEFLFN(LFNA)
*             WHERE
*               LFNA = LOCAL FILE NAME IN FORMAT EITHER
*                       INTEGER (EG 5 = TAPE5)  OR
*                       HOLLERITH (EG 5LTAPE5 OR 5HTAPE5)
*
*         EXIT
*           LFN = LOCAL FILE NAME IN USEFUL FORMAT
*                 (LEFT JUSTIFIED, ZERO FILL).
*               IF = 0, AN ERROR WAS ENCOUNTERED.
*
*         USES
*           A136, B1234567, X1234567
*
*         CALLS
*           AEISER  - ISSUE ERROR MESSAGE
*
*         NOTE
*           EXPECT A -9- TYPE ERROR FOR -FORMAT-
          SPACE  2,8
          ENTRY  AEFLFN
TRACE$    VFD    42/6HAEFLFN,18/AEFLFN      FOR FORTRAN TRACEBACK
AEFLFN    DATA   0         ENTRY/EXIT LINE
          SPACE  2,8
*   PICK UP PARAMETER AND CHECK TO SEE IF A FILE NAME OR A TAPE NUMBER
*   WAS GIVEN
          SA3    X1        FORMAL PARAMETER
          SX1    X3        TAPE NUMBER
          SB1    1         CONSTANT
          MX7    -18
          BX3    X7*X3
          NZ     X3,CKBLNK      IF FILE NAME, CHECK FOR BLANKS
          SPACE  2,8
*  CHECK TAPE NUMBER TO SEE IF IT IS WITHIN RANGE 1=<N=<99
          ZR     X1,FLFN0       ERROR IF N = 0
          NG     X1,FLFN0       ERROR IF N NEGATIVE
          SX2    99
          IX2    X2-X1
          PL     X2,FLFN0.1     ERROR IF N GREATER 99
FLFN0     BX6    X1
          SA1    ARG1           ARGUEMENT LIST FOR ERROR PROCESSOR
          SA6    VALUE          SAVE VALUE FOR ERROR PROCESSOR
+         RJ     =XAEISER
-         VFD    30/TRACE$      SUBROUTINE CALL
          MX6    0
          EQ     AEFLFN         ERROR EXIT.
          SPACE   2,8
*   CONVERT TAPE NUMBER TO DISPLAY CODE AND APPEND TO -TAPE-
FLFN0.1   SX4    0
          SA3    =4LTAPE
          SX2    X1-10
          PL     X2,LFN1        IF TAPE NUMBER IS 10 - 99
*   CONVERT NUMBER LESS THAN 10
          SX1    X1+1R0         N IN DISPLAY CODE
          LX1    60-5*6
          BX6    X1+X3          APPEND TO -TAPE-
          EQ     AEFLFN         FINISHED.
          SPACE  2,8
*  CONVERT A TWO DIGIT NUMBER TO DISPLAY CODE
LFN1      SX2    X1-20
          SX1    X1-10
          SX4    X4+100B
          PL     X2,LFN1        IF TAPE NUMBER IS NOT YET REDUCED
          IX2    X1+X4
          SX1    X2+2R00        NN IN DISPLAY CODE
          LX1    60-6*6
          BX6    X1+X3          APPEND TO -TAPE-
          EQ     AEFLFN         FINISHED
          SPACE   2,8
*  REMOVE TRAILING BLANKS FROM SUPPLIED FILE NAME
*  FIRST - LOCATE FIRST TRAILING BLANK
CKBLNK    BX6    X3             SAVE FILE NAME
          MX7    6
          LX7    6              CHARACTER MASK
          SB3    1R             CONSTANTS USED IN LOOP
          SB2    7
          SB5    B1             LOOP COUNTER
FLFN2     LX3    6
          BX4    X7*X3          NEXT CHARACTER
          SB4    X4
          EQ     B4,B0,AEFLFN      FINISHED - NO TRAILING BLANKS
          EQ     B4,B3,FLFN3    FOUND A BLANK
          SB5    B5+B1          STEP COUNTER
          LE     B5,B2,FLFN2    LOOP
          EQ     AEFLFN         FINISHED - NO BLANKS FOUND
          SPACE  2,8
*  NOW REMOVE THE TRAILING BLANKS
FLFN3     SX1    B5-B1          NO OF LAST NON BLANK CHARAACTER
          SX2    6
          IX1    X1*X2          NO OF BITS IN LFN
          SB2    X1
          SB2    B2-B1          NO OF BITS IN LFN - 1
          MX7    1
          AX7    B2             FORM MASK
          BX6    X6*X7          REMOVE BLANKS
          EQ     AEFLFN FINISHED.
          SPACE  2,8
*  FIELDS REQUIRED FOR ERROR MESSAGE.
FORMAT    DATA   H+(" ***LOGICAL UNIT NUMBER ", I5, " OUT OF RANGE")+
VALUE     DATA   0      HOLDS LOGICAL UNIT NUMBER FOR ERROR MESSAGE
ARG1      CON    FORMAT         ARGUEMENT LIST FOR AEISER
          CON    VALUE
          CON    ARG1           FORCE IT TO PRINT -VALUE-
          DATA   0
          END
