*DECK ROUTE
          IDENT  ROUTE
          TITLE  ROUTE - SEND FILE TO OUTPUT QUEUE
          COMMENT   AELIB - SEND FILE TO QUEUE
          SPACE  2
**        ROUTE
*
*         TITLE
*           ROUTE A FILE TO AN OUTPUT QUEUE
*
*         ENTRY
*           CALL ROUTE (LFN, IER, PARAM1, VALUE1, --- )
*             WHERE
*               LFN = LOCAL FILE NAME OR LOGICAL UNIT NUMBER
*               IER = ERROR CODE RETURNED (FROM DSP)
*               PARAM - OPTIONAL PARAMETERS (SEE DESCRIPTION OF ROUTE
*                     IN NOS/BE REFERENCE MANUAL)
*                     PARAMETERS SUPPORTED - DEF, DC, EC, FID, REP, TID
*               VALUE - VALUE ASSOCIATED WITH PARAMETER
*
*         EXIT
*           IER = 0  - ROUTE SUCCESSFUL
*               NE 0  ERROR FROM DSP (SEE NOS/BE REFERENCE MANUAL)
*
*         CALLS
*           RTINIT - INITIALIZE
*           RTSTOR - STORE PARAMETER
*           RTERR  - ISSUE ERROR MESSAGE.
*
*         WRITTEN BY
*         C J TANNER  JUNE 1979
*         THIS IS AELIB ROUTINE 02-05-21
          SPACE  2,8
          ENTRY  ROUTE
TRACE$    VFD    42/5HROUTE,18/ROUTE    USED BY FTN TRACE BACK
TRACE     EQU    TRACE$
ROUTE     DATA   0            ENTRY/EXIT LINE
          SPACE  2,8
*  SAVE A0, PARAMETER LIST ADDRESS AND ADDRESS OF IER
          SX6    A0
          SA6    TEMPA0
          SA0    A1
*CALL STATC
          SA2    A1+1
          BX7    X2           ADDRESS OF IER
          SA7    AIER         SAVE IT
          SPACE  2,8
*  CALL RTINIT PREPARE THE FILE FOR ROUTINE ETC.
          SX6    X1           ADDRESS OF LFN
          SA6    ARG1         PASSIT TO RTINIT
          SA1    ARG1         ARGUMENT LIST
+         RJ     =XRTINIT     SUBROUTINE CALL
-         VFD    30/TRACE$
          SPACE  2,8
*  IF ERRORS IN INITIALIZATION, THEN RETURN.
          SA1    IER
          NZ     X1,RTER110
          SPACE  2,8
*  PASS EACH PAIR OF PARAMETERS TO RTSTORE.  THIS PROGRAM WILL DECODE
*  THEM AND STORE THE VALUE IN THE DSP CALL BLOCK
RT100     SA0    A0+2         GET NEXT PAIR OF PARAMETERS
          SA1    A0           ADDRESS OF CODE
          SA2    A1+1         ADDRESS OFVALUE
          ZR     X1,RT200     END OF LIST
          BX6    X1
          LX7    X2
          SA6    ARG2         PUT INTO ARGUMENT LIST
          SA7    ARG2+1       FOR RTSTOR
          SA1    ARG2        ARGUMENT LIST
+         RJ     =XRTSTOR     SUBROUTINE CALL
-         VFD    30/TRACE$
          SPACE  2,8
*  IF NO ERRORS IN PARAMETER CRACKING, CALL DSP
          SA1    IER          ERROR FLAG
          ZR     X1,RT100       NO ERRORS - LOOP
          EQ     RTER100          GO PRINT ERROR MESSAGE
          SPACE  2,8
*         CALL RTCLOS TO CLOSE ROUTE FILE
RT200     RJ     =XRTCLOS     SUBROUTINE CALL
-         VFD    30/TRACE$
          SA1    IER
          NZ     X1,RTER110   IF ERROR MESSAGE DURING CLOSE
          SPACE  2,8
*  ALL PARAMETERS HAVE BEEN CRACKED. CALL DSP TO PERFORM THE ROUTEING.
          ROUTE  DSPCALL,RCL
          SPACE  2,8
*  CHECK FOR ERRORS
          SA1    DSPCALL
          MX0    6
          LX0    6            MASK FOR DSP ERROR CODE
          LX1    60-12        RIGHT JUSTIFY DSP ERROR CODE
          BX6    X1*X0        MASK OFF ERROR CODE
          ZR     X6,RT900       NORMAL RETURN
          SPACE  2,8
*  DSP FOUND AN ERROR. ISSUE AN ERROR MESSAGE
          SA6    IER            SAVE ERROR CODE
RTER100   SA1    ARG2           ARGUEMENT LIST (REQUIRED FOR ERRORS
                                FOUND BY RTSTOR.
+         RJ     =XRTERR        ISSUE ERROR MESSAGE
-         VFD    30/TRACE$      SUBROUTINE CALL
RTER110   SA1    IER
          BX6    X1             GET ERROR CODE
          EQ     RTER900        RETURN IT TO USER.
          SPACE  2,8
*  NORMAL RETURN - SET IER TO ZERO, RESTORE A0 AND LEAVE
RT900     MX6    0
RTER900   SA1    AIER         ADDRESS OF IER
          SA6    X1           STORE IER
          SA2    TEMPA0
          SA0    X2           RESTORE A0
          EQ     ROUTE        RETURN
          SPACE  4,8
*  DATA FIELDS. - COMMON BLOCK USED BY ROUTE, RTINIT AND RTSTORE
          USE    /RTCOMN/
IER       DATA   0            ERROR CODE
DSPCALL   BSSZ   7            DSP CALLING BLOCK
DSPCD     BSS    10
ECCODE    BSS    15
ECVAL     BSS    15
DUPLS     BSS    10
*IF -DEF,NOS,1
NOS       DATA   0
*IF DEF,NOS,1
NOS       DATA   1
ILOC      DATA   0
AFIT      BSSZ   2
          USE    *
          SPACE  2,8
*  DATA FIELDS  - INTERNAL FIELDS
AIER      DATA   0            ADDRESS OF IER
TEMPA0    DATA   0            TEMP STORE FOR A0
          SPACE  2,8
*  DATA FIELDS  - ARGUMENT LISTS
ARG1      BSSZ   2            TO RTINIT
ARG2      BSSZ   3            TO RTSTOR
          SPACE  4,8
** COMPASS SUBROUTINES
*
**        RTBLNK
*
*         TITLE
*           REMOVE TRAILING BLANKS FROM A CHARACTER STRING
*
*         ENTRY
*           PRM = RTBLNK(PRMA)
*             WHERE
*                PRMA = FIELD WITH TRAILING BLANKS
*
*         EXIT
*           PRM = SAME FIELD WITHOUT TRAILING BLANKS
*
*         SPACE  2,8
          ENTRY  RTBLNK
RTBLNK    DATA   0            ENTRY/EXIT LINE
          SPACE  2,8
*  LOCATE  FIRST TRAILING BLANK
          SA1    X1           PARAMETER
          BX6    X1           SAVE IT
          MX7    6
          LX7    6            CHARACTER MASK
          SB3    1R           CONSTANTS USED IN LOOP
          SB2    10
          SB5    1            LOOP COUNTER
BLNK10    LX1    6
          BX2    X7*X1         NEXT CHARACTER
          SB4    X2
          EQ     B4,B0,RTBLNK      FINISHED - NO TRAILING BLANKS
          EQ     B4,B3,BLNK20      FOUND A BLANK
          SB5    B5+1         STEP COUNTER
          LE     B5,B2,BLNK10 LOOP
          EQ     RTBLNK       FINISHED - NO BLANKS FOUND
          SPACE  2,8
*  NOW REMOVE THE TRAILING BLANKS
BLNK20    SX1    B5-1         NO OF LAST NON-BLANK CHARACTER
          SX2    6
          IX1    X1*X2        NO OF BITS IN LFN
          SB2    X1
          SB2    B2-1         NO OF BITS IN LFN - 1
          MX7    1
          AX7    B2           FORM MASK
          BX6    X6*X7        REMOVE BLANKS
          EQ     RTBLNK       FINISHED
          END
      SUBROUTINE RTINIT(LFN)
      IMPLICIT INTEGER (A-Z)
C  COMMON DATA FOR ROUTE ROUTINES
      COMMON /RTCOMN/ IER, DSPCAL(7), DSPCD(10), ECCODE(15), ECVAL(15),
     1    DUPLS(10), NOS, ILOC, AFIT(2)
C  COMMON BLOCK FOR ERROR PROCESSING MODULE
      COMMON /AEERCM/  ROUTIN, FLAG
C*        RTINIT
C
C         TITLE
C           PERFORM INITIALIZING FUNCTIONS FOR ROUTE
C
C         ENTRY
C           CALL RTINIT(LFN)
C              WHERE
C                LFN = LOCAL FILE NAME OR LOGICAL UNIT NUMBER
C         EXIT
C           1. LFN-IS CONVERTED TO PROPER FORMAT AND PUT INTO DSPCAL
C           2. REMAINDER OF DSPCAL IS CLEARED
C
C         ERRORS
C           1  -  LOGICAL U\IT NUMBER OUT OF RANGE (FROM AEFLFN)
C
C         CALLS
C           AEFLFN - FORMAT LFN
C           IGETFIT  - FIND FIT
C           ALEROF - TURN OFF AN ERROR MESSAGE
C           ALERON - TURN ON AN ERROR MESSAGE.
C         NOTE - THIS ROUTINE CALLS IGETFIT WITH ERROR MESSAGE 1
C         TURNED OFF.
C      CLEAR THE DUPLICATE PARAMETER ARRAY SO THAT THE "DUPLICATE
C      PARAMETER" MESSAGE WILL NOT BE GIVEN ON THE SECOND CALL TO
C      ROUTE.
      DO 10 I=1,10
 10   DUPLS(I) = 0
      ROUTIN = 20521
      FLAG = 1
C    CALL IGETFIT TO LOCATE THE FIT
 100  I = IGETFIT (LFN, IER, 1)
      IF (IER .EQ. 0) GO TO 105
C     TAPE NUMBER OUT OF RANGE - RETURN
      IF (IER .EQ. 1) RETURN
C     NO FILE FOUND, LFN MUST BE FORMATED
      DSPCAL (1) = AEFLFN (LFN)
      IF (DSPCAL (1) .NE. 0) GO TO 110
      IER = 1
      RETURN
C     FIT FOUND. USE LFN FROM THE FIT (IN CASE THE FIT HAS BEEN
C     EQUIVALENCED.
 105  FLAG = 2
      ILOC = I - LOCF(AFIT(1)) + 1
      DSPCAL(1) = AFIT(ILOC) .AND. MASK(42)
C  CLEAR FIELDS IN COMMON BLOCK
110   IER = DSPCAL(3) = DSPCAL(4) = DSPCAL(5) = 0
C  SET -RETURN ERROR CODE- BIT.
*IF -DEF,AELIB5
      DSPCAL(2) = 10000B
*ENDIF
*IF DEF,AELIB5
      DSPCAL(2) = O"10000"
*ENDIF
      RETURN
      END
      SUBROUTINE RTSTOR (RTCODE, VALUE)
      IMPLICIT INTEGER (A-Z)
C*    RTSTOR
C
C     TITLE
C      STORE PARAMETER IN DSPCAL
C
C     ENTRY
C      CALL RTSTOR (RTCODE, VALUE)
C         WHERE
C            RTCODE - PARAMETER CODE. ONE OF -
C                      DEF, DC, EC, FID, REP, TID
C            VALUE  - VALUE ASSOCIATED WITH RTCODE
C
C     EXIT
C       CONTENTS OF VALUE ARE PLACED IN THE APPROPRIATE SPOT IN DSPCAL
C       AND THE CORRECT FLAG SET.
C
C     ERRORS
C       IER = 0 - NO ERRORS FOUND
C             7 - DC = IN NOT ALLOWED
C             101 - REPEAT COUNT GREATER 37B
C             102 - UNKNOWN EXTERNAL CHARACTERISTIC
C             103 - UNKNOWN PARAMETER
C             104 - DUPLICATE CODE
C   NOTE  - ERROR MESSAGES ARE PRINTED BY -RTERR- WHICH IS CALLED
C           BY -ROUTE-.
C  COMMON DATA FOR ROUTE ROUTINES
      COMMON /RTCOMN/ IER, DSPCAL(7), DSPCD(10), ECCODE(15), ECVAL(15),
     1    DUPLS(10), NOS, ILOC, AFIT(2)
C  ARRAYS USED INTERNALLY
C     DSPCD - ALLOWED VALUES OF RTCODE
C     DUPLS - FLAGS OF CODES USED FOR DUPLICATE CHECK
C     ECCODP- ALLOWED VALUES OF EC - EXT CHAR.(PUNCH)
C     ECCODL- ALLOWED VALUES OF EC (PRINT)
C     XNUM  - USER NUMBER ARRAY (NOS ONLY)
      DIMENSION XNUM(2)
*IF -DEF,AELIB5
      DATA DSPCD /3LDEF, 2LDC, 2LEC, 3LFID, 3LREP, 3LTID, 2LST, 2LFC,
     1    2LID, 2LUN/
*ENDIF
*IF DEF,AELIB5
      DATA DSPCD /L"DEF", L"DC", L"EC", L"FID", L"REP", L"TID", L"ST", L
     1"FC",       L"ID", L"UN"/
*ENDIF
*IF -DEF,AELIB5
      DATA ECCODE/2LB4, 2LB6, 2LA6, 2LA9, 2LSB, 5L80COL, 3L026, 3LO26,
     1    3L029, 3LO29, 5LASCII, 4*0/
*ENDIF
*IF DEF,AELIB5
      DATA ECCODE/L"B4", L"B6", L"A6", L"A9", L"SB", L"80COL", L"026", L
     1"O26",      L"029", L"O29", L"ASCII", 4*0/
*ENDIF
      DATA ECVAL/    3,    4,    5,    6,    1,       2,     4,     4,
     1        5,     5,       6, 4*0/
C  REMOVE TRAILING BLANKS FROM CODE
      XCODE = RTBLNK(RTCODE)
C  SEARCH FOR CODE IN DSPCD
      DO 100 I=1,10
      IF (XCODE .EQ. DSPCD(I)) GO TO 110
100   CONTINUE
C
C ** UNKNOWN CODE
105   IER = 103
      RETURN
C  BRANCH TO APPROPRIATE SECTION TO PROCESS CODE.
C    THIS CODE IS LIKE A CASE STATEMENT
110   IF(DUPLS(I).EQ. 0)GO TO 120
C**   DUPLICATE CODE
      IER=104
      RETURN
120   DUPLS(I)=1
*IF -DEF,AELIB5
      GO TO (200, 300, 400, 500, 600, 700, 800, 900, 1000, 1100), I
*ENDIF
*IF DEF,AELIB5
      GO TO (200, 300, 400, 500, 600, 700, 800, 900, 1000, 1100), I
      CALL GOTOER
*ENDIF
C  DEF
C  IF VALUE = 0, DO NOTHING, OTHERWISE SET DEF FLAG.
200   IF (VALUE .EQ. 0) RETURN
      DSPCAL(2) = DSPCAL(2) + 1
      RETURN
C  DC
C  PUT DISP CODE INTO BYTE 2 OF DSPCAL(2) AND SET FLAG
*IF -DEF,AELIB5
 300  XVAL = RTBLNK(VALUE) .A. MASK(12)
*ENDIF
*IF DEF,AELIB5
 300  XVAL = RTBLNK(VALUE) .AND.MASK(12)
*ENDIF
*IF -DEF,AELIB5
310   DSPCAL(2) = DSPCAL(2) .OR. SHIFT(XVAL,36) .OR. 20B
*ENDIF
*IF DEF,AELIB5
310   DSPCAL(2) = DSPCAL(2) .OR. SHIFT(XVAL,36) .OR. O"20"
*ENDIF
      RETURN
C  EC
C  LOOK UP VALUE IN PUNCH THEN PRINT EC TABLES. PUT NUMBER INTO TOP HALF
C  OF BYTE 3 IN DSPCAL(2) AND SET EC FLAG
400   XVAL = RTBLNK(VALUE)
      DO 410 I=1,15
      IF (XVAL .EQ. ECCODE(I)) GO TO 420
410   CONTINUE
C ** UNKNOWN EC CODE
      IER = 102
      RETURN
*IF -DEF,AELIB5
 420  DSPCAL(2) = DSPCAL(2) .OR. SHIFT(ECVAL(I),21) .OR. 200B
*ENDIF
*IF DEF,AELIB5
 420  DSPCAL(2) = DSPCAL(2) .OR. SHIFT(ECVAL(I),21) .OR. O"200"
*ENDIF
      RETURN
C  FID
C  IF FIRST CHAR OF FID = *, DET FID = * FLAG AND LEFT SHIFT FID 1 CHAR.
500   XVAL = RTBLNK(VALUE)
*IF -DEF,AELIB5
      X = MASK(6) .A. XVAL
*ENDIF
*IF DEF,AELIB5
      X = MASK(6) .AND.XVAL
*ENDIF
*IF -DEF,AELIB5
      IF (X .NE. 1L*) GO TO 510
*ENDIF
*IF DEF,AELIB5
      IF (X .NE. L"*") GO TO 510
*ENDIF
      XVAL = SHIFT(XVAL,6)
      IF (NOS .NE. 0) GO TO 510
*IF -DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + 100B
*ENDIF
*IF DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + O"100"
*ENDIF
C  PUT FID INTO DSPCAL(4) AND SET FID FLAG.
510   IF (XVAL .EQ. 0) RETURN
*IF -DEF,AELIB5
      DSPCAL(4) = XVAL .A. MASK(30)
*ENDIF
*IF DEF,AELIB5
      DSPCAL(4) = XVAL .AND.MASK(30)
*ENDIF
*IF -DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + 40B
*ENDIF
*IF DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + O"40"
*ENDIF
      RETURN
C  REP
C  PUT REPEAT COUNT INTO BYTE 3 OF DSPCAL(5) AND SET REP FLAG
*IF -DEF,AELIB5
600   IF (VALUE .LE. 37B) GO TO 610
*ENDIF
*IF DEF,AELIB5
600   IF (VALUE .LE. O"37") GO TO 610
*ENDIF
C ** REPEAT COUNT TOO LARGE
      IER = 101
      RETURN
610   DSPCAL(5) = DSPCAL(5) .OR. SHIFT(VALUE,12)
*IF -DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + 40000B
*ENDIF
*IF DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + O"40000"
*ENDIF
      RETURN
C  TID
C  PUT TID INTO BYTE 4 OF DSPCAL(3) AND SET TID FLAG
*IF -DEF,AELIB5
 700  XVAL = RTBLNK(VALUE) .A. MASK(12)
*ENDIF
*IF DEF,AELIB5
 700  XVAL = RTBLNK(VALUE) .AND.MASK(12)
*ENDIF
*IF -DEF,AELIB5
      IF (XVAL .NE. 1LC)  GO TO 710
*ENDIF
*IF DEF,AELIB5
      IF (XVAL .NE. L"C")  GO TO 710
*ENDIF
      DSPCAL(2) = DSPCAL(2) + 2
      RETURN
710   IF (NOS .NE. 0) GO TO 720
      DSPCAL(3) = DSPCAL(3) .OR. SHIFT (XVAL, 12)
      DSPCAL(2) = DSPCAL(2) + 4
      RETURN
C     PROCESS TID FOR NOS
720   DSPCAL (4) = DSPCAL(4) .OR. SHIFT (XVAL, 12)
*IF -DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + 100B
*ENDIF
*IF DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) + O"100"
*ENDIF
      RETURN
C   ST
C   PUT DESTINATION ID INTO BYE 1 AND 2 OF DSPCAL(3) AND SET  STATION BI
*IF -DEF,AELIB5
 800  XVAL = RTBLNK(VALUE) .A. MASK(18)
*ENDIF
*IF DEF,AELIB5
 800  XVAL = RTBLNK(VALUE) .AND.MASK(18)
*ENDIF
*IF -DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) .OR. 10B
*ENDIF
*IF DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) .OR. O"10"
*ENDIF
      DSPCAL(3) = DSPCAL(3) .OR. SHIFT(XVAL,42)
      RETURN
C     FC
C     IF NO VALUE GIVEN, IGNORE PARAMETER.
C     PUT FORMS CODE INTO BYTE 1 OF DSPCAL(2) AND SET FC BIT
900   XVAL = RTBLNK(VALUE) .AND. MASK(12)
      IF (XVAL .EQ. 0) RETURN
*IF -DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) .OR. (SHIFT(XVAL,48) .OR. 2000B)
*ENDIF
*IF DEF,AELIB5
      DSPCAL(2) = DSPCAL(2) .OR. (SHIFT(XVAL,48) .OR. O"2000")
*ENDIF
      RETURN
C     ID (NOS ONLY)
C     IGNORE VALUE AT PRESENT. JUST SET CENTRAL SITE BIT.
1000  IF (NOS .EQ. 0) GO TO 105
      DSPCAL(2) = DSPCAL(2) + 2
      RETURN
C     UN (NOS ONLY)
C     IF USER NUMBER SPECIFIED, PUT IT INTO ARRAY XNUM AND PUT
C     COMPLEMENT OF ITS ADDRESS INTO TID WORD.
C     IF USER NUMBER NOT SPECIFIED, SET TID WORD TO -0
1100  IF (NOS .EQ. 0) GO TO 105
      XVAL = RTBLNK(VALUE)
      IF (XVAL .EQ. 0) GO TO 1110
      XNUM(1) = 0
      XNUM(2) = XVAL
*IF -DEF,AELIB5
      DSPCAL(3) = AND(-1 * LOCF(XNUM(1)), 77777777B)
*ENDIF
*IF DEF,AELIB5
      DSPCAL(3) = AND(-1 * LOCF(XNUM(1)), O"77777777")
*ENDIF
      DSPCAL(2) = DSPCAL(2) + 4
      RETURN
*IF -DEF,AELIB5
1110  DSPCAL(3) = 77777777B
*ENDIF
*IF DEF,AELIB5
1110  DSPCAL(3) = O"77777777"
*ENDIF
      DSPCAL(2) = DSPCAL(2) + 4
      RETURN
      END
      SUBROUTINE RTERR (RTCODE, VALUE)
      IMPLICIT INTEGER (A-Z)
C*    RTERR
C
C     TITLE
C       ISSUE ERROR MESSAGES FOR DSP
C
C     ENTRY
C       -IER- IN COMMON BLOCK -RTCOMN- CONTAINS DSP ERROR CODE.
C       RTCODE AND VALUE - AS FOR -RTSTOR-. REQUIRED FOR ERRORS
C                          FOUND IN THAT ROUTINE.
C
C     EXIT
C       AN APPROPRIATE ERROR CODE HAS BEEN ISSUED
C
C     ERRORS
C       SEE NOS/BE REFERENCE MANUAL CHAPTER 6 - THE ROUTE MACRO
C       FOR A LIST OF CODES AND CORRESPONDING ERRORS.
C
C     CALLS
C       ALERPR - DO WE PRINT AN ERROR MESSAGE.
C       TRACEB - PRINT A TRACE BACK.
C
C  COMMON DATA FOR ROUTE ROUTINES
      COMMON /RTCOMN/ IER, DSPCAL(7), DPSCD(10), ECCODE(15), ECVAL(15),
     1    DUPLS(10), NOS, ILOC, AFIT(2)
C
C  DECLARE ALERPR LOGICAL
      LOGICAL ALERPR
C
C  FORMATS -
C  FIRST FORMAT IS AN ERROR MESSAGE THAT IS ALWAYS ISSUED.
*IF -DEF,AELIB5
100   FORMAT (" ***ERROR IN ROUTE SUBROUTINE, LFN = ", A7)
*ENDIF
*IF DEF,AELIB5
100   FORMAT (' ***ERROR IN ROUTE SUBROUTINE, LFN = ', A7)
*ENDIF
C  ERROR MESSAGES FOR DSP ERRORS. THE STATEMENT NUMBER OF THE FORMATS
C  EQUALS THE ERROR CODE FROM DSP.
*IF -DEF,AELIB5
1     FORMAT ("    INVALID LFN - DSP")
*ENDIF
*IF DEF,AELIB5
1     FORMAT ('    INVALID LFN - DSP')
*ENDIF
*IF -DEF,AELIB5
2     FORMAT ("    CANT ROUTE NON ALLOCATABLE EQP")
*ENDIF
*IF DEF,AELIB5
2     FORMAT ('    CANT ROUTE NON ALLOCATABLE EQP')
*ENDIF
*IF -DEF,AELIB5
3     FORMAT ("    ILLEGAL FILE TYPE")
*ENDIF
*IF DEF,AELIB5
3     FORMAT ('    ILLEGAL FILE TYPE')
*ENDIF
*IF -DEF,AELIB5
4     FORMAT ("    NO PERMISSION TO ROUTE THIS FILE")
*ENDIF
*IF DEF,AELIB5
4     FORMAT ('    NO PERMISSION TO ROUTE THIS FILE')
*ENDIF
*IF -DEF,AELIB5
6     FORMAT ("    IMMEDIATE ROUTING - NO FILE - IGNORED")
*ENDIF
*IF DEF,AELIB5
6     FORMAT ('    IMMEDIATE ROUTING - NO FILE - IGNORED')
*ENDIF
*IF -DEF,AELIB5
7     FORMAT ("    INVALID DISPOSITION CODE - ROUTING IGNORED")
*ENDIF
*IF DEF,AELIB5
7     FORMAT ('    INVALID DISPOSITION CODE - ROUTING IGNORED')
*ENDIF
*IF -DEF,AELIB5
10    FORMAT ("    INVALID FID - ROUTING IGNORED")
*ENDIF
*IF DEF,AELIB5
10    FORMAT ('    INVALID FID - ROUTING IGNORED')
*ENDIF
*IF -DEF,AELIB5
11    FORMAT ("    DSP ABORTED BY SYSTEM")
*ENDIF
*IF DEF,AELIB5
11    FORMAT ('    DSP ABORTED BY SYSTEM')
*ENDIF
*IF -DEF,AELIB5
12    FORMAT ("    DSP PARAMETER OUTSIDE FL")
*ENDIF
*IF DEF,AELIB5
12    FORMAT ('    DSP PARAMETER OUTSIDE FL')
*ENDIF
*IF -DEF,AELIB5
17    FORMAT ("    DSP COMPLETE BIT ALREADY SET")
*ENDIF
*IF DEF,AELIB5
17    FORMAT ('    DSP COMPLETE BIT ALREADY SET')
*ENDIF
*IF -DEF,AELIB5
20    FORMAT ("    FILE ON DISMOUNTABLE DEVICE - ROUTING IGNORED")
*ENDIF
*IF DEF,AELIB5
20    FORMAT ('    FILE ON DISMOUNTABLE DEVICE - ROUTING IGNORED')
*ENDIF
*IF -DEF,AELIB5
21    FORMAT ("    TID NOT ALPHANUMERIC - ROUTING IGNORED")
*ENDIF
*IF DEF,AELIB5
21    FORMAT ('    TID NOT ALPHANUMERIC - ROUTING IGNORED')
*ENDIF
*IF -DEF,AELIB5
23    FORMAT ("    INVALID LINK TYPE - ROUTING IGNORED ")
*ENDIF
*IF DEF,AELIB5
23    FORMAT ('    INVALID LINK TYPE - ROUTING IGNORED ')
*ENDIF
*IF -DEF,AELIB5
 24   FORMAT ("    FILE WILL BE COPIED TO QUEUE DEVICE")
*ENDIF
*IF DEF,AELIB5
 24   FORMAT ('    FILE WILL BE COPIED TO QUEUE DEVICE')
*ENDIF
C  THIS ERROR MESSAGE IS A CATCH ALL FOR DSP ERRORS I DON"T THINK
C  WILL EVER OCCUR.
*IF -DEF,AELIB5
99    FORMAT ("    UNKNOWN ERROR CODE ", I4)
*ENDIF
*IF DEF,AELIB5
99    FORMAT ('    UNKNOWN ERROR CODE ', I4)
*ENDIF
C  ERROR MESSAGES FOR ERRORS DETECTED BY RTSTOR
*IF -DEF,AELIB5
101   FORMAT ("    REPEAT COUNT - ", O4, "B GREATER THAN 37B")
*ENDIF
*IF DEF,AELIB5
101   FORMAT ('    REPEAT COUNT - ', O4, 'B GREATER THAN 37B')
*ENDIF
*IF -DEF,AELIB5
102   FORMAT ("    UNKNOWN EXTERNAL CHARACTERISTICS ", A5)
*ENDIF
*IF DEF,AELIB5
102   FORMAT ('    UNKNOWN EXTERNAL CHARACTERISTICS ', A5)
*ENDIF
*IF -DEF,AELIB5
103   FORMAT ("    UNKNOWN PARAMETER ", A7)
*ENDIF
*IF DEF,AELIB5
103   FORMAT ('    UNKNOWN PARAMETER ', A7)
*ENDIF
*IF -DEF,AELIB5
104   FORMAT ("    DUPLICATE PARAMETER ", A7)
*ENDIF
*IF DEF,AELIB5
104   FORMAT ('    DUPLICATE PARAMETER ', A7)
*ENDIF
C  RETURN IF THIS ERROR MESSAGE IS NOT TO BE PRINTED.
      IF (.NOT. ALERPR(20521,IER))   RETURN
C  USE COMPUTED GO TO'S TO PRINT THE APPROPRIATE MESSAGE.
      PRINT 100,DSPCAL(1)
*IF -DEF,AELIB5
      IF (IER .LE. 26B)
     1  GO TO (201, 202, 203, 204, 200, 206, 207, 210,
     2         211, 212, 200, 200, 200, 200, 217, 220,
     3         221, 200, 223, 224, 200, 200), IER
*ENDIF
*IF DEF,AELIB5
      IF (IER .LE. O"26")
     1    THEN
      GO TO (201, 202, 203, 204, 200, 206, 207, 210,
     2       211, 212, 200, 200, 200, 200, 217, 220,
     3       221, 200, 223, 224, 200, 200), IER
      CALL GOTOER
      ENDIF
      CONTINUE
*ENDIF
      IF (IER .LT. 101) GO TO 200
*IF -DEF,AELIB5
      IF (IER .LT. 105)
     1  GO TO (301, 302, 303, 304), IER-100
*ENDIF
*IF DEF,AELIB5
      IF (IER .LT. 105)
     1  THEN
      GO TO (301, 302, 303, 304), IER-100
      CALL GOTOER
      ENDIF
      CONTINUE
*ENDIF
200   PRINT 99, IER
      GO TO 900
201   PRINT 1
      GO TO 900
202   PRINT 2
      GO TO 900
203   PRINT 3
      GO TO 900
204   PRINT 4
      GO TO 900
206   PRINT 6
      GO TO 900
207   PRINT 7
      GO TO 900
210   PRINT 10
      GO TO 900
211   PRINT 11
      GO TO 900
212    PRINT 12
      GO TO 900
217   PRINT 17
      GO TO 900
220   PRINT 20
      GO TO 900
221   PRINT 21
      GO TO 900
223   PRINT 23
      GO TO 900
224   PRINT 24
      GO TO 900
301   PRINT 101, VALUE
      GO TO 900
302   PRINT 102, VALUE
      GO TO 900
303   PRINT 103, RTCODE
      GO TO 900
304   PRINT 104, RTCODE
C  PRINT A TRACEBACK
900   CALL TRACEB(0)
      RETURN
      END
      SUBROUTINE RTCLOS
      IMPLICIT INTEGER (A-Z)
C*    RTCLOS
C
C     TITLE
C       CLOSE FILE BEING ROUTED
C
C     ENTRY
C      CALLING PARAMETERS HAVE BEEN CRACKED.
C      ILOC CONTAINS LOCATION OF FIT.
C
C     EXIT
C       IF FILE EXISTS AND ROUTE IS NOT DEFERRED, IT IS CLOSED.
C
C     ERRORS
C       CANNOT CLOSE MASS STORAGE FILE (FROM AECLOS)
C
C     CALLS
C       AECLOS - CLOSE FILE
      COMMON /RTCOMN/ IER, DSPCAL(7), DSPCD(10), ECCODE(15), ECVAL(15),
     1    DUPLS(10), NOS, ILOC, AFIT(2)
      IX = DSPCAL(2) .AND. 1
      IF (ILOC .EQ. 0 .OR. IX .EQ. 1) RETURN
      CALL AECLOS (AFIT(ILOC), IER)
      IF (IER .NE. 0) IER = 2
      RETURN
      END
