*DECK SETCCL
      SUBROUTINE SETCCL(RGNAME,IVAL)
C
C FORTRAN CALLABLE ROUTINE TO SET THE VALUES OF CCL REGISTERS.
C
C CALL SETCCL(RGNAME,IVAL)
C
C PARAMETERS -
C    RGNAME   INTEGER INPUT VARIABLE, SPECIFIES THE REGISTER NAME.
C             IT MUST BE ONE OF THE SET 2LR1, 2LR2, 2LR3, 3LR1G.
C
C    IVAL     INTEGER INPUT VARIABLE, THE VALUE TO BE STORED IN
C             THE SPECIFIED REGISTER.  THE RANGE OF VALUES IS:
C
C                            0 @ IABS(IVAL) @ 131071 (I.E. 377777B)
C
C ERROR CHECKING -
C    IF RGNAME IS NOT ONE OF THE ABOVE SET, OR IF IVAL IS NOT IN THE
C    RANGE GIVEN ABOVE, TRACEBACK INFORMATION WILL BE WRITTEN TO THE
C    OUTPUT FILE AND THE JOB WILL BE ABORTED.
C
C THIS ROUTINE IS CALLED BY THE AELIB FUNCTION IGETCCL AT THE
C    ENTRY POINT GETCCL.
C
C THIS ROUTINE CALLS FGETJCI AND FSETJCI WHICH CALL THE MACROS
C    GETJCI AND SETJCI.
C
C CODED BY EA OKAZAKI   1979 OCTOBER
C
C
      IMPLICIT INTEGER (A-Z)
      INTEGER BUFFER(3)
C
C
C     STATEMENT FUNCTION CCFLAG CLEARS COMPLETION FLAG FOR CALLING
C     GETJCI AND SETJCI MACROS.
*IF -DEF,AELIB5
      CCFLAG(A)=A .AND. 77777777777777777700B
*ENDIF
*IF DEF,AELIB5
      CCFLAG(A)=A .AND. O"77777777777777777700"
*ENDIF
C
*CALL STATF
C
      WHICH="SET"
      GO TO 100
C
C
*IF -DEF,AELIB5
      ENTRY GETCCL
*ENDIF
*IF DEF,AELIB5
      ENTRY GETCCL(RGNAME,IVAL)
*ENDIF
C
      WHICH="GET"
C
C
C     TEST FOR LEGAL FIRST PARAMETER
C
*IF -DEF,AELIB5
  100 IF (RGNAME .NE. 2LR1) GO TO 110
*ENDIF
*IF DEF,AELIB5
  100 IF (RGNAME .NE. L"R1") GO TO 110
*ENDIF
         BASE=1
         K=1
         LENGTH=18
         GO TO 200
C
*IF -DEF,AELIB5
  110 IF (RGNAME .NE. 2LR2) GO TO 120
*ENDIF
*IF DEF,AELIB5
  110 IF (RGNAME .NE. L"R2") GO TO 120
*ENDIF
         BASE=1
         K=19
         LENGTH=18
         GO TO 200
C
*IF -DEF,AELIB5
  120 IF (RGNAME .NE. 2LR3) GO TO 130
*ENDIF
*IF DEF,AELIB5
  120 IF (RGNAME .NE. L"R3") GO TO 130
*ENDIF
         BASE=1
         K=37
         LENGTH=18
         GO TO 200
C
*IF -DEF,AELIB5
  130 IF (RGNAME .NE. 3LR1G) GO TO 500
*ENDIF
*IF DEF,AELIB5
  130 IF (RGNAME .NE. L"R1G") GO TO 500
*ENDIF
         BASE=2
         K=37
         LENGTH=18
C
C
C     FOR SET, TEST FOR LEGAL SECOND PARAMETER
C
  200 CONTINUE
      IF (WHICH .NE. "SET") GO TO 300
*IF -DEF,AELIB5
         IF (IABS(IVAL) .GT. 377777B) GO TO 500
*ENDIF
*IF DEF,AELIB5
         IF (IABS(IVAL) .GT. O"377777") GO TO 500
*ENDIF
C
C
C     DO GETJCI FOR BOTH GET AND SET
C
  300 CONTINUE
      BUFFER(BASE)=CCFLAG(BUFFER(BASE))
      CALL FGETJCI(BUFFER(BASE))
C
C
C     CALL LBYT AND EXTEND SIGN FOR GET
C
      IF (WHICH .NE. "GET") GO TO 400
         IVAL=LBYT(K,LENGTH,BUFFER(2))
*IF -DEF,AELIB5
         IF ((IVAL .AND. 400000B) .NE. 0) IVAL=
     ,      IVAL .OR. 77777 77777 77770 00000B
*ENDIF
*IF DEF,AELIB5
         IF ((IVAL .AND. O"400000") .NE. 0) IVAL=
     ,        IVAL .OR. O"77777 77777 77770 00000"
*ENDIF
         RETURN
C
C
C     CALL SBYT AND SETJCI FOR SET
C
  400 CONTINUE
         CALL SBYT(K,LENGTH,BUFFER(2),IVAL)
         BUFFER(BASE)=CCFLAG(BUFFER(BASE))
         CALL FSETJCI(BUFFER(BASE))
         RETURN
C
C
C     PARAMETER ERRORS - SEND MESSAGE AND ABORT JOB.
C
  500 CONTINUE
      PRINT 9000
*IF -DEF,AELIB5
 9000 FORMAT (" ***ILLEGAL PARAMETER")
*ENDIF
*IF DEF,AELIB5
 9000 FORMAT (' ***ILLEGAL PARAMETER')
*ENDIF
      CALL TRACEB(1)
      END
          IDENT  FGETJCI
          ENTRY  FGETJCI,FSETJCI
          TITLE  FGETJCI - FTN ACCESS TO JOB CONTROL INFORMATION
          COMMENT          FTN ACCESS TO JOB CONTROL INFORMATION
*
* FORTRAN CALLABLE SUBROUTINES -
*
* CALL FGETJCI(A)
*
* WHERE A IS LOCATION OF TWO WORDS INTO WHICH
*         JOB CONTROL INFORMATION WILL BE READ
*         BY CALLING THE MACRO GETJCI.
*
* CALL FSETJCI(A)
*
* WHERE A IS LOCATION OF TWO WORDS FROM WHICH
*         JOB CONTROL INFORMATION WILL BE SET
*         BY CALLING THE MACRO SETJCI.
*
* USED BY THE AELIB ROUTINES IGETCCL AND SETCCL.
*
* FOR THE NOS/BE VERSION 1.3 SYSTEM AT LEVEL 499.
*
* CODED BY EA OKAZAKI   1979 OCTOBER
*
 FGETJCI  EQ     *+1S17
          GETJCI X1
          EQ     FGETJCI
*
 FSETJCI  EQ     *+1S17
          SETJCI X1
          EQ     FSETJCI
*
          END
