*DECK SIMPLT
      SUBROUTINE SIMPLT(JOBOPT,X,Y,N,PEN,SYMB,LOGOPT)
************************************************************************
**                                                                    **
**    NOTE THAT SIMPLT IS WRITTEN IN MODULAR FORM USING THE ADDITIONAL**
**    ROUTINES:                                                       **
**       LOGPR13                                                      **
**       LOGPR14                                                      **
**       LOGPR15                                                      **
**       LOGPR16                                                      **
**       LOGPR17                                                      **
**       LOGPR18                                                      **
**       LOGPR19                                                      **
**       LOGPR20                                                      **
**       LOGPR21                                                      **
**       DUMPON                                                       **
**    LOGPR13 THROUGH DUMPON ACCOMPANY SIMPLT ON AELIB SOURCE TAPE    **
**    UNDER DECK NAME SIMPLT                                          **
**                                                                    **
************************************************************************
C
C
C SIMPLT IS AN AUTOMATIC PLOTTING SUBROUTINE.  IT IS CAPABLE OF PRODUC-
C ING AN ENTIRE PLOT FROM A SINGLE CALL.  IT CAN BE USED TO PLOT LINEAR,
C SEMI-LOGARITHMIC OR LOG-LOG GRAPHS.  SIMPLT ALSO ALLOWS MANY OPTIONAL
C PARAMETERS TO BE SPECIFIED, WHICH ENABLE THE USER TO TAILOR THE GRAPH
C TO HIS OWN TASTES, AND PRODUCE COMPLETELY ACCEPTABLE FINAL RESULTS.
C THERE ARE THREE LOGICALLY SEPARATE SECTIONS WITHIN THE SIMPLT
C SUBROUTINE:
C A) READ IN SECTION FOR OPTIONAL PARAMETERS, CONTAINING FACILITIES FOR
C     READING IN FORMATS, SCALE SPECIFICATIONS, SYMBOL MEANINGS, AND THE
C     LOCATIONS OF TITLES FROM DATA CARDS
C B) FRAME AND LABELLING SECTION WHICH SETS UP AND PLOTS THE AXES AND
C     PRINTS ALL TITLES AND TIC LABELS.
C C) CURVE SECTION, WHICH PLOTS CURVES ON POINTS AND (OPTIONALLY)
C     PRINTS THE MEANINGS OF THE SYMBOLS PLOTTED.
C THESE THREE SECTIONS CAN BE COMBINED IN A VARIETY OF WAYS, DEPENDING
C UPON THE VALUE OF THE JOBOPT PARAMETER.  ALL OF THE PARAMETERS WHICH
C CAN BE SPECIFIED THROUGH SECTION A CAN ALTERNATELY BE PASSED THROUGH
C COMMON BLOCKS.  AN OPTIONAL DUMP OF ALL OF THE PARAMETERS USED BY
C SECTION B IN PLOTTING THE FRAME AND LABELS IS ALSO AVAILABLE.  THERE
C ARE TWO LEGAL CALLING SEQUENCES:
C     CALL SIMPLT(JOBOPT,X,Y,N,PEN,SYMB,LOGOPT)
C     CALL SIMPLT(JOBOPT,X,Y,N,PEN,SYMB)
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975
C MODIFIED BY J. WENDORF, JUNE,1979
C   (MODIFY ERROR HANDLING; MODIFY AXIS LENGTH LIMITS; FIX POSITIONING
C    OF SYMBOL IN SYMBOL MEANING MESSAGE.)
C
C
C
      REAL X(1), Y(1), TEMP(15)
      REAL MTOE
      INTEGER NAMTAB(37)
      INTEGER IPTR(5)
      LOGICAL DUMP
      LOGICAL METRIC
      COMMON/LWENG/XL,YL,XLM,YLM
      COMMON /SCALES/ XMIN, XMAX, TICX, FXSCAL, YMIN, YMAX, TICY, FYSCAL
      COMMON/FORMAT/XIL,YIL,FTITLE(8),FSUBTIT(8),FXAXTIT(8),
     $                FYAXTIT(8), NSTVARS, STVARS(10)
      COMMON /SYMEAN/ SYMCOD(10), FSYMTXT(2,10), SYMLOC(2)
      COMMON /TITLOC/ TITLEL(2), SUBTITL(2), XAXTITL(2), YAXTITL(2)
      EQUIVALENCE (ISYMB,RSYMB)
*IF -DEF,AELIB5
      DATA XMIN,XMAX,TICX,FXSCAL,YMIN,YMAX,TICY,FYSCAL,UNDEF,TITLEL,
     $     SUBTITL,XAXTITL,YAXTITL,SYMLOC /19*37775555555555555555B/
*ENDIF
*IF DEF,AELIB5
      DATA XMIN,XMAX,TICX,FXSCAL,YMIN,YMAX,TICY,FYSCAL,UNDEF,TITLEL,
     $     SUBTITL,XAXTITL,YAXTITL,SYMLOC /19*O"37775555555555555555"/
*ENDIF
*IF -DEF,AELIB5
      DATA XIL,YIL /2*37775555555555555555B/
*ENDIF
*IF DEF,AELIB5
      DATA XIL,YIL /2*O"37775555555555555555"/
*ENDIF
*IF -DEF,AELIB5
      DATA FTITLE /10H(*SIMPLT O,10HUTPUT*)   ,6*10H          /
      DATA FSUBTIT /10H(*      *),7*10H          /
      DATA FXAXTIT /10H(*X COORDI,10HNATE*)    ,6*10H          /
      DATA FYAXTIT /10H(*Y COORDI,10HNATE*)    ,6*10H          /
*ENDIF
*IF DEF,AELIB5
      DATA FTITLE /10H('SIMPLT O,10HUTPUT')   ,6*10H          /
      DATA FSUBTIT /10H('      '),7*10H          /
      DATA FXAXTIT /10H('X COORDI,10HNATE')    ,6*10H          /
      DATA FYAXTIT /10H('Y COORDI,10HNATE')    ,6*10H          /
*ENDIF
      DATA NSTVARS /0/
*IF -DEF,AELIB5
*IF -DEF,AELIB5
      DATA SYMCOD /10*(-1.0)/, FSYMTXT/10*(10H(*      *),10H          )/
*ENDIF
*IF DEF,AELIB5
      DATA SYMCOD /10*-1.0/, FSYMTXT/10(10H('      '),10H          )/
*ENDIF
*ENDIF
*IF DEF,AELIB5
      DATA SYMCOD /10*-1.0/, FSYMTXT/10(10H(*      *),10H          )/
*ENDIF
      DATA LO /-1/
      DATA NAMTAB /10HXMIN   200,10HXMAX   200,10HTICX   300,
     $             10HFXSCAL 400,10HYMIN   200,10HYMAX   200,
     $             10HTICY   300,10HFYSCAL 400,10HXL     200,
     $             10HYL     200,10HFTITLE 408,10HFSUBTIT408,
     $             10HFXAXTIT408,10HFYAXTIT408,10HNSTVARS100,
     $             10HSTVARS 310,10HSYMCOD 310,10HFSYMB1 402,
     $             10HFSYMB2 402,10HFSYMB3 402,10HFSYMB4 402,
     $             10HFSYMB5 402,10HFSYMB6 402,10HFSYMB7 402,
     $             10HFSYMB8 402,10HFSYMB9 402,10HFSYMB10402,
     $             10HSYMLOCX200,10HSYMLOCY200,10HTITLOCX200,
     $             10HTITLOCY200,10HSUBLOCX200,10HSUBLOCY200,
     $             10HXAXLOCX200,10HXAXLOCY200,10HYAXLOCX200,
     $             10HYAXLOCY200/
      DATA  IPTR / 8, 16, 29, 37, 0 /
*IF -DEF,AELIB5
      DATA OFFSET / 05254406000145052540B /
*ENDIF
*IF DEF,AELIB5
      DATA OFFSET / O"05254406000145052540" /
*ENDIF
C
C     IPTR         POINTS TO LAST "NAMTAB" ENTRY FOR EACH LABELED COMMON
C
C
      METRIC=.FALSE.
      GO TO 50
C
C
*IF -DEF,AELIB5
      ENTRY SIMPLTM
*ENDIF
*IF DEF,AELIB5
      ENTRY SIMPLTM(JOBOPT,X,Y,N,PEN,SYMB,LOGOPT)
*ENDIF
      METRIC=.TRUE.
   50 ETOM=25.4
      MTOE=1./ETOM
*CALL STATF
C
C     INITIALIZE ERROR NUMBERS FOR LOGPR20 ERROR ROUTINE.
C        1 - ***JOBOPT NOT 0,1,2,3, OR 4.
C        2 - ***LOGOPT NOT 0,1,2, OR 3.
C        3 - ***X AXIS DECLARED LT 0.005 OR GT 160 INCHES.
C        4 - ***Y AXIS DECLARED LT 0.005 OR GT 28.175 INCHES.
C        5 - ***JOBOPT 2 OR 3 CALL NOT PRECEDED BY JOBOPT 0 OR 1 CALL.
      NERR0=1
      NERR1=2
      NERR2=3
      NERR3=4
      NERR4=5
C
C
C     CHECK THE JOBOPT AND LOGOPT PARAMETERS FOR LEGALITY.
C
      IF ((JOBOPT .LT. 0) .OR. (JOBOPT .GT. 4)) CALL LOGPR20(NERR0)
      LF=0
      IF(LOCF(LOGOPT).NE.0) LF=LOGOPT
      IF ((LF .LT. 0) .OR. (LF .GT. 3)) CALL LOGPR20(NERR1)
C
C
C     BRANCH TO THE APPROPRIATE SECTION OF SIMPLT, DEPENDING UPON THE
C     VALUE OF JOBOPT.
C
      JOBOP2=JOBOPT
*IF -DEF,AELIB5
      GO TO (100,200,300,400,100) JOBOPT+1
*ENDIF
*IF DEF,AELIB5
      GO TO (100,200,300,400,100) JOBOPT+1
      CALL GOTOER
*ENDIF
C
C
C
C
C
C SECTION A: READ IN SECTION
C
C
C     SET THE FXSCAL AND FYSCAL ENTRIES IN NAMTAB ACCORDING TO THE TYPE
C     OF AXIS REFERRED TO (LINEAR OR LOGARITHMIC).  THEN CALL LOGPR17,
C     THE INPUT SCANNER.  IF ONLY SECTION A IS TO BE EXECUTED, RETURN.
C     OTHERWISE, GO ON TO SECTION B.
C
  100 NAMTAB(4)=10HFXSCAL 400
      NAMTAB(8)=10HFYSCAL 400
*IF -DEF,AELIB5
      IF((LF.EQ.1).O.(LF.EQ.3)) NAMTAB(4)=10HFXSCAL 100
*ENDIF
*IF DEF,AELIB5
      IF((LF.EQ.1).OR.(LF.EQ.3)) NAMTAB(4)=10HFXSCAL 100
*ENDIF
*IF -DEF,AELIB5
      IF((LF.EQ.2).O.(LF.EQ.3)) NAMTAB(8)=10HFYSCAL 100
*ENDIF
*IF DEF,AELIB5
      IF((LF.EQ.2).OR.(LF.EQ.3)) NAMTAB(8)=10HFYSCAL 100
*ENDIF
      CALL LOGPR17(NAMTAB,XMIN,XIL,SYMCOD,TITLEL,IPTR,37)
      IF(JOBOPT.EQ.4) RETURN
C
C
C
C
C
C SECTION B: FRAME AND LABELLING SECTION
C
C
C     IF A DUMP HAS BEEN REQUESTED BY THE USER, CALL LOGPR21, THE
C     PARAMETER DUMP ROUTINE.  CHECK XL AND YL FOR LEGALITY.  CALL
C     LOGPR13 TWICE,  FIRST FOR THE X-AXIS AND THEN FOR THE Y-AXIS.
C     LOGPR13 DETERMINES THE MIN AND MAX STARTING VALUES TO BE USED IN
C     THE AUTOMATIC AXIS LIMITS AND TIC VALUE CALCULATING ROUTINES.
C
  200 CALL DUMPRET(DUMP)
      IF (.NOT. DUMP) GOTO 201
C
C     ....DUMP /SCALES/
C
*IF -DEF,AELIB5
          CALL LOGPR21(NAMTAB,XMIN,8, 8H/SCALES/ )
*ENDIF
*IF DEF,AELIB5
          CALL LOGPR21(NAMTAB,XMIN,8, '/SCALES/')
*ENDIF
C
C     ....DUMP /FORMAT/
C
*IF -DEF,AELIB5
      CALL LOGPR21(NAMTAB(9),XIL,8,8H/FORMAT/)
*ENDIF
*IF DEF,AELIB5
      CALL LOGPR21(NAMTAB(9),XIL,8,'/FORMAT/')
*ENDIF
C
C     ....DUMP /SYMEAN/
C
*IF -DEF,AELIB5
          CALL LOGPR21(NAMTAB(17),SYMCOD,13, 8H/SYMEAN/ )
*ENDIF
*IF DEF,AELIB5
          CALL LOGPR21(NAMTAB(17),SYMCOD,13, '/SYMEAN/')
*ENDIF
C
C     ....DUMP /TITLOC/
C
*IF -DEF,AELIB5
          CALL LOGPR21(NAMTAB(30),TITLEL,8, 8H/TITLOC/ )
*ENDIF
*IF DEF,AELIB5
          CALL LOGPR21(NAMTAB(30),TITLEL,8, '/TITLOC/')
*ENDIF
C
201   CONTINUE
      XL=YL=8.0
      IF (METRIC) GO TO 202
      IF(XOR(UNDEF,XIL).NE.0) XL=XIL
      IF(XOR(UNDEF,YIL).NE.0) YL=YIL
      GO TO 203
  202 IF(XOR(UNDEF,XIL).NE.0) XL=XIL*MTOE
      IF(XOR(UNDEF,YIL).NE.0) YL=YIL*MTOE
  203 XLM=XL*ETOM
      YLM=YL*ETOM
      IF ((XL .LT. 0.005) .OR. (XL .GT. 160.0)) CALL LOGPR20(NERR2)
      IF ((YL .LT. 0.005) .OR. (YL .GT. 28.175)) CALL LOGPR20(NERR3)
*IF -DEF,AELIB5
      IF(JOBOP2.EQ.2) GO TO (212,216,214,218) LO+1
*ENDIF
*IF DEF,AELIB5
      IF(JOBOP2.EQ.2) THEN
      GO TO (212,216,214,218) LO+1
      CALL GOTOER
      ENDIF
*ENDIF
      CALL LOGPR13(X,N,XMIN,XMAX,XMIN2,XMAX2)
      CALL LOGPR13(Y,N,YMIN,YMAX,YMIN2,YMAX2)
C
C
C     DETERMINE THE APPROPRIATE PLOGZZ OR PLOT MODE 1 PARAMETERS.  CALL
C     LOGPR14 FOR LINEAR AXIS PARAMETERS AND LOGPR15 FOR LOGARITHMIC.
C     THESE TWO ROUTINES ALSO DETERMINE THE TIC LABELLING PARAMETER
C     VALUES TO BE USED IN THE AXLGZZ OR AXLIN ROUTINES.  MAKE THE
C     APPROPRIATE PLOGZZ OR PLOT MODE 1 CALL.  THEN MAKE THE CORRESPON-
C     DING AXLGZZ OR AXLIN CALL TO PLOT THE TIC LABELS (BUT NOT THE AXIS
C     TITLES).
C
      LO=LF
*IF -DEF,AELIB5
      GO TO (211,215,211,215) LO+1
*ENDIF
*IF DEF,AELIB5
      GO TO (211,215,211,215) LO+1
      CALL GOTOER
*ENDIF
C
C
  211 CALL LOGPR14(XMIN2,XMAX2,1,RXMIN,RXMAX,RTICX,RFXSCAL,NFXSCAL)
      IF(LO.EQ.2) GO TO 213
C
      CALL LOGPR14(YMIN2,YMAX2,2,RYMIN,RYMAX,RTICY,RFYSCAL,NFYSCAL)
  212 IF (METRIC) GO TO 2121
      CALL PLOT(1,XL, YL, RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLIN(0,0,0,0,RFXSCAL,NFXSCAL,RFYSCAL,NFYSCAL)
      GO TO 220
 2121 CALL PLOTM(1,XLM,YLM,RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLINM(0,0,0,0,RFXSCAL,NFXSCAL,RFYSCAL,NFYSCAL)
      GO TO 220
C
C
  213 CALL LOGPR15(YMIN2,YMAX2,2,RYMIN,RYMAX,RTICY,NFYSCAL)
  214 IF (METRIC) GO TO 2141
      CALL PLOGY(1,XL, YL, RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLGY(0,0,0,0,RFXSCAL,NFXSCAL,NFYSCAL)
      GO TO 220
 2141 CALL PLOGYM(1,XLM,YLM,RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLGYM(0,0,0,0,RFXSCAL,NFXSCAL,NFYSCAL)
      GO TO 220
C
C
  215 CALL LOGPR15(XMIN2,XMAX2,1,RXMIN,RXMAX,RTICX,NFXSCAL)
      IF(LO.EQ.3) GO TO 217
C
      CALL LOGPR14(YMIN2,YMAX2,2,RYMIN,RYMAX,RTICY,RFYSCAL,NFYSCAL)
  216 IF (METRIC) GO TO 2161
      CALL PLOGX(1,XL, YL, RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLGX(0,0,0,0,NFXSCAL,RFYSCAL,NFYSCAL)
      GO TO 220
 2161 CALL PLOGXM(1,XLM,YLM,RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLGXM(0,0,0,0,NFXSCAL,RFYSCAL,NFYSCAL)
      GO TO 220
C
C
  217 CALL LOGPR15(YMIN2,YMAX2,2,RYMIN,RYMAX,RTICY,NFYSCAL)
  218 IF (METRIC) GO TO 2181
      CALL PLOGXY(1,XL, YL, RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLGXY(0,0,0,0,NFXSCAL,NFYSCAL)
      GO TO 220
 2181 CALL PLOGXYM(1,XLM,YLM,RXMIN,RXMAX,RYMIN,RYMAX,RTICX,RTICY)
      CALL AXLGXYM(0,0,0,0,NFXSCAL,NFYSCAL)
C
C
C     PLOT THE X-AXIS TITLE.
C
  220 CALL LOGPR16(2,136,FXAXTIT,TEMP,NB,NT,0,0)
      IF(NT.EQ.0) GO TO 230
      XLOC=(XL-(NT-NB)*0.16)/2.0
      YLOC=-0.5
      IF(METRIC) XLOC=XLOC*ETOM
      IF(METRIC) YLOC=YLOC*ETOM
      IF(XOR(UNDEF,XAXTITL(1)).NE.0) XLOC=XAXTITL(1)
      IF(XOR(UNDEF,XAXTITL(2)).NE.0) YLOC=XAXTITL(2)
*IF -DEF,AELIB5
      IF(.N.METRIC) CALL PLOT(13,TEMP,2,0,XLOC,YLOC)
*ENDIF
*IF DEF,AELIB5
      IF(.NOT.METRIC) CALL PLOT(13,TEMP,2,0,XLOC,YLOC)
*ENDIF
      IF(METRIC) CALL PLOTM(13,TEMP,2,0,XLOC,YLOC)
C
C
C     PLOT THE Y-AXIS TITLE.
C
  230 CALL LOGPR16(2,136,FYAXTIT,TEMP,NB,NT,0,0)
      IF(NT.EQ.0) GO TO 240
      XLOC=-0.65
*IF -DEF,AELIB5
      IF((LO.LT.2).A.(NFYSCAL.GT.0)) XLOC=-(NFYSCAL+2.5)*0.08
*ENDIF
*IF DEF,AELIB5
      IF((LO.LT.2).AND.(NFYSCAL.GT.0)) XLOC=-(NFYSCAL+2.5)*0.08
*ENDIF
      YLOC=(YL-(NT-NB)*0.16)/2.0
      IF(METRIC) XLOC=XLOC*ETOM
      IF(METRIC) YLOC=YLOC*ETOM
      IF(XOR(UNDEF,YAXTITL(1)).NE.0) XLOC=YAXTITL(1)
      IF(XOR(UNDEF,YAXTITL(2)).NE.0) YLOC=YAXTITL(2)
*IF -DEF,AELIB5
      IF(.N.METRIC) CALL PLOT(13,TEMP,2,6,XLOC,YLOC)
*ENDIF
*IF DEF,AELIB5
      IF(.NOT.METRIC) CALL PLOT(13,TEMP,2,6,XLOC,YLOC)
*ENDIF
      IF(METRIC) CALL PLOTM(13,TEMP,2,6,XLOC,YLOC)
C
C
C     CALCULATE HEADING AREA ALLOWED ABOVE THE GRAPH (AREA FOR TITLE,
C     SUBTITLE AND SYMBOL MEANINGS.
C
  240 HEDAREA=10.175-YL
      IF (HEDAREA .LT. 0.0) HEDAREA=28.175-YL
      IF(HEDAREA.GT.2.5) HEDAREA=2.5
C
C
C     CALCULATE AN APPROPRIATE SIZE FOR THE TITLE.
C
      CALL LOGPR16(2,136,FTITLE,TEMP,NB,NT,0,0)
      IF(NT.EQ.0) GO TO 250
      TITAREA=HEDAREA/3.0
C
      DO 245 I=1,4
         IF(I*0.08.GT.TITAREA) GO TO 246
  245 CONTINUE
C
  246 SIZE=I-1.0
      IF(SIZE-1.0) 260,248,247
C
  247 TLEN=SIZE*0.08*(NT-NB)
      IF(TLEN.LE.XL+1.5) GO TO 248
      SIZE=SIZE-1.0
      IF(SIZE.GT.1.0) GO TO 247
C
C
C     PLOT THE TITLE.
C
  248 XLOC=(XL-SIZE*0.08*(NT-NB))/2.0
      YLOC=HEDAREA-TITAREA+YL
      IF(METRIC) XLOC=XLOC*ETOM
      IF(METRIC) YLOC=YLOC*ETOM
      IF(XOR(UNDEF,TITLEL(1)).NE.0) XLOC=TITLEL(1)
      IF(XOR(UNDEF,TITLEL(2)).NE.0) YLOC=TITLEL(2)
*IF -DEF,AELIB5
      IF(.N.METRIC) CALL PLOT(13,TEMP,SIZE,0,XLOC,YLOC)
*ENDIF
*IF DEF,AELIB5
      IF(.NOT.METRIC) CALL PLOT(13,TEMP,SIZE,0,XLOC,YLOC)
*ENDIF
      IF(METRIC) CALL PLOTM(13,TEMP,SIZE,0,XLOC,YLOC)
C
C
C     CALCULATE AN APPROPRIATE SIZE FOR THE SUBTITLE.
C
  250 CALL LOGPR16(2,136,FSUBTIT,TEMP,NB,NT,NSTVARS,STVARS)
      IF(NT.EQ.0) GO TO 260
      TITAREA=HEDAREA/4.0
C
      IF(TITAREA.LT.0.08) GO TO 260
      SIZE=1.0
      IF(TITAREA.LT.0.2) GO TO 255
      SIZE=2.0
      IF(0.16*(NT-NB).GT.XL+1.5) SIZE=1.0
C
C
C     PLOT THE SUBTITLE.
C
  255 XLOC=(XL-SIZE*0.08*(NT-NB))/2.0
      YLOC=YL+HEDAREA*5.0/12.0
      IF(METRIC) XLOC=XLOC*ETOM
      IF(METRIC) YLOC=YLOC*ETOM
      IF(XOR(UNDEF,SUBTITL(1)).NE.0)XLOC=SUBTITL(1)
      IF(XOR(UNDEF,SUBTITL(2)).NE.0)YLOC=SUBTITL(2)
*IF -DEF,AELIB5
      IF(.N.METRIC) CALL PLOT(13,TEMP,SIZE,0,XLOC,YLOC)
*ENDIF
*IF DEF,AELIB5
      IF(.NOT.METRIC) CALL PLOT(13,TEMP,SIZE,0,XLOC,YLOC)
*ENDIF
      IF(METRIC) CALL PLOTM(13,TEMP,SIZE,0,XLOC,YLOC)
C
C
C     DETERMINE THE STARTING LOCATION FOR THE SYMBOL MEANINGS AND CALCUL
C     OTHER VALUES NEEDED WHEN PLOTTING THEM IN SECTION C.
C
  260 XLOC=0.0
      YLOC=YL+HEDAREA*5.0/12.0-0.2
      IF(METRIC) GO TO 265
      IF(XOR(UNDEF,SYMLOC(1)).NE.0) XLOC=SYMLOC(1)
      IF(XOR(UNDEF,SYMLOC(2)).NE.0) YLOC=SYMLOC(2)
      GO TO 270
  265 IF (XOR(UNDEF,SYMLOC(1)).NE.0) XLOC=SYMLOC(1)*MTOE
      IF (XOR(UNDEF,SYMLOC(2)).NE.0) YLOC=SYMLOC(2)*MTOE
  270 CONTINUE
      LF=LO
      YL2=YL
*IF -DEF,AELIB5
      IF(.N.METRIC)
     1CALL PLOT(4,TEMP,TEMP,TEMP(2),TEMP(3),TEMP(4),TEMP(5),TEMP,TEMP)
*ENDIF
*IF DEF,AELIB5
      IF(.NOT.METRIC)
     1  CALL PLOT(4,TEMP,TEMP,TEMP(2),TEMP(3),TEMP(4),TEMP(5),TEMP,TEMP)
*ENDIF
      IF(METRIC)
     1CALL PLOTM(4,TEMP,TEMP,TEMP(2),TEMP(3),TEMP(4),TEMP(5),TEMP,TEMP)
      XSC=(TEMP(3)-TEMP(2))/XL
      YSC=(TEMP(5)-TEMP(4))/YL
      GO TO 400
C
C
C
C
C
C     IF JOBOPT IS 2, CHECK THAT SECTION B HAS BEEN EXECUTED PREVIOUSLY,
C     DUMP THE PARAMETERS IF THE USER HAS REQUESTED IT, AND BRANCH TO
C     THE APPROPRIATE PLOGZZ OR PLOT MODE 1 CALL WHICH WAS USED THE LAST
C     TIME SECTION B WAS EXECUTED.
C
  300 IF(LO.NE.-1) GO TO 200
      CALL LOGPR20(NERR4)
C
C
C
C
C
C SECTION C: CURVE SECTION.
C
C
C     CHECK THAT SECTION B HAS BEEN EXECUTED PREVIOUSLY, TELL PLOT WHICH
C     COORDINATES TO TAKE THE LOGARITHMS OF, IF ANY, AND PLOT THE DATA.
C
  400 IF (LO .EQ. -1) CALL LOGPR20(NERR4)
      CALL PLTFLG(LF)
*IF -DEF,AELIB5
      IF(.N.METRIC) CALL PLOT(2,PEN,SYMB,X,Y,N)
*ENDIF
*IF DEF,AELIB5
      IF(.NOT.METRIC) CALL PLOT(2,PEN,SYMB,X,Y,N)
*ENDIF
      IF (METRIC) CALL PLOTM(2,PEN,SYMB,X,Y,N)
C
C
C     CHECK IF THE SYMBOL JUST PLOTTED HAS BEEN GIVEN A MEANING.
C
      NSYMB=RSYMB=SYMB
      IF(SHIFT(ISYMB,-48).EQ.0) NSYMB=ISYMB
C
      DO 420 I=1,10
         NSYMBT=RSYMB=SYMCOD(I)
         IF(SHIFT(ISYMB,-48).EQ.0) NSYMBT=ISYMB
         IF(NSYMBT.EQ.-1) GO TO 420
         IF(NSYMBT.EQ.NSYMB) GO TO 430
  420 CONTINUE
C
      RETURN
C
C
C     PLOT THE SYMBOL, FOLLOWED BY ITS MEANING.
C
  430 IF ((NSYMB .LE. 0) .OR. (NSYMB .GT. 24)) NSYMB=1
      OFFACT=0.04
      IF (MOD(NSYMB,2) .EQ. 0) GO TO 435
      NSYMB=NSYMB+1
      OFFACT=0.02
  435 XLOC2=XLOC+OFFACT*FLOAT(AND(SHIFT(OFFSET,NSYMB),3))
      YLOC2=YLOC+OFFACT*FLOAT(AND(SHIFT(OFFSET,-NSYMB),3))
      XLOC2=XLOC2*XSC+TEMP(2)
      YLOC2=YLOC2*YSC+TEMP(4)
      IF (METRIC) GO TO 440
      CALL PLOT(2,0,SYMB,XLOC2,YLOC2,1)
      CALL PLOT(13,FSYMTXT(1,I),1,0,XLOC+0.2,YLOC)
      GO TO 450
  440 CALL PLOTM(2,0,SYMB,XLOC2,YLOC2,1)
      XLOC2=(XLOC+0.2)*ETOM
      YLOC2=YLOC*ETOM
      CALL PLOTM(13,FSYMTXT(1,I),1,0,XLOC2,YLOC2)
  450 CONTINUE
C
C
C     DETERMINE THE LOCATION FOR THE NEXT SYMBOL MEANING.
C
      YLOC=YLOC-0.2
      IF(XOR(UNDEF,SYMLOC(1)).NE.0) RETURN
      IF(XOR(UNDEF,SYMLOC(2)).NE.0) RETURN
      IF(YLOC.GE.YL2) RETURN
      XLOC=XLOC+2.0
      YLOC=YL2+HEDAREA*5.0/12.0-0.2
      RETURN
      END
      SUBROUTINE LOGPR13(Z,N,ZMIN,ZMAX,ZMINR,ZMAXR)
C
C
C LOGPR13 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT DETERMINES THE MIN AND MAX VALUES TO BE USED AS INITIAL
C QUANTITIES IN BOTH THE LINEAR AND LOGARITHMIC ALGORITHMS FOR CALCULAT-
C ING AXIS LIMITS AND TIC VALUES.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975
C MODIFIED BY J. WENDORF, JUNE,1979.
C   (FIX CHECK FOR MIN EQUALS MAX WITHIN EPS; MODIFY ERROR HANDLING.)
C
C
C
      REAL Z(1)
      EQUIVALENCE (IN,RN)
*IF -DEF,AELIB5
      DATA UNDEF /37775555555555555555B/
*ENDIF
*IF DEF,AELIB5
      DATA UNDEF /O"37775555555555555555"/
*ENDIF
      DATA EPS / 1.0E-8 /
C
C
C     INITIALIZE ERROR NUMBER FOR LOGPR20 ERROR ROUTINE.
C       6 - ***ZERO VALUE FOR NUMBER OF X,Y PAIRS.
C
      NERR=6
C
C
C     FORCE N INTO TYPE INTEGER AND SET IT POSITIVE.
C
      NN=IN=N
      IF(SHIFT(IN,-48).NE.0) NN=RN
      IF(NN.LT.0) NN=-NN
      IF (NN .EQ. 0) CALL LOGPR20(NERR)
C
C
C     SCAN ARRAY Z FOR MINIMUM AND MAXIMUM VALUES.
C
      ZMINR=ZMAXR=Z(1)
      IF(NN.EQ.1) GO TO 15
      DO 10 I=2,NN
         ZMINR=AMIN1(ZMINR,Z(I))
         ZMAXR=AMAX1(ZMAXR,Z(I))
   10 CONTINUE
C
C
C     IF THE MINIMUM OR MAXIMUM WERE DEFINED BY THE USER, RETURN THOSE
C     VALUES.  OTHERWISE, RETURN THE ACTUAL MINIMUM AND MAXIMUM.
C
   15 IF(XOR(UNDEF,ZMIN).NE.0) ZMINR=ZMIN
      IF(XOR(UNDEF,ZMAX).NE.0) ZMAXR=ZMAX
C
C
C     IF THE MINIMUM VALUE EQUALS THE MAXIMUM, ADJUST BOTH OF THEM.
C
      ADJUST=EPS*(ABS(ZMINR)+ABS(ZMAXR))
      IF (ABS(ZMAXR-ZMINR) .GT. ADJUST) GO TO 20
      ZMINR=ZMINR-ADJUST
      ZMAXR=ZMAXR+ADJUST
      IF (ABS(ZMAXR-ZMINR) .GT. ADJUST) GO TO 20
      ZMINR=ZMINR-1.0
      ZMAXR=ZMAXR+1.0
   20 RETURN
      END
      SUBROUTINE LOGPR14(AMIN,AMAX,N,RZMIN,RZMAX,RTICZ,RFZSCAL,NFZSCAL)
C
C
C LOGPR14 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT DETERMINES THE MIN,MAX AND TIC VALUES TO BE USED FOR A
C LINEAR AXIS IN A MODE 1 CALL OF PLOGZZ OR PLOT.  IT ALSO DETERMINES
C THE LINEAR SCALE TIC LABEL PARAMETER VALUES (THE FORMAT AND NUMBER OF
C CHARACTERS) TO BE USED IN THE CORRESPONDING CALL OF AXLGZZ OR AXLIN.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C MODIFIED BY J. WENDORF, JULY,1979.
C    (FIX ALGORITHM FOR AUTOMATIC CALCULATION OF TICK LABEL FORMATS.)
C
C
C
      REAL TAB(3)
      INTEGER TEMP(10)
      COMMON /SCALES/ USERD1(4,2)
      COMMON/LWENG/USERD2(4)
      EQUIVALENCE (RTICW,ITICW), (IABMAX,RABMAX)
*IF -DEF,AELIB5
      DATA TAB /5.0, 2.0, 1.0/, UNDEF/37775555555555555555B/
*ENDIF
*IF DEF,AELIB5
      DATA TAB /5.0, 2.0, 1.0/, UNDEF/O"37775555555555555555"/
*ENDIF
    1 FORMAT(2H(E,I2,1H.,I1,1H))
    2 FORMAT(10A1)
    3 FORMAT(2H(F,I1,1H.,I1,1H))
C
C
C     FIND AN APPROPRIATE TIC VALUE GIVEN THE ACTUAL MINIMUM AND MAXIMUM
C     AMIN AND AMAX, RESPECTIVELY.
C
      TICMAX=((USERD2(N)-10.0)/40.0+1.125)*ABS(AMAX-AMIN)/USERD2(N)
      IORDIF=ALOG10(ABS(AMAX-AMIN))
C
   10 TICL=10.0**IORDIF
C
      DO 20 I=1,3
         IF(TICL*TAB(I).LE.TICMAX) GO TO 30
   20 CONTINUE
C
      IORDIF=IORDIF-1
      GO TO 10
C
   30 RTICZ=TAB(I)*TICL
C
C
C     DETERMINE AN APPROPRIATELY ROUNDED MINIMUM AND MAXIMUM.
C
      J=1
      IF(AMIN.GT.AMAX) J=-1
C
      K=AMIN/RTICZ
*IF -DEF,AELIB5
      IF((AMIN*J.LT.0.0).A.(AMIN.NE.RTICZ*K)) K=K-J
*ENDIF
*IF DEF,AELIB5
      IF((AMIN*J.LT.0.0).AND.(AMIN.NE.RTICZ*K)) K=K-J
*ENDIF
      RZMIN=K*RTICZ
C
      K=AMAX/RTICZ
*IF -DEF,AELIB5
      IF((AMAX*J.GT.0.0).A.(AMAX.NE.RTICZ*K)) K=K+J
*ENDIF
*IF DEF,AELIB5
      IF((AMAX*J.GT.0.0).AND.(AMAX.NE.RTICZ*K)) K=K+J
*ENDIF
      RZMAX=K*RTICZ
C
C
C     IF THE DISTORTION IS NOT TOO GREAT, SET EITHER THE MINIMUM OR THE
C     MAXIMUM TO ZERO.
C
      IF(RZMIN*RZMAX.LE.0.0) GO TO 40
      IF(ABS(RZMAX-RZMIN).GT.10.0*ABS(RZMIN)) RZMIN=0.0
      IF(ABS(RZMAX-RZMIN).GT.10.0*ABS(RZMAX)) RZMAX=0.0
C
C
C     IF THE USER DEFINED MINIMUM, MAXIMUM OR TIC VALUE, RETURN THOSE
C     VALUES.  OTHERWISE, RETURN CALCULATED VALUES.
C
   40 IF(XOR(UNDEF,USERD1(1,N)).NE.0) RZMIN=USERD1(1,N)
      IF(XOR(UNDEF,USERD1(2,N)).NE.0) RZMAX=USERD1(2,N)
      IF(XOR(UNDEF,USERD1(3,N)).NE.0) RTICZ=USERD1(3,N)
C
C
C     IF THE TIC LABEL FORMAT HAD BEEN DEFINED BY USER, DETERMINE THE
C     NUMBER OF CHARACTERS (FOR CENTRING PURPOSES).  RETURN
C     THE USERS FORMAT AND THE NUMBER OF CHARACTERS.
C
      RTIC=RTICW=RTICZ
      IF(SHIFT(ITICW,-48).EQ.0) RTIC=ITICW
      IF(RTIC .GT.0.0) GO TO 50
   45 NFZSCAL=0
      RETURN
C
   50 ABMAX=AMAX1(ABS(RZMAX),ABS(RZMIN))
      IF(ABMAX.EQ.0.0) GO TO 45
      IF(XOR(UNDEF,USERD1(4,N)).EQ.0) GO TO 100
C
      IABMAX=ABMAX
      DECODE(10,2,USERD1(4,N)) TEMP
      DO 60 I=1,10
         IF(TEMP(I).EQ.1HI) GO TO 70
   60 CONTINUE
C
      RABMAX=ABMAX
C
   70 CALL LOGPR16(1,30,USERD1(4,N),TEMP,NB,NFZSCAL,1,RABMAX)
      RFZSCAL=USERD1(4,N)
      IF(N.EQ.1) NFZSCAL=NFZSCAL+NB
      RETURN
C
C
C     IF THE TIC LABEL FORMAT HAD NOT BEEN DEFINED BY USER, CALCULATE
C     THE FORMAT AND THE NUMBER OF CHARACTERS IT GENERATES.
C
  100 CDMAX=ALOG10(ABMAX)
      IF ((CDMAX .GE. -1E-8) .OR. (AINT(CDMAX)-CDMAX .LE. -CDMAX*1E-8))
     1   CDMAX=CDMAX+1.0
      J=CDMAX
      CDTIC=ALOG10(RTIC)
      IF ((CDTIC .GE. -1E-8) .OR. (AINT(CDTIC)-CDTIC .LE. -CDTIC*1E-8))
     1   CDTIC=CDTIC+1.0
      K=CDTIC
      K=MAX0(J-K+1,1)
      K=MIN0(K,7)
C
      IF ((ABMAX .GE. 100000.0) .OR. (ABMAX .LT. 0.1)) GO TO 110
      I=MAX0(J,K)
      J=I-J
      NFZSCAL=I+2
      ENCODE(10,3,RFZSCAL) NFZSCAL, J
      RETURN
C
  110 NFZSCAL=K+6
      ENCODE(10,1,RFZSCAL) NFZSCAL, K
      RETURN
      END
      SUBROUTINE LOGPR15(AMIN,AMAX,N,RZMIN,RZMAX,LGTIC,LGTICS)
C
C
C LOGPR15 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT DETERMINES THE MIN, MAX AND TIC VALUES TO BE USED FOR A
C LOGARITHMIC AXIS IN A MODE 1 CALL OF PLOGZZ.  IT ALSO DETERMINES THE
C LOGARITHMIC TIC SWITCH TO BE USED IN THE CORRESPONDING CALL OF
C AXLGZZ.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C MODIFIED BY J. WENDORF, JUNE,1979.
C   (MODIFY ERROR HANDLING.)
C
C
C
      REAL TABLOG(11), LGTIC
      COMMON /SCALES/ USERD1(4,2)
      COMMON/LWENG/USERD2(4)
      EQUIVALENCE (RLGTIC,ILGTIC)
*IF -DEF,AELIB5
      DATA UNDEF/37775555555555555555B/
*ENDIF
*IF DEF,AELIB5
      DATA UNDEF/O"37775555555555555555"/
*ENDIF
      DATA TABLOG/0.0,0.0,0.0,0.30103,0.47712,0.60206,0.69897,0.77815,
     $            0.845098,0.90309,0.954243/
C
C
C     INITIALIZE ERROR NUMBER FOR LOGPR20 ERROR ROUTINE.
C        7 - ***ILLEGAL VALUES SPECIFIED FOR LOGARITHMIC SCALE.
C
      NERR=7
C
C
C     FIMD AN APPROPRIATE TIC VALUE GIVEN THE ACTUAL MINIMUM AND MAXIMUM
C     AMIN AND AMAX, RESPECTIVELY.
C
      IF ((AMIN .LE. 0.0) .OR. (AMAX .LE. 0.0)) CALL LOGPR20(NERR)
C
      BMIN=ALOG10(AMIN)
      BMAX=ALOG10(AMAX)
      CL=USERD2(N)/ABS(BMAX-BMIN)
C
      LGTIC=11.0
      IF(CL.GT.0.75) LGTIC=13.0
      IF(CL.GT.1.25) LGTIC=14.0
      IF(CL.GT.2.25) LGTIC=15.0
C
C
C     DETERMINE AN APPROPRIATELY ROUNDED MINIMUM AND MAXIMUM. ROUNDING
C     IS TO THE NEAREST INTEGER POWER OF TEN, IF ACCEPTEBLE, ELSE TO THE
C     NEAREST TIC, IF ACCEPTEBLE, ELSE TO A VALUE WHICH INCREASES THE
C     RANGE OF VALUES BY 1/20.
C
C     INITIALIZE THE ROUTINE.
C
      J=1
      IF(BMIN.LT.BMAX) GO TO 10
      J=-1
      RZMIN=BMIN
      BMIN=BMAX
      BMAX=RZMIN
C
   10 ITICK=LGTIC
      CALL LOGPR12(BMIN,BMAX,ITICK,MIN,MAX,I1,I2,ISTEP)
C
      STOFF=(BMAX-BMIN)/20.0
      OFFMIN=(BMIN-MIN)*CL
      MAX2=MAX
      IF(BMAX.GT.MAX) MAX2=MAX+1
      OFFMAX=(MAX2-BMAX)*CL
C
C     ROUND OUT MINIMUM.
C
      IF(OFFMIN*10.0.GT.USERD2(N)) GO TO 20
      BMIN=10.0**MIN
      GO TO 50
C
   20 DO 30 I=I1,I2,ISTEP
         IF(MIN+TABLOG(I).GT.BMIN) GO TO 40
   30 CONTINUE
C
   40 OFFMIN=OFFMIN-TABLOG(I-ISTEP)*CL
      RZMIN=BMIN-STOFF
      IF(OFFMIN*20.0.LE.USERD2(N)) RZMIN=MIN+TABLOG(I-ISTEP)
      BMIN=10.0**RZMIN
C
C     ROUND OUT MAXIMUM.
C
   50 IF(OFFMAX*10.0.GT.USERD2(N)) GO TO 60
      BMAX=10.0**MAX2
      GO TO 100
C
   60 DO 70 I=I1,I2,ISTEP
         IF(MAX+TABLOG(I).GE.BMAX) GO TO 80
   70 CONTINUE
C
      GO TO 85
   80 OFFMAX=(MAX+TABLOG(I)-BMAX)*CL
   85 RZMAX=BMAX+STOFF
      IF(OFFMAX*20.0.LE.USERD2(N)) RZMAX=MAX+TABLOG(I)
      BMAX=10.0**RZMAX
C
C
C     IF USER DEFINED MINIMUM, MAXIMUM OR TIC VALUE, RETURN THOSE
C     VALUES.  OTHERWISE, RETURN CALCULATED VALUES.
C
  100 IF(J.EQ.-1) GO TO 110
      RZMIN=BMIN
      RZMAX=BMAX
      GO TO 120
C
  110 RZMIN=BMAX
      RZMAX=BMIN
C
  120 IF(XOR(UNDEF,USERD1(1,N)).NE.0) RZMIN=USERD1(1,N)
      IF(XOR(UNDEF,USERD1(2,N)).NE.0) RZMAX=USERD1(2,N)
      IF(XOR(UNDEF,USERD1(3,N)).NE.0) LGTIC=USERD1(3,N)
C
C
C     IF USER DEFINED LOGARITHMIC TIC SWITCH, RETURN THAT VALUE, ELSE
C     SET IT ON, I.E. "0.
C
      RLGTIC=USERD1(4,N)
      LGTICS=1
      IF(XOR(UNDEF,USERD1(4,N)).NE.0) LGTICS=ILGTIC
      RETURN
      END
      SUBROUTINE LOGPR16(N,NC,IFORM,IARAY,NB,NT,NV,VARS)
C
C
C LOGPR16 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT EVALUATES THE OUTPUT OF THE VARIABLE FORMATS.  IT CALCULAT
C THE NUMBER OF LEADING BLANKS AND THE TOTAL NUMBER OF CHARACTERS
C GENERATED BY THE FORMAT, INCLUDING LEADING BLANKS BUT EXCLUDING
C TRAILING ONES.  IT ALSO CONTAINS FACILITIES FOR CONVERTING THE OUTPUT
C GENERATED BY THE FORMAT INTO A HOLLERITH VARIABLE FORMAT.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C
C
C
      INTEGER VARS(NV), IARAY(1), ITEMP(10)
      DATA IBLANK /10H          /
    1 FORMAT(10A1)
    2 FORMAT(5X,1H(,I3,A1)
C
C
C     DO THE APPROPRIATE CORE TO CORE WRITE.
C
*IF -DEF,AELIB5
      IF(NV.EQ.0) ENCODE(NC,IFORM,IARAY(N))
*ENDIF
*IF DEF,AELIB5
      IF(NV.EQ.0) ENCODE(NC,IFORM,IARAY(N))
*ENDIF
*IF -DEF,AELIB5
      IF(NV.NE.0) ENCODE(NC,IFORM,IARAY(N)) VARS
*ENDIF
*IF DEF,AELIB5
      IF(NV.NE.0) ENCODE(NC,IFORM,IARAY(N)) VARS
*ENDIF
C
C
C     CALCULATE THE NUMBER OF LEADING BLANKS.
C
      NW=NC/10
      IF(NW*10.NE.NC) NW=NW+1
      NW=NW+N-1
C
      DO 10 I=N,NW
         IF(IARAY(I).NE.IBLANK) GO TO 20
   10 CONTINUE
C
      NB=NT=0
      RETURN
C
   20 NB=(I-N)*10
      DECODE(10,1,IARAY(I)) ITEMP
      ISAV1=I
C
      DO 30 I=1,10
         IF(ITEMP(I).NE.IBLANK) GO TO 40
   30 CONTINUE
C
   40 NB=NB+I-1
      ISAV2=I
C
C
C     CALCULATE THE TOTAL NUMBER OF CHARACTERS GENERATED BY THE FORMAT,
C     INCLUDING LEADING BLANKS AND EXCLUDING TRAILING ONES.
C
      DO 50 I=N,NW
         J=NW-I+N
         IF(IARAY(J).NE.IBLANK) GO TO 60
   50 CONTINUE
C
   60 NT=(J-N+1)*10
      DECODE(10,1,IARAY(J)) ITEMP
      JSAV=J
C
      DO 70 I=1,10
         J=11-I
         IF(ITEMP(J).NE.IBLANK) GO TO 80
   70 CONTINUE
C
   80 NT=NT-I+1
C
C
C     IF OPTION N EQUALS ONE, RETURN.  ELSE CONVERT THE OUTPUT GENERATED
C     BY THE FORMAT INTO A HOLLERITH VARIABLE FORMAT BEFORE RETURNING.
C
      IF(N.EQ.1) RETURN
C
      IF(J.EQ.10) IARAY(JSAV+1)=10H)
      IF(J.LT.10) ITEMP(J+1)=10H)
      ENCODE(10,1,IARAY(JSAV)) ITEMP
C
      DECODE(10,1,IARAY(ISAV1)) ITEMP
      I=IARAY(1)=IBLANK
      IF(ISAV2.EQ.1) I=10HH
      IF(ISAV2.GT.1) ITEMP(ISAV2-1)=10HH
      ENCODE(10,1,IARAY(ISAV1)) ITEMP
      ENCODE(10,2,IARAY(ISAV1-1)) NT-NB, I
      RETURN
      END
      SUBROUTINE LOGPR17(NAMTAB,STO1,STO2,STO3,STO4,IPTR,NUMNAM)
C
C
C LOGPR17 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT IS THE SECTION A CARD INPUT SCANNER, AND BY ITSELF, IT
C HANDLES THE FREE FORM, NAMELIST TYPE OF INPUT.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C MODIFIED BY J. WENDORF, JUNE,1979
C   (FIX CHECK FOR END PARAMETER; MODIFY ERROR HANDLING.)
C MODIFIED BY J. WENDORF, JULY,1979.
C    (FIX BUG IN HANDLING OF NUMERIC CONSTANTS - THE "SNEAKY STAR"
C     PROBLEM.)
C MODIFIED BY J. WENDORF, AUGUST,1979.
C   (FIX USE OF ENCODE SO THAT IT DOESN"T WRITE INTO THE SAME LOCATION
C    SPECIFIED IN THE IOLIST.)
C
C     STO1         FWA OF /SCALES/
C     STO2         FWA OF /FORMAT/
C     STO3         FWA OF /SYMEAN/
C     STO4         FWA OF /TITLOC/
C
C     IPTR         LIST OF POINTERS TO "NAMTAB" INDICATING THE LOCATION
C                  OF THE LAST ENTRY FOR EACH LABELED COMMON
C
C
C
C
      INTEGER NAMTAB(1), STO1(1), STO2(1), STO3(1), STO4(1), IPTR(1)
*IF DEF,AELIB5
      CHARACTER * 10 IFORM
*ENDIF
      INTEGER CARD(80), TEMP(80), TYPE, DIMENS
      EQUIVALENCE (ISTOR,RSTOR)
    1 FORMAT(80A1)
    2 FORMAT (8X,I2)
    3 FORMAT(7X,I1)
*IF -DEF,AELIB5
    4 FORMAT(2H(I,I2,1H))
*ENDIF
*IF DEF,AELIB5
    4 FORMAT(  2H(I, I2.2, 1H)  )
*ENDIF
*IF -DEF,AELIB5
    5 FORMAT(2H(E,I2,1H))
*ENDIF
*IF DEF,AELIB5
    5 FORMAT(  2H(E, I2, 3H.0) )
*ENDIF
C
C
C     INITIALIZE THE ERROR NUMBERS FOR THE LOGPR20 ERROR ROUTINE.
C        8 - ***INVALID VARIABLE NAME PRECEDING POINTER.
C        9 - ***INVALID SUBSCRIPT PRECEDING POINTER.
C       10 - ***ONE OF (=, WAS EXPECTED AT POINTER.
C       11 - ***INVALID NUMERIC CONSTANT PRECEDING POINTER.
C       12 - ***INVALID REPEAT FACTOR IN CONSTANT PRECEDING POINTER.
C       13 - ***TOO MANY CONSTANTS FOR PRESENT VARIABLE.
C       14 - ***VARIABLE FORMAT CONSTANT PRECEDING POINTER IS TOO LONG.
C
      NERR1=8
      NERR2=9
      NERR3=10
      NERR4=11
      NERR5=12
      NERR6=13
      NERR7=14
C
C
C     ENSURE THAT A NEW CARD IS READ AS THE FIRST DATA CARD.
C
      IC=81
C
C
C     SCAN FOR A VARIABLE NAME.
C
    9 CALL LOGPR18(CARD,IC)
*IF -DEF,AELIB5
   10 CALL LOGPR19(CARD,IC,TEMP(2),-7,2H=(,3,IFOUND)
*ENDIF
*IF DEF,AELIB5
   10 CALL LOGPR19(CARD,IC,TEMP(2),-7,'=(',3,IFOUND)
*ENDIF
      IF(IFOUND.LE.0) GO TO 30
C
      II = IFOUND+1
      ENCODE(IFOUND,1,TEMP) (TEMP(I),I=2,II)
      IF(TEMP(1).EQ.3HEND) RETURN
      TEMP(1)=SHIFT(TEMP(1),-18)
C
C
C     SEARCH NAME TABLE FOR NAME THAT WAS FOUND.  DETERMINE CORRESPON-
C     DING STORAGE ADDRESS AND EXTRACT THE TYPE AND DIMENSIONS OF THE
C     VARIABLE FROM THE TABLE.
C
      NBLK = IS = 1
C
C.....NBLK    INDICATES CURRENT LABELED COMMON BEING REFERENCED
C.....IS      STORAGE ADDRESS RELATIVE TO FWA OF CURRENT LABELED COMMON
C
      DO 20 I=1,NUMNAM
C     ....DETERMINE WHICH BLOCK IS BEING REFERENCED
          IF (I .LE. IPTR(NBLK)) GOTO 15
C         ....NEW BLOCK, INCREMENT BLOCK COUNTER
C                        RE-INITIALIZE RELATIVE STORAGE ADDRESS
              NBLK = NBLK + 1
              IS = 1
15        CONTINUE
         DECODE(10,2,NAMTAB(I)) DIMENS
         IF(SHIFT(NAMTAB(I),-18).EQ.TEMP(1)) GO TO 40
         IS=IS+DIMENS
         IF(DIMENS.EQ.0) IS=IS+1
   20 CONTINUE
C
   30 CALL LOGPR20(CARD,IC,NERR1)
C
   40 DECODE(8,3,NAMTAB(I)) TYPE
      IF(TYPE.EQ.4) GO TO 400
C
C
C     EXTRACT SUBSCRIPT, IF APPLICABLE, AND ADJUST STORAGE ADDRESS.
C
      CALL LOGPR18(CARD,IC)
      IF(DIMENS.EQ.0) GO TO 70
C
      ISUB=1
      IF(CARD(IC).NE.1H() GO TO 70
      IC=IC+1
      CALL LOGPR18(CARD,IC)
*IF -DEF,AELIB5
      CALL LOGPR19(CARD,IC,TEMP,20,3H),=,4,IFOUND)
*ENDIF
*IF DEF,AELIB5
      CALL LOGPR19(CARD,IC,TEMP,20,'),=',4,IFOUND)
*ENDIF
      IF(IFOUND.LE.0) GO TO 50
      IF(CARD(IC).EQ.1H )CALL LOGPR18(CARD,IC)
      IF(CARD(IC).NE.1H)) GO TO 50
      ENCODE(IFOUND,1,TEMP(30)) (TEMP(I),I=1,IFOUND)
*IF -DEF,AELIB5
      ENCODE(10,4,IFORM) IFOUND
*ENDIF
*IF DEF,AELIB5
      WRITE(IFORM, 4)  IFOUND
*ENDIF
*IF -DEF,AELIB5
      DECODE(IFOUND,IFORM,TEMP(30)) ISUB
*ENDIF
*IF DEF,AELIB5
      DECODE(IFOUND,IFORM,TEMP(30)) ISUB
*ENDIF
*IF -DEF,AELIB5
      IF((ISUB.GE.0).A.(ISUB.LE.DIMENS)) GO TO 60
*ENDIF
*IF DEF,AELIB5
      IF((ISUB.GE.0).AND.(ISUB.LE.DIMENS)) GO TO 60
*ENDIF
C
   50 CALL LOGPR20(CARD,IC,NERR2)
C
   60 IS=IS+ISUB-1
      IC=IC+1
      CALL LOGPR18(CARD,IC)
C
C
   70 IF(CARD(IC).NE.1H=) GO TO 410
      IC=IC+1
      CALL LOGPR18(CARD,IC)
C
C
C     PROCESS CONSTANT(S).
C
*IF -DEF,AELIB5
   75 CALL LOGPR19(CARD,IC,TEMP,25,2H, ,2,IFOUND)
*ENDIF
*IF DEF,AELIB5
   75 CALL LOGPR19(CARD,IC,TEMP,25,', ',2,IFOUND)
*ENDIF
      IF(IFOUND.LE.0) GO TO 90
      IF(CARD(IC).EQ.1H ) CALL LOGPR18(CARD,IC)
      IF(CARD(IC).NE.1H,) GO TO 410
C
      MULFAC=I1=I=1
      TEMP(IFOUND+1)=1H
*IF -DEF,AELIB5
      CALL LOGPR19(TEMP,I1,TEMP(30),IFOUND,1H*,1,I2)
*ENDIF
*IF DEF,AELIB5
      CALL LOGPR19(TEMP,I1,TEMP(30),IFOUND,'*',1,I2)
*ENDIF
      IF(I2) 100,90,80
   80 ENCODE(I2,1,TEMP(30)) (TEMP(I),I=1,I2)
*IF -DEF,AELIB5
      ENCODE(10,4,IFORM) I2
*ENDIF
*IF DEF,AELIB5
      WRITE(IFORM, 4)  I2
*ENDIF
*IF -DEF,AELIB5
      DECODE(I2,IFORM,TEMP(30)) MULFAC
*ENDIF
*IF DEF,AELIB5
      DECODE(I2,IFORM,TEMP(30)) MULFAC
*ENDIF
      IF(MULFAC.LE.0) CALL LOGPR20(CARD,IC,NERR5)
      IFOUND=IFOUND-I2-1
      I=I1+1
      IF(IFOUND.GT.0) GO TO 100
C
   90 CALL LOGPR20(CARD,IC,NERR4)
C
C
  100 TEMP(80)=I
*IF -DEF,AELIB5
      CALL LOGPR19(TEMP,TEMP(80),TEMP(30),IFOUND,2H.E,2,TEMP(79))
*ENDIF
*IF DEF,AELIB5
      CALL LOGPR19(TEMP,TEMP(80),TEMP(30),IFOUND,'.E',2,TEMP(79))
*ENDIF
      I2=I+IFOUND-1
      ENCODE(IFOUND,1,TEMP(30)) (TEMP(I1),I1=I,I2)
*IF -DEF,AELIB5
      ENCODE(10,5,IFORM) IFOUND
*ENDIF
*IF DEF,AELIB5
      WRITE(IFORM, 5)  IFOUND
*ENDIF
*IF -DEF,AELIB5
      IF((TYPE.NE.2).A.(TEMP(79).EQ.-1))ENCODE(10,4,IFORM) IFOUND
*ENDIF
*IF DEF,AELIB5
*IF -DEF,AELIB5
      IF((TYPE.NE.2).AND.(TEMP(79).EQ.-1))ENCODE(10,4,IFORM) IFOUND
*ENDIF
*IF DEF,AELIB5
      IF  ((TYPE.NE.2) .AND. (TEMP(79).EQ.-1))  WRITE(IFORM, 4)  IFOUND
*ENDIF
*ENDIF
*IF -DEF,AELIB5
      IF (NBLK .EQ. 1) DECODE(IFOUND,IFORM,TEMP(30)) STO1(IS)
*ENDIF
*IF DEF,AELIB5
      IF (NBLK .EQ. 1) DECODE(IFOUND,IFORM,TEMP(30)) STO1(IS)
*ENDIF
*IF -DEF,AELIB5
      IF (NBLK .EQ. 2) DECODE(IFOUND,IFORM,TEMP(30)) STO2(IS)
*ENDIF
*IF DEF,AELIB5
      IF (NBLK .EQ. 2) DECODE(IFOUND,IFORM,TEMP(30)) STO2(IS)
*ENDIF
*IF -DEF,AELIB5
      IF (NBLK .EQ. 3) DECODE(IFOUND,IFORM,TEMP(30)) STO3(IS)
*ENDIF
*IF DEF,AELIB5
      IF (NBLK .EQ. 3) DECODE(IFOUND,IFORM,TEMP(30)) STO3(IS)
*ENDIF
*IF -DEF,AELIB5
      IF (NBLK .EQ. 4) DECODE(IFOUND,IFORM,TEMP(30)) STO4(IS)
*ENDIF
*IF DEF,AELIB5
      IF (NBLK .EQ. 4) DECODE(IFOUND,IFORM,TEMP(30)) STO4(IS)
*ENDIF
*IF -DEF,AELIB5
      IF((TYPE.NE.1).O.(TEMP(79).EQ.-1))GO TO 110
*ENDIF
*IF DEF,AELIB5
      IF((TYPE.NE.1).OR.(TEMP(79).EQ.-1))GO TO 110
*ENDIF
      IF (NBLK .NE.1) GOTO 102
         ISTOR = STO1(IS)
         STO1(IS) = RSTOR
         GOTO 110
102   IF (NBLK .NE. 2) GOTO 103
         ISTOR = STO2(IS)
         STO2(IS) = RSTOR
         GOTO 110
103   IF (NBLK .NE. 3) GOTO 104
         ISTOR = STO3(IS)
         STO3(IS) = RSTOR
         GOTO 110
104   IF (NBLK .NE. 4) GOTO 110
         ISTOR = STO4(IS)
         STO4(IS) = RSTOR
C
C
  110 MULFAC=MULFAC-1
      IF(MULFAC.LE.0) GO TO 120
      ISUB=ISUB+1
      IF(ISUB.GT.DIMENS) GO TO 130
      IS=IS+1
      IF (NBLK .EQ. 1) STO1(IS) = STO1(IS-1)
      IF (NBLK .EQ. 2) STO2(IS) = STO2(IS-1)
      IF (NBLK .EQ. 3) STO3(IS) = STO3(IS-1)
      IF (NBLK .EQ. 4) STO4(IS) = STO4(IS-1)
      GO TO 110
C
C
  120 IC=IC+1
      CALL LOGPR18(CARD,IC)
      IF(CARD(IC).LE.1HZ) GO TO 10
      ISUB=ISUB+1
      IS=IS+1
      IF(ISUB.LE.DIMENS) GO TO 75
C
  130 CALL LOGPR20(CARD,IC,NERR6)
C
C
C     HANDLE VARIABLE FORMAT INPUT.
C
  400 IF(CARD(IC).EQ.1H ) CALL LOGPR18(CARD,IC)
      IF(CARD(IC).NE.1H=) GO TO 410
      IC=IC+1
      CALL LOGPR18(CARD,IC)
      IF(CARD(IC).EQ.1H() GO TO 420
C
  410 CALL LOGPR20(CARD,IC,NERR3)
C
  420 IF(DIMENS.EQ.0) DIMENS=1
      ILEFT=1
      IRIGHT=0
      LEN=10*DIMENS-1
      IT=1
  430 TEMP(IT)=CARD(IC)
      IF(ILEFT.EQ.IRIGHT) GO TO 450
      IT=IT+1
      IC=IC+1
      IF(LEN.LE.0) GO TO 440
*IF -DEF,AELIB5
      CALL LOGPR19(CARD,IC,TEMP(IT),LEN,2H(),2,IFOUND)
*ENDIF
*IF DEF,AELIB5
      CALL LOGPR19(CARD,IC,TEMP(IT),LEN,'()',2,IFOUND)
*ENDIF
      IF(IFOUND.EQ.-1) GO TO 440
      IT=IT+IFOUND
      IF(CARD(IC).EQ.1H() ILEFT=ILEFT+1
      IF(CARD(IC).EQ.1H)) IRIGHT=IRIGHT+1
      LEN=LEN-IFOUND-1
      GO TO 430
C
  440 CALL LOGPR20(CARD,IC,NERR7)
C
450   CONTINUE
      IF (NBLK .EQ. 1) ENCODE(IT,1,STO1(IS)) (TEMP(I),I=1,IT)
      IF (NBLK .EQ. 2) ENCODE(IT,1,STO2(IS)) (TEMP(I),I=1,IT)
      IF (NBLK .EQ. 3) ENCODE(IT,1,STO3(IS)) (TEMP(I),I=1,IT)
      IF (NBLK .EQ. 4) ENCODE(IT,1,STO4(IS)) (TEMP(I),I=1,IT)
      IC=IC+1
      CALL LOGPR18(CARD,IC)
      IF(CARD(IC).NE.1H,) GO TO 410
      IC=IC+1
      GO TO 9
C
      END
      SUBROUTINE LOGPR18(CARD,IC)
C
C
C LOGPR18 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT IS USED BY THE INPUT SCANNER, LOGPR17, TO SKIP OVER
C STRINGS OF BLANKS.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C MODIFIED BY J.WENDORF, SEPT.1978 , TO CHECK IC.GT.80
C MODIFIED BY J. WENDORF, JUNE,1979.
C   (CHECK FOR  END OF FILE ENCOUNTERED UNEXPECTEDLY.)
C
C
C
      INTEGER CARD(80)
*IF -DEF,AELIB5
    1 FORMAT(80A1)
*ENDIF
*IF DEF,AELIB5
    1 FORMAT(BZ,80A1)
*ENDIF
C
C     INITIALIZE THE ERROR NUMBER FOR THE LOGPR20 ERROR ROUTINE.
C       15 - ***END OF FILE ENCOUNTERED UNEXPECTEDLY ON INPUT.
C
      NERR1=15
C
C
      IF(IC.GT.80) GO TO 15
    5 DO 10 I=IC,80
         IF(CARD(I).NE.1H ) GO TO 20
   10 CONTINUE
C
   15 CARD(1)=3HEOF
*IF -DEF,AELIB5
      READ 1, CARD
*ENDIF
*IF DEF,AELIB5
      READ (*,1, END=10000)CARD
*ENDIF
*IF -DEF,AELIB5
      IF (CARD(1) .EQ. 3HEOF) CALL LOGPR20(NERR1)
*ENDIF
*IF DEF,AELIB5
10000 IF (CARD(1) .EQ. 3HEOF) CALL LOGPR20(NERR1)
*ENDIF
      IC=1
      GO TO 5
C
   20 IC=I
      RETURN
      END
      SUBROUTINE LOGPR19(CARD,IC,TEMP,LEN,ICHARS,N,IFOUND)
C
C
C LOGPR19 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT IS USED BY THE INPUT SCANNER, LOGPR17, TO SCAN FOR
C PARTICULAR CHARACTERS AND TO STORE ANY INTERMEDIATE CHARACTERS IT
C ENCOUNTERS WHILE SCANNING.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C MODIFIED BY J.WENDORF, SEPT.1978, TO CHECK FOR IC.GT.80
C MODIFIED BY J. WENDORF, JUNE,1979.
C   (CHECK FOR END OF FILE ENCOUNTERED UNEXPECTEDLY; CHECK FOR END
C    PARAMETER, WHEN REQUESTED.)
C
C
C
      INTEGER CARD(80), TEMP(80), ICHAR(5)
*IF -DEF,AELIB5
    1 FORMAT(80A1)
*ENDIF
*IF DEF,AELIB5
    1 FORMAT(BZ,80A1)
*ENDIF
C
C     INITIALIZE THE ERROR NUMBER FOR THE LOGPR20 ERROR ROUTINE.
C       15 - ***END OF FILE ENCOUNTERED UNEXPECTEDLY ON INPUT.
C
      NERR1=15
C
C
      IFOUND=-1
      DECODE(N,1,ICHARS) (ICHAR(I),I=1,N)
      IT=0
C
      IF(IC.GT.80) GO TO 25
    5 DO 20 I=IC,80
C
         DO 10 J=1,N
           IF(ICHAR(J).EQ.CARD(I)) GO TO 30
   10    CONTINUE
C
         IT=IT+1
         IF (IT .GT. IABS(LEN)) GO TO 40
         TEMP(IT)=CARD(I)
*IF -DEF,AELIB5
         IF ((LEN .GE. 0) .O. (IT .NE. 3)) GO TO 20
*ENDIF
*IF DEF,AELIB5
         IF ((LEN .GE. 0) .OR.(IT .NE. 3)) GO TO 20
*ENDIF
            IF ((TEMP(1) .EQ. 1HE) .AND. (TEMP(2) .EQ. 1HN) .AND.
     $          (TEMP(3) .EQ. 1HD)) GO TO 30
   20 CONTINUE
C
C
   25 CARD(1)=3HEOF
*IF -DEF,AELIB5
      READ 1, CARD
*ENDIF
*IF DEF,AELIB5
      READ (*,1, END=10000)CARD
*ENDIF
*IF -DEF,AELIB5
      IF (CARD(1) .EQ. 3HEOF) CALL LOGPR20(NERR1)
*ENDIF
*IF DEF,AELIB5
10000 IF (CARD(1) .EQ. 3HEOF) CALL LOGPR20(NERR1)
*ENDIF
      IC=1
      GO TO 5
C
C
   30 IFOUND=IT
   40 IC=I
      RETURN
      END
      SUBROUTINE LOGPR20(CARD,IC,NERR)
C
C
C LOGPR20 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT IS USED TO HANDLE THE PROCESSING OF ERROR MESSAGES.
C IF REQUESTED, IT WILL PRINT OUT THE PRESENT DATA CARD AND
C A POINTER INDICATING THE COLUMN TO WHICH THE SCANNER HAD ADVANCED.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C MODIFIED BY J. WENDORF, JUNE,1979.
C   (HANDLE ALL SIMPLT ERRORS USING NEW AELIB SCHEME.)
C
C
C
      INTEGER CARD(80)
      DATA NUMS/10H1234567890/
    1 FORMAT(1H ,80A1)
    2 FORMAT(1H0/1H0)
    3 FORMAT(10A1)
C
C
      PRINT 2
      NUMERR=CARD(1)
      IF (LOCF(IC) .EQ. 0) GO TO 30
      NUMERR=NERR
      PRINT 1, CARD
      DECODE (10, 3, NUMS) (CARD(I), I=1,10)
C
      DO 10 I=11,80
         CARD(I)=CARD(I-10)
   10 CONTINUE
C
      N=IC/10
      IF(N*10.EQ.IC) N=N-1
      I1=N*10
C
      DO 20 I=1,10
         CARD(I1+I)=10H.
   20 CONTINUE
C
      CARD(IC)=10H'
      PRINT 1, CARD
C
   30 IF (NUMERR .EQ. 1) PRINT 101
*IF -DEF,AELIB5
  101 FORMAT(" ***JOBOPT NOT 0,1,2,3, OR 4")
*ENDIF
*IF DEF,AELIB5
  101 FORMAT(' ***JOBOPT NOT 0,1,2,3, OR 4')
*ENDIF
      IF (NUMERR .EQ. 2) PRINT 102
*IF -DEF,AELIB5
  102 FORMAT(" ***LOGOPT NOT 0,1,2, OR 3")
*ENDIF
*IF DEF,AELIB5
  102 FORMAT(' ***LOGOPT NOT 0,1,2, OR 3')
*ENDIF
      IF (NUMERR .EQ. 3) PRINT 103
*IF -DEF,AELIB5
  103 FORMAT(" ***X AXIS DECLARED LT 0.005 OR GT 160 INCHES")
*ENDIF
*IF DEF,AELIB5
  103 FORMAT(' ***X AXIS DECLARED LT 0.005 OR GT 160 INCHES')
*ENDIF
      IF (NUMERR .EQ. 4) PRINT 104
*IF -DEF,AELIB5
  104 FORMAT(" ***Y AXIS DECLARED LT 0.005 OR GT 28.175 INCHES")
*ENDIF
*IF DEF,AELIB5
  104 FORMAT(' ***Y AXIS DECLARED LT 0.005 OR GT 28.175 INCHES')
*ENDIF
      IF (NUMERR .EQ. 5) PRINT 105
*IF -DEF,AELIB5
  105 FORMAT(" ***JOBOPT 2 OR 3 CALL NOT PRECEDED BY JOBOPT 0 OR 1 CALL"
     $      )
*ENDIF
*IF DEF,AELIB5
  105 FORMAT(' ***JOBOPT 2 OR 3 CALL NOT PRECEDED BY JOBOPT 0 OR 1 CALL'
     $      )
*ENDIF
      IF (NUMERR .EQ. 6) PRINT 106
*IF -DEF,AELIB5
  106 FORMAT(" ***ZERO VALUE FOR NUMBER OF X,Y PAIRS")
*ENDIF
*IF DEF,AELIB5
  106 FORMAT(' ***ZERO VALUE FOR NUMBER OF X,Y PAIRS')
*ENDIF
      IF (NUMERR .EQ. 7) PRINT 107
*IF -DEF,AELIB5
  107 FORMAT(" ***ILLEGAL VALUES SPECIFIED FOR LOGARITHMIC SCALE")
*ENDIF
*IF DEF,AELIB5
  107 FORMAT(' ***ILLEGAL VALUES SPECIFIED FOR LOGARITHMIC SCALE')
*ENDIF
      IF (NUMERR .EQ. 8) PRINT 108
*IF -DEF,AELIB5
  108 FORMAT(" ***INVALID VARIABLE NAME PRECEDING POINTER")
*ENDIF
*IF DEF,AELIB5
  108 FORMAT(' ***INVALID VARIABLE NAME PRECEDING POINTER')
*ENDIF
      IF (NUMERR .EQ. 9) PRINT 109
*IF -DEF,AELIB5
  109 FORMAT(" ***INVALID SUBSCRIPT PRECEDING POINTER")
*ENDIF
*IF DEF,AELIB5
  109 FORMAT(' ***INVALID SUBSCRIPT PRECEDING POINTER')
*ENDIF
      IF (NUMERR .EQ. 10) PRINT 110
*IF -DEF,AELIB5
  110 FORMAT(" ***ONE OF (=, WAS EXPECTED AT POINTER")
*ENDIF
*IF DEF,AELIB5
  110 FORMAT(' ***ONE OF (=, WAS EXPECTED AT POINTER')
*ENDIF
      IF (NUMERR .EQ. 11) PRINT 111
*IF -DEF,AELIB5
  111 FORMAT(" ***INVALID NUMERIC CONSTANT PRECEDING POINTER")
*ENDIF
*IF DEF,AELIB5
  111 FORMAT(' ***INVALID NUMERIC CONSTANT PRECEDING POINTER')
*ENDIF
      IF (NUMERR .EQ. 12) PRINT 112
*IF -DEF,AELIB5
  112 FORMAT(" ***INVALID REPEAT FACTOR IN CONSTANT PRECEDING POINTER")
*ENDIF
*IF DEF,AELIB5
  112 FORMAT(' ***INVALID REPEAT FACTOR IN CONSTANT PRECEDING POINTER')
*ENDIF
      IF (NUMERR .EQ. 13) PRINT 113
*IF -DEF,AELIB5
  113 FORMAT(" ***TOO MANY CONSTANTS FOR PRESENT VARIABLE")
*ENDIF
*IF DEF,AELIB5
  113 FORMAT(' ***TOO MANY CONSTANTS FOR PRESENT VARIABLE')
*ENDIF
      IF (NUMERR .EQ. 14) PRINT 114
*IF -DEF,AELIB5
  114 FORMAT(" ***VARIABLE FORMAT CONSTANT PRECEDING POINTER IS TOO",
     $       " LONG")
*ENDIF
*IF DEF,AELIB5
  114 FORMAT(' ***VARIABLE FORMAT CONSTANT PRECEDING POINTER IS TOO',
     $       ' LONG')
*ENDIF
      IF (NUMERR .EQ. 15) PRINT 115
*IF -DEF,AELIB5
  115 FORMAT(" ***END OF FILE ENCOUNTERED UNEXPECTEDLY ON INPUT")
*ENDIF
*IF DEF,AELIB5
  115 FORMAT(' ***END OF FILE ENCOUNTERED UNEXPECTEDLY ON INPUT')
*ENDIF
      CALL TRACEB(1)
      END
      SUBROUTINE LOGPR21(NAMTAB,STORAGE,NUMNAM,BLOCK)
C
C
C LOGPR21 IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM,
C SIMPLT.  IT DUMPS ALL OF THE PARAMETERS USED BY SECTION B OF SIMPLT TO
C DRAW THE FRAME AND PLOT THE VARIOUS LABELS AND TITLES.  THE DUMP SHOWS
C BOTH THE OCTAL AND ACTUAL (NUMERIC OR ALPHANUMERIC) CONTENTS.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C
C
C
      INTEGER STORAGE(1), NAMTAB(1), TYPE, DIMENS, UNDEF1, UNDEF2
*IF -DEF,AELIB5
      DATA UNDEF1/77777777777777774000B/, UNDEF2/3777B/
*ENDIF
*IF DEF,AELIB5
      DATA UNDEF1/O"77777777777777774000"/, UNDEF2/O"3777"/
*ENDIF
*IF -DEF,AELIB5
    1 FORMAT(1H1 10X "DUMP OF SIMPLT PARAMETERS FROM  "A10/
     ,       " NAME" 8X "CONTENTS")
*ENDIF
*IF DEF,AELIB5
    1 FORMAT(1H1 ,10X ,'DUMP OF SIMPLT PARAMETERS FROM  ',A10/
     ,          ' NAME' ,8X ,'CONTENTS')
*ENDIF
    2 FORMAT(A7,I1,I2)
*IF -DEF,AELIB5
    3 FORMAT(1H ,A7,5X,O20,"  VALUE TO BE CALCULATED")
*ENDIF
*IF DEF,AELIB5
    3 FORMAT(1H ,A7,5X,O20,'  VALUE TO BE CALCULATED')
*ENDIF
    4 FORMAT(1H ,A7,5X,O20,2X,A10)
*IF -DEF,AELIB5
    5 FORMAT(1H ,A7,5X,O20,"  UNDEFINED VALUE")
*ENDIF
*IF DEF,AELIB5
    5 FORMAT(1H ,A7,5X,O20,'  UNDEFINED VALUE')
*ENDIF
    6 FORMAT(1H ,A7,5X,O20,I15.12)
    7 FORMAT(1H ,A7,5X,O20,G20.12)
*IF -DEF,AELIB5
    8 FORMAT(1H0 10X "***END OF DUMP OF  "A10"***")
*ENDIF
*IF DEF,AELIB5
    8 FORMAT(1H0 ,10X ,'***END OF DUMP OF  ',A10,'***')
*ENDIF
C
C
      PRINT 1, BLOCK
      IS=1
C
      DO 100 I=1,NUMNAM
         DECODE(10,2,NAMTAB(I)) NAME,TYPE,DIMENS
         PRINT 7
         IF(DIMENS.EQ.0) DIMENS=1
         IS2=IS+DIMENS-1
C
         DO 90 J=IS,IS2
           IF(STORAGE(J).NE.2H4;) GO TO 10
           PRINT 3, NAME,STORAGE(J)
           GO TO 80
C
   10      IF(TYPE.NE.4) GO TO 20
           PRINT 4, NAME,STORAGE(J),STORAGE(J)
           GO TO 80
C
   20      ISH=SHIFT(STORAGE(J),-48)
*IF -DEF,AELIB5
           IF((ISH.NE.UNDEF1).A.(ISH.NE.UNDEF2)) GO TO 30
*ENDIF
*IF DEF,AELIB5
           IF((ISH.NE.UNDEF1).AND.(ISH.NE.UNDEF2)) GO TO 30
*ENDIF
           PRINT 5, NAME,STORAGE(J)
           GO TO 80
C
   30      IF(TYPE.NE.3) GO TO 40
           IF(SHIFT(STORAGE(J),-48).EQ.0) GO TO 50
           GO TO 60
   40      IF(TYPE.NE.1) GO TO 60
   50      PRINT 6, NAME,STORAGE(J),STORAGE(J)
           GO TO 80
C
   60      PRINT 7, NAME,STORAGE(J),STORAGE(J)
C
   80      NAME=10H
C
   90    CONTINUE
C
         IS=IS+DIMENS
  100 CONTINUE
C
      PRINT 8, BLOCK
      RETURN
      END
      SUBROUTINE DUMPON(RETSW)
C
C
C DUMPON IS ONE OF THE MODULES OF THE AUTOMATIC PLOTTING SYSTEM, SIMPLT.
C THROUGH IT THE USER CAN TURN THE PARAMETER DUMP ON AND OFF.
C
C
C
C WRITTEN BY J. WENDORF, JULY,1975.
C
C
C
      LOGICAL DUMPSW,RETSW
      DATA DUMPSW/.FALSE./
C
*CALL STATF
C
C     ENTRY POINT DUMPON TURNS THE PARAMETER DUMP ON.
C
      DUMPSW=.TRUE.
      RETURN
C
C
C     ENTRY POINT DUMPOFF TURNS THE PARAMETER DUMP OFF.
C
*IF -DEF,AELIB5
      ENTRY DUMPOFF
*ENDIF
*IF DEF,AELIB5
      ENTRY DUMPOFF(RETSW)
*ENDIF
      DUMPSW=.FALSE.
      RETURN
C
C
C     ENTRY POINT DUMPRET IS USED BY SIMPLT TO RETRIEVE THE VALUE OF THE
C     DUMP SWITCH.
C
*IF -DEF,AELIB5
      ENTRY DUMPRET
*ENDIF
*IF DEF,AELIB5
      ENTRY DUMPRET(RETSW)
*ENDIF
      RETSW=DUMPSW
      RETURN
      END
