*DECK SMLOGX
       SUBROUTINE SMLOGX (XL,YL,YMIN,YMAX,TIC,EXL,NC,FORMX,NTX,FORMY,
     1 NTY,FORMSL,NCSL)
C
C THE SUBROUTINE HAS TWO ENTRY POINTS:
C    SMLOGX  - ALL DIMENSIONAL QUANTITIES PASSED IN THE ARGUMENT LIST
C ARE IN INCHES
C    SMLOGXM - ALL DIMENSIONAL QUANTITIES ARE IN MILLIMETERS
C DIMENSIONAL QUANTITIES ARE PASSED IN THE ARGUMENT LIST AND ON THE
C METRIC ENTRY, SMLOGXM,  THEY ARE CONVERTED TO ENGLISH UNITS, THE
C INTERNAL WORKING UNITS OF THE ROUTINE.  CALLS TO PLOT ARE MADE BY
C SMLOGX AND SMLOGXM MAKES CORRESPONDING CALLS TO PLOTM.  DIMENSIONAL
C QUANTITIES ARE CONVERTED BACK TO MILLIMETERS BEFORE A PLOTM MODE 1
C CALL TO PLOT THE FRAME IS MADE BY SMLOGXM.
C
       DIMENSION ALOGX(3),XX(2),YY(3)
C
      REAL MTOE
      LOGICAL METRIC
       DATA TITLE1/4H(I3)/,TITLE2/6H(2H10)/,TITLE3/4H(I1)/
       DATA ALOGX/0,0.30103,0.69897/
*CALL STATF
C
      METRIC=.FALSE.
      XLE=XL
      YLE=YL
      GO TO 10
C
C     ENTRY SMLOGXM ALLOWS USE OF METRIC DIMENSIONS
C
*IF -DEF,AELIB5
      ENTRY SMLOGXM
*ENDIF
*IF DEF,AELIB5
      ENTRY SMLOGXM(XL,YL,YMIN,YMAX,TIC,EXL,NC,FORMX,NTX,FORMY,    NTY,F
     +ORMSL,NCSL)
*ENDIF
C
*CALL  STATF
C
      METRIC=.TRUE.
      ETOM=25.4
      MTOE=1./ETOM
C
C     CONVERT METRIC DIMENSIONS TO ENGLISH
C
      XLE=XL*MTOE
      YLE=YL*MTOE
C
   10 LEX=EXL
       ISEX=SEX=LEX - IABS(NC)
      CLN=(EXL-SEX)/XLE
      YMM=(YMAX-YMIN)/YLE
       NTIC=0
       IF (TIC.NE.0.0) NTIC=(YMAX - YMIN)/TIC
       NTIC=IABS(NTIC) + 1
C
       TICXX=0.0
       IF (NC.LT.0) TICXX=1.0
      IF (METRIC) GO TO 20
      CALL PLOT(1,XLE,YLE,SEX,EXL,YMIN,YMAX,TICXX,TIC)
      GO TO 40
C
C     CONVERT ENGLISH DIMENSIONS TO METRIC BEFORE PLOTTING THE FRAME
C
   20 XLM=XLE*ETOM
      YLM=YLE*ETOM
      CALL PLOTM(1,XLM,YLM,SEX,EXL,YMIN,YMAX,TICXX,TIC)
   40 IF (NC.LT.0) GO TO 110
       YY(1)=YMIN
       YY(2)=YMAX
      DO 100 I=ISEX,LEX
       JJ=1
       IF (I.EQ.ISEX) JJ=2
      DO 100 J=JJ,3
       XX(1)=XX(2)=I + ALOGX(J)
      IF (XX(1).GE.EXL) GO TO 110
      IF (METRIC) GO TO 50
      CALL PLOT(2,1,0,XX,YY,2)
      GO TO 70
   50 CALL PLOTM(2,1,0,XX,YY,2)
   70 YY(3)=YY(1)
       YY(1)=YY(2)
       YY(2)=YY(3)
  100 CONTINUE
C
  110 IF (NTX.EQ.0) GO TO 115
       XLOC=0.5*(EXL + SEX) - 0.08*CLN*NTX
      IF(XLOC.LT.SEX) XLOC=SEX
       YLOC=YMIN - 0.46*YMM
      IF (METRIC) GO TO 113
      CALL PLOT(3,FORMX,2,0,XLOC,YLOC)
      GO TO 115
  113 CALL PLOTM(3,FORMX,2,0,XLOC,YLOC)
  115 JJ=ISEX+LEX
       DO 140 I=ISEX,LEX
       J=JJ - I
      DO 125 K=2,3
       XLOC=J + ALOGX(5 - K)
      IF (XLOC.GE.EXL) GO TO 125
       YLOC=YMIN - 0.14*YMM
       L=-3*K + 11
      IF (METRIC) GO TO 118
      CALL PLOT(3,TITLE3,1,0,XLOC,YLOC,L,1)
      GO TO 120
  118 CALL PLOTM(3,TITLE3,1,0,XLOC,YLOC,L,1)
  120 IF (NC.GE.0) GO TO 125
       XX(1)=XX(2)=XLOC
       YY(1)=YMIN
       YY(2)=YMIN + 0.13*YMM
      IF (METRIC) GO TO 124
      CALL PLOT(2,1,0,XX,YY,2)
      GO TO 125
  124 CALL PLOTM(2,1,0,XX,YY,2)
  125 CONTINUE
       XLOC=J
       YLOC=YMIN - 0.145*YMM
      IF (METRIC) GO TO 129
      CALL PLOT(3,TITLE1,1,0,XLOC,YLOC,J,1)
      GO TO 130
  129 CALL PLOTM(3,TITLE1,1,0,XLOC,YLOC,J,1)
  130 XLOC=J-0.3*CLN
       YLOC=YMIN - 0.23*YMM
      IF (METRIC) GO TO 135
      CALL PLOT(3,TITLE2,2,0,XLOC,YLOC)
      GO TO 140
  135 CALL PLOTM(3,TITLE2,2,0,XLOC,YLOC)
  140  CONTINUE
C   YTITLE
       IF (NTY.EQ.0) GO TO 150
      XLOC=SEX-0.65*CLN
       YLOC=0.5*(YMAX+YMIN) - 0.08*YMM*NTY
      IF(YLOC.LT.YMIN)YLOC=YMIN
      IF (METRIC) GO TO 145
      CALL PLOT(3,FORMY,2,6,XLOC,YLOC)
      GO TO 150
  145 CALL PLOTM(3,FORMY,2,6,XLOC,YLOC)
  150  IF (NCSL.EQ.0) GO TO 170
       XLOC=SEX - 0.08*CLN*(NCSL + 0.5)
       DO 160 I=1,NTIC
       Y1=YMIN + (I-1)*TIC
      IF (METRIC) GO TO 155
      CALL PLOT(3,FORMSL,1,0,XLOC,Y1,Y1,1)
      GO TO 160
  155 CALL PLOTM(3,FORMSL,1,0,XLOC,Y1,Y1,1)
  160  CONTINUE
  170  IF (NC.LT.0) GO TO 180
       RETURN
C
C   TICKS
  180  DO 190 I=ISEX,LEX
       DO 190 K=2,3
       XLOC=I + ALOGX(K)
       IF (XLOC.GE.EXL) RETURN
       XX(1)=XX(2)=XLOC
       YY(1)=YMAX - 0.13*YMM
       YY(2)=YMAX
      IF (METRIC) GO TO 185
      CALL PLOT(2,1,0,XX,YY,2)
      GO TO 190
  185 CALL PLOTM(2,1,0,XX,YY,2)
  190  CONTINUE
       RETURN
       END
