*DECK SMLOGY
       SUBROUTINE SMLOGY (XL,YL,XMIN,XMAX,TIC,EXL,NC,FORMX,NTX,FORMY,
     1 NTY,FORMSL,NCSL)
C
C THE SUBROUTINE HAS TWO ENTRY POINTS:
C    SMLOGY  - ALL DIMENSIONAL QUANTITIES PASSED IN THE ARGUMENT LIST
C ARE IN INCHES
C    SMLOGYM - ALL DIMENSIONAL QUANTITIES ARE IN MILLIMETERS
C DIMENSIONAL QUANTITIES ARE PASSED IN THE ARGUMENT LIST AND ON THE
C METRIC ENTRY, SMLOGYM, THEY ARE CONVERTED TO ENGLISH UNITS, THE
C INTERNAL WORKING UNITS OF THE ROUTINE.  CALLS TO PLOT ARE MADE BY
C SMLOGY AND SMLOGYM MAKES CORRESPONDING CALLS TO PLOTM.  DIMENSIONAL
C QUANTITIES ARE CONVERTED BACK TO MILLIMETERS BEFORE A PLOTM MODE 1
C CALL TO PLOT THE FRAME IS MADE BY SMLOGYM.
C
       DIMENSION ALOGY(3),XX(3),YY(2)
C
      REAL MTOE
      LOGICAL METRIC
       DATA TITLE1/4H(I3)/,TITLE2/6H(2H10)/,TITLE3/4H(I1)/
       DATA ALOGY/0,0.30103,0.69897/
*CALL STATF
C
      METRIC=.FALSE.
      XLE=XL
      YLE=YL
      GO TO 10
C
C
C     ENTRY SMLOGYM ALLOWS USE OF METRIC DIMENSIONS
C
*IF -DEF,AELIB5
      ENTRY SMLOGYM
*ENDIF
*IF DEF,AELIB5
      ENTRY SMLOGYM(XL,YL,XMIN,XMAX,TIC,EXL,NC,FORMX,NTX,FORMY,    NTY,F
     +ORMSL,NCSL)
*ENDIF
C
*CALL  STATF
C
      METRIC=.TRUE.
      ETOM=25.4
      MTOE=1./ETOM
C
C     CONVERT METRIC DIMENSIONS TO ENGLISH
C
      XLE=XL*MTOE
      YLE=YL*MTOE
C
   10 LEX=EXL
       ISEX=SEX=LEX - IABS(NC)
      CLN=(EXL-SEX)/YLE
      XMM=(XMAX-XMIN)/XLE
       NTIC=0
       IF (TIC.NE.0.0) NTIC=(XMAX - XMIN)/TIC
       NTIC=IABS(NTIC) + 1
C
       TICYY=0.0
       IF (NC.LT.0) TICYY=1.0
      IF (METRIC) GO TO 20
      CALL PLOT(1,XLE,YLE,XMIN,XMAX,SEX,EXL,TIC,TICYY)
      GO TO 30
C
C     CONVERT ENGLISH DIMENSIONS TO METRIC BEFORE PLOTTING THE FRAME
C
   20 XLM=XLE*ETOM
      YLM=YLE*ETOM
      CALL PLOTM(1,XLM,YLM,XMIN,XMAX,SEX,EXL,TIC,TICYY)
   30 IF (NC.LT.0) GO TO 110
       IF (NC.LT.0) GO TO 120
       XX(1)=XMIN
       XX(2)=XMAX
      DO 100 I=ISEX,LEX
         JJ=1
         IF (I.EQ.ISEX) JJ=2
         DO 100 J=JJ,3
            YY(1)=YY(2)=I+ALOGY(J)
            IF (YY(1).GE.EXL) GO TO 110
            IF (METRIC) GO TO 40
            CALL PLOT(2,1,0,XX,YY,2)
            GO TO 50
   40       CALL PLOTM(2,1,0,XX,YY,2)
   50       XX(3)=XX(1)
            XX(1)=XX(2)
            XX(2)=XX(3)
  100 CONTINUE
C   YTITLE
  110 IF (NTY.EQ.0) GO TO 130
       XLOC=XMIN - 0.65*XMM
       YLOC=0.5*(EXL + SEX) - 0.08*CLN*NTY
      IF(YLOC.LT.SEX) YLOC=SEX
      IF (METRIC) GO TO 120
       CALL PLOT (3,FORMY,2,6,XLOC,YLOC)
      GO TO 130
  120 CALL PLOTM(3,FORMY,2,6,XLOC,YLOC)
C
  130  JJ=ISEX + LEX
      DO 300 I=ISEX,LEX
         J=JJ-I
         DO 200 K=2,3
            YLOC=J+ALOGY(5-K)
            IF (YLOC.GT.EXL) GO TO 200
            XLOC=XMIN-0.1*XMM
            L=-3*K+11
            IF (METRIC) GO TO 140
            CALL PLOT(3,TITLE3,1,0,XLOC,YLOC,L,1)
            GO TO 150
  140       CALL PLOTM(3,TITLE3,1,0,XLOC,YLOC,L,1)
  150       IF (NC.GE.0)GO TO 200
            XX(1)=XMIN
            XX(2)=XMIN+0.13*XMM
            YY(1)=YY(2)=YLOC
            IF (METRIC) GO TO 190
            CALL PLOT(2,1,0,XX,YY,2)
            GO TO 200
  190       CALL PLOTM(2,1,0,XX,YY,2)
  200    CONTINUE
         XLOC=XMIN-0.6*XMM
         YLOC=J-0.08*CLN
         IF (METRIC) GO TO 240
         CALL PLOT(3,TITLE2,2,0,XLOC,YLOC)
         GO TO 250
  240    CALL PLOTM(3,TITLE2,2,0,XLOC,YLOC)
  250    XLOC=XMIN-0.3*XMM
         YLOC=J+0.045*CLN
         IF (METRIC) GO TO 290
         CALL PLOT(3,TITLE1,1,0,XLOC,YLOC,J,1)
         GO TO 300
  290    CALL PLOTM(3,TITLE1,1,0,XLOC,YLOC,J,1)
  300 CONTINUE
C   XTITLE
      IF (NTX.EQ.0) GO TO 360
       XLOC=0.5*(XMAX+XMIN) - 0.08*XMM*NTX
      IF(XLOC.LT.XMIN)XLOC=XMIN
       YLOC=SEX - 0.5*CLN
      IF (METRIC) GO TO 350
      CALL PLOT(3,FORMX,2,0,XLOC,YLOC)
      GO TO 360
  350 CALL PLOTM(3,FORMX,2,0,XLOC,YLOC)
  360 IF (NCSL.EQ.0) GO TO 410
       X2=0.04*NCSL*XMM
       YLOC=SEX - 0.2*CLN
      DO 400 I=1,NTIC
         X1=XMIN+(I-1)*TIC
         XLOC=X1-X2
         IF (METRIC) GO TO 390
         CALL PLOT(3,FORMSL,1,0,XLOC,YLOC,X1,1)
         GO TO 400
  390    CALL PLOTM(3,FORMSL,1,0,XLOC,YLOC,X1,1)
  400 CONTINUE
  410 IF (NC.LT.0) GO TO 420
       RETURN
C
C   TICKS
  420 DO 500 I=ISEX,LEX
         DO 500 K=2,3
            YLOC=I+ALOGY(K)
            IF (YLOC.GE.EXL) RETURN
            XX(1)=XMAX-0.13*XMM
            XX(2)=XMAX
            YY(1)=YY(2)=YLOC
            IF (METRIC) GO TO 450
            CALL PLOT(2,1,0,XX,YY,2)
            GO TO 500
  450       CALL PLOTM(2,1,0,XX,YY,2)
  500 CONTINUE
       RETURN
       END
