*DECK SPACE
      SUBROUTINE SPACE(XP,YP,ZP,NX,NY,NRZP,PHIY,PHIZ,VUFACT,WIDTH)
C
C       SPACE - A 3-D PERSPECTIVE PLOT ROUTINE WRITTEN BY
C        E. MYLES REACTOR PHYSICS BRANCH
C   PARAMETERS
C             XP   - ARRAY OF X COORDINATES
C            YP    - ARRAY OR Y COORDINATES
C             ZP   - ARRAY OF VALUES Z(X(I),Y(J))  FOR POINT I,J
C             NX   - NUMBER OF POINTS IN XP ARRAY
C             NY   - NUMBER OF POINTS IN YP ARRAY
C             NRZP - NUMBER OF COLUMNS IN ZP - AS DIMENSIONED
C             PHIY - ANGLE OF ROTATION AROUND Y AXIS
C                            MUST BE BETWEEN 0. AND 90.
C             PHIZ - ANGLE OF ROTATION AROUND Z AXIS
C                            MUST BE BETWEEN 0. AND 90.
C             VUFACT  - VIEWING FACTOR
C             WIDTH   - PLOT PAPER WIDTH , IF NEGATIVE DRAW 3-D FRAM
C
C  ****    IDENT  REMT   - G. SUTHERLAND
C  ****       REMOVE TX AND TY ARRAYS.
C
C
C   *****    UPDATE  REMR  - G. SUTHERLAND
C        REMOVE ARRAY R AND REFERENCES TO SHIFTB
C             ARRAY R STORED IN UPPER HALF (48-25) OF ARRAY G
C             VARIABLE IM USED TO STORE II+1
C
C    ****    UPDATE ADDW - G. SUTHERLAND
C         UPDATE TO PROVIDE ALTERNATE CARDS FOR WIDE PLOTTER
C       TO USE WIDE PLOTTER VERSION ADD  A *DEFINE WIDEP CARD
C           TO UPDATE INPUT STREAM
C
C
C     *****   UPDATE FIX01  - G. SUTHERLAND
C         FIX ERROR IN CARD REMR.52
C              INCORRECT DEFINITION OF AN ELEMENT OF G ARRAY
C
C    *****    UPDATE FIX02 - G. SUTHERLAND
C          ADD CHECK OF PARAMETER NY, AND CHECKS TO CATCH SX, SY, FIN
C               OVERFLOWS. PLACE DIMENSIONING OF X,Y,SX,SY, AND VALUE
C               SETTING FOR MAXY, MAXK IN PLOTTER DEPENDENT PART
C              OF UPDATE LISTING.
C
C    ****   UPDATE INTER  G. SUTHERLAND
C         UPDATE TO CORRECT PHIY, PHIZ. THEY WERE INTERCHANGED IN
C            ORIGINAL PROGRAM.
C     ****    UPDATE VPT       -G.K.S.
C        UPDATE TO CORRECT POSITIONING OF XO COORDINATE OF VIEWPOINT
C     *****      UPDATE PHICKS        BY -G.K.S.
C            UPDATE TO
C         1 - CHECK FOR XCTE EQ XMIN LINE HIDDEN AND IF SO CHANGE
C               YO COORDINATE OF VIEWPOINT TO MAKE IT VISABLE.
C                **** THIS IS AN INHERENT PROBLEM WITH THIS FIXED
C                       QUADRANT ALGORITHM  THE ALGORITHM ASSUMES THAT
C                    THE XMAX, YMIN POINT IS ALWAYS CLOSEST TO THE
C                     VIEWPOINT AND THAT THE XMAZ CTE AND YMIN CTE
C                       LINES ARE ALWAYS VISABLE
C         2 - SECTION TO DRAW FRAM WAS MOVED, PLACING IT IMMEDIATELY
C                   AFTER MODE 1 CALL TO PLOT. - A DEBUG AID
C     *****    UPDATE REMCTE              -G.K.S.
C        UPDATE TO REPLACE INITIAL BOUNDS ON LOWER VISIBLITY (USED TO BE
C               1750B IE - 10 INCHES)  WITH 7777B. -(ALOWS WIDE PLOTS)
C           - REMOVE VISABILITY CHECK FOR LAST POINT. (LAST .01 INCH
C              STEP).  PROBLEMS OCCURRED IF SLOPE OF XCTE LINE WAS
C               VERY LARGE AND MORE THAN 1 PLOT POINT EXISTED IN A
C               .01 INCH SEGMENT IN THE XPRIME DIRECTION.  AFTER THIS
C                FIX A LINE OF UP TO .01 INCHES MAY BE DRAWN INTO THE
C               INVISIBLE AREA.    - THIS CONFLICT OCCURS BECAUSE
C              PROGRAM KEEPS TRACK OF Y CORDINATES OF VISIBLE AREA
C               AT EACH X VALUE
C              AND THUS HAS TROUBLE WITH XCTE LINES WITH LARGE SLOPES
C   INTRODUCE VARIABLE IEND TO POINT TO LAST ELEMENT OF G WHICH IS
C          DEFINED.
C       BEFORE THIS PROGRAM WOULD UPDATE G ARRAY FOR A SINGLE LINE ONLY
C               IF IT WAS DRAWING THE FIRST YCTE DASH.  NOW IT DOES IT
C          EVERY TIME IT GOES ABOVE THE IEND POINTER.
C    *****    UPDATE REMSUB
C                UPDATE TO REMOVE SUBROUTINE DNUOB AND PLACE IN IN LINE
C         AND PERFORM VARIOUS OPTIMIZATIONS SUGGESTED BY JOHN S.
C    ****    UPDATE XMAXMIN          - GKS
C          UPDATE TO HAVE SPACE CALCULATE ZMAX, ZMIN INTERNALLY AND TO
C           REMOVE  ZDIRMAX, AND ZDIRMIN FROM PARAMETER LIST
C     *****     UPDATE YPLUS      - G.K.S.
C      UPDATE TO REMOVE POSSIBILITY OF YPRIME BEING ZERO. IF YPRIME
C          IS ZERO FOR ANY POINT ON THE FIRST XCTE LINE (I=1) THEN
C          LOWER BOUND WILL NOT BE SET PROPERLY.
C    *****   UPDATE INVLN - L EVANS
C            UPDATE TO FIX UP CASE OF A WHOLE X CONSTANT LINE
C            BEING INVIVIBLE
C
      DIMENSION XP(NX),YP(NY),ZP(NRZP,NY)
C
C THE SUBROUTINE HAS TWO ENTRY POINTS:
C    A) SPACE  - ALL DIMENSIONAL QUANTITIES PASSED IN ARGUMENT LIST
C ARE IN INCHES
C    B) SPACEM - ALL DIMENSIONAL QUANTITIES ARE IN MILLIMETERS
C DIMENSIONAL QUANTITIES ARE PASSED IN THE ARGUMENT LIST AND ON
C THE METRIC ENTRY, SPACEM, THEY ARE CONVERTED TO ENGLISH UNITS.  CALLS
C TO PLOT ARE MADE BY SPACE, AND SPACEM MAKES CORRESPONDING CALLS TO
C PLOTM.  DIMENSIONAL QUANTITIES ARE CONVERTED BACK TO MILLIMETERS
C BEFORE A PLOTM MODE 1 CALL IS MADE BY SPACEM.
C
      DIMENSION FIN(100),Q(6)
      DIMENSION XLIM(2), YLIM(2), ZLIM(2)
      DIMENSION S(16),T(16),U(16),V(16),W(16)
      LOGICAL METRIC
      REAL MTOE
      INTEGER X,Y,FIN,G,CC,STX,STY,XOLD,YOLD,Q
      INTEGER PREVIS,VIS,PRELAST,STOP
      EQUIVALENCE (XLIM(1),XMAX),(XLIM(2),XMIN),(YLIM(1),YMAX),(YLIM(2),
     1YMIN),(ZLIM(1),ZMAX),(ZLIM(2),ZMIN)
*IF -DEF,AELIB5
      EQUIVALENCE (S,SX), (T,SX(17)), (U,SX(33)), (V,SX(49)),
     , (W,SX(65))
*ENDIF
*IF DEF,AELIB5
      EQUIVALENCE (S(1),SX(1)), (T(1),SX(17)), (U(1),SX(33)), (V(1),SX(4
     ,9)),            (W(1),SX(65))
*ENDIF
C     *****   DIMENSION OF ARRAYS G,X,Y,SX, SY AND VALUES OF
C           VARIABLES XS, YS, MAXY, AND MAXK
*IF -DEF,WIDEP
C   SET FOR SMALL PLOTTERS
C
      DIMENSION G(2002)
      DIMENSION X(64),Y(64),SX(224),SY(224)
      DATA XS,YS/20.,10./
      DATA MAXY,MAXK/ 64, 224 /
*ENDIF
*IF DEF,WIDEP
C   SET FOR LARGE PLOTTER
      DIMENSION X(100), Y(100), SX(350), SY(350)
      DIMENSION G(6002)
      DATA XS,YS/60.,28./
      DATA MAXY,MAXK/ 100, 350 /
*ENDIF
*
* INITIALIZE
*
*IF -DEF,AELIB5
      DATA Q/7777B,77770000B,777700000000B,7777000000000000B,
     ,  77777777B,7777777700000000B/
*ENDIF
*IF DEF,AELIB5
      DATA Q/O"7777",O"77770000",O"777700000000",O"7777000000000000",
     ,        O"77777777",O"7777777700000000"/
*ENDIF
C   ****    MAXCC IS SIZE OF FIN ARRAY AND MAX VALUE OF VARIABLE CC
      DATA MAXCC/ 100/
C
C
C    ****    STATEMENT FUNCTION DEFINITIONS
C
C  **  LOAD BITS 48-25 FROM I AND BITS 24-1 FROM J)
C
*IF -DEF,AELIB5
      LOAD(I,J)=(I.AND.Q(6)).OR.(J.AND.Q(5))
*ENDIF
*IF DEF,AELIB5
      LOAD(I,J)=(I.AND.Q(6)).OR.(J.AND.Q(5))
*ENDIF
C
C  **  REMOVE LOWER BOUND TO DATE FROM G
C
*IF -DEF,AELIB5
      IOL(M)=G(M).AND.Q(1)
*ENDIF
*IF DEF,AELIB5
      IOL(M)=G(M).AND.Q(1)
*ENDIF
C
C  **  REMOVE UPPER BOUND TO DATE FROM G
C
*IF -DEF,AELIB5
      IOU(M)=SHIFT((G(M).AND.Q(3)),-24)
*ENDIF
*IF DEF,AELIB5
      IOU(M)=SHIFT((G(M).AND.Q(3)),-24)
*ENDIF
*CALL  STATF
C
      ENWIDTH=WIDTH
      METRIC=.FALSE.
      GO TO 8
C
C     ALTERNATE ENTRY ALLOWS METRIC UNITS TO BE USED AS DIMENSIONS
C
*IF -DEF,AELIB5
      ENTRY SPACEM
*ENDIF
*IF DEF,AELIB5
      ENTRY SPACEM(XP,YP,ZP,NX,NY,NRZP,PHIY,PHIZ,VUFACT,WIDTH)
*ENDIF
*CALL STATF
C
      METRIC=.TRUE.
      ETOM=25.4
      MTOE=1./ETOM
C
C     CONVERT METRIC DIMENSIONS TO ENGLISH
C
      ENWIDTH=WIDTH*MTOE
    8 CONTINUE
C     *****   SET ZMAX,ZMIN
      ZMAX=ZMIN=ZP(1,1)
      DO 10 I=1,NX
      DO 10 J=1,NY
      IF(ZP(I,J).GT.ZMAX)ZMAX=ZP(I,J)
      IF(ZP(I,J).LT.ZMIN)ZMIN=ZP(I,J)
 10   CONTINUE
C
C     *****     CHECK THAT NY IS LESS THAN MAXY
      IF(NY.LE.MAXY)GO TO 90
      IER=3
      GO TO 9999
 90   CONTINUE
      ROTZ=PHIZ* .0174532925
      ROTY=PHIY* .0174532925
      FIN(1)=0
      XMIN=XP(1)
      XMAX=XP(NX)
      YMIN=YP(1)
      YMAX=YP(NY)
      YSIZE=ABS(ENWIDTH)
      IF (YSIZE.GT.0.0.AND.YSIZE.LE.YS) GO TO 13849
*
* TEST PLOT WIDTH (PLOT-Y DIRECTION)
*
      IF(YSIZE.GT.0.0.AND.YSIZE.LE.YS) GO TO 13849
      IER=4
      GO TO 9999
*
* TEST USER DEFINED LIMITS
*
13849 IF(XMAX.LE.XMIN.OR.YMAX.LE.YMIN.OR.ZMAX.LE.ZMIN) GO TO 1857
*
* CHECK LEGALITY OF ROTATION ANGLES
*
      IF(PHIZ.LT.0.0.OR.PHIZ.GT.90.0.OR.ABS(PHIY).GT.90.0) GO TO 2183
*
*
* CALCULATE ELEMENTS OF PROJECTION MATRIX..
* (EXCLUDE ELEMENT (2,3) WHICH IS ZERO.
*
      SA = SIN(ROTY)
      CA = COS(ROTY)
      ST = SIN(ROTZ)
      CT = COS(ROTZ)
      T1=-CA*CT
      T2=ST*CA
      T3=SA
      T4=ST
      T5=CT
      T6=SA*CT
      T7=-SA*ST
      T8=CA
*
* COMPUTE PARALLEL PROJECTED MAXIMA AND MINIMA (USER UNITS)
*     NEEDED FOR DETERMINING VIEWING POINT (XO,YO,ZO)
*
      L=1
      DO 80 I=1,2
      DO 80 J=1,2
      DO 80 K=1,2
      X1=XLIM(I)*T1+YLIM(J)*T2+ZLIM(K)*T3
      Y1=XLIM(I)*T4+YLIM(J)*T5
      Z1=XLIM(I)*T6+YLIM(J)*T7+ZLIM(K)*T8
      IF(L.GT.1) GO TO 81
      L=2
      XPROMIN=XPROMAX=X1
      YPROMIN=YPROMAX=Y1
      ZPROMIN=ZPROMAX=Z1
      GO TO 80
   81 IF(X1.GT.XPROMAX) XPROMAX=X1
      IF(X1.LT.XPROMIN) XPROMIN=X1
      IF(Y1.GT.YPROMAX) YPROMAX=Y1
      IF(Y1.LT.YPROMIN) YPROMIN=Y1
      IF(Z1.GT.ZPROMAX) ZPROMAX=Z1
      IF(Z1.LT.ZPROMIN) ZPROMIN=Z1
   80 CONTINUE
*
* IF VIEWING FACTOR IS LESS THAN 1, TAKE APPROPRIATE ACTION
*
      VIEW=VUFACT
      IF(VIEW.GE.1.0) GOTO 3129
      IER=7
      PRINT 8888,IER
      VIEW=1.0
*
* COMPUTE VIEWING POINT (XO,YO,ZO)
*
 3129 YO=YPROMIN+(YPROMAX-YPROMIN)/2.0
      ZO=ZPROMIN+(ZPROMAX-ZPROMIN)/2.0
      XO=XPROMAX + (XPROMAX-XPROMIN)*VIEW
*
* CALCULATE PERSPECTIVE PROJECTION MAXIMA AND MINIMA (USER-UNITS)
* REQUIRED FOR COMPUTING SCALING FACTORS.
*
 104  CONTINUE
      L=1
      DO 105 I=1,2
      DO 105 J=1,2
      DO 105 K=1,2
      X1=XLIM(I)*T1+YLIM(J)*T2+ZLIM(K)*T3
      Y1=XLIM(I)*T4+YLIM(J)*T5
      Z1=XLIM(I)*T6+YLIM(J)*T7+ZLIM(K)*T8
      FACT=XO/(XO-X1)
      XPRO=FACT*(Y1-YO)+YO
      YPRO=FACT*(Z1-ZO)+ZO
      IF(L.GT.1) GO TO 106
      L=2
      XPMIN=XPMAX=XPRO
      YPMIN=YPMAX=YPRO
      GO TO 105
  106 IF(XPRO.GT.XPMAX) XPMAX=XPRO
C  ****   WHEN MIN VALUE IN DIR. OF PAPER MOTION FOUND , SAVE Y POINTER
      IF(XPRO.GE.XPMIN) GO TO 107
      XPMIN=XPRO
      IM=J
 107  CONTINUE
      IF(YPRO.GT.YPMAX) YPMAX=YPRO
      IF(YPRO.LT.YPMIN) YPMIN=YPRO
  105 CONTINUE
      IF(IM.EQ.2)GO TO 108
C
C    ****    PHIY TOO GREAT FOR THIS VIEW POINT
C          MOVE VIEW POINT TOLOOK AT EDGE OF X=XMIN PLANE
      YO=YPROMIN-1.E-100
      IER=-2
      PRINT 8888,IER
      GO TO 104
 108  CONTINUE
*
* COMPUTE PERSPECTIVE PROJECTED INTERVALS. (STILL USER-UNITS)
*
      DXPU=XPMAX-XPMIN
      DYPU=YPMAX-YPMIN
*
* COMPUTE SIZE OF PLOT IN X-DIRECTION (TENTATIVE)
*
      XSIZE=YSIZE*DXPU/DYPU
      IF(XSIZE.LE.XS) GO TO 1000
C
C   ***   IF WE REACH THIS POINT, XSIZE EXCEEDS THE PRESET LIMIT
C   ***   .....   ACTION - REDUCE XSIZE TO XS AND REDUEC YSIZE
C            BY THE SAME PROPORTION.
      YSIZE=(XS/XSIZE)*YSIZE
      XSIZE=XS
*
* ROUND UP PLOT SIZES TO THE NEAREST .01 INCH AND DEFINE PLOT INTERVALS.
*
 1000 XL=XSIZE*100.0
      LX=XL+.499
      LXP2=LX+2
      FLX=LX
      XXL=FLX*.01
      YL=YSIZE*100.
      LY=YL+.499
      FLY=LY
      YYL=FLY*.01
*
* DEFINE PLOTTING AREA AFTER FINAL CHECK ON SIZES.
*
      IF(XXL.GT.0.0.AND.XXL.LE.XS.AND.YYL.GT.0.0.AND.YYL.LE.YS)
     1                 GO TO 1856
      IER=10
      GO TO 9999
 1857 IER=1
      GO TO 9999
 2183 IER=2
 9999 PRINT 8888,IER
*IF -DEF,AELIB5
 8888 FORMAT(1X*SPACE PARAMETER ERROR NUMBER*I3)
*ENDIF
*IF DEF,AELIB5
 8888 FORMAT(1X,'SPACE PARAMETER ERROR NUMBER',I3)
*ENDIF
      RETURN
 1856 IF (METRIC) GO TO 1860
      CALL PLOT(1,XXL,YYL,0.,FLX,0.,FLY,-1,-1)
      GO TO 1880
C
C     CONVERT ENGLISH DIMENSIONS TO METRIC BEFORE MAKING A PLOTM
C     MODE 1 CALL TO PLOT THE FRAME.
C
 1860 XLM=XXL*ETOM
      YLM=YYL*ETOM
      CALL PLOTM(1,XLM,YLM,0.,FLX,0.,FLY,-1,-1)
*
* COMPUTE SCALING FACTORS.
*
 1880 SCALX=FLX/DXPU
      SCALY=FLY/DYPU
*
* SCAN LINES OF CONSTANT XP, BEGINNING AT XP(1).THE SCAN OF EACH LINE IS
* FROM RIGHT TO LEFT, IE FROM YP(NY) TO YP(1). THE COORDINATES OF THE
* PROJECTIONS OF THE POINTS Z(I,J),J=1,NY ARE SAVED IN X,Y - THEY ARE
* NEEDED DURING THE NEXT SCAN TO DRAW THE COORDINATES YP=CONSTANT.
* THE CC SEGMENTS OF THE XP=CONSTANT CURVE ARE STORED IN SX,SY - THE END
* POINT OF THE SEGMENT CC IS HELD IN FIN(CC+1).
C
C   ****    G HAS ONE ENTRY FOR EACH POSSIBLE PLOTTER PT. ON THE
C          X AXIS (100 POINTS PER INCH)
C
C        USE OF G ARRAY AND Q MASKS
C    BITS      OLD POS          MASK
C    1-12     G(BITS1-12)    Q(1)    LOWEST PT. PLOTTED TO DATE
C   13-24     G(BITS 13-24)  Q(2)    LOWEST PT. PLOTTED THIS SCAN
C   25-36     R(BITS 1-12)   Q(3)   HIGHEST PT. PLOTTED TO DATE
C   37-18     R(BITS 13-24)  Q(4)   HIGHEST PT. PLOTTED THIS SCAN
C   1 -24     G              Q(5)    OLD G ARRAY
C   25-48     R              Q(6)    OLD R ARRAY
      YOMXPM=YO-XPMIN
      ZOMYPM=ZO-YPMIN
C  *****  PLOT VIEW FRAME
      IF(ENWIDTH.GT.0.0) GOTO 7300
      CALL PRESET(S,16,XMIN)
      S(1)=S(2)=S(3)=S(4)=S(11)=S(12)=S(15)=S(16)=XMAX
      CALL PRESET(T,16,YMIN)
      T(2)=T(3)=T(4)=T(5)=T(6)=T(7)=T(14)=T(15)=YMAX
      CALL PRESET(U,16,ZMIN)
      U(1)=U(2)=U(4)=U(5)=U(7)=U(8)=U(10)=U(11)=ZMAX
      DO 7000 I=1,16
      X1=S(I)*T1+T(I)*T2+U(I)*T3
      Y1=S(I)*T4+T(I)*T5
      Z1=S(I)*T6+T(I)*T7+U(I)*T8
      FACT=XO/(XO-X1)
      V(I)=(FACT*(Y1-YO)+YOMXPM)*SCALX+0.5
 7000 W(I) = (FACT*(Z1-ZO) + ZOMYPM)*SCALY + 1.0
      IF (METRIC) GO TO 7100
      CALL PLOT(2,1,0,V,W,16)
      GO TO 7300
 7100 CALL PLOTM(2,1,0,V,W,16)
 7300 CONTINUE
      PREVIS=VIS=1
      PRELAST=LAST=1
      ICC=Q(5)
      CALL PRESET(G,LXP2,ICC)
      DO 100 I=1,NX
      VIS=PREVIS
      LAST=PRELAST
      IF(I.NE.2)   GO TO 4000
      DO 4001 L=1,LXP2
      J=G(L).AND.Q(6)
      IF(J.NE.0)G(L)=J.OR.(SHIFT(J,-24).OR.Q(2))
 4001 CONTINUE
 4000 K=0
      CC=0
      J=NY
      XT1=XP(I)*T1
      XT4=XP(I)*T4
      XT6=XP(I)*T6
   20 XOLD=X(J)
      YOLD=Y(J)
      X1=XT1+YP(J)*T2+ZP(I,J)*T3
      Y1=XT4+YP(J)*T5
      Z1=XT6+YP(J)*T7+ZP(I,J)*T8
      FACT=XO/(XO-X1)
      X(J)=(FACT*(Y1-YO)+YOMXPM)*SCALX+0.5
      Y(J) = (FACT*(Z1-ZO) + ZOMYPM)*SCALY + 1.0
*
      IF(J.NE.NY)   GO TO 3000
      IF(I.NE.1)   GO TO 4002
      K=K+1
      SX(K)=X(J)
      SY(K)=Y(J)
C     **** SET INITIAL POINTER TO END OF G ARRAY
      IEND=X(J)+1
      GO TO 31
 4002 ISW=3
      IC=XOLD
      ID=YOLD
C     *****   CHECK FOR VISIBILITY OF STARTING POINT Y(NY) OF LAST LINE
      I1=IOL(IC+1)
      I2=IOU(IC+1)
      IF(ID.GT.I1.AND.ID.LT.I2)VIS=0
      IE=X(J)
      IF=Y(J)
      IF(VIS.EQ.1)   GO TO 14002
      GO TO 3010
14002 K=K+1
      SX(K)=IC
      SY(K)=ID
      GO TO 3010
 3001 IF(I.EQ.1)   GO TO 31
      IC=X(J)
      ID=Y(J)
      IE=XOLD
      IF=YOLD
      ISW=2
      GO TO 3010
 3111 PREVIS=VIS
      PRELAST=LAST
   31 J=J-1
      IF(J.GT.0)   GO TO 20
      I1=1
      I2=LXP2
      NRET=0
C      *****    CODE TO UPDATE VISIBILITY BOUNDS FROM I1 TO I2
C                USING THE MAX (OR MIN) OF TO DATE AND LINE TO DATE V
C               VALUES
 9    DO 7 M=I1,I2
      LR=SHIFT((G(M).AND.Q(4)),-36)
      LG=SHIFT((G(M).AND.Q(2)),-12)
      LLR=SHIFT((G(M).AND.Q(3)),-24)
      LLG=       G(M).AND.Q(1)
      IF(LR-LLR)3,4,4
   3  LR=LLR
   4  IF(LG-LLG)6,6,5
   5  LG=LLG
 6     G(M)=(SHIFT(LR,24).OR.LG).OR.Q(2)
 7    CONTINUE
      IF(NRET.GE.1) GO TO 14006
      IF(VIS.NE.1)   GO TO 13111
      CC=CC+1
      FIN(CC+1)=K
13111 CONTINUE
*     NOW DRAW THE SEGMENTS. TO MINIMIZE PLOTTING TIME, DRAW ALTERNATE-
*     LY LEFT TO RIGHT AND RIGHT TO LEFT
*
C     *****     CHECK FOR SX, SY ARRAY OVERFLOW
C
      IF(K.LE.MAXK)GO TO 91
      IER=5
      GO TO 9999
C     *****     CHECK FOR FIN ARRAY OVERFLOW
 91   CONTINUE
      IF(CC.LE.0) GOTO 100
      IF(CC.LT.MAXCC)GO TO 92
      IER=6
      GO TO 9999
 92   CONTINUE
      IF((I.AND.1).EQ.0)GO TO 50
*     LEFT TO RIGHT
      DO 40 J=1,CC
      K1=FIN(J)
      K2=FIN(J+1)
      NK=K2-K1
      IF(NK.LT.2)GO TO 40
      IF (METRIC) GO TO 35
      CALL PLOT(2,1,0,SX(K1+1),SY(K1+1),NK)
      GO TO 40
   35 CALL PLOTM(2,1,0,SX(K1+1),SY(K1+1),NK)
40    CONTINUE
      GO TO 100
*
*     RIGHT TO LEFT
*
50    DO 60 JJ=1,CC
      J=CC-JJ+1
      K1=FIN(J)
      K2=FIN(J+1)
      NK=K2-K1
      IF(NK.LT.2)GO TO 60
      IF (METRIC) GO TO 55
      CALL PLOT(2,1,0,SX(K1+1),SY(K1+1),-NK)
      GO TO 60
   55 CALL PLOTM(2,1,0,SX(K1+1),SY(K1+1),-NK)
60    CONTINUE
*
  100 CONTINUE
*
      RETURN
*
 3000 ISW=1
      IC=X(J+1)
      ID=Y(J+1)
      IE=X(J)
      IF=Y(J)
 3010 YY=IC-IE
      IF(YY)3011,3013,3011
 3011 AM=(ID-IF)/YY
      B=(IC*IF-IE*ID)/YY
 3013 STX=IC
      STY=ID
      IDIR=1
      STOP=0
      IF(IC.GT.IE)   GO TO 3020
      IDIR=-1
 3020 II=STX+IDIR
      IM=II+1
 3021 II=II-IDIR
      IM=II+1
      IF(STOP.EQ.1)   GO TO 4004
      IF(II.NE.IE)   GO TO 4005
      IY=IF
      STOP=1
      GO TO 4006
 4004 IF(VIS.NE.1)   GO TO 3099
      K=K+1
      SX(K)=IE
      SY(K)=IF
      IF(ISW.NE.2)   GO TO 3099
      K=K+1
      SX(K)=STX
      SY(K)=STY
      GO TO 3099
 4005 IY=AM*II+B+0.5
 4006 IF(II.NE.IC)   GO TO 14006
      IF(ISW.NE.1)   GO TO 14006
      IF(IDIR.NE.-1)   GO TO 14006
      I1=IC+1
      I2=IE+1
C     ****    UPDATE BOUNDS ON LINE OVER SECTION JUST EVALUATED
C         WHEN UPDATING FINISHED CONTROL WILL RETURN TO 14006
      NRET=1
      GO TO 9
14006 IF(IY-IOU(IM))4008,4007,4007
 4007 LAST=1
      IF(ISW.NE.2)GO TO 13021
 6000 IF(IC.LE.IE)   GO TO 3021
      G(IM)=LOAD(SHIFT(IY,24),G(IM))
      GO TO 3021
13021 G(IM)=LOAD(SHIFT((IOU(IM).OR.SHIFT(IY,12)), 24),G(IM))
C    ****    CHECK FOR POINT FURTHER RIGHT THAN PLOTTED AREA TO DATE.
C          IF SO SET BOTH BOUNDS OF VISIBLE AREA TO THIS VALUE
      IF(IM.LE.IEND)GO TO 3021
      G(IM)=LOAD(SHIFT(IY,24),IY.OR.Q(2))
      IEND = IM
      GO TO 3021
 4008 IF(IY-IOL(IM)) 4009, 4009, 4010
 4009 LAST=2
      IF(ISW.NE.1)   GO TO 33021
      G(IM)=LOAD(G(IM),IOL(IM).OR.SHIFT(IY,12))
      GO TO 3021
33021 G(IM)=LOAD(G(IM),((G(IM).AND.Q(2)).OR.IY))
      GO TO 3021
 4010 IF(VIS.NE.1)   GO TO 4011
      K=K+1
      SX(K)=II
*IF -DEF,AELIB5
      IF(LAST.EQ.1)1,2
*ENDIF
*IF DEF,AELIB5
      IF(LAST.EQ.1)GOTO 1
      GOTO 2
*ENDIF
 4011 IF(ISW.EQ.2)   GO TO 13060
30601 IF(STOP.EQ.1)   GO TO 3099
      LP=0
      GO TO 3060
C
C      FLOAT MUST BE USED AS THERE IS NO CONVERSION OF
C      MODES IN A MASKING EXPRESSION. SY IS REAL AND R (AND G )
C      ARE INTEGER
 1    SY(K)=FLOAT(IOU(IM))
      I1=IOU(IM)
      I2=IOU(IM+IDIR)
      GO TO 4012
 2    SY(K)=FLOAT(IOL(IM))
      I1=IOL(IM)
      I2=IOL(IM+IDIR)
C    ****    IF ABS(SLOPE) GT THAN 10 USE PT. NOT BOUND FOR DRAWING
C          LINE    THIS IS A PARTIAL FIX (COMPROMISE)
 4012 IF(IABS(I1-I2).GT.10)SY(K)=IY
      IF(ISW.EQ.2)GO TO 4017
      VIS=0
      CC=CC+1
      FIN(CC+1)=K
      GO TO 30601
 5297 IF(IF.LT.IOU(IM))GO TO 6668
      LP=1
      GO TO 4014
 6668 IF(IF.GT.IOL(IM)) GO TO 3099
      LP=1
      GO TO 4015
 3060 II=II-IDIR
      IM=II+1
      IF(II.EQ.IE)   GO TO 5297
      IY=AM*II+B+0.5
      IF(IY-IOU(IM)) 4013, 4014, 4014
 4014 LAST=1
      STY=IOU(IM)
      G(IM)=LOAD(SHIFT((IOU(IM).OR.SHIFT(IY,12)), 24),G(IM))
      GO TO 4016
 4017 K=K+1
      SX(K)=STX
      SY(K)=STY
      GO TO 3099
 4013 IF(IY-IOL(IM)) 4015, 4015, 3060
 4015 LAST=2
      STY=IOL(IM)
      G(IM)=LOAD(G(IM),IOL(IM).OR.SHIFT(IY,12))
 4016 VIS=1
      STX=II
      K=K+1
      SX(K)=STX
      SY(K)=STY
      IF(LP.EQ.1)   GO TO 3099
      GO TO 3020
13060 II=II+IDIR
      IM=II+1
 5000 II=II-IDIR
      IM=II+1
      IF(II.EQ.IE)   GO TO 3099
      IY=AM*II+B+0.5
      IF(IY-IOU(IM)) 5001, 5002, 5002
 5001 IF(IY-IOL(IM)) 5003, 5003, 5000
 5002 STY=IOU(IM)
      GO TO 5004
 5003 STY=IOL(IM)
 5004 STX=II
      K=K+1
      SX(K)=STX
      SY(K)=STY
      K=K+1
      SX(K)=IE
      SY(K)=IF
      K=K+1
      SX(K)=STX
      SY(K)=STY
      VIS=0
      CC=CC+1
      FIN(CC+1)=K
*IF -DEF,AELIB5
 3099 GO TO (3001,31,3111),ISW
*ENDIF
*IF DEF,AELIB5
 3099 GO TO (3001,31,3111),ISW
      CALL GOTOER
*ENDIF
      END
