*DECK SYMBOL
      SUBROUTINE SYMBOL(XXX,YYY,H,IBCD,ANGLE,NCHAR)
************************************************************************
**                                                                    **
**    NOTE THAT SYMBOL IS WRITTEN IN MODULAR FORM USING THE ADDITIONAL**
**    ROUTINE:                                                        **
**       PLFL                                                         **
**    PLFL IS STORED ON AELIB SOURCE TAPE WITH ROUTINE PLT UNDER DECK **
**                                                                    **
************************************************************************
C
C THIS SUBROUTINE PLOTS CHARACTERS OR SYMBOLS AND HAS SEPARATE CALL
C FORMATS FOR EACH. IF THE LAST ARGUMENT IS NON-NEGATIVE, THEN
C CHARACTERS ARE PLOTTED(STANDARD CALL). OTHERWISE SINGLE SYMBOLS ARE
C PLOTTED(SPECIAL CALL)
C
C ARGUMENTS COMMON TO BOTH CALLS
C    XXX  -
C    YYY  -  COORDINATES, IN INCHES, OF THE LOWER LEFT HAND CORNER OF
C            THE FIRST CHARACTER TO BE PRODUCED. THE PEN IS UP WHILE
C            MOVING TO THIS POINT FOR STANDARD CALL. SEE ARGUMENTS FOR
C            SPECIAL CALL FOR PEN STATUS
C
C          - IF EITHER OR BOTH COORDINATES HAVE A VALUE OF 999., THIS
C            MEANS THAT THE VALUE OF THAT COORDINATE WILL BE
C            THAT VALUE DEFINED BY WHERE SUBROUTINE.(SEE INTRODUCTORY
C            COMMENTS FOR THAT ROUTINE)
C
C    H -  HEIGHT,IN INCHES, OF CHARACTER TO BE PLOTTED. FOR OUT PLOTTER
C         ONLY  INTEGRAL MULTIPLES OF .08 IN.  BETWEEN .08 AND .8 IN.
C         ARE ALLOWED, SO HEIGHT IS ROUNDED TO CLOSEST VALUE
C    ANGLE - ANGLE,IN DEGREES FROM THE X-AXIS  AT WHICH ANNOTATION IS TO
C            BE PLOTTED. FOR OUR PLOTTER ONLY INTEGRAL MULTIPLES OF
C            45 DEGREES BETWEEN 0 AND 360 DEGREES ARE ALLOWED,SO ANGLE
C            IS CONVERTED TO NEXT HIGHEST SUCH VALUE
C            (NOTE - CHARACTERS PLOTTED AT ODD MULTIPLES OF 45 DEGREES
C            ARE SQRT(2)*HEIGHT, WHERE HEIGHT CALCULATED AS ABOVE)
C            SPECIAL SYMBOLS ARE ALWAYS PLOTTED A 0 DEGREES. THE
C            PARAMETER, ANGLE, HAS A DIFFERENT MEANING FOR SPECIAL
C            SYMBOLS AS DESCRIBED BELOW
C
C ARGUMENTS FOR STANDARD CALL ONLY
C
C    IBCD - THE CHARACTERS TO BE PLOTTED, IN DISPLAY CODE
C         - IF NCHAR GT 0 THEN THESE CHARACTERS MUST BE LEFT JUSTIFIED
C           IN A VARIABLE, ARRY, OR HOLLERITH LITERAL
C         - IF NCHAR EQ 0 THEN IBCD MUST CONTAIN A SINGLE, RIGHT
C           JUSTIFIED CHARACTER
C    NCHAR- NUMBER OF CHARACTERS TO BE PLOTTED FROM IBCD
C
C
C ARGUMENTS FOR SPECIAL CALL
C    IBCD - INTEGER CODE FOR DESIRED SUMBOL. SINCE OUR PLOTTERS CAN
C           HANDLE ONLY NON-ROTATED SYMBOLS OF TWO SIZES, AND SINCE
C           OUR SYMBOLS AND SYMBOL NUMBERS ARE NOT COMPATIBLE WITH
C           CALCOMP"S, THE FOLLOWING SCHEME HAS BEEN SET UP -
C           IF ANGLE EQ 0 THEN USE INTEQ AS OUR SYMBOL CODE AND PLOT.
C            (HEIGHT AND ANGLE HAVE NO MEANING FOR THIS CASE)
C           IF ANGLE NE 0 THEN ASSUME INTEQ IS CALCOMP SYMBOL CODE AND
C            CONVERT, VIA A TABLE, TO OUR CODE, IF POSSIBLE. IF
C            CONVERSION IMPOSSIBLE THEN PLOT NO SYMBOL. IF HEIGHT IS
C            LT .08 THEN SMALLER SIZE OF OUR SYMBOLS IS USED. OTHERWISE
C            LARGER IS USED.(CONVERSION TABLE ASSUMES CALCOMP SYMBOLS AS
C            ON PAGE 16 OF PROGRAMMING CALCOMP PEN PLOTTERS)
C    NCHAR - IF EQ -1,PEN IS UP DURING MOVE TO XXX,YYY
C          - IF LE -2,PEN IS DOWN DURING MOVE TO XXX,YYY
C
C
C ROUTINES CALLED -
C        PLOT FROM AELIB
C        PLT, PLFL FROM CALCOMP PACKAGE
C
C WRITTEN BY L EVANS   SEPTEMBER 1973
C REVISED BY L EVANS - TO BUFFER PLT CALLS    OCTOBER 1975
C REVISED BY G N WILLIAMS - TO CORRECTLY HANDLE CHARACTER STRINGS THAT
C             80 JUNE     - ARE NOT BLANK FILLED AFTER NCHAR CHARACTERS.
C
      DIMENSION IBCD(1)
*CALL BLOCK
*CALL BLOCKS
      DIMENSION ITABLE(20)
*IF -DEF,AELIB5
      INTEGER IFORM(2),NFORM(3,2)
*ENDIF
*IF DEF,AELIB5
      INTEGER  IFORM(2)
      CHARACTER * 10  NFORM(3,2)
*ENDIF
C
*IF -DEF,AELIB5
      DATA ( NFORM(I,1),I=1,3)/10H(1H(,I2,1H  ,
     2                         10HA,I2,1H))   ,
     3                         10H            /
C
      DATA ( NFORM(I,2),I=1,3)/10H(1H(,I2,6H  ,
     2                         10HA10,1A,I2,  ,
     3                         10H1H))        /
*ENDIF
*IF DEF,AELIB5
      DATA ( NFORM(I,1),I=1,3)/ '(1H(,I2,1H' ,
     2                          'A,I2,1H)) ' ,
     3                          '          ' /
C
      DATA ( NFORM(I,2),I=1,3)/ '(1H(,I2,6H' ,
     2                          'A10,1A,I2,' ,
     3                          '1H))      ' /
*ENDIF
C
      DATA ITABLE/1,1,3,5,7,19,15,23,13,17,11,11,21,9,6*0/
*CALL STATF
*CALL ERROR
*CALL PLCHK
C
C     XXX AND YYY ARE CHECKED FOR LEGALITY. IF EITHER IS ILLEGAL, A
C     MESSAGE IS PRINTED AND THE CALL IGNORED
C
      LX=LEGVAR(XXX)
      LY=LEGVAR(YYY)
*IF -DEF,AELIB5
      IF((LX.EQ.0).A.(LY.EQ.0)) GOTO 1
*ENDIF
*IF DEF,AELIB5
      IF((LX.EQ.0).AND.(LY.EQ.0)) GOTO 1
*ENDIF
*IF -DEF,AELIB5
      CALL AELERR(MESSNO,1HF)
*ENDIF
*IF DEF,AELIB5
      CALL AELERR(MESSNO,'F')
*ENDIF
  1   CONTINUE
C
C ADJUST CALCOMP PARAMETERS
C
       X=XXX
      Y=YYY
      XX=XN
      IF(X .NE.999.)XX=XORG+X*FACT
      YY=YN
      IF(NCHAR.LT.0) GO TO 100
      IF(Y .NE.999.)YY=YORG+Y*FACT
      ISIZE=(H*FACT)/.08
      IF((ISIZE*.08+.04).LT.H*FACT) ISIZE=ISIZE+1
      IF(ISIZE.EQ.0) ISIZE=1
      IF(ISIZE.GT.10) ISIZE=3
      A=ANGLE/57.256
      DIR=AMOD((360.-ANGLE)/45.,8.)
      IDIR=DIR
      RSIZE=ISIZE
      IF(FLOAT(IDIR/2).NE.(DIR/2.)) RSIZE=RSIZE*1.4
C
C     UPDATE PRESENT POSITION POINTERS XN,YN
C
      IF(NCHAR.EQ.0)GOTO 25
        GOTO 26
C     THEN
 25     XN=COS(A)*RSIZE*.08+XX
        YN=SIN(A)*RSIZE*.08+YY
        GOTO 27
C     ELSE
 26     XN=COS(A)*IABS(NCHAR)*RSIZE*.08+XX
        YN=SIN(A)*IABS(NCHAR)*RSIZE*.08+YY
  27  CONTINUE
C
C     ONLY IMPLEMENT SYMBOL IF STARTING COORDINATES ARE IN RANGE
C
C
C     INPLEMENT STANDARD SYMBOL CALL WITH A PLOT MOD 3 CALL
C
      IF(NCHAR.EQ.0) GOTO 80
      IREM=MOD(NCHAR,10)
      NFULLW=(NCHAR-1)/10
      M=NFULLW+1
      IF (IREM .EQ. 0) IREM=10
      ITYPE=1
      IF (NFULLW .GT. 0)ITYPE=2
      NFULLW=MAX0(1,NFULLW)
C
*IF -DEF,AELIB5
      ENCODE(20,NFORM(1,ITYPE),IFORM)NFULLW,IREM
*ENDIF
*IF DEF,AELIB5
      ENCODE(20,NFORM(1,ITYPE),IFORM)NFULLW,IREM
*ENDIF
C
      GOTO 200
C
C STANDARD SYMBOL CALL WITH SINGLE CHAR
C
   80 IFORM(1)=4H(R1)
      M=1
C
C     PLOT"S ENTRY POINT PLOTC IS USED HERE TO AVOID A POSSIBLE NAME
C     CONFLICT WITH CALCOMP"S ROUTINE CALLED PLOT (CALLING PLOTC
C     PRODUCES THE SAME RESULTS AS CALLING PLOT)
C
 200  CALL PLOTC(3,IFORM,ISIZE,IDIR,XX,YY,IBCD,M)
      GOTO 201
C
C SPECIAL SYMBOL CALL
C MOVE CURRENT POSITION TO XX,YY
 100  I=NCHAR
      IF(I.LT.-2) I=-2
      I=I+4
      XR=X
      YR=Y
      CALL PLT(XR,YR,I)
C
C     ONLY IMPLEMENT SPECIAL SYMBOL CALL IF COORDINATES ARE IN RANGE
C
C NO ANGLED SYMBOLS ALLOWED - ALL SYMBOLS ARE PLOTTED AT 0 DEGREES
C USE ANGLE AS FOLLOWS - IF ANGLE=0 THE USE OUR SYMBOL CODE
C                        IF ANGLE NOT =0 THEN USE CALCOMP SYMBOLS AND
C                        CONVERT(PLOT NO SYMBOL IF CONVERSION IMPOSS)
C ONLY TWO SYMBOL SIZES ARE AVAILABLE - .04IN OR .08IN
C THESE ONLY HAVE MEANING FOR CALCOMP SYMBOLS
      J=IBCD(1)
      IF(ANGLE.EQ.0) GOTO 150
      ISIZE=1
      IF(H*FACT.LT..08) ISIZE=0
      J=J+1
      IF(J.GT.20)J=20
      J=ITABLE(J)
      IF(J.NE.0) J=J+ISIZE
C
C     IF SYMBOL TO BE PLOTTED
*CALL PLCHK
C
C     PLOT"S ENTRY POINT PLOTC IS USED HERE TO AVOID A POSSIBLE NAME
C     CONFLICT WITH CALCOMP"S ROUTINE CALLED PLOT (CALLING PLOTC
C     PRODUCES THE SAME RESULTS AS CALLING PLOT)
C
 150  CALL PLOTC(2,0,J,XN,YN,1)
  201 RETURN
      END
