*DECK TRACEB
*IF -DEF,EXTERNAL
      SUBROUTINE TRACEB(IABORT)
C
C THIS SUBROUTINE IS CALLED BY AELIB ROUTINES TO ISSUE A TRACEBACK
C REPORT FOLLOWING THE PRINTING OF AN AELIB ERROR MESSAGE.
C IT HAS ONE INPUT PARAMETER, IABORT, THAT SPECIFIES THE FATE OF THE
C USERS PROGRAM FOLLOWING THE TRACEBACK REPORT.
C        IABORT = 0  - RETURN CONTROL TO THE AELIB SUBROUTINE
C        IABORT " 0 - ABORT THE USERS JOB
C
C
C METHOD
C     THE TRACEBACK REPORT IS ISSUED BY CALLING THE FTN LIBRARY ROUTINE
C SYSTEM. SYSTEM REQUIRES TWO INPUT PARAMETERS -
C     ERRNUM - INTEGER ERROR NUMBER
C     MESG - HOLLERITH STRING CONTAINING ERROR MESSAGE
C FOR THIS APPLICATION OF SYSTEM WE USE THE TWO ERROR NUMBERS RESERVED
C FOR THE USER, THAT IS -
C     ERROR NUMBER 51 - ISSUE TRACEBACK REPORT AND RETURN CONTROL TO
C                       THE AELIB ROUTINE.
C     ERROR NUMBER 52 - ISSUE TRACEBACK REPORT AND ABORT THE USERS JOB.
C
C THE MESSAGE ISSUED BY SYSTEM IDENTIFIES THE ERROR AS NON-FATAL OR
C FATAL AND DEFINES THE ASSOCIATED NUMBER. ALTHOUGH DOCUMENTATION FOR
C SYSTEM IN THE FTN EXT REF MANUAL STATES THAT THE FIRST CHARACTER
C IN THE MESSAGE IS USED FOR CARRIAGE CONTROL, ACTUALLY THIS CHARACTER
C LESS 66B IS USED. SO TO GET SINGLE SPACING, WE USE ZERO =33B.
C
C
C   SPECIAL NOTE :
C
C             THERE ARE TWO VERSIONS OF TRACEB IN THE AELIB PROGRAM
C             LIBRARY UNDER THE DECK NAME TRACEB.  ONE IS THE INTERNAL
C             VERSION USED BY ROUTINES IN AELIB AND THE OTHER IS AN
C             EXTERNAL VERSION THAT IS TO ACCOMPANY AELIB ROUTINES
C             (WHICH REFERENCE SETBAD) BEING SENT TO ANOTHER SITE.
C
C             THE UPDATE DIRECTIVE "*COMPILE TRACEB" WILL CAUSE THE
C             INTERNAL VERSION TO BE WRITTEN TO THE COMPILE FILE.
C             WITH THE ADDITION OF THE DIRECTIVE "*DEFINE EXTERNAL"
C             THE EXTERNAL VERSION OF TRACEB WILL BE WRITTEN TO THE
C             COMPILE FILE.
C
C
C WRITTEN BY L EVANS  CRNL       1979 MARCH
C
C
C REVISED BY G.L. KLAWITTER  MARCH 1980 TO DECREASE LENGTH OF ERROR
C MESSAGE LINE LENGTHS TO 72 CHARACTERS OR LESS.
C
C
      IF(IABORT.NE.0) GOTO 100
C
C        NON-FATAL AELIB ERROR
C
*IF -DEF,AELIB5
         CALL SYSTEM(51,"0AELIB ERROR, REPORTED AS TRACEB ERROR NUMBER 5
     ,1, ALLOWS JOB TO CONTINUE.")
*ENDIF
*IF DEF,AELIB5
         CALL SYSTEM(51,'0AELIB ERROR, REPORTED AS TRACEB ERROR NUMBER 5
     ,1, ALLOWS JOB TO CONTINUE.')
*ENDIF
         RETURN
 100  CONTINUE
C
C        FATAL AELIB ERROR
C
*IF -DEF,AELIB5
         CALL SYSTEM(52,"0AELIB ERROR, REPORTED AS TRACEB ERROR NUMBER 5
     ,2, FORCES JOB TERMINATION.")
*ENDIF
*IF DEF,AELIB5
         CALL SYSTEM(52,'0AELIB ERROR, REPORTED AS TRACEB ERROR NUMBER 5
     ,2, FORCES JOB TERMINATION.')
*ENDIF
C
      END
*ENDIF
*IF DEF,EXTERNAL
      SUBROUTINE TRACEB(IABORT)
C
C **********************************************************************
C ******                                                          ******
C ******   AELIB UTILITY TRACEB  -  EXTERNAL VERSION    2-5-74    ******
C ******                                                          ******
C **********************************************************************
C *                                                                    *
C * PURPOSE :                                                          *
C *                                                                    *
C *           THIS IS A "DO-NOTHING" ROUTINE INTENDED TO ACCOMPANY     *
C *           AELIB ROUTINES SENT TO ANOTHER SITE.  IT REPLACES THE    *
C *           INTERNAL VERSION OF TRACEB WHICH IS USED BY AELIB        *
C *           ROUTINES TO ISSUE A TRACEBACK REPORT FOLLOWING THE       *
C *           PRINTING OF AN AELIB ERROR MESSAGE.                      *
C *                                                                    *
C * ENTRY :   CALL TRACEB(IABORT)                                      *
C *                                                                    *
C *           IABORT - INTEGER INPUT VARIABLE SPECIFYING THE FATE OF   *
C *                    THE USERS PROGRAM FOLLOWING THE AELIB TRACEBACK *
C *                    REPORT.                                         *
C *                  - IABORT = 0  RETURN CONTROL TO AELIB ROUTINE.    *
C *                    IABORT " 0  ABORT USERS JOB.                    *
C *                                                                    *
C *                                                                    *
C * INTERNAL TRACEBACK METHOD                                          *
C *                                                                    *
C *           THE TRACEBACK REPORT IN THE INTERNAL VERSION OF TRACEB   *
C *           IS ISSUED BY CALLING THE FTN LIBRARY ROUTINE SYSTEM.     *
C *           SYSTEM REQUIRES TWO INPUT PARAMETERS; ERRNUM, THE INTEGER*
C *           ERROR NUMBER, AND MESG, A HOLLERITH STRING CONTAINING    *
C *           THE ERROR MESSAGE.  FOR THIS APPLICATION OF SYSTEM WE    *
C *           USE TWO ERROR NUMBERS RESERVED FOR THE USER.  ERROR      *
C *           NUMBER 51 AND ERROR NUMBER 52.                           *
C *           ERROR NUMBER 51 : ISSUE TRACEBACK REPORT AND RETURN      *
C *                             CONTROL TO THE AELIB ROUTINE.          *
C *           ERROR NUMBER 52 : ISSUE TRACEBACK REPORT AND ABORT THE   *
C *                             USERS JOB.                             *
C *           THE MESSAGE ISSUED BY SYSTEM IDENTIFIES THE ERROR AS     *
C *           NON-FATAL OR FATAL AND DEFINES THE ASSOCIATED NUMBER.    *
C *           ALTHOUGH DOCUMENTATION FOR SYSTEM IN THE FTN EXT REFER-  *
C *           ENCE MANUAL STATES THAT THE FIRST CHARACTER IN THE       *
C *           MESSAGE IS USED FOR CARRIAGE CONTROL, ACTUALLY THIS      *
C *           CHARACTER LESS 66B IS USED.  SO TO GET SINGLE SPACING    *
C *           WE USE ZERO=33B.                                         *
C *                                                                    *
C *           INTERNAL TRACEB CODE TO CALL SYSTEM FOLLOWS.             *
C *                                                                    *
C *      IF (IABORT.NE.0) GO TO 100                                    *
C * C                                                                  *
C * C       NON-FATAL AELIB ERROR.                                     *
C * C                                                                  *
C *         CALL SYSTEM(51,"0AELIB ERROR, REPORTED AS TRACEB ERROR     *
C *     ,NUMBER 51, ALLOWS JOB TO CONTINUE.")                          *
C *         RETURN                                                     *
C *  100 CONTINUE                                                      *
C * C                                                                  *
C * C       FATAL AELIB ERROR.                                         *
C * C                                                                  *
C *         CALL SYSTEM(52,"0AELIB ERROR, REPORTED AS TRACEB ERROR     *
C *     ,NUMBER 52, FORCES JOB TERMINATION.")                          *
C *      END
C *                                                                    *
C *                                                                    *
C * AUTHOR :                                                           *
C *                                                                    *
C *           G.L. KLAWITTER, CRNL.                                    *
C *           MARCH 1980.                                              *
C *                                                                    *
C **********************************************************************
C
C
      RETURN
      END
*ENDIF
