*DECK USERAP
*IF -DEF,EXTERNAL
          IDENT    USERAP
          SST
*
* ENTRY
*     CALL USERAP(UN,CN,PW) RETURNS USER NUMBER, CHARGE NUMBER AND
*     PASSWORD FROM CP AREA, LEFT ADJUSTED WITH BLANK FILL.
*
* EXIT
*     UN = USER NUMBER LEFT JUSTIFIED BLANK FILL
*     CN = CHARGE NUMBER LEFT JUSTIFIED BLANK FILL
*     PW = PASSWORD LEFT JUSTIFIED BLANK FILL
*
* ERROR
*     IF USERAP CALLED WITH LESS THAN 3 ARGUMENTS A MESSAGE
*     IS ISSUED AND ONLY THE ARGUMENTS IN THE CALL WILL
*     BE DEFINED.
*    REVISED FOR NOS COMPATIBILITY 1982 JULY
*    ON NOS, RETURN ONLY USER NUMBER, LEAVING
*    CHARGE NUMBER AND PASSWORD FIELDS BLANK
*
*
* EXTERNALS
*     SYS=    COMMUNICATES SYSTEM REQUESTS FROM A USER PROGRAM
*     AIESER  AELIB ROUTINE TO ISSUE ERROR MESSAGE
*     ACT     IS A PP ROUTINE TO ACCESS THE CP AREA
*
* AUTHORS
*     WRITTEN BY  D MCPHERSON AND GARY STEWART JAN. 1982
*
* NOTE   AT TYPE 9 ERROR SHOULD BE EXPECTED
*
*IF -DEF,NOS
CNWORD    EQU      W.CPFACT  CHARGE AND USER NUMBERS
*                            VFD  24/4LCHGN,30/5LUSERN,6/..
*
PWWORD    EQU      W.CPINS   PASSWORD IN 1ST WORD OF INSTALLATION AREA
*                            VFD   60/10HPASSWORD
*ENDIF
*
          ENTRY    USERAP
TRACE     VFD      42/6HUSERAP,18/USERAP   FOR FTN TRACEBACK
USERAP    DATA     0
*CALL STATC
          SB1      1
          SX6      A0
          SA6      SAVA0           SAVE A0
          SA4      A1              SAVE APLIST ADDRESS
          ZR       X4,NOARG        IF NO ARG. IN CALL
*
*IF -DEF,NOS
*    THE PP ROUTINE ACT IS CALLED TO ACCESS WORD 50 OF THE
*    CONTROL POINT AREA WHICH CONTAINS THE CHARGE AND USER NUMBER
          SA2      CNCALL
          BX6      X2
          SA6      STATUSW
          SA1      CALLACT
          BX6      X1
          RJ       =XSYS=
          SA1      STATUSW+1
          MX0      30
          LX1      24         NOS/BE USERNUM IS 5 CHARACTERS
          SA3      BLANKS
          BX6      X0*X1
          BX7      -X0*X3
          IX6      X6+X7
*ENDIF
*IF DEF,NOS
          USERNUM   STATUSW+1
          SA1       STATUSW+1
          SX0      77B
          SA3      BLANKS     NOS USERNUM IS 1 TO 7 CHARACTERS
BFILL     BX6      X0*X1
          NZ       X6,BDONE
          BX6      X0*X3
          LX0      6
          IX1      X1+X6
          NG       X0,BDONE    JUST IN CASE
          EQ       BFILL
BDONE     BX6      X1
*ENDIF
          MX0      30
          SA6      X4              STORE UN
          MX0      24
          LX1      36
          SA4      A4+B1           ADDRESS OF 2ND PAR TO X4
          ZR       X4,NOARG        IF NO 2ND ARG IN CALL
*IF DEF,NOS,3
*
*   SET CHARGE NUMBER BLANK IF ON NOS
          BX1     X3
          BX6      X0*X1           CN LEFT ADJUSTED
          BX7      -X0*X3
          BX6      X6+X7
          SA6      X4              PUT AWAY CN
*IF -DEF,NOS
*
*    THE PP ROUTINE ACT IS CALLED TO ACCESS WORD 170 OF THE
*    CONTROL POINT AREA WHICH CONTAINS THE PASSWORD
          SA1      PWCALL
          BX6      X1
          SA6      STATUSW
          SA1      CALLACT
          BX6      X1
          RJ       =XSYS=
          SA1      STATUSW+1
*ENDIF
*IF DEF,NOS,1
*    SET PW BLANK IF ON NOS
          SA4      A4+B1           ADDRESS OF 3RD PAR TO X4
          ZR       X4,NOARG        IF NO 3RD ARG IN CALL
          BX6      X1
          SA6      X4
          SA5      SAVA0
          SA0      X5              RESTORE A0
          EQ       USERAP
*
*    ERROR EXIT IF THERE ARE LESS THAN 3 ARG. IN CALL TO USERAP
NOARG     SX6      020544
          SX7      1
          SA6      IROUTIN         SET UP COMMON/AEERCM/
          SA7      MESSAG
          SA1      ARG1            ARGUMENT LIST
+         RJ       =XAEISER        AELIB ROUTINE TO ISSUE ERROR MESSAGE
-         VFD      30/TRACE        FOR TRACEBACK
          SA5      SAVA0           RESTORE A0
          SA0      X5
          EQ       USERAP
*
*IF -DEF,NOS,3
CALLACT   VFD      24/4LACTP,18/0,18/STATUSW
CNCALL    VFD      6/0,1/1,17/CNWORD,12/1,12/0,6/0,6/10B
PWCALL    VFD      6/0,1/1,17/PWWORD,12/1,12/0,6/0,6/10B
STATUSW   BSS      2
BLANKS    VFD      60/10R
SAVA0     DATA     0
*
*   COMMON/AEERCM/ FOR AEISER
          USE /AEERCM/
IROUTIN   BSS      1
MESSAG    BSS      1
          USE *
ADDR      BSSZ     2               PARAMETERS FOR USERAP
FORMAT    DIS      ,+(" ***ERROR IN USERAP - LESS THAN 3 ARG IN CALL")+
ARG1      CON      FORMAT          PARAMETER LIST
          CON      *
          CON      VALUE
          DATA     0
VALUE     DATA     0
*
*
          END
*ENDIF
*IF DEF,EXTERNAL
      SUBROUTINE USERAP(UN,CN,PW)
C
C **********************************************************************
C *           EXTERNAL VERSION OF USERAP                               *
C *           THIS SUBROUTINE OBTAINS THE ACCOUNT PARAMETERS           *
C *           FROM THE CRNL JOB CARD                                   *
C *           THESE WOULD HAVE BEEN                                    *
C *                                                                    *
C *      UN = USER NUMBER LEFT JUSTIFIED BLANK FILL                    *
C *      CN = CHARGE NUMBER LEFT JUSTIFIED BLANK FILL                  *
C *      PW = PASSWORD LEFT JUSTIFIED BLANK FILL                       *
C *                                                                    *
C *           THIS EXTERNAL VERSION WILL DEFINE THESE VALUES           *
C *           AS BLANKS                                                *
C *                                                                    *
C **********************************************************************
C
      UN=10H
      CN=10H
      PW=10H
      RETURN
      END
*ENDIF
