*DECK ZEROM
      FUNCTION ZEROM(B,AUX,H,E,IFLAG)
C ZERO OF A FUNCTION BY MUELLER"S METHOD
C REF.- RTMI IN IBM SCIENTIFIC SUBROUTINES
C
C IF SINGLE ROOT NOT INDICATED,I E NO SIGN CHANGE FOUND, THEN
C LOOK FOR DOUBLE ROOT USING STEPMIN ROUTINE
C
C IFLAG=0 IF SINGLE ROOT FOUND
C IFLAG=1 IF DOUBLE ROOT FOUND
C ERROR CONDITIONS - ZERO SET TO INDEF VALUE
C AND IFLAG=2 IF NO SIGN CHANGE AFTER 20 STEPS
C     IFLAG=3 IF NO CONVERGENCE IN EITHER X OR F VALUES
C     IFLAG=4 IF NO CONVERGENCE IN ONLY F VALUES
C IMPLEMENTED BY L EVANS  JULY 1973
C
C  MODIFIED BY L EVANS 1978 JUNE TO
C         - SAVE GENERATED FUNCTION VALUES TO LOOK FOR A DOUBLE ROOT
C         - TEST THE FUNCTION MINIMUM FOR A CHANGE IN SIGN
C         - RETURN THE "ZERO" FUNCTION VALUE IN COMMON BLOCK ENTRY FL
C          IF A ZERO WAS FOUND
C
      INTEGER SGN,SW
      REAL FSAVE(21)
      EXTERNAL AUX
      COMMON/LASTV/XL,XR,FL,FR
*CALL STATF
C FOR NOW USE CONSTANT 10 ITERATIONS, MAY MAKE A PARAMETER LATER
      IEND=10
      IFLAG=0
      XL=B
C EVALUATE F(A+NH) FOR N=1,...20 UNTIL 2 SUCCESSIVE VALUES HAVE
C OPPOSITE SIGN
      FL=AUX(XL)
      FSAVE(1)=FL
   10 DO 15 I=1,20
      XR=XL+H
      FR=AUX(XR)
      IF(FR)11,95,11
   11 IF(FL*FR)25,25,12
   12 XL=XR
      FL=FR
      FSAVE(I+1)=FL
   15 CONTINUE
C
C IF NO SIGN CHANGE FOUND LOOK FOR A DOUBLE ROOT
C
      XL=B
      FL=FSAVE(1)
      SGN=1
      IF(FL.LT.0) SGN=-1
      SW=0
      DO 200 I=1,20
      LOCFL=I
      XR=XL+H
      FR=FSAVE(I+1)
      IF((FR-FL)*SGN.GT.0) GOTO 190
      SW=1
      GOTO 195
  190 IF(SW.NE.0) GOTO 250
  195 XL=XR
  200 FL=FR
C
C NO CHANGE OF SIGN OF SLOPE
  201 IFLAG=2
*IF -DEF,AELIB5
      ZEROM=17770000000000000000B
*ENDIF
*IF DEF,AELIB5
      ZEROM=O"17770000000000000000"
*ENDIF
      GOTO 99
C
C CHANGE OF SIGN OF SLOPE LOCATED,FIND MIN VALUE
C
  250 HH=ABS(H)
      NO=100
      ER=E*AMAX1(1.0,ABS(XL))
      XLN=STEPMIN(AUX,XL,HH,ER,IST,NO,SGN)
      IF(IST.GE.5) GOTO 201
      FLN=AUX(XLN)
      IF(FLN*FL.GT.0) GOTO 260
C
C         MINIMUM IS OF OPPOSITE SIGN TO FL - LOOK FOR FIRST ODD
C             ORDER ROOT BETWEEN XL-H AND XLN
C
              XR=XLN
              FR=FLN
              IF((XLN-XL)*H.GT.0) GOTO 25
              XL=XL-H
              FL=FSAVE(LOCFL-1)
              GOTO 25
C
C     IF MINIMUM IS CLOSE ENOUGH TO ZERO ACCEPT IT AS A DOUBLE ROOT
C
 260  IF(ABS(FLN).GT.100*E) GOTO 201
      XL=XLN
      FL=FLN
      IFLAG=1
      GOTO 90
C GENERATE TOLERANCE FOR FUNCTION VALUES
   25 TOLF=100*E
      I=0
C START ITERATION LOOP
   30 I=I+1
C BISECTION LOOP
      DO 48 K=1,IEND
      X=(XL+XR)/2
      F=AUX(X)
      IF(F)35,97,35
   35 IF(SIGN(1.,F)+SIGN(1.,FR))40,37,40
C INTERCHANGE XL AND XR SO F AND FR HAVE SAME SIGN
   37 TOL=XL
      XL=XR
      XR=TOL
      TOL=FL
      FL=FR
      FR=TOL
C CHECK INEQUALITY FOR INVERSE PARABOLIC INTERPOLATION
   40 TOL=F-FL
      A=F*TOL
      A=A+A
      IF(A-FR*(FR-FL))42,43,43
C IF LAST ITERATION +1, DON"T DO INTERPOLATION
   42 IF(I-IEND)60,60,43
   43 XR=X
      FR=F
C TEST ON SATISFACTORY ACCURACY IN BISECTION LOOP
C NEED BOTH ARGUMENT AND FUNCTION CONDITIONS SATISFIED
C TO TERMINATE BISECTION LOOP
      TOL=E
      A=ABS(XR)
      IF(A-1.)46,46,45
   45 TOL=TOL*A
   46 IF(ABS(XR-XL)-TOL)47,47,48
   47 IF(ABS(FR-FL)-TOLF)55,55,48
   48 CONTINUE
C NO CONVERGENCE AFTER IEND ITERATION STEPS FOLLOWED BY
C IEND STEPS OF BISECTION     OR
C AT ANY ITERATION STEP, INEQUALITY FOR INTERPOLATION NEVER SATISFIED
C AND CONVERGENCE NOT ACHIEVED BY BISECTION ALONE
   50 IFLAG=3
      IF((ABS(XR-XL)-TOL).LE.0.) IFLAG=4
*IF -DEF,AELIB5
      ZEROM=17770000000000000000B
*ENDIF
*IF DEF,AELIB5
      ZEROM=O"17770000000000000000"
*ENDIF
      GOTO 99
C
C CONVERGENCE ACHIEVED IN BISECTION STEP
C RETURN X CORRESPONDING TO SMALLER F VALUE
C
   55 IF(ABS(FR)-ABS(FL))97,97,90
C COMPUTATION OF ITERATED X-VALUE BY INVERSE PARABOLIC INTERPOLATION
   60 A=FR-F
      DX=(X-XL)*FL*(1.+F*(A-TOL)/(A*(FR-FL)))/TOL
      XM=X
      FM=F
      X=XL-DX
      F=AUX(X)
      IF(F)65,97,65
C TEST ON SATISFACTORY ACCURACY IN ITERATION LOOP
   65 TOL=E
      A=ABS(X)
      IF(A-1.)67,67,66
   66 TOL=TOL*A
   67 IF(ABS(DX)-TOL)68,68,70
   68 IF(ABS(F)-TOLF)97,97,70
C PREPARE NEXT BISECTION LOOP
   70 IF(SIGN(1.,F)+SIGN(1.,FL))75,72,75
   72 XR=X
      FR=F
      GOTO 30
   75 XL=X
      FL=F
      XR=XM
      FR=FM
      GOTO 30
C RETURN WITH APPROPRIATE X VALUE
   90 ZEROM=XL
      GOTO 99
   95 ZEROM=XR
      XL=XR
      FL=FR
      GOTO 99
   97 ZEROM=X
      XL=X
      FL=F
   99 RETURN
      END
